<?php
/*

File dedicated to UI related PHP functions only,

These functions are NOT to be used on the front-end as they may change from time to time. Less backward compatibility on these, as all PHP files under /admin/ are updated at once!

		
*/

use JetBrains\PhpStorm\ArrayShape;

/**
 * NOT USED IN 2023 UPGRADE
 */
function modal_html($title, $content, $id, $labelyes='Yes', $labelno='No', $functionyes='return true', $functionno = false, $hideclose=false) {
	if($title!='' & $content!='' & $id!='') {
	?>
	<div class="modal fade" id="<?=$id?>" tabindex="-1" role="dialog" aria-labelledby="<?=$id.'modallabel'?>" aria-hidden="true">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
			        <?
					if($labelyes===false && $labelno===false  && $hideclose===false) {
					?>
					<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
			        <?
				    }
			        ?>
			        <h4 class="modal-title" id="<?=$id.'modallabel'?>"><?=$title?></h4>
				</div>
				<div class="modal-body">
				<?=$content?>
				</div>
				<div class="modal-footer">
					<?
					if($labelyes===false && $labelno===false && $hideclose===false) {
					?>
					<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
					<?
					}

					if($labelyes!==false) {
					?>
					<button type="button" class="btn btn-primary" id="<?=$id?>_yes"><?=$labelyes?></button>
					<?
					}

					if($labelno!==false) {
					?>
					<button type="button" class="btn btn-danger" id="<?=$id?>_no"><?=$labelno?></button>
					<?
					}
					?>
				</div>
			</div>
		</div>
	</div>
	<?
	// define close function
	// either way modal has to close after hit YES or NO.
	$closefunction = "$('#".$id."').modal('hide');";
	?>
	<script type="text/javascript">
		$(document).ready(function(){
			$('#<?=$id?>_yes').click(function(){
				<?=$closefunction?>
				<?=$functionyes?>
			});

			$('#<?=$id?>_no').click(function(){
				<?=$closefunction?>
				<?=$functionno?>
			});
		});
	</script>

	<?
	}
}


/**
 * Specially designed for 2023 admin upgrade ... creates bootstrap 5 modal
 * @param array $options
 * @return void
 */
function brixwork_modal_html(array $options = array()) {
    // LOOK THROUGH BELOW TO SEE WHAT OPTIONS ARE AVAILABLE!
    $options['modal_base_class']= $options['modal_base_class'] ?: 'brixwork-admin-modal';
    $options['header_content']  = $options['header_content'] ?: '';
    $options['body_content']    = $options['body_content'] ?: '';
    $options['footer_content']  = $options['footer_content'] ?: '';
    $options['id']              = $options['id'] ?: 'example_modal';
    $options['label']           = $options['label'] ?: 'example modal';
    $options['animation_type']  = $options['animation_type'] ?: 'fade';
    $options['extra_classes']   = $options['extra_classes'] ?: '';
    $options['hide_x']          = $options['hide_x'] ? 'display: none' : 'display: true'; // boolean
    ?>
    <div class="modal <?=$options['modal_base_class']?> <?=$options['animation_type']?> <?=$options['extra_classes']?>" id="<?=$options['id']?>" tabindex="-1" aria-labelledby="<?=$options['label']?>" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h2 class="modal-title"><?= $options['header_content'] ?></h2>
                    <button style="<?=$options['hide_x'] ?>" type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <?=$options['body_content']?>
                </div>
                <div class="modal-footer" style="display: <?=$options['footer_content'] ? 'flex' : 'none'?>">
                    <?=$options['footer_content']?>
                </div>
            </div>
        </div>
    </div>
<?php
}


/**
 * BUILD PAGINATION HTML - 2023 Admin upgrade
 * @param $object_type  string  BRIXWORK OBJECT TYPE
 * @param $current_page int     CURRENT PAGE NUMBER GIVEN BY WINDOW VARIABLE.
 * @param $num_pages    int     MAX NUMBER OF PAGES ... CALCULATED AHEAD OF TIME
 * @return string               PAGINATION HTML
 */
function brixwork_object_pagination(string $object_type, int $current_page ,int $num_pages): string {
    // build the class name that interacts with the Javascript to make pagination function
    $object_type_class = '';
    switch ($object_type):
        case 'homes':
        case 'home':
            $object_type_class = 'homes_pagelink';
            break;
        case 'agents':
        case 'agent':
            $object_type_class = 'agents_pagelink';
            break;
        case 'buildings':
        case 'building':
            $object_type_class = 'buildings_pagelink';
            break;
    endswitch;

    // build html ... opening
    $page_links_html =	'
		<nav aria-label="Manage '.ucwords($object_type).' Pagination">
			<ul class="pagination flex-wrap py-3 my-0">
	';
    // build html ... body
    for ($counter = 1; $counter <= $num_pages; $counter++):
        $current_class = ($current_page == $counter);
        $additional_classes = $current_class ? 'active' : '';
        //$additional_attribute = $current_page ? 'aria-current="page"' : '';
        $page_links_html .= '
		<li class="page-item '.$additional_classes.'">
			<span class="page-link '.$object_type_class.'" rel="'.$counter.'">'.$counter.'</span>
		</li>
		';
    endfor;
    // build html ... closing
    $page_links_html .= '
			</ul>
		</nav>
	';

    return $page_links_html;
}


/**
 * CREATE NAV TABS ACCORDING TO 2023 ADMIN UPGRADE DESIGN!
 * @param $object_type      string  Define what object this function is being used for ex) 'home' or 'agent'
 * @param $nav_tab_array    array   Array of strings that represents each tab to create ex) $nav_tab_array = array( 'Basic Info', 'Contact Info', 'Photos', 'Videos', 'SEO' )
 * @return void                     Returns a Completed block of HTML with functionalities.
 */
function brixwork_object_tabs(string $object_type, array $nav_tab_array): void {
    global $settings;
    ?>
    <ul class="brixwork_listing_nav nav nav-tabs nav-fill" role="tablist">
        <?php
        foreach ($nav_tab_array as $key => $each_nav_tab):
            $first_tab = $key == 0;
            $url_selected = isset($_GET['section']);
            $each_href = preg_replace('/[^a-z0-9]+/i', '-', strtolower(trim($each_nav_tab))); // lower case -> connect words with "-" ... eg) Basic Info -> basic-info

            $nav_item_classes = '';
            $nav_link_classes    = ($url_selected && ($_GET['section'] == $each_href.'-tab')) || (!$url_selected && $first_tab) ? 'active' : '';
            $nav_link_attributes = ($url_selected && ($_GET['section'] == $each_href.'-tab')) || (!$url_selected && $first_tab) ? 'aria-current="page" aria-selected="true"' : 'aria-selected="false"';

            // special condition just for "home"
            if ($object_type == 'home' || $object_type == 'homes') {
                $display_condition = (($settings['rental_enabled'] == 0 && $each_nav_tab == 'Rental') || ($settings['commercial_enabled'] == 0 && $each_nav_tab == 'Commercial')) ? 'd-none' : '';
                $nav_item_classes .= $display_condition;
            }

            // special condition just for "setting" ... do not show "Photos" tab for normal user
            if ($object_type == 'setting' && !login_level_check(USER_LOGIN_BRIXWORK) && $each_nav_tab == 'Photos') continue;
            ?>
            <li class="nav-item <?=$nav_item_classes?>" role="presentation">
                <a id="<?=$each_href?>-controls" class="nav-link <?=$nav_link_classes?>" data-bs-toggle="tab" data-bs-target="#<?=$each_href?>-tab" role="tab" aria-controls="<?=$each_href?>" <?=$nav_link_attributes?>>
                    <?=$each_nav_tab?>
                </a>
            </li>
        <?php
        endforeach; ?>
    </ul>
<?php
}

/**
 * DISPLAY UNIT TYPES OF A BUILDING
 * @param $id
 * @param $label
 * @param bool $checked
 * @return void
 */
function display_type_row($id, $label, bool $checked = false) {
?>
    <div class="col-sm-4 py-2 form-check checkbox" id="btype_<?=$id?>">
        <input class="form-check-input" type="checkbox" name="types[]" value="<?=$id?>" id="type_<?=$id?>" <?=$checked ? 'checked' : ''?>/>
        <label class="form-check-label" for="type_<?=$id?>" style="text-transform: none">
            <?=$label?>
        </label>
    </div>
<?php
}


/**
 * CREATE / UPDATED / DELETE CUSTOM FIELDS FROM OBJECT
 * @param $object   object  initialized object data. ex) $home, $building, $page
 * @return void
 */
function process_custom_fields(object $object) {
    // to see which custom fields were submitted, and remove from existing.
    $custom_field_names_logged = array();
    $custom_field_order = 0;
    if(is_array($_POST['custom_field'])) {
        foreach($_POST['custom_field'] as $keyvalue) {
            if($object->get_custom_fields($keyvalue['name'])) {
                $object->update_custom_field($keyvalue['id'], $keyvalue['value'], $keyvalue['desc'], $custom_field_order);
            } else {
                $object->add_custom_field($keyvalue['name'], $keyvalue['value'], $keyvalue['desc'], $custom_field_order);
            }
            $custom_field_names_logged[] = $keyvalue['name'];
            $custom_field_order++;
        }
    }

    // delete custom keys that were not submitted. Means the user hit the MINUS button to delete.
    foreach($object->custom_fields as $keyname => $keyvalue) {
        if(!in_array($keyname, $custom_field_names_logged)) {
            // not found in list of custom fields submitted.
            $params['id'] = $keyvalue['id'];
            $object->drop_custom_field($params);
        }
    }
}

/**
 * HELPER FUNCTION FOR CUSTOM FIELDS FOR DIFFERENT OBJECTS ( HOME, BUILDING, AGENT, AND PAGE )
 * @param $new_key  string  Name of the new custom field
 * @param $val
 * @return void
 */
function field_value_textarea(string $new_key, $val) { ?>
    <div class="col-lg-5 pt-2">
        <textarea class="form-control" rows="2" name="custom_field[<?=$new_key?>][value]" placeholder="Enter of the value of this field" aria-label="Custom Field Value"><?=cleanupfortextfield($val)?></textarea>
    </div>
<?php
}

/**
 * RETURNS TWO THINGS - LATEST IMPORT TIME & LINK TO THE LATEST LOG FILE
 * @param string $filename      string to look for in the file name (eg: 'import_' or 'groupbuilding_' )
 * @return array                arr[0] = timestamp, arr[1] = log file link
 */
function get_cron_log_info(string $filename, $cron_path): array {
    $timestamp = $log_file_link = '';
    $last_time = 0;

    if (file_exists($cron_path)) {
        $dir = new DirectoryIterator($cron_path);

        foreach ($dir as $file_info) {
            $log_filename = $file_info->getFilename();

            if (!$file_info->isDot()) {
                // file format looks like import_2015-03-17 18:25:19.log
                if (str_contains($log_filename, $filename)) {
                    $log_file_timestamp = $file_info->getMTime();
                    if ($log_file_timestamp > $last_time) {
                        $last_time = $log_file_timestamp;
                        $log_file_link = $log_filename;
                    }
                }
            }
        }
        $timestamp = $last_time;
    }

    return array($timestamp, $log_file_link);
}

/** DISPLAYS DESIRED STRING IN FORMAT.
 * @param $content  string  content to display ... wrap it in <p> tag.
 * @param $class    string  CSS class to append ... usually for color variants.
 * @return string
 */
function brixwork_alert(string $content, string $class = 'default'): string {
    return "<div class='brixwork_alert mt-3 $class'>$content <span><i class='bi bi-x-lg'></i></span></div>";
}

/** This function requires $_SESSION[$session_message_name]. Useful for a message that should appear only once.
 * @param $session_message_name string  name of the session message to display & unset right after.
 * @return void     message will be printed using echo statement.
 */
function session_alert_display(string $session_message_name): void {
    if (isset($_SESSION[$session_message_name])) {
        // only display message if it exists.
        echo brixwork_alert($_SESSION[$session_message_name]);

        if ($_SERVER['REQUEST_METHOD'] == 'GET') {
            // unset the session message, so it will not appear upon refresh.
            unset($_SESSION[$session_message_name]);
        }
    }
}


function alert_display($content, $class='danger') {
	$return = '<!--<div class="row">-->
				<div class="alert alert-'.$class.'" role="alert">
				'.$content.'
				</div>
			<!--</div>-->';
	return $return;
}

function js_redirect($url='index.php', $ms = 3000, $notag = false) {
	// genreates a simple redirect javascript snippet to be inserted any where in HTML
	$return = ($notag==false ? '<script type="text/javascript">' : '')
		.'window.leaveflag=1;
		setTimeout("window.location = \"'.$url.'\";", '.$ms.');'
	.($notag==false ? '</script>' : '');
	return $return;
}

/**
 * OLD BOOTSTRAP TABLE HEADER ... used in users & subareas ... delete?
 * @param $anchor
 * @param $link
 * @param $class
 * @param $ajaxlink
 * @param $ajaxfunction
 * @return void
 */
function headerdisplay($anchor,$link=1,$class='',$ajaxlink = 0,$ajaxfunction='') {
	if($_GET['order'] == "asc" || $_GET['order']=="") {
		$neworder = "desc";
	} else if($_GET['order'] == "desc") {
		$neworder = "asc";
	}

	if($_GET['idr']!="") {
		$preserveidr = "&idr=".$_GET['idr'];
	}

	if($link==1) {
		if($ajaxlink == 0) {
			$linkstart='<a href="'.$_SERVER['PHP_SELF'].'?item='.$anchor.'&order='.$neworder.$preserveidr.'" class="WhiteTableLink">';
			$linkend = '</a>';
		} else {
			$linkstart='<a href="#" onclick="'.$ajaxfunction.'(\''.$anchor.'\',\''.$neworder.'\')" class="WhiteTableLink">';
			$linkend = '</a>';
		}
	} else {
		$linkstart='';
		$linkend = '';
	}
	echo "<th class=\"".$class."\">".$linkstart.ucfirst($anchor).$linkend."</th>\n";
}


function startdatatable($id='') {
	echo '<table align="center" cellspacing="5" border="0" width="100%" class="datatable"'.($id!='' ? 'id="'.$id.'"' : '').'>';
}

function closetable() {
	echo '</table>';
}

function fieldnamecell($value) {
echo '<td align="right" class="datacell">'.$value.'</td>';
}

function itemdisplay($b,$c="datacell") {
	if($b == null){echo "\n<td class=\"".$c."\">&nbsp;</td>";} else {echo "\n<td class=\"".$c."\">".$b."</td>";}
}


function display_property_block($homeid) {
	global $settings;
	$thishome = new home;
	$thishome->initialize($homeid);
	$propertylink = $thishome->get_property_link($settings['url_trail'],'showlisting/');
	$return = '<div class="col-md-12">';
	$return .=  $thishome->get_main_image(420, 280, 'noimage.jpg', array('img-thumbnail', 'img-responsive'));
		$return .= '<h4 class="text-center">'.$thishome->address.'</h4>';
		$return .= '<h5 class="text-center">'.$thishome->areacity.'</h5>';
		$return .= '<p class="text-center lead success"><big><strong>'.$thishome->price.'</strong></big></p>';

		$return .=  '<p>Bedrooms: '.$thishome->bedroom.', Bathrooms: '.$thishome->bathroom.'<br />Size: '.$thishome->sqft.($thishome->lot!='' ? '&nbsp;&nbsp;&nbsp;Lot: '.$thishome->lot: '');

		if($thishome->building) {
			$return .=  '<br /><strong>'.$thishome->bldg->name.'</strong> <a href="admin_modbuilding.php?idr='.$thishome->bldg->id.'&mode=modify" target="_blank">[edit building]</a>';
		}

		$return .= '<br />[<a href="'.$propertylink.'" target="_blank">view property page</a>]';


		$return.= '<a href="'.generateQrCode($thishome->get_property_link($settings['url-trail'])).'" target="_blank">'.display_ui_icon('QRcode.png').'</a>';
		if($thishome->source==0) {
			$return .=  '<a href="admin_modprod.php?idr='.$thishome->id.'&mode=modify">'.display_ui_icon('Edit.png').'</a>';
		} else {
			$return .= 'MLS&reg; Feed Listing';
		}

		$return .= '<select id="listing_feature_'.$thishome->id.'" class="listing_feature_toggle" rel="'.$thishome->id.'">
			<option value="0">Not Featured</option>
			<option value="1" '.($thishome->feature==1 ? ' selected="selected"':'').'>Featured</option>
		</select>';

	$return.='</div>';

	return $return;
}

/**
 * display_page_block for 2023 upgrade
 * @param $pages
 * @param int $level
 * @param int $parent
 * @param bool $parent_last_elem
 * @return void
 */
function list_pages_2023($pages, int $level = 0, int $parent = 0, bool $parent_last_elem = false): void {
    if (!is_array($pages)) return;  // no child ... return

    $top_page = $level == 0;

    // collapse div wrapper
    if (!$top_page) {
        $last_collapse = $parent_last_elem ? 'last_collapse_elem' : '';
        $rel = $parent ? "rel='$parent'" : '';
        echo "<div class='$last_collapse level_$level collapse_wrapper collapse' id='collapse_$parent' $rel>";
    }

    // loop through pages list
    foreach ($pages as $page_id => $page_data):
        $each_page = new page;
        $each_page->initialize($page_id);
        $last_element_bool = $page_id === array_key_last($pages) || $level == 0; // the collapse for level 0 (top parent) is also considered "last collapse elem"
        $has_children = is_array($each_page->children);

        $font_weight = 500 - $level * 100;
        $page_display_title = $each_page->menu_title ?: $each_page->title;

        $child_page_class   = (!$top_page) ? ' child_list' : '';
        $hidden_class       = $each_page->publish == 0 ? ' hidden_list' : '';
        $last_element_class = $last_element_bool ? ' last_elem' : '';
        $embedded_class     = ($each_page->embedded) ? ' embedded_page' : '';

        // overall wrapper for each top parent div
        if ($top_page || $has_children) {
            $top_list_class = $top_page ? 'top_list' : '';
            echo "<div id='page_$each_page->id' class='brixwork_list_wrapper $top_list_class'>";
        }
        ?>

        <div id="page_<?=$each_page->id?>" class="each_list<?=$child_page_class?><?=$hidden_class?><?=$last_element_class?><?=$embedded_class?>" data-level="<?=$level?>">
            <div class="expand_toggle">
                <?php
                if ($has_children)
                    echo '<a class="collapse_control collapsed" href="#collapse_'.$each_page->id.'" data-bs-toggle="collapse" aria-expanded="false" aria-controls="collapse_'.$each_page->id.'"><i class="bi bi-plus-circle-fill"></i></a>';
                ?>
            </div>

            <?php // PAGE TITLE ?>
            <h5 class="each_list__title" style="font-weight: <?=$font_weight?>"><?=login_level_check(USER_LOGIN_BRIXWORK) ? '[ID: '.$each_page->id.'] ' : ''?><?=$page_display_title?></h5>

            <div class="each_list__functions_wrapper">
                <?php
                if ($_REQUEST['brix_view'] == 1 && is_countable($each_page->parents)) {
                    echo '<div class="col-md-1">';
                    echo '<input type="text" name="page_parent" id="page_parent_'.$each_page->id.'" rel="'.$each_page->id.'" data-change="page_parent" class="form-control input-sm trim_input change_page_parent" value="'.$each_page->parents[count($each_page->parents)-1].'" placeholder="par" />';
                    echo '</div>';
                }

                // add subpage button
                if ($each_page->breed || $_REQUEST['brix_view'] == 1)
                    echo '<a href="pages_mod.php?mode=new&parent='.$each_page->id.'"  class="btn btn-admin grey_teal each_list__btn mx-0"><i class="bi bi-plus-lg"></i>Add Subpage</a>';
                ?>
                <?php
                if ($level !== 0 || $_REQUEST['brix_view'] == 1)
                    echo "<button class='btn btn-admin reddish each_list__btn each_list__delete mx-0' value='$each_page->id'>Delete</button>"
                ?>
                <a href="pages_mod.php?idr=<?=$each_page->id?>&mode=modify" class="btn btn-admin light_blue each_list__btn mx-0 px-4">Edit</a>
                <select aria-label="Page Publish Status" class="form-select page_publish_toggle" rel="<?=$each_page->id?>">
                    <option value="0" <?=$each_page->publish == 0 ? 'selected' : ''?>>Hide</option>
                    <option value="1" <?=$each_page->publish == 0 ? '' : 'selected'?>>Show</option>
                </select>

                <div class="each_page__img_wrapper d-none d-lg-block">
                    <?php
                    if ($main_img = $each_page->get_main_images_path(0, false, false)) {
                        echo "<img src='$main_img' class='page_hover_image_trigger' alt='$each_page->title main image'>";
                    }
                    ?>
                </div>
            </div>
        </div>

        <?php
        list_pages_2023($each_page->children, $level + 1, $each_page->id, $last_element_class);

        if ($top_page || $has_children) // close div "brixwork_page_wrapper
            echo '</div>';
    endforeach;

    if ($level != 0) // close child collapse <div class="collapse_wrapper">
        echo '</div>';
}

/**
 * LOOKS FOR SIBLING ID ... RETURN FALSE IF NONE.
 * @param $parent_page      page
 * @param $current_page_id  int
 * @return int|string|bool
 */
function find_siblings_2023(page $parent_page, int $current_page_id): int|string|bool {
    $prev_id = '';
    foreach ($parent_page->children as $child_id => $child_page) {
        if ($current_page_id === $child_id) {
            return $prev_id ?: $child_id;
        }
        $prev_id = $child_id;
    }
    return $prev_id ?: false;
}

function display_page_block($pages, $toppid=0, $depth=0, $skipcontainer=false, $parent_breed = false, $brix_view = false) {
	if($depth>0) {
		// adjust left padding & font size to show hierarchy as you cascade downwards!
		$padding_left=(20*$depth).'px';
		$font_size = (18-$depth).'px';
	} else {
		$padding_left = '0px';
		$font_size = '18px';
	}

	if($skipcontainer!==true) {
		echo '<div class="col-md-12 pages_set depth_'.$depth.'" id="pages_'.$toppid.'" rel="'.$toppid.'" data-depth="'.$depth.'">';
	}

	foreach ($pages as $pagearray) {
		$thispage = new page;
		$thispage->initialize($pagearray['id']);

		$addclass = '';

		if($pagearray['embedded']==1) {
			$addclass .= ' page_embedded';
		}

		if($pagearray['publish']==1) {
			$addclass .= ' page_publish';
		}

		//variable to override if statements to always show delete and add subpage buttons.
		$brix_view = ( ($brix_view == 1 || $brix_view ) && $_COOKIE['username'] == 'brixwork' ? true : false);

		echo '<div class="row pages_row '.$addclass.'" id="page_'.$pagearray['id'].'" rel="'.$depth.'">';

		echo '<div class="col-md-4 col-sm-6"><p style="padding-left: '.$padding_left.'; font-size: '.$font_size.';">'
			.(is_array($pagearray['children']) ? '<a rel="'.$pagearray['id'].'" class="btn btn-default btn-xs pages_toggle" id="pages_toggle_'.$pagearray['id'].'"><span class="glyphicon glyphicon-plus"></span></a>' : '<a class="btn btn-default btn-xs disabled"><span class="glyphicon glyphicon-plus"></span></a>').
			'&nbsp;&nbsp;<span class="pages_title"'.($pagearray['menu_title']!=$pagearray['title'] ? ' data-toggle="tooltip" data-placement="bottom" title="'.$pagearray['title'].'"' : '').'>'.($pagearray['menu_title']!='' ? $pagearray['menu_title'] : $pagearray['title']).' <small>(ID: '.$pagearray['id'].')</small></span>'.
			($pagearray['breed'] || $brix_view ? '&nbsp;&nbsp;<a href="pages_mod.php?mode=new&parent='.$pagearray['id'].'" style="margin-left: '.$padding_left.';" class="btn btn-primary btn-xs"><span class="glyphicons glyphicon-plus"></span>Add Subpage</a>' : '').
			'</p></div>';

		echo '<div class="col-md-6 col-sm-4 col-xs-12 form-inline pages_functions">';
			echo '<div class="row">';
				echo '<div class="col-sm-8 col-xs-6">
					<p style="font-size: '.$font_size.';">
					<a class="btn btn-primary btn-sm" href="mainimage.php?idr='.$pagearray['id'].'&folder=pages"><span class="glyphicon glyphicon-picture hidden-xs"></span>&nbsp;&nbsp;Images</a>&nbsp;
					<a class="btn btn-primary btn-sm" href="attach.php?idr='.$pagearray['id'].'&folder=pages"><span class="glyphicon glyphicon-tags hidden-xs"></span>&nbsp;&nbsp;Attach</a>&nbsp;
					<a class="btn btn-primary btn-sm" href="gallery.php?idr='.$pagearray['id'].'&folder=pages"><span class="glyphicon glyphicon-camera hidden-xs"></span>&nbsp;&nbsp;Gallery <span class="badge">'.($thispage->photos ? count($thispage->photos) : '0').'</span></a>&nbsp;
					<a class="btn btn-default  btn-sm" href="pages_mod.php?idr='.$pagearray['id'].'&mode=modify"><span class="glyphicon glyphicon-pencil hidden-xs"></span>&nbsp;&nbsp;Edit</a>&nbsp;
					'.(($depth>0 && $parent_breed) || $brix_view ? '<a class="btn btn-danger btn-sm page_delete" href="#" rel="'.$pagearray['id'].'"><span class="glyphicon glyphicon-minus"></span></a>' :'');
				echo '</div>';
				switch ($pagearray['publish']) {
					case 0:
					$hiddenselected = ' selected';
					$publishedselected = '';
					break;

					case 1:
					$hiddenselected = '';
					$publishedselected = ' selected="selected"';
					break;
				}
				echo '<div class="col-sm-4 col-xs-6">';
					echo '
						<p style="font-size: '.$font_size.';">
						<select class="form-control input-xs page_publish_toggle '.$selectclass.'" rel="'.$pagearray['id'].'">
						<option value="0"'.$hiddenselected.'>Hide</option>
						<option value="1"'.$publishedselected.'>Show</option>
						</select>
						</p>
					'; // publish toggle
				echo '</div>';
			echo '</div>';
		echo '</div>'; // end of .pages_functions
/*

		// display main image pif possible
		$not_empty = true;
		if (is_array($thispage->topimage)) {
			$not_empty = false;

			if ($thispage->topimage[0] !== false){ $not_empty = true; ;}
			if ($thispage->topimage[1] !== false){ $not_empty = true; ;}
			if ($thispage->topimage[2] !== false){ $not_empty = true; ;}
		}
*/

		if($thispage->get_main_images_path(0, false, false)) {
			echo '<div class="col-md-1 hidden-sm hidden-xs page_image_container">';
			echo '<a href="#" class="page_hover_image_trigger"><img src="'.$thispage->get_main_images_path(0, false, false).'" class="img-responsive" />';
			echo '<img src="'.$thispage->get_main_images_path(0, false, false).'" class="page_hover_image_trigger_display" /></a>';

			echo '</div>';
		} else {
			echo '<div class="col-md-1 hidden-sm hidden-xs">&nbsp;</div>';
		}

		if ($brix_view && is_countable($thispage->parents)) {
			echo '<div class="col-md-1">';
			echo '<input type="text" name="page_parent" id="page_parent_'.$thispage->id.'" rel="'.$thispage->id.'" data-change="page_parent" class="form-control input-sm trim_input change_page_parent" value="'.$thispage->parents[count($thispage->parents)-1].'" placeholder="par" />';
			echo '</div>';
		}

		if(is_array($pagearray['children'])) {
			// loop again, this has subpages!
			display_page_block($pagearray['children'], $pagearray['id'], $depth+1, false, $pagearray['breed'], $brix_view);
		}
		echo '</div>';// end of .pages_row
	}

	if($skipcontainer!==true) {
		echo '</div>';// end of .pages_set
	}
}


function display_feature_row($id, $label, $checked=false) {
	?>
	<div class="row" id="bfeature_<?=$id?>" data-id="<?=$id?>">
		<div class="col-sm-11 col-sm-offset-1 col-xs-10 col-xs-offset-2 d-flex">
			<div class="checkbox">
				<input type="checkbox" name="features[]" value="<?=$id?>" rel="<?=$id?>" id="feature_<?=$id?>"<?=($checked===true ? 'checked="checked"' : '')?>/>
				<label class="orderhandle" for="feature_<?=$id?>"><?=$label?></label>
			</div>
            <div class="remove">
                <a class="remove_feature" href='#' data-id="<?=$id?>" rel="<?=$id?>">Delete</a>
            </div>
		</div>
	</div>
	<?
}

/**
 * FEATURE DISPLAY WRAPPER
 * @param $object           object  which object is using this function? $home or $building?
 * @param $featurearray     array   Array that holds all currently available features
 * @return void
 */
function init_listing_features(object $object, array $featurearray): void { ?>
    <div id="<?=$object->objecttype?>features" class="row mx-0 mt-4">
        <?php
        $featuresdisplayed = array();

        // LOOK FOR ALREADY SELECTED FEATURES WITHIN THE HOME OBJECT -> THEN DISPLAYS ALL THAT'S SELECTED.
        if ($object->data['features']):
            if(str_contains($object->data['features'] ?: '', ',')): // catches multiple features separated by comma.
                $hfeature_array = explode(',',$object->data['features']);
            else: // either 1 feature or none
                $hfeature_array = $object->data['features'] ? array($object->data['features']) : array();
            endif;

            if(count($hfeature_array) > 0): // Display the content of the array.
                foreach($hfeature_array as $hfeature):
                    $featuresdisplayed[] = $hfeature; // mark the ones displayed already as it was part of the features, and therefore at the top of list!

                    if ($featurearray[$hfeature] == false) continue; // skip the ones without label, most likely deleted and not saved through "Save Object" button.

                    display_listing_features($hfeature, $featurearray[$hfeature], true);
                endforeach;
            endif;
        endif;

        // THEN DISPLAY THE OTHER FEATURES THAT'S NOT SELECTED .... in case home has no other features, skips to this part.
        if(count($featurearray) > 0):
            foreach ($featurearray as $featureid => $featurelabel):
                if ( !in_array($featureid, $featuresdisplayed) ): // display only the ones that's not listed above
                    display_listing_features($featureid, $featurelabel);
                endif;
            endforeach;
        endif; ?>
    </div>

    <?php // NEW FEATURE INPUT FIELD ?>
    <div id="new_feature_group" class="row mt-4">
        <div class="col-sm-6 col-lg-3">
            <input type="text" class="form-control" id="new_feature" placeholder="Type in the new feature ..." aria-label="Add a new feature"/>
        </div>
        <div class="col-sm-6 col-md-4 col-lg-3 mt-3 mt-sm-0">
            <button class="btn btn-admin mx-0 px-4" type="submit" form="new_feature_form" id="add_new_feature">Add New Feature</button>
        </div>
    </div>
<?php
}


/**
 * DISPLAYS THE FEATURES OF THE LISTING - 2023 UPGRADE
 * this function should already be wrapped by "row" ... start with col size
 * @param $id       int     id of the feature
 * @param $label    string  name
 * @param $checked  boolean already checked or not
 * @return void     html block
 */
function display_listing_features(int $id, string $label, bool $checked = false): void {
    ?>
    <div class="each_listing_feature col-xl-4 py-2 col-sm-6 form-check checkbox" id="bfeature_<?=$id?>" data-id="<?=$id?>">
        <input class="form-check-input" type="checkbox" name="features[]" value="<?=$id?>" rel="<?=$id?>" id="feature_<?=$id?>" <?=$checked ? 'checked' : ''?>>
        <label class="form-check-label orderhandle" for="feature_<?=$id?>" style="text-transform: none">
            <?=$label?>
        </label>
        <?php // Deleting building feature is only available to Manager/Admin
        if (login_level_check(USER_LOGIN_MANAGER)) { ?>
            <a class="remove_feature" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="Delete this feature - this feature will be removed from ALL listings" data-id="<?=$id?>" rel="<?=$id?>"><i class="bi bi-trash-fill"></i></a>
        <?php
        } ?>
    </div>
<?php
}


function seo_tab($object, $defaults) {
	global $settings;
?>
	<div class="row">
		<div class="col-md-6">
			<div class="form-group">
				<div class="mb-4 mt-auto">
					<label for="metatitle" class="control-label orange">Meta Title</label>
					<input type="text" name="metatitle" id="metatitle" class="form-control googlepreview_field calculate_length" value="<?=$object->data['metatitle']?>" rel="<?=$settings['metatitle_max_length']?>" />
					<div id="metatitle_length" class="alert alert-danger"></div>
				</div>

				<div class="mb-4 mt-auto">
					<label for="slug" class="control-label orange">Custom URL Slug</label>
					<input type="text" name="slug" id="slug" class="form-control trim_input googlepreview_field" value="<? echo $object->data['slug'];?>" rel="<?=$settings['url_max_length']?>">
				</div>

				<div class="mt-auto">
                    <label for="metadescription" class="control-label orange">Meta Description</label>
                    <textarea name="metadescription" id="metadescription" class="form-control googlepreview_field calculate_length" rows="4" rel="<?=$settings['metadescription_max_length']?>"><?= $object->data['metadescription'] ?></textarea>
					<div id="metadescription_length" class="alert alert-danger"></div>
				</div>

			</div>
		</div>
		<div class="col-md-6 mt-4 ps-5">
            <div class="w-50">
                <img src="images/google_logo.png" class="img-full" alt="Google Logo" />
            </div>

            <div id="googlepreview">
				<input type="hidden" id="url_root" value="<?=$defaults['url_root']?>" />
				<input type="hidden" id="objecttype" value="<?=$defaults['objecttype']?>" />
				<input type="hidden" id="sitepath" value="<?=$settings['sitepath']?>" />
				<input type="hidden" id="metatitle_default" value="<?=$defaults['metatitle_default']?>" />
				<input type="hidden" id="metadescription_default" value="<?=$defaults['metadescription_default']?>" />
				<input type="hidden" id="slug_default" value="<?=$defaults['slug_default']?>" />

				<h3><?=$defaults['metatitle_original']?></h3>
                <cite><?=$settings['url_max_length'] < strlen($defaults['url_original'] ?: '') ? substr($defaults['url_original'], 0, $settings['url_max_length']). '&hellip;' : $defaults['url_original']?></cite>
				<span><?=$defaults['metadescription_original']?></span>
			</div>
		</div>
	</div>
<?
}


/**
 * @param $name string Is the name of the field, as well as the array key name at $settings['keyname']
 * @param $value Prefilled value.. usually fill the $settings['keyname'] value since these fields display what is already in DB.
 * @param $label string <Label> tag text.
 * @param $placeholder placeholder="" attribute value to describe what it is.
 * @param $firstdivclass First div is the <label> container. col-md-5 etc. can be set to denote width and other CSS elements.
 * @param $seconddivclass Second div is the <input> container. col-md-8 etc. can be set to denote width and other CSS elements.
 * @param bool $allowmultiple Allows array, so that resulting value has $settings['keyname'][0], $settings['keyname'][1] etc.
 * @param bool $adminmultiple Allows ONLY for username 'brixwork' so users cannot break it.
 * @param bool $readonly Read only mode to disallow change by user.. of course coders can override via Inspector?
 * @param string $tooltip You can pop a Bootstrap tooltip with this!
 * @return string
 */
function settings_text($name, $value, $label, $placeholder, $firstdivclass, $seconddivclass, $allowmultiple = false, $adminmultiple = true, $readonly = false, $tooltip='') {
	$return = '';

	// pre set some variables?
	$readonlyattr = ($readonly==true && $_COOKIE['username']!='brixwork' ? 'readonly="readonly"' : '');

	$return .= '<div class="'.$firstdivclass.'"><label for="'.$name.'" class="control-label '.($readonly==true ? 'opacity50' : '').'">'.$label.'</label></div>';
	$return .= '<div class="'.$seconddivclass.' settings_container" '.($tooltip!='' ? 'data-toggle="tooltip" data-placement="bottom" title="'.$tooltip.'"' : '').' id="settings_'.$name.'_container">';

	if(is_array($value)) {
		// value is array, so we display multiple rows!
		foreach($value as $count => $v) {

			if($allowmultiple==true || ($_COOKIE['username']=='brixwork' && $adminmultiple==true)) {
				$return .= '<div class="input-group bottom_10">';
				$return .= '<span class="input-group-btn "><button class="btn btn-danger remove_array_button" type="button" rel="' . $name . '" tabindex="-1">-</button></span>';
			}
			$return .= '<input class="form-control trim_input" name="'.$name.'[]" value="'.cleanupfortextfield($v).'" placeholder="'.$placeholder.'" '.$readonlyattr.' autocomplete="off" type="text" />';
			if($allowmultiple==true || ($_COOKIE['username']=='brixwork' && $adminmultiple==true)) {
				$return .= '<span class="input-group-btn "><button class="btn btn-primary add_array_button" type="button" rel="' . $name . '" tabindex="-1">+</button></span>';
				$return .= '</div>'; // end of input-group
			}

		}
	} else {
		if($allowmultiple==true || ($_COOKIE['username']=='brixwork' && $adminmultiple==true)) {
			$return .= '<div class="input-group bottom_10">';
			$return .= '<span class="input-group-btn "><button class="btn btn-danger remove_array_button" rel="'.$name.'" type="button" tabindex="-1">-</button></span>';
		}
		$return .= '<input class="form-control trim_input" name="'.$name.'[]" value="'.cleanupfortextfield($value).'" placeholder="'.$placeholder.'" '.$readonlyattr.' autocomplete="new-password" type="text" />';
		if($allowmultiple==true || ($_COOKIE['username']=='brixwork' && $adminmultiple==true)) {
			$return .= '<span class="input-group-btn "><button class="btn btn-primary add_array_button" rel="'.$name.'" type="button" tabindex="-1">+</button></span>';
			$return .= '</div>'; // end of input-group
		}
	}

	$return .= '</div>';

	return $return;
}

/**
 * PRINT THE INPUT TEXT WITH PROPER DELETE BUTTON AND ONE "ADD" BUTTON AT THE END, IF APPLICABLE.
 * Make sure to wrap with bootstrap column!
 * @param array $options    ARRAY OF OPTIONS ... REFER TO FIRST PART OF FUNCTION TO SEE WHAT'S AVAILABLE
 * @return void
 */
function settings_text_2023(array $options = array()): void {
    $name               = $options['name'] ?: false;
    $value              = $options['value'] ?: false;
    $label              = $options['label'] ?: false;
    $placeholder        = $options['placeholder'] ?: '';            // fallback value
    $disable            = $options['disable'] ?: false;
    $tooltip            = $options['tooltip'] ? 'data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-custom-class="brixwork-tooltip" data-bs-title="'.$options['tooltip'].'"' : '';

    // quick data verification ... there are some required info before building text input
    if (!$name) {
        echo "<div><p6 class='text-danger'>Critical Information Missing. Name: '$name'</p6></div>";
        return;
    }
    // name needs to be an array.
    $name_array  = $name.'[]';

    // if ALL inputs need to be disabled for whatever condition ...
    $disable_input = '';
    if ($disable) {
        $disable_input = 'disabled';
    }

    // turn value into array if it's not already
    if (!is_array($value))
        $value = array(0 => $value);

    // only print label if it exists
    if ($label)
        echo "<label for='$name' class='control-label orange'>$label</label>";

    // start the wrapper div
    echo "<div class='settings_input_wrapper' id='$name-wrapper' $tooltip>";
    foreach ($value as $key => $each_value) {
        echo "<div class='settings_each_input mb-2'>";

            if (!$disable) // only display order handle if input is not disabled
                echo "<div class='orderhandle d-none' rel='$name'><i class='bi bi-grip-vertical'></i></div>";

            echo "<input class='form-control' id='$name' name='$name_array' value='$each_value' placeholder='$placeholder' $disable_input/>";

            if (!$disable) // only display DELETE if input is not disabled
                echo "<a class='delete_setting_array d-none' rel='$name'>DELETE</a>";

        echo "</div>";
    }
    echo "</div>"; // CLOSING <div class='settings_input_wrapper' id='$name-wrapper'>

    // start button wrapper div.
    if (!$disable) {
        echo "<div class='settings_function_wrapper'>";
        echo "    <a class='btn btn-admin grey_teal edit_setting_array' rel='$name'>Edit</a>";
        echo "    <a class='btn btn-admin light_blue add_setting_array d-none' rel='$name'>Add</a>";
        echo "</div>"; // CLOSING <div class='settings_function_wrapper'>
    }
}


/**
 * SIMPLE FUNCTION TO PRINT OUT LABEL & PROPER INPUT FIELD
 * NO EXTRA FEATURES, JUST PLAIN LABEL AND TEXT FIELD.
 * @param array $options
 * @return void
 */
function admin_text_basic(array $options = array()): void {
    $name = $options['name'] ?: false;
    $label = $options['label'] ?: false;
    $value = $options['value'];
    $container_id = $options['container_id'] ?: '';
    $placeholder = $options['placeholder'] ?: '';
    $disable = $options['disable'] ? 'disabled' : '';
    $readonly = $options['readonly'] ? 'readonly' : '';
    $tooltip = $options['tooltip'] ? 'data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-custom-class="brixwork-tooltip" data-bs-title="'.$options['tooltip'].'"' : '';

    if (!$name) {
        echo "<h6 class='text-danger'>Critical Info Missing. Please check your parameter</h6>";
        return;
    }

    // for case when the name comes in as name[]... remove the [] to use as ID.
    $id = str_replace(array("[", "]"), "", $name);

    // if not array, change to array with single value ... just for display. If it is array, $name should reflect that.
    if (!is_array($value)) {
        $value = array(0 => $value);
        $multiple_spacing = '';
    }
    else {
        $name = $name.'[]';
        $multiple_spacing = 'mb-2';
    }
    ?>

    <div <?=$tooltip?> id="<?=$container_id?>">
        <?php
        if ($label)
            echo "<label for='$id' class='control-label orange'>$label</label>";

        foreach ($value as $key => $each_value) {
            $processed_val = cleanupfortextfield($each_value);
            echo "<input type='text' class='form-control $multiple_spacing' id='$id' name='$name' value='$processed_val' placeholder='$placeholder' $disable $readonly/>";
        } ?>
    </div>
<?php
}


/**
 * SIMPLE FUNCTION TO PRINT OUT LABEL & PROPER INPUT FIELD
 * NO EXTRA FEATURES, JUST PLAIN LABEL AND TEXT FIELD.
 * @param array $options
 * @return void
 */
function admin_dropdown(array $options = array()): void {
    $name = $options['name'] ?: false;
    $label = $options['label'] ?: false;
    $value = $options['value'] ?: '';
    $tooltip = $options['tooltip'] ? 'data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-custom-class="brixwork-tooltip" data-bs-title="'.$options['tooltip'].'"' : '';
    $value_variants = $options['value_variants'] ?: false;

    if (!$name || !is_array($value_variants)) {
        echo "<h6 class='text-danger'>Critical Info Missing. Please check your parameter</h6>";
        return;
    }
    ?>
    <div <?=$tooltip?>>
        <?php
        if ($label)
            echo "<label for='$name' class='control-label orange'>$label</label>"
        ?>
        <select id="<?=$name?>" name="<?=$name?>" class="form-select">
            <?php
            foreach ($value_variants as $each_value => $each_desc) {
                $selected_text = $each_value == $value ? 'selected' : '';
                echo "<option value='$each_value' $selected_text >$each_desc</option>";
            }
            ?>
        </select>
    </div>
    <?php
}


/**
 * BUILD CHECKBOX AND CHECK THE DEFAULT VALUES
 * @param array $options
 * @return void
 */
function admin_checkbox(array $options = array()): void {
    $name = $options['name'] ?: false;
    $value = $options['value'] ?: '';
    $tooltip = $options['tooltip'] ? 'data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-custom-class="brixwork-tooltip" data-bs-title="'.$options['tooltip'].'"' : '';
    $value_variants = $options['value_variants'] ?: false;
    $label_class = $options['label_class'] ?: false;

    $name_array = $name.'[]';

    if (!is_array($value))
        $value = array(0 => $value);

    echo "<div $tooltip class='row'>";

    foreach ($value_variants as $key => $each_value) {
        if (!$each_value) continue;
        $checked = in_array($key, $value) ? 'checked' : '';
        $id = $name.'_checkbox_'.$key;

        echo "<div class='col-lg-3 col-sm-6 mb-3'>";
        echo "    <div class='form-check checkbox' id='$id'>";
        echo "        <input class='form-check-input' type='checkbox' id='$id' name='$name_array' value='$key' $checked/>";
        echo "        <label class='form-check-label' for='$id' $label_class>$each_value</label>";
        echo "    </div>";
        echo "</div>";
    }
    echo "</div>";
}


/**
 * BUILDS A SWITCH FOR SETTINGS PAGE
 * @param array $options    ARRAY OF OPTIONS ... REFER TO FIRST PART OF FUNCTION TO SEE WHAT'S AVAILABLE
 * @return void
 */
function admin_switch(array $options = array()): void {
    $name = $options['name'] ?: false;
    $value = $options['value'] ?: 0;
    $label = $options['label'] ?: false;
    $spacing = $options['spacing'] == 'auto' ? 'my-auto' : 'mt-3 mb-2';
    $tooltip = $options['tooltip'] ? 'data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-custom-class="brixwork-tooltip" data-bs-title="'.$options['tooltip'].'"' : '';

    $checked = $options['value'] == 1 ? 'checked' : '';
    ?>
    <div class="form-check form-switch <?=$spacing?>">
        <input type="hidden" name="<?=$name?>" value="0">
        <input class="form-check-input admin_switch" role="switch" type="checkbox" value="<?=$value?>" name="<?=$name?>" id="<?=$name?>" <?=$checked?> >
        <label class="form-check-label orange m-0" for="<?=$name?>" <?=$tooltip?>><?=$label?></label>
    </div>
    <?php
}


/**
 * create row with multiple input fields each with different name
 * REQUIRES A HIDDEN INPUT FIELD THAT KEEPS COUNT OF HOW MANY INPUTS
 * @param array $options
 * @return void
 */
function admin_multi_input(array $options = array()): void {
    $row_name       = $options['row_name'] ?: false;    // name of each row, will be appended with key number
    $name_array     = $options['name_array'] ?: false;  // required
    $value_array    = $options['value_array'] ?: false; // most of the time, it's just $settings['$name_array[key]']
    $counter_id     = $options['counter_id'] ?: false;  // id of the hidden counter div.
    $counter        = $options['counter'] ?: 0;         // required
    $input_class    = $options['input_class'] ?: false; // array of class names for each input field in a row.
    $tooltip        = $options['tooltip'] ?: false;
    $placeholder    = $options['placeholder'] ?: '';


    if (!$name_array) {
        echo "<p>Critical Info Missing, Please check parameters.</p>";
    }

    // wrapper to append the new row on javascript click for "ADD"
    $row_name_wrapper = $row_name.'_wrapper';
    echo "<div class='settings_multi_input_wrapper' id='$row_name_wrapper'>";

    // loop as many times as "counter" and print row of input fields
    for ($row_num = 0; $row_num < intval($counter); $row_num++) {
        echo "<div class='settings_multi_input mb-3' id='$row_name'>";

        // print each input field
        foreach ($name_array as $key => $each_name) {
            $db_name_array = $each_name.'[]';
            $each_name_class = $input_class[$key];
            $tooltip_html = $tooltip[$key] ? "data-bs-toggle='tooltip' data-bs-placement='bottom' data-bs-custom-class='brixwork-tooltip' data-bs-title='$tooltip[$key]' " : false;
            $value = $value_array[$key][$row_num] ?? $placeholder;
            echo "<input class='form-control $each_name_class' id='$each_name' name='$db_name_array' value='$value' aria-label='$row_name' $tooltip_html/>";
        }

        echo "<a class='multi_input__delete' rel='$counter_id'>DELETE</a>";
        echo "</div>";
    }

    echo "</div>"; // end of <div class='settings_multi_input_wrapper'>

    // for adding, simply copy html with corresponding ID and set value to empty.
    echo "<a class='btn btn-admin light_blue multi_input__add' data-name='$row_name' data-counter-id='$counter_id'>Add</a>";
}


/**
 * 2023 Upgrade for function settings_textarea
 * @param array $options
 * @return void
 */
function admin_textarea(array $options = array()) : void {
    $name = $options['name'] ?: false;
    $value = $options['value'];
    $label = $options['label'] ?: false;
    $class = $options['class'] ?: false;
    $rows = $options['rows'] ?: 1;
    $placeholder = $options['placeholder'] ?: false;
    $tooltip = $options['tooltip'] ? 'data-bs-toggle="tooltip" data-bs-placement="bottom" data-bs-custom-class="brixwork-tooltip" data-bs-title="'.$options['tooltip'].'"' : '';

    if (!$name)
        echo "<p>Critical Info Missing, Please check your parameter</p>";


    if ($label)
        echo "<label for='$name' class='control-label orange'>$label</label>";

    if ($tooltip)
        echo "<div $tooltip>";

    echo "<textarea class='form-control $class' id='$name' name='$name' rows='$rows' placeholder='$placeholder'>$value</textarea>";

    if ($tooltip)
        echo "</div>";
}


function custom_settings_text($name, $value, $editable = null, $id = null) {
	$return = '';
	$brix = ($_COOKIE['username']=='brixwork');
	$readonlyattr = ($_COOKIE['username']!='brixwork' ? 'readonly="readonly"' : '');

	if ($editable == 0 && !$brix) {
		//not showing non editable rows to clients!
		return false;
	}

	$return .= '
            <div class="input-group bottom_10" style="width: 100%">
            	<input name="id[]" value="'.$id.'" style="display: none" />
            	'.($brix && false ? '
	            <span class="input-group-btn ">
	            	<button class="btn btn-danger remove_array_button" type="button" rel="type" tabindex="-1">-</button>
	            </span>
            	' : '' ).'	            
				<div class="col-md-4">
					<input class="form-control trim_input sett_name" name="name[]" value="'.$name.'" placeholder="" autocomplete="off" '.($brix?'':'readonly').' />
				</div>
				<div class="col-md-'.($brix?'7':'8').'">
					<input class="form-control trim_input" name="value[]" value="'.$value.'" placeholder="" autocomplete="off" />
				</div>
				<div class="col-md-1" '.($brix?'':'style="display: none"').'>
					<input class="form-control trim_input" name="editable[]" value="'.($editable!==null?$editable:0).'" placeholder="" autocomplete="off" />
				</div>				
            	'.($brix ? '
                <span class="input-group-btn ">
                	<button class="btn btn-primary add_array_button" type="button" rel="type" tabindex="-1">+</button>
                </span>
            	' : '' ).'
            	<div class="clear"></div>                
			</div>';

	return $return;
}

function settings_textarea($name, $value, $label, $firstdivclass, $seconddivclass, $readonly = false, $rows = 10, $tooltip='') {
	$return = '';

	// pre set some variables?
	$readonlyattr = ($readonly==true && $_COOKIE['username']!='brixwork' ? 'readonly="readonly"' : '');

	$return .= '<div class="'.$firstdivclass.'"><label for="'.$name.'" class="control-label">'.$label.'</label></div>';
	$return .= '<div class="'.$seconddivclass.' settings_container" '.($tooltip!='' ? 'data-toggle="tooltip" data-placement="bottom" title="'.$tooltip.'"' : '').' id="settings_'.$name.'_container">';


	$return .= '<textarea class="form-control" name="'.$name.'" rows="'.$rows.'" '.$readonlyattr.' >'.$value.'</textarea>';


	$return .= '</div>';

	return $return;
}

function settings_select($name, $value, $options, $label, $selecttext, $firstdivclass, $seconddivclass, $allowmultiple = false, $readonly = false, $tooltip='') {
	$return = '';

    if($selecttext=='' || !isset($selectedtext)) {
		$selecttext = false;
    }

	// pre set some variables?
	$readonlyattr = ($readonly==true && $_COOKIE['username']!='brixwork' ? 'disabled="disabled"' : '');

	$return .= '<div class="'.$firstdivclass.'"><label for="'.$name.'" class="control-label">'.$label.'</label></div>';
	$return .= '<div class="'.$seconddivclass.' settings_container"  '.($tooltip!='' ? 'data-toggle="tooltip" data-placement="bottom" title="'.$tooltip.'"' : '').'  id="settings_'.$name.'_container">';

	// value is array, so we display multiple rows!
	$return .= '<select '.($allowmultiple==true ? 'multiple' : '').' class="form-control" name="'.$name.($allowmultiple==true ? '[]' : '').'" '.$readonlyattr.'>';
	if($selecttext!==false && $selecttext!='') {
		// dummy row that asks to choose..
		$return .= '<option value="">'.$selecttext.'</option>';
	}
	foreach($options as $id=>$option) {
		if( (is_array($value) && in_array($id, $value)) || $id==$value) {
			$selectedtext = 'selected="selected"';
		} else {
			$selectedtext = '';
		}
		$return .= '<option value="'.$id.'" '.$selectedtext.'>'.$option.'</option>';
	}

	$return .= '</select>';


	$return .= '</div>';

	return $return;
}

function settings_checkbox($name, $value, $options, $label, $firstdivclass, $seconddivclass, $allowmultiple = true, $readonly = false, $tooltip='', $skipblank = false) {
	$return = '';

	// pre set some variables?
	$readonlyattr = ($readonly==true && $_COOKIE['username']!='brixwork' ? 'disabled="disabled"' : '');
	$readonlyclass = ($readonly==true && $_COOKIE['username']!='brixwork' ? 'disabled' : '');
	$inputtype = ($allowmultiple ? 'checkbox' : 'radio');
	$inputbracket = ($allowmultiple ? '[]' : '');

	$return .= '<div class="'.$firstdivclass.'"><label for="'.$name.'" class="control-label '.($readonly==true ? 'opacity50' : '').'">'.$label.'</label></div>';
	$return .= '<div class="'.$seconddivclass.' settings_container"  '.($tooltip!='' ? 'data-toggle="tooltip" data-placement="bottom" title="'.$tooltip.'"' : '').'  id="settings_'.$name.'_container">';

	// value is array, so we display multiple rows!
	// $return .= '<select '.($allowmultiple==true ? 'multiple' : '').' class="form-control" name="'.$name.($allowmultiple==true ? '[]' : '').'" value="'.$v.'" placeholder="'.$placeholder.'" '.$readonlyattr.'>';

	foreach($options as $id=>$option) {
		if($skipblank==true && $option=='') continue; // skip blanks
		if((is_array($value) && in_array($id, $value) )|| $id==$value) {
			$selectedtext = ' checked="checked"';
		} else {
			if($readonly==true && $_COOKIE['username']!='brixwork') {
				$selectedtext = ' disabled';
			} else {
				$selectedtext = '';
			}
		}
		$return .= '<div class="'.$inputtype.' '.$readonlyclass.'">
                        <input type="'.$inputtype.'" id="'.$name.'_checkbox_'.$id.'" name="'.$name.$inputbracket.'" value="'.$id.'" '.$selectedtext.' />
                        <label for="'.$name.'_checkbox_'.$id.'">'.($option!='' ? $option : '(Blank)').'</label>
                    </div>';
	}

	$return .= '</div>';

	return $return;
}


function set_gallery_photo_filename($params) {
	$prefix = ($params['prefix']!='' ? $params['prefix'] : 'gallery_photo'); // default is gallery_photo but hopefully this never happens.
	$number = ($params['number']!='' ? $params['number'] : 0); // photo # what? Gallery sequence matters.
	$digits = ($params['digits']!='' &&  $params['digits']>0 ? $params['digits'] : 2); // for the most part 2 digits is fine. Cannot be 0 digits. impossible.
	$ext = (isset($params['ext']) && $params['ext']!='' ? $params['ext'] : 'jpg'); // photo # what? Gallery sequence matters.

	if($digits==1) {
		$number_display = $number.""; // pass the raw number without manipulation but force string.
	} else if($digits>1) {
		$number = "".$number; // force number to string first.
		$zeros = $digits - strlen($number); // how many zeros to add?
		$zerocount = 0;
		$number_display = ""; // start with blank.
		while($zerocount<$zeros) {
			$number_display = $number_display."0"; // add zeros.
			$zerocount++;
		}
		$number_display = $number_display.$number; // add it to end to make it 02, 03 etc.
	}

	$return = url_format($prefix.'-'.$number_display).'.'.$ext;

	return $return;
}


function attach_gallery_image($destinationfolder, $idr, $file_name, $file_tmp, $file_title='', $timestamp = 0) {
	// this file is used for gallery images that dupilcate itself into web/ original/ /mobile etc.,
	// for attaching other files such as .pdf floroplans, main.jpg for main image, look below for attach_files() below.
	global $settings;
	global $local;
	global $now;
	global $mysqli;
	global $handle;

	if($destinationfolder!='' && $idr!='' && $file_tmp!='' && $file_name!='') {
		$photorefcolumn = substr($destinationfolder, 0, strlen($destinationfolder)-1); // remove the s from the folder tables, as it references to the `home` or `building` columns of the `photos` table.

		$S3Path = getS3FilePath( $settings, $idr, $destinationfolder );

		$file_path = $S3Path.'/mobile/';
		$file_name = sanitize_filename_for_s3_and_return($settings['s3_bucket'], $file_path, $file_name);
		if($file_title=='') {
			// If not given, use filename without extention (assume these are all JPGs by now thanks to sanitize_filename_for_s3_and_return();
			$file_title = $mysqli->real_escape_string(str_ireplace('.jpg', '', $file_name)); // clean up file title so the .jpg doesn't become part of it by default.
		} else {
			$file_title = $mysqli->real_escape_string(trim($file_title));
		}

		$source_file_path = $file_tmp;

		$uploadresults = CheckPathAndUploadFile( $settings, $idr, $destinationfolder, $source_file_path, $file_name, $settings['s3_bucket'], true ); // found in /includes/s3/utils.php for reference, internal function written by Steven Stark.
		$query = "SELECT MAX(ord) AS `maxord` FROM `photos` WHERE `".$photorefcolumn."`='".$idr."'";
		$result = $mysqli->query($query);
        if($result->num_rows==0) {
            $nextord = 0.0;
        } else {
            $lastphoto = $result->fetch_assoc();
            $nextord = $lastphoto['maxord']+1;
        }

        if(is_url($source_file_path)) {
			// if its full URL rather than locally uploaded JPG, save it?
			// This will only be used for the few MLS distributions suh as viva.brixwork.com etc. that get cloud URL of images fed in.
			$url = $file_tmp;
			$s3 = 0;
		} else {
			$url = '';
			$s3 = 1;
		}

		$sql = "INSERT INTO `photos` (`".$photorefcolumn."`, `filename`, `title`,`ord`,`s3`, `url`, `timestamp`) VALUES ('".$idr."','".$file_name."','".$file_title."','".$nextord."', '".$s3."', '".$url."', '".($timestamp>0 ? $timestamp : $local)."')";

        if(!$mysqli->query($sql)) {
			$mysql_result = array('success'=>false, 'message'=>$mysqli->error);
        } else {
            $mysql_result = array('success'=>true, 'message'=>$mysqli->insert_id);
        }

        $result = array(
            'photoupload'=>$uploadresults, // should contain 4 arrays for original, web, mobile & thumb uploaded result URLs.
            'mysql_insert'=>$mysql_result
        );

		return $result;
	} else {
		return false;
	}
}

function attach_files($destinationfolder, $idr, $filename, $filedata) {
	/*
	 * This funtion attaches main images, pdfs etc. - not to be confused with gallery population function attach_gallery_image();
	 *
	 * */
	// $_REQUEST['destinationfolder']
	// $_REQUEST['idr']
	// $_REQUEST['filename']
	// $_FILES['Filedata']
	global $settings;
	global $local;
	global $now;
	global $mysqli;

	if($filedata['name']!="" && $destinationfolder!='' && is_numeric($idr)===true) {

		$file = pathinfo($filename);
		$ext  = strtolower($file['extension']);
		if( !isset( $ext ) || ( $ext === '' ) ) {
			$ext = 'jpg';
		}

		$localModifiedFilePath = $_SERVER['DOCUMENT_ROOT']."/tmp/s3_temp_modified_".$idr.".{$ext}";

		if($ext=='jpg' || $ext=='jpeg' || $ext=='png' || $ext=='gif') {
			// it's an image, we may must crop/resize then upload.
			$imagedata = getimagesize($filedata['tmp_name']);
			$width = $imagedata[0]; // get width / height of the actual image from temp file.
			$height = $imagedata[1];

			$widthratio = $_REQUEST['minwidth'] / $width;
			$heightratio = $_REQUEST['minheight'] / $height;

			$targetratio = $_REQUEST['minwidth']/$_REQUEST['minheight'];
			$givenratio = $width/$height;

			$targetwidth = $width; // by default, just set targetwidth of the image to the width.
			write_log("Requires: ".$_REQUEST['minwidth']." X ".$_REQUEST['minheight'].".\r\n");
				if($width<$_REQUEST['minwidth'] || $height<$_REQUEST['minheight']) {
				// photo width or height falls short of what is required. Need to expand it, even if it pixelates. Just tell customers to NOT use small photos... easy enough.
				write_log("photo width or height falls short of what is required. Need to expand it, even if it pixelates. File: ".$width." X ".$height.".\r\n");

				if($width<$_REQUEST['minwidth'] && $height<$_REQUEST['minheight']) {
					// both width & height are short... figure out what needs to increase more, width or height, and base it off of that.
					write_log("both width & height (".$width." X ".$height.") are short... figure out what needs to increase more, width or height, and base it off of that..\r\n");
					if($widthratio >= $heightratio) {
						// width falls short more. If the width is set to the minwidth, then height will automatically exceed minheight.
						write_log("width falls short more. If the width is set to the minwidth, then height will automatically exceed minheight .\r\n");
						$targetwidth = $_REQUEST['minwidth'];
					} else {
						// height falls short more. Set the width to the ratio of the targetheight/fileheight
						write_log("height falls short more. Set the width to the ratio of the targetheight/fileheight.\r\n");
						$targetwidth = $_REQUEST['minwidth'] * $heightratio;
					}
				} else if($width<$_REQUEST['minwidth']) {
					// only width is shorter than target, so increase the width first then base height from it.
					write_log("only width is shorter than target, so increase the width first then base height from it. \r\n");
					$targetwidth = $_REQUEST['minwidth'];
				} else {
					// only height is shorter than target, so increase the height first then base width from it.
					write_log("only height is shorter than target, so increase the height first then base width from it. \r\n");
					$targetwidth = $_REQUEST['minwidth'] * $heightratio;
				}
			} else {
				// sizes fine as is!
				$targetwidth = $width;
			}
			write_log("Final Target Width: ".$targetwidth." \r\n");

			resize_image($filedata['tmp_name'],$localModifiedFilePath,$targetwidth, '', false, true); // write to to temporary file.
			$results = CheckPathAndUploadFile( $settings, $idr, $destinationfolder, $localModifiedFilePath, $filename, $settings['s3_bucket'], false ); // found in /includes/s3/utils.php for reference, internal function written by Steven Stark.
			$object_url = $results[0]['file']['ObjectURL']; // this was tagged as 'file'

			$checkattachments = check_s3_attachments($destinationfolder, $idr, 'mainphoto'); // update the attachment check on the mysql table based on what's been recently attached. Also updates the modify_date of the object.

			// updating the home/building/page object's timestamp in order to force a recache on cloudfront via
			// ?timestamp=xxxxx is done at the ajax_cropimage.php level so we skip it.
		} else {
			// NOT an image, probably a PDF attachment of sorts?
			$url = $filedata['tmp_name'];
			$results = CheckPathAndUploadFile( $settings, $idr, $destinationfolder, $url, $filename, $settings['s3_bucket'], false );
			$object_url = $results[0]['file']['ObjectURL']; // this was tagged as 'file'

			$checkattachments = check_s3_attachments($destinationfolder, $idr, 'pdf'); // update the attachment check on the mysql table based on what's been recently attached. Also updates the modify_date of the object.

		}
		if(file_exists($localModifiedFilePath)) {
			unlink($localModifiedFilePath);
		}

		// print_r($checkattachments);
		$return =  $object_url;

	} else {
		$error = "Not enough variables. Folder: {$destinationfolder}, ID: {$idr}, Filename:  {$filename}, ".gettype($filedata).", Filesize: ".filesize($filedata['tmp_name'])."\r\n";
		$return = $error;
	}

	return $return;
}

/*
 * Function to get list of photos from common RETS (phRETS based) systems.
 * */
function rets_get_photos($params, &$rets) {

	$sysid = ($params['sysid']!='' ? $params['sysid'] : false);
	$home_id = ($params['idr']!='' ? $params['idr'] : false); // not really used in this function but need to log.
	$object_ids = (isset($params['object_ids']) ? $params['object_ids'] : false);
	$location_only = (isset($params['location_only']) ? $params['location_only'] : false);
	$photoobject = (isset($params['photoobject']) && $params['photoobject'] !='' ? $params['photoobject'] : "Photo");

	write_log("Fetch RETS photos for  ".$home_id." with sysid ".$sysid.":\r\n");

	if(is_object($rets)) {
		try {
			if ($object_ids != false && $location_only != false) {
				$result = $rets->GetObject("Property", $photoobject, $sysid, $object_ids, $location_only);
			} else if ($object_ids != false && $location_only == false) {
				$result = $rets->GetObject("Property", $photoobject, $sysid, $object_ids);
			} else if ($object_ids == false && $location_only != false) {
				$result = $rets->GetObject("Property", $photoobject, $sysid, "*", $location_only);
			} else {
				// default for the oldest.
				$result = $rets->GetObject("Property", $photoobject, $sysid);
			}
		} catch (Error $e) {
			// Handle the error or log it
			$error_info = $e->getMessage();
			$result = false;
		}

		$returnarray = array();

		if(is_countable($result) && $result[0]->isError()!==true) {
			foreach($result as $pcount => $photo) {
				// rebuilt the $photos var.
				$array = array();
				if(method_exists($photo,'getObjectId')) {
					// Newer version of PHRETS (2.0+) that returns objects with methods, so store them in easy array.
					if($photo->isError()) {
						// failed. Return ReplyText so that rets_import_photos() can report the error.
						$array['Success'] = false;
						$error = $photo->getError();
//						$array['Content-Desc'] = $error->code.' - '.$error->message;
					} else {
						$array['Success'] = true;
						$array['Content-ID'] = $photo->getContentId();
						$array['Content-Desc'] = $photo->getContentDescription();
						$array['Object-ID'] = $photo->getObjectId();
						if($location_only=="1" && method_exists($photo, 'getLocation') ) {
							$array['URL'] = $photo->getLocation();
							// Some boards feed URLs without http(s) - add.
							if (strpos($array['URL'], '//') === 0) {
								// It starts with // so append with https?
								$array['URL'] = 'https:'.$array['URL'];
							}
						} else if(method_exists($photo, 'getContent')) {
							$array['Data'] = $photo->getContent();
						}
					}

				} else {
					// build the raw array as it is for the old phRETS version.
					$array = $photo;
				}
				$returnarray[] = $array;
			}
			$return = $returnarray;
		} else if($result === false) {
			$return = 'RETS Object call failed - maybe a temporary network glitch or packet drop. Try again?'.' - '.$error_info;
        } else {
			/*
			if first object error is true, most likely a no photo error?
			PHRETS\Models\RETSError Object
			(
				[code:protected] => 20403
				[message:protected] => No Object Found [262780847:1].
			)
			 */
			$error_info = $result[0]->getError();
			$return = $error_info->getCode().' - '.$error_info->getMessage();;
		}
	} else {
		$return = false;
	}

	return $return;

}

/**
 * Function to take photo array (most likely from rets_get_photos())
 * and localize to the `photos` table for any listing.
 *
 * @param $photos
 * @param $params - sysid, idr, address, use_external_url, rets_timestamp etc.
 * @param bool $overwrite - remove all existing photos?
 * @return array|false
 */
function rets_import_photos($photos, $params, $overwrite = true) {
	// flush existing, and update all photos of a listing from the MLS db.
	// $rets should be the RETS object to make th call to the RETS server.
	// $home_id is the internal UID of the home object under `homes` table.
	// $sysid is the unique ID to call the photos for the listing, under the PHRETS system - different from internal home ID.
	// Most MLS systems have their own unique system ID for a listing that is separate from the MLS #.
	global $mysqli;
    global $now;

	$photo_array = ($photos ? $photos : false);
	$home_id = ($params['idr']!='' ? $params['idr'] : false);
	$address = ($params['address']!='' ? $params['address'] : false);

	$use_external_URL = ($params['use_external_url']!='' ? $params['use_external_url'] : false); // whether to fully download the file and re-sto

	$server_timestamp = ($params['rets_timestamp']!='' ? $params['rets_timestamp'] : $now);

	if($home_id!==false && $photo_array!==false) {
		$photos_action_log = array();
		$photos_summary = '';
		$photos_success = true;
		/*
         * this function returns false on complete fail (if key parameters missing),
         * but because it loops through many photos, each with S3 uploads, and MySQL entries, we want to log actions,
         *
         * */


		if($overwrite===true) {
			// prepare to re-write this - empty 'mls_photo' column (the quick reference to the 1st photo within `homes` table.
			set_mls_photo($home_id, '');
		}

		if( (is_array($photos) || is_object($photos)) && count($photos)>0 && $photos[0]['Success']==true) {
			$p_res = $mysqli->query("SELECT * FROM `photos` WHERE `home` = '$home_id'");
			$photos_summary .= 'Received '.count($photos).', ';
            $deletecount = 0;
			if($p_res->num_rows>0) {
				while ($p_row = $p_res->fetch_assoc()) {
					$removeresult = remove_gallery_photos($p_row, 'homes');
					if($removeresult===false) {
						$photos_action_log[] = "Removing old image failed for ID ".$p_row['id']." (".$p_row['filename'].") at ".$home_id;
						$photos_success = false; // even one failure should be logged as a fail to raise a flag.
					} else {
						$deletecount++;
						$photos_action_log[] = "Removed old image ".$p_row['filename'].". ".$removeresult[1]." S3 objs and ".$removeresult[2]." MySQL rows zapped.";
                    }
				}
				$photos_summary .= ' deleted '.$deletecount.'/'.$p_res->num_rows.', ';
			}

            $photos_uplaod_count = 0;
			foreach ($photos as $pcount => $photo) {
				$content_id = (isset($photo['Content-ID']) ? $photo['Content-ID'] : $home_id.'-'.$pcount); // CREA DDF does not return Content-ID for each photo. It's just an array of URLs. Improvise.
				$number = $photo['Object-ID']; // could we use $pcount instead?

				$fname_params['prefix'] = $address; // prefix should be full address for SEO.
				$fname_params['number'] = $number; // 0, 1, 2 sequence to add suffix to filename (double digit.
				$fname_params['digits'] = (count($photos)>99 ? 3 : 2); // most likely less than 100 photos, so 2 digits is fine.
				$file_name = set_gallery_photo_filename($fname_params);

				$gallery_params = array();
				$gallery_params['photo_count'] =  $pcount; // raw array count from 0.
				$gallery_params['photo_number'] = $fname_params['number']; // photo sequence display, 01, 02 etc.

                // TODO: even with external URL, if the board/feed wants us to DOWNLOAD the target file, we need to have option to do that?
                if(array_key_exists('URL', $photo) && $photo['URL']!='') {
					$gallery_params['url'] = $photo['URL']; // raw Binary data for JPG. dont ask why we go from uppercase to lowercase.
					$gallery_params['use_external_url'] = $use_external_URL; // Some boards may still require us to download our own, not just hotlink to their CDN URL.
				} else if($photo['Data']!='') {
					$gallery_params['use_external_url'] = false; // definitely false in this case, definitely have to store in our own S3
					$gallery_params['data'] = $photo['Data']; // raw Binary data for JPG.
				}

				$gallery_params['timestamp'] = $server_timestamp;
				$gallery_params['filename'] = $file_name;
				$gallery_params['home_id'] = $home_id;

				$gallery_result = rets_photo_to_gallery($gallery_params);

				if ($gallery_result !== false) {
                    $photos_uplaod_count++;
					$photos_action_log[] = "Inserted image ".$file_name.", from ".(isset($gallery_params['use_external_url']) ? 'external URL' : 'binary data')." for home ID ".$home_id;
				} else {
                    // what to log if failed?
					$photos_success = false;
					$photos_action_log[] = "Failed to image ".$file_name.", from ".(isset($gallery_params['use_external_url']) ? 'external URL' : 'binary data')." for home ID ".$home_id;
                    if(isset($gallery_params['data'])) {
                        $fail_reason = 'Data returned had '. strlen($gallery_params['data']).' bytes ';
                    } else if(isset($gallery_params['url'])) {
	                    $fail_reason = 'URL was '.$gallery_params['url'].', '; // feed URL to troubleshoot?
                    }
                    $fail_reason .= ', MySQL Last Error: '.$mysqli->error;
					$photos_action_log[] = "Image insert failed on for ({$content_id}-{$number}) for $home_id. ".$fail_reason;
				}
			}
			$photos_summary .= ' uploaded '.$photos_uplaod_count.'/'.count($photos).'.';

		} else {
			// no new photos, skipping the loop result from the RETS server for $photos var
			$photos_action_log[] = "No photos fed in from photos array for ".$home_id.'<br />';
		}

        $resultarray = array();
        $resultarray['action_log'] = $photos_action_log;
        $resultarray['summary'] = $photos_summary;
		$resultarray['code'] = ($photos_success == true ? 1 : 0);
        return $resultarray; // return raw array.

	} else {
        echo "Home ID or Photo array was faulty!<br />";
;		// need at least sysID or home ID.
		return false;
	}

}

/*
 * This function handles taking photos from RETS (Vancouver's Paragon, or CREA DDF etc.)
 * It handles photos that are either in a URL format (fetch & uplaod to our gallery) or downloaded in a binary file data format in $photos['Data'] var both.
 * For importing photos from other sources (i.e., in future, if we pull from Pixilink's photo database) we will
 * need another function to fetch them and prepare the right variables etc. for final insertion using attach_gallery_image();
 * */
function rets_photo_to_gallery($params) {
	global $handle; // error logging.
	global $local;
	global $now;
	global $mysqli;

	$photo_count =  ($params['photo_count']!='' ? $params['photo_count'] : 0); // raw array count from 0.
	$photo_number =  ($params['photo_number']!='' ? $params['photo_number'] : 1); // photo sequence display, 01, 02 etc.
	$photo_data = (isset($params['data']) && $params['data']!='' ? $params['data'] : false); // raw Binary data for JPG... coudl be blank if URL is being passed.
	$timestamp = ($params['timestamp']!='' ? $params['timestamp'] : $now); // Timestamp, fall back to now?
	$photo_url = (isset($params['url']) && $params['url']!='' ? $params['url'] : false); // if URL instead of data, we need to download.
	$use_external_url =  ($params['use_external_url']!='' ? $params['use_external_url'] : false);
	$filename = ($params['filename']!='' ? $params['filename'] : md5($local));
	$home_id =  ($params['home_id']!='' ? $params['home_id'] : false);

	if($home_id!==false) {
		/*
		 * Here, we determine how the photo is fetched & stored.
		 * If the photo is on a URL (rather than in raw binary data) we do have the option to merely
		 * store the URL of the JPG on the VIVA or CREA DDF's own CDN, reduce our costs.
		 * however some boards may provide the photo in a URL but not want us loading them directly to all sites,
		 * so we have the option to force a download of the JPG from the said URLs then upload.
		 * attach_gallery_image() will automatically use the URL as the final final destination (s3=0)
		 *  and avoid saving our own web/original (just thumb/mobile on our own S3/Cloudfront).
		 * */
		if($photo_url!==false && $photo_url!='' && $use_external_url===true) {
			$tmp_path = $photo_url; // attach_gallery_image() will fetch remote file from this URL and also store it.
		} else {
			if($photo_url!==false && $use_external_url===false && (!$photo_data || $photo_data=='')) {
				// Fetching JPG from remote but we still have to save the file on our own as the board does not allow hot load from their CDN.
				$photo_data = curl_get_file_contents($photo_url,'GET');
			} // otherwise the $photo_data will already have the file binary data in it.
			$tmp_path = $_SERVER['DOCUMENT_ROOT']."/tmp/temp_".$filename; // attach_gallery_image will get from this.
			@file_put_contents($tmp_path, $photo_data);
		}

		// write_log("processing image ({$filename}) into photos table for from {$tmp_path} for home ID {$home_id}\r\n");

		$gallery_image = attach_gallery_image('homes', $home_id, $filename, $tmp_path, 'Photo '.$photo_number, $timestamp);
		if($photo_count==0) {
			if($use_external_url===true) {
				$first_photo_url = $photo_url;
			} else {
				if(array_key_exists('photoupload', $gallery_image)) {
					// newer deeper array return from attach_gallery_image puts all results under 'photoupload' array.
					$photourl = $gallery_image['photoupload'][1]['web']['ObjectURL'];
				} else {
					// older function just gets the array directly without the 'photoupload' key.
					$photourl = $gallery_image[1]['web']['ObjectURL'];
				}
				$first_photo_url = s3_to_cloudfront($photourl);
			}

			// Convert S3 URL to a cloudfront URL for preview image
			set_mls_photo($home_id, $first_photo_url);
		}

		if(file_exists($tmp_path)) {
            unlink($tmp_path);
        } // remove temp file!
	} else {
		return false;
	}
}

function set_mls_photo($home_id, $url) {
	global $mysqli;

	$url = trim($mysqli->real_escape_string($url)); // basic clean up.

	if($url!='' && is_url($url)) {
		$mls_photo_url = $url;
	} else {
		$mls_photo_url = '';
	}
	$mls_photo_sql = "UPDATE `homes` SET `mls_photo`='".$mls_photo_url."' WHERE `id` = '$home_id'";
	$result = $mysqli->query($mls_photo_sql);
	return $result;
}

function update_settings_row($name, $value) {
	global $mysqli;
	$result = $mysqli->query("SELECT `id`, `value` FROM `settings` WHERE `name`='".$mysqli->real_escape_string($name)."'");
	if(!$result->num_rows) {
		$update = $mysqli->query("INSERT INTO `settings` (`name`, `value`) VALUES ('".$mysqli->real_escape_string($name)."', '".$mysqli->real_escape_string($value)."')");
	} else {
		$array = $result->fetch_assoc();
		if($array['value']==$value) {
			$update = true;
		} else {
			$update = $mysqli->query("UPDATE `settings` SET `value_old` = `value`, `value`='".$mysqli->real_escape_string($value)."' WHERE `id`=".$array['id']);
		}
	}

	if(!$update) {
		return $mysqli->error;
	} else {
		return true;
	}
}

function update_custom_settings_row($name, $value, $editable, $id) {
	global $mysqli;

	if ($name == '' && $value == '' && $id != '') {
		$update = $mysqli->query("DELETE FROM `custom_settings` WHERE `id` = $id");
	} else {

		$result = $mysqli->query("SELECT `id`, `value` FROM `custom_settings` WHERE `name`='".$mysqli->real_escape_string($name)."'");
		if(!$result->num_rows) {
			$update = $mysqli->query("INSERT INTO `custom_settings` (`name`, `value`, `editable`) VALUES ('".$mysqli->real_escape_string($name)."', '".$mysqli->real_escape_string($value)."', '".$mysqli->real_escape_string($editable)."' )");
		} else {
			$array = $result->fetch_assoc();
			if($array['value']==$value) {
				$update = true;
			} else {
				$update = $mysqli->query("UPDATE `custom_settings` SET `value_old` = `value`, `value`='".$mysqli->real_escape_string($value)."', `name`='".$mysqli->real_escape_string($name)."' WHERE `id`=".$array['id']);
			}
		}
	}

	if(!$update) {
		return $mysqli->error;
	} else {
		return true;
	}
}

/**
 * This function prepares teh final S3 key (path & filename) but ONLY for gallery photos to ensure the path is all good.
 * It also auto appends the suffix to make gallery photos increment from 0 to 20 etc.
 * This should not be used for any other type of attachments.
 * @param $bucket
 * @param $filepath
 * @param $filename
 * @return string
 */
function sanitize_filename_for_s3_and_return($bucket, $filepath, $filename) {


	$beforeext = substr($filename, 0, strrpos($filename, '.'));
	$fileext = strtolower(substr($filename, strrpos($filename, '.')+1));
	if($fileext=='jpeg') $fileext ='jpg'; // force it to .jpg!
	$filename = strtolower(url_format($beforeext).'.'.$fileext);
	$original_filepath = $filepath; // need the path of the destination Key on S3 to compare if file already exists. /www.mysite.com/homes/432532/mobile/

	if(!preg_match('/\/$/',$original_filepath)) {
		$original_filepath = $original_filepath.'/';
	}

	// Check if filename already exists - in that case, add one more -1 at the end.
	// not to be confused with the number appending that set_gallery_photo_filename() does when cycling through RETS photos!
	// This is more for realtors uploading JPG images and happening to have same filename by their error.
	// This will rarely kick in.
	$checkpath = $original_filepath.$filename;
	$suffixcount = 1;
	while (verifyExists($bucket, $checkpath) == true) {

		$filename = $beforeext.'-'.$suffixcount.'.'.$fileext;
		$checkpath = $original_filepath.$filename; // append check path for next iteration if needed.

		$suffixcount++;
	}
	return $filename;
}


//
/**
 * Back-end banners linking to Google should contain parameters to identify they came from back-end.
 * See how many are coming from back-end
 * ?utm_source=backend&utm_medium=website&utm_campaign=backend_banners&utm_term=cpanel&utm_content=printmedia
 * @param $params can contain array key for all these.
 */
function google_analytics_campaign_vars($params) {
	global $settings;
	$params['utm_source'] = ($params['utm_source']!='' ? $params['utm_source'] : 'clientsite');
	$params['utm_medium'] = ($params['utm_medium']!='' ? $params['utm_medium'] : 'backend');
	$params['utm_campaign'] = ($params['utm_campaign']!='' ? $params['utm_campaign'] : 'backend_banners');
	// in most cases, backend banners.
	$params['utm_term'] = ($params['utm_term']!='' ? $params['utm_term'] : $settings['sitepath']);
	$params['utm_content'] = ($params['utm_content']!='' ? $params['utm_content'] : 'print_media'); // really shold not be blank!

	foreach($params as $paramkey => $paramvar) {
		$finalparam[$paramkey] = urlencode($paramvar);
	}
	$returnvar = '?utm_source='.$finalparam['utm_source'].'&utm_medium='.$finalparam['utm_medium'].'&utm_campaign='.$finalparam['utm_campaign'].'&utm_term='.$finalparam['utm_term'].'&utm_content='.$finalparam['utm_content'];
	return $returnvar;
}


/*
** getAnalytics for analytics
*/

function gAnalytics($listing,$total = false){
	$fileName = md5("gAnalytics".date('Y-m-d')).'.json';
	$filePath = "api/cache/$fileName";
	if(file_exists($filePath)){

		$data = file_get_contents($filePath);
		if($data){
			$data = json_decode($data,true);
			if(isset($data[$listing]['data'])){
				if($total){
					$data = $data[$listing]['data'];
					return array_sum(array_column($data,'pageviews'));
				}else{
					return $data[$listing];
				}
			}
		}
	}
	return false;
}

function modal_aGraph($listing){
	global $settings;
	$data = gAnalytics($listing);
	$thishome = new home;
	$thishome->initialize($listing);
	?>

	<div class="modal fade" id="GoogleAnalytics" tabindex="-1" role="dialog" aria-labelledby="modallabel" aria-hidden="true">
		<div class="modal-dialog modal-lg">
			<div class="modal-content">
				<div class="modal-header">
					<button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
					<h4 class="modal-title"><?php echo $thishome->fulladdress ?></h4>
					<p>Page views for last 7 days(Google Analytics)</p>
				</div>
				<div class="modal-body analytic_content">
					<?php if($settings['google_analytics'] && $settings['google_analytics']){
						if(isset($data['data'])){
							$page_views  = $data['data'];
							$page_sources = $data['dataSource'];
							?>
							<div class="row">
								<div class="col-sm-6">
									<div id="line_chart" style="width:500px;"></div>
								</div>
								<div class="col-sm-6">
									<div id="pie_chart"></div>
								</div>
							</div>
							<p class="text-center ajax_lImmi"><img src="images/ajax-loader.gif"><br>Processing your request...</p>
							<script>
								setTimeout(function(){
									$(".ajax_lImmi").remove();
									google.charts.load('current', {packages: ['corechart', 'line']});
									google.charts.setOnLoadCallback(drawBasic);
									google.charts.setOnLoadCallback(drawChartPie);
								},1000);
								function drawBasic() {
									var data = new google.visualization.DataTable();
									data.addColumn('string', 'Date');
									data.addColumn('number', 'PageViews');
									data.addRows([

										<?php foreach ($page_views as $_data){ ?>
										[<?php echo "'".date('m-d',strtotime($_data['date']))."'"; ?>, <?php echo $_data['pageviews']; ?>],
										<?php } ?>
									]);

									var options = {
										hAxis: {
											title: 'Date'
										},
										vAxis: {
											title: 'PageViews'
										},
										pointSize: 4,
										series: {
											1: {curveType: 'function'}
										},
										legend: { position: 'top' }
									};

									var chart = new google.visualization.LineChart(document.getElementById('line_chart'));

									chart.draw(data, options);
								}
								function drawChartPie() {

									var data = google.visualization.arrayToDataTable([
										['source','sessions'],
										<?php foreach ($page_sources as $key => $val){ ?>
										['<?php echo ucfirst($key); ?>', <?php echo $val; ?>],
										<?php } ?>
									]);
									var options = {
										title: 'Search Sources',
										legend: { position: 'top' }
									};

									var chart = new google.visualization.PieChart(document.getElementById('pie_chart'));

									chart.draw(data, options);
								}
							</script>
						<?php }else{
							echo '<p>Google Analytics is setup but API oAUTH based feed is not integrated. <a href="/admin/traffic.php" class="btn btn-success">Click here to setup oAuth</a></p>';
						}
					} else {
						echo '<p>Google Analytics is not setup. <a target="_blank" href="http://support.brixwork.com/support/solutions/articles/8000038179-setting-up-google-analytics" class="btn btn-success">Guide to setup Google Analytics</a></p>';
					} ?>
				</div>
				<div class="modal-footer">
					<?php if($settings['google_analytics'] && $settings['google_analytics'] && isset($data['data'])){ ?>
						<a href="/showlisting/<?= $listing ?>/" class="btn btn-success">View Full Analytics Details</a>
					<?php } ?>
					<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
				</div>
			</div>
		</div>
	</div>
	<script type="text/javascript">
		$("#modal_processing").modal('hide');
	</script>
	<?php
}


#[ArrayShape(['message' => "string", 'code' => "int"])]
function update_login_table($options): array {
    global $mysqli;

    $id         = $options['id'] ?: false;
    $hash       = $options['hash'] ?: false;
    $duration   = $options['duration'] ?: '';   // set default data
    $expiry     = $options['expiry'] ?: '';     // set default data

    if (!$id)   return array('message' => 'Missing ID ... cannot process login data.', 'code' => 0);
    if (!$hash) return array('message' => 'Missing hash ... cannot process login data.', 'code' => 0);

    // comparing the generated hash vs. the already existing hash. Match ID and Hash.
    $login_query = "SELECT id, hash FROM login WHERE user='".$mysqli->real_escape_string($id)."' AND hash='".$hash."'";
    $login_check = $mysqli->query($login_query);

    // if match exists, update expiry on the login table ... if new hash, insert new value to login table.
    if ($login_check->num_rows > 0) {
        $login_data = $login_check->fetch_assoc();
        $login_id = $login_data['id'];  // This `id` is not user's id. It is the `id` of the login row. User's ID is stored under `user` column of `login` table.

        $hash_query = "UPDATE login SET expiry='".$expiry."' WHERE id=".$login_id;
        $message = "Login already exists - extending duration: Login ID: ".$login_id;
    } else {
        $hash_query = "INSERT INTO login (`user`,`hash`,`duration`,`expiry`) VALUES('".$id."','".$hash."','".$duration."','".$expiry."')";
        $message = "New Login - inserting new login hash";
    }

    // update the table & user data
    $mysqli->query($hash_query);

    return array('message' => 'Login Table Successfully Updated. '.$message, 'code' => 1);
}