<?php
/*
Filename: ajax_listingsurl.php
Location: /admin

Method: AJAX
Output: AJAX

Description: Generates listings search URL based on parameters in order to create the unique listing search with the $params built into it.
*/

include 'start.php';

include 'msg.inc';
include 'dropdown.inc';
if($_SERVER['HTTP_X_REQUESTED_WITH']!='XMLHttpRequest') {
	echo "Invalid Request.";
} else {
	/*
	 * 
	 * VARS passed:
	 *  
	 * Refer to ajax_listingsurl.php to get an idea.
	 *  
	 */
	$code = 0; // code 0 by default
	
	// first convert the $_REQUEST array, by key, to a $param var, 
	if($_REQUEST['building_search_city']!='') {
		$query['city'] = $_REQUEST['building_search_city'];
	}
	
	if($_REQUEST['building_search_subarea']!='') {
		$query['area'] = $_REQUEST['building_search_subarea'];
	}
	
	if($_REQUEST['building_search_type']!='') {
		$query['type'] = $_REQUEST['building_search_type'];
	}	
		
	// features to convert to separate queries.
	if(is_array($_REQUEST['building_search_features']) && count($_REQUEST['building_search_features'])>0) {
		foreach($_REQUEST['building_search_features'] as $queryfeature) {
			$query['features'][] = $queryfeature;
		} 
	}
	
	if($_REQUEST['bldg_status']!='') {
		$query['status'] = $_REQUEST['bldg_status'];
	}

	if($_REQUEST['building_pets']!='') {
		$query['pets'] = 'yes';
	}

	if($_REQUEST['building_rent']!='') {
		$query['rentals'] = 'yes';
	}
	
	$query['page'] = 1;
	
	$url = $settings['sitepath'].($_REQUEST['listing_custom_filename']!='' ? $_REQUEST['listing_custom_filename'] :'buildings_list');
	foreach($query as $key=>$value) {
		$url .= '/'.$key;
		if(is_array($value)) {
			$arraycount = 0;
			$url .= '-';
			foreach($value as $arrayvar) {
				if($arraycount>0) {
					$url .= ';';
				}
				$url .= urlencode($arrayvar);
				$arraycount++;
			}
		} else if(strlen($value)>0) {
			$url.='-'.urlencode($value);
		}
	}

	if($url!=$settings['sitepath'].'buildings_list') {
		$code = 1;
	} else {
		$message = 'No criteria set.';
	}
	
	// and then we run it through the param_to_query function to filter it out. 
	$json_array = array('listingurl'=>$url, 'code' => $code, 'message'=>$message);
	echo json_encode($json_array);
}

require_once 'ajax_footer.php';
?>