<?php
include 'start.php';
global $settings;
// start.php runs validate_login() function.

$log_file = 'logs/crop_'.$_REQUEST['type'].'-'.$_REQUEST['idr'].'-'.$_REQUEST['filename'].'-'.$now.'.log';
if (is_writable(dirname($log_file))) {
	$log_handle = fopen($log_file, 'a+');
} else {
	$log_handle = null;
}

$destinationfolder = $mysqli->real_escape_string($_REQUEST['object']);
$objecttype = substr($destinationfolder, 0, strlen($destinationfolder)-1);
$objectid = intval(trim($_REQUEST['idr']));
/*

filename	main.jpg
folder	../homes/37862
h	1080
idr	37862
object    homes
theight	658
twidth	1170
type	homes
w	1920
x	0
y	94
*/
if($_REQUEST['x']!="" && $_REQUEST['filename']!='') {
	$type =$mysqli->real_escape_string(trim($_REQUEST['type']));// is it homes, buildings etc.?
	$idr =  $mysqli->real_escape_string($objectid); // self explanatory.
	$filename = $mysqli->real_escape_string(trim($_REQUEST['filename']));
	
    $s3filename = getS3FilePath( $settings, $idr, $type).'/'.$filename;
	
	if(verifyExists($settings['s3_bucket'], $s3filename)) {
		$s3response = getFile($settings['s3_bucket'], '', $objectid, $_REQUEST['filename'],$_REQUEST['type']);
	} else {
		echo "S3 upload unverified for ".$s3filename." on bucket ".$settings['s3_bucket'].PHP_EOL;
		write_log( "S3 upload unverified for ".$s3filename." on bucket ".$settings['s3_bucket'].PHP_EOL);
	}

	$imagebody = $s3response['Body']; // full file content of the image.
	$localTempPath = $_SERVER['DOCUMENT_ROOT']."/tmp/s3_temp_precrop_".$filename; // $filename includes the extension and all.
	file_put_contents($localTempPath, $imagebody);

	write_log("Fetching uploaded s3 JPG from ".$s3filename." to ".$localTempPath.PHP_EOL);

	$imagedata = getimagesize($localTempPath);
	// var_dump($imagedata);

	$width = $imagedata[0];
	$height = $imagedata[1];
	$mimetype = $imagedata['mime']; 
	
	$image_p = imagecreatetruecolor($_REQUEST['twidth'], $_REQUEST['theight']);
	imagesavealpha($image_p, true);
	$trans_colour = imagecolorallocatealpha($image_p, 0, 0, 0, 127);
	imagefill($image_p, 0, 0, $trans_colour); // creates a blank image to start.
	
	// generate image var from existing image first. 
	switch($mimetype) {
		case "image/jpeg":
			$img_r = imagecreatefromjpeg($localTempPath); //jpeg file
			$ext = 'jpg';
		break;
		case "image/gif":
			$img_r = imagecreatefromgif($localTempPath); //gif file
			$ext = 'gif';
		break;
		case "image/png":
			$img_r = imagecreatefrompng($localTempPath); //png file
			$ext = 'png';
		break;
		default: 
			$img_r=imagecreatefromjpeg($localTempPath);
		break;
	}

	$localModifiedFilePath = $_SERVER['DOCUMENT_ROOT']."/tmp/s3_temp_cropped_".$idr.".{$ext}";
	// temporary local path to save resized image. 

	// force all numeric.. cause PHP 7 is pickier.
	$image_x = $_REQUEST['x']*1;
	$image_y = $_REQUEST['y']*1;

	$image_twidth = $_REQUEST['twidth']*1;
	$image_theight = $_REQUEST['theight']*1;

	$image_w = $_REQUEST['w']*1;
	$image_h = $_REQUEST['h']*1;

	if(($image_y+$image_theight)>$image_h) {
		$image_y--; // take one pixel off so we don't end up with a blank black sliver at the bottom.
	}

	if(($image_x+$image_twidth)>$image_w) {
		$image_x--; // take one pixel off so we don't end up with a blank black sliver on the right. d
	}
//
//	echo "X Start point: {$image_x}\n";
//	echo "Y Start point: {$image_y}\n";
//
//	echo "Target Width: {$image_twidth}\n";
//	echo "Target Height: {$image_theight}\n";
//
//	echo "Image Visible Width: {$image_w}\n";
//	echo "Image Visible Height: {$image_h}\n";
//
//	echo "Image Original Width: {$width}\n";
//	echo "Image Original Height: {$height}\n";

	imagecopyresampled($image_p,$img_r,0,0,$image_x,$image_y,$image_twidth,$image_theight,$image_w,$image_h);

	write_log("Process new JPG to  ".$localModifiedFilePath.PHP_EOL);
	// write the generated image, in $image_p, into the local file.
	switch($mimetype){
		case "image/jpeg":
			imagejpeg($image_p, $localModifiedFilePath, ($settings['imagequality']!='' ? $settings['imagequality'] : 75));
		break;
		case "image/gif":
			imagegif($image_p, $localModifiedFilePath);
		break;
		case "image/png":
			imagepng($image_p, $localModifiedFilePath, 0);
		break;
		default: 
			imagejpeg($image_p, $localModifiedFilePath, ($settings['imagequality']!='' ? $settings['imagequality'] : 75));
		break;
	}
	
	$result = CheckPathAndUploadFile( $settings, $idr, $type, $localModifiedFilePath, $filename, $settings['s3_bucket'], false );
	// print_r($result);
	write_log("New raw cloudfront path was ".$result[0]['file']['ObjectURL'].PHP_EOL);

	echo s3_to_cloudfront($result[0]['file']['ObjectURL']).'?timestamp='.$local;
	// this function bypasses the attach_files() function. The attach files just ran with main image upload. 
	// crop only runs RIGHT AFTER, and uses local path, so better to just go straight to CheckPathAndUploadFile() function. 

	// delete temp local files.
	unlink($localModifiedFilePath);
	unlink($localTempPath);

	// update the table of the object to have the latest modified date. 
	$updatevar['modify_date'] = $now; // modified date is often synced up with MLS sync, so we have separate fields.
	$updatevar['timestamp'] = $now; // timestamp of last tiem udpated.
	$uid = update_to_table($destinationfolder, $updatevar,$objectid);
	$memcache_params = array(
		'type'=>$objecttype,
		'objectid'=>$objectid
	);
	get_memcache($memcache_params, 'delete');

}

// functions
function write_log ($msg) {
	global $log_handle;
	if (!empty($log_handle)) {
		fwrite($log_handle, $msg, strlen($msg));
	}
}

require_once 'ajax_footer.php';
?>