<?php
/*
Filename: ajax_listlinks.php

Method: AJAX
Output: AJAX/JSON

Description: Master file that loads up the buildings list, as well as the buildings quick search module to help users organize & choose buildings to feature on the website. 

Author: Jeff Kee
*/

include 'start.php';

// start.php runs validate_login() function
$destinationfolder = 'resources'; // although the primary query is through the resourcecategories table, the resources is the money table anyway.
$destinationtable = 'resources';

$linkssql = "SELECT * FROM `resourcecategories` WHERE `id`!='' ORDER BY `ord` ";
$link_list = $mysqli->query($linkssql);

$categories = get_resource_link_categories('','','',false, true);

if (!$link_list):

    echo "<div class='w-50 my-5 p-5 text-bg-warning rounded'>";
    echo "	<h4 class='text-center'>No Links / Resources Yet!</h4>";
    echo "</div>";

else:
    ?>
    <div class="collapse_wrapper category_wrapper" rel="0">
        <?php
        foreach ($categories as $category_id => $category_content) {

            $query['categoryid'] = $category_id;
            $links = get_resource_links($query, 'ord', 'asc');

            // wrap top category in collapsible div.
            // detect last elem.
            $last_elem = intval($category_id) === intval(end($categories)['id']) ? 'last_elem' : '';
            ?>
            <div id='category_<?=$category_id?>' class='brixwork_list_wrapper top_list'>
                <div id="category_<?=$category_id?>" class="each_list last_elem" style="padding-left: 22px">
                    <div class="expand_toggle">
                        <?php
                        if ($links): ?>
                            <a class="collapse_control collapsed" href="#collapse_<?=$category_id?>" data-bs-toggle="collapse" aria-expanded="false" aria-controls="collapse_<?=$category_id?>"><i class="bi bi-plus-circle-fill"></i></a>
                        <?php endif; ?>
                    </div>

                    <h5 class="each_list__title"><?=$category_content['title']?><?=login_level_check(1) ? ' (ID: '.$category_id.')' : false?></h5>

                    <div class="each_list__functions_wrapper">
                        <a href="resources_mod.php?mode=new&category=<?=$category_id?>" class="btn btn-admin grey_teal each_list__btn">Add Contact</a>
                        <button type="button" class="btn btn-admin light_blue each_list__btn category_mod" data-id="<?=$category_id?>" data-name="<?=$category_content['title']?>">Edit</button>
                        <?php
                        if (!$links)
                            echo "<button type='button' class='btn btn-admin reddish each_list__btn category_delete' rel='$category_id'>Delete</button>"
                        ?>
                    </div>
                </div>


                <?php // collapsed links under category
                if ($links) {
                    echo "<div class='last_collapse_elem level_1 collapse collapse_wrapper resource_wrapper' id='collapse_$category_id' rel='$category_id'>";
                    foreach ($links as $link_id => $link_content):
                        $each_link = new resource;
                        $each_link->initialize($link_id);
                        $last_elem = intval($link_id) === intval(end($links)['id']) ? 'last_elem' : '';
                        $hidden_elem = $each_link->publish == 0 ? 'hidden_list' : '';
                        $title_string = $each_link->title ?: $each_link->company;
                        ?>
                        <div id="resource_<?=$link_id?>" class="each_list child_list <?=$last_elem?> <?=$hidden_elem?>" style="padding-left: 44px">
                            <div class="expand_toggle"></div>
                            <h5 class="each_list__title" style="font-weight: 400;"><?=$title_string?><?=login_level_check(1) ? ' (ID: '.$link_id.')' : false?></h5>

                            <div class="each_list__functions_wrapper">
                                <a class="btn btn-admin light_blue each_list__btn" href="resources_mod.php?idr=<?=$link_id?>&mode=modify">Edit</a>
                                <button type="button" class="btn btn-admin reddish each_list__btn resource_delete" rel="<?=$link_id?>" data-parent="<?=$category_id?>">Delete</button>
                                <select class="form-select resource_publish_toggle" rel="<?=$link_id?>" aria-label="resource publish status">
                                    <option value="0" <?=$each_link->publish == 0 ? 'selected' : ''?>>Hidden</option>
                                    <option value="1" <?=$each_link->publish == 0 ? '' : 'selected'?>>Publish</option>
                                </select>
                            </div>
                        </div>
                    <?php
                    endforeach;
                    echo "</div>";
                } ?>
            </div>
        <?php
        } ?>
    </div>
<?php
endif;

require_once 'ajax_footer.php';