<?php
include 'start.php';

// start.php runs validate_login() function
global $login_user;

// USER SQL QUERY
$user_sql = "SELECT `id`, `level` FROM `users` WHERE `username`!='brixwork' AND `username`!='jeffkee' ORDER BY level ASC, email ASC";
$user_res = $mysqli->query($user_sql);
?>
<div class="table-responsive">
    <table id="brixwork_users_table" class="table table-hover align-middle">
        <thead>
        <tr>
            <th class="users_table_header" scope="col">USER</th>
            <th class="users_table_header" scope="col">ROLE</th>
            <th class="users_table_header" scope="col">ACTIONS</th>
        </tr>
        </thead>

        <tbody>
        <?php // loop through existing users, open with <tr> for each user
        while ($each_user_id = $user_res->fetch_assoc()):
            /**
             * Display certain LEVELS only
             * 1. admin login will be able to see all users.
             * 2. Managers need to see everyone, so they can set associated agents. (EXCEPT ADMIN and other managers?)
             * 3. login user id - get from $login_user from start.php
             */
            if ($login_user->getLevel() > USER_LOGIN_MANAGER) {
                // if login user is not admin/manager level, only allowed to display self (current login). Therefore, skip IDs that are not self.
                $allowed_id = $login_user->getID();
                if ($allowed_id != $each_user_id['id']) continue;
            }
            else if ($login_user->getLevel() == USER_LOGIN_MANAGER) {
                // as manager login, do not show admin level.
                $skip_level = USER_LOGIN_ADMIN;
                if ($skip_level == $each_user_id['level']) continue;
            }

            // initiate user based on the ID queried.
            $id = $each_user_id['id'];
            $each_user = new user(array('id' => $id), $mysqli, $settings);

            // Mark logged in user.
            $logged_in_div = '';
            if ($each_user->isUserAuthenticated()) {
                $logged_in_div = "<span class='user_login'>Signed in</span>";
            }
            ?>
            <tr>
                <th class="brixwork_user__name" id="<?=$id?>" scope="row"><?=$each_user->getUsername() ?: $each_user->getEmail()?> <?=$logged_in_div?></th>
                <td id="role"><?=$settings['user_level_label'][$each_user->getLevel()]?></td>
                <td id="functions">
                    <div id="users_function_wrapper" class="each_user">
                        <a class="btn btn-admin light_blue px-3" href="users_mod.php?idr=<?=$id?>&mode=modify">Edit</a>
                        <?php // normal user should not be able to delete themselves
                        if ($login_user->getLevel() <= USER_LOGIN_ADMIN) {
                            echo "<button class='btn btn-admin reddish px-3' onclick='delete_user($id)'>Delete</button>";
                        } ?>
                    </div>
                </td>
            </tr>
        <?php
        endwhile; ?>

        </tbody>

    </table>
</div>


<?php
require_once 'ajax_footer.php';