<?php
include 'start.php';


/*
Values Entered
$_REQUEST['change'] = indicates type of change.
$_REQUEST['value'] = indicates target value.
$_REQUEST['field'] = indicates target value.
$_REQUEST['idr'] = id of teh target home.
*/

$mls = (isset($_REQUEST['mls']) ? $mysqli->real_escape_string(trim($_REQUEST['mls'])) : '');
$idr = (isset($_REQUEST['idr']) ? $mysqli->real_escape_string(trim($_REQUEST['idr'])) : '');
$objectid  = $idr;

//start.php runs validate_login() function.
$destinationfolder = 'homes';
$destinationtable = 'homes';


$log_file = 'logs/homes_log.' . date('Y.m.d') . '.log';
if (is_writable(dirname($log_file))) {
	$handle = fopen($log_file, 'a+');
} else {
	$handle = null;
}

$logparams = array();
$logparams['objecttype'] = $destinationtable; // is it homes/buildings/pages or agents?
$logparams['objectid'] = $objectid; // is it homes/buildings/pages or agents?

switch($_REQUEST['change']) {
	case "soldstatus":
		// Change to SOLD status, and change modify date to make it recent.
		$sql = "UPDATE `".$destinationtable."` SET `sold`=".$mysqli->real_escape_string($_REQUEST['value']).", `modify_date`= '".$now."' WHERE `id`=".$idr;
		$execute = $mysqli->query($sql);
		if($mysqli->affected_rows==1) {
			$memcache_params = array(
				'type'=>'home',
				'listingsource'=>BRIX_LISTING_OWN,
				'objectid'=>$idr
			);
			get_memcache($memcache_params, 'delete');

			$code = 1;
			$homeid_modified = $idr;
			$message = 'Successfully changed '.$idr.' sold status.';
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = 'Failed to change ID '.$idr.' sold status.';
		}
		break;

	case "featurestatus":
		// update the featured status of a listing from the HOMES list.
		// DO NOT CHANGE Modify date, we don't want overrides from MLS being blocke.d
		// needs to be deprecated in favour of the "feature" case, because that one is more robust to import & process even non-localized MLS listings.
		$result = $mysqli->query('SELECT `source`, `ord` FROM homes WHERE `id` = '.$idr);
		$resultArray = $result->fetch_assoc();

		if ($resultArray['source'] == BRIX_LISTING_MLS) {
			if ($_REQUEST['value'] == 1) {
				// Featuring this listing so push down all source=1 feature=1 listings +1 (push down)
				$ord = 1;
				$increment = '+1';
				$sqlAppend = '';
			} else {
				// Unfeaturing, so get all source=1 and feature=1 listings that were AFTER thsi listing and -1 (pull them back up)
				$ord = 0;
				$increment = '-1';
				$sqlAppend = ' AND ord > '.$resultArray['ord'];
			}

			$sql = "UPDATE homes SET ord = ord ".$increment." WHERE (source = 0 OR (source = 1 AND feature = 1))".$sqlAppend; // We should also account for featured MLS listings.

			$mysqli->query($sql);
		}

		$sql = "UPDATE `".$destinationtable."` SET `feature`=".$_REQUEST['value']." WHERE `id`=".$idr;
		$execute = $mysqli->query($sql);

		if ($mysqli->affected_rows==1) {
			$code = 1;
			$homeid_modified = $idr;
			$message = 'Home ID '.$idr.' feature status updated to '.($_REQUEST['value']==1 ? 'FEATURED' : 'NOT FEATURED').'.';
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = 'Failed to change ID '.$idr.' feature status.';
		}
		break;

	case "publishstatus":
		$sql = 'UPDATE '.$destinationtable.' SET publish="'.$mysqli->real_escape_string($_REQUEST['value']).'" WHERE id="'.$idr.'"';
		$execute = $mysqli->query($sql);
		if ($mysqli->affected_rows==1) {
			// this can only be for source=0 listings
			$memcache_params = array(
				'type'=>'home',
				'listingsource'=>BRIX_LISTING_OWN,
				'objectid'=>$idr
			);
			get_memcache($memcache_params, 'delete');

			$code = 1;
			$homeid_modified = $idr;
			$message = 'Publish status changed for '.$idr.'.';
		} else {
			$code = 0;
			$message = 'Failed to change ID '.$idr.' publish status.';
		}
		break;

	case "feature":
		// Modify MLS listing that was previously NOT featured as "featured"!
		// do NOT change modify date as this will prevent re-crawl of updated data such as price etc.!
		// featurestatus and this one are different.. featurestatus is the one that handles toggle on/off.,.
		// This one is more useful for freshly feature=1 an MLS listing. It even tries to import from MLS motehrship if its'a  brand new listnig.
		$homesql = "SELECT `id` FROM `".$destinationtable."` WHERE `mls`='".$mls."'";
		$homeresult = $mysqli->query($homesql);

		if ($homeresult->num_rows==0) {
			// import it first from a RETS core!
			if ($settings['mls_import_url']!='') {
				// if separate MLS import url is set such as kamloops or other region...
				$importurl = $settings['mls_import_url'];
			} else {
				// otherwise default to demo.brixwork.com which is master_url, for MLS from REBGV MLS feed.
				$importurl = 'https://vancouver.brixwork.com/';
			}

			include '../cron/cron_functions.php';// loads up all cities etc.
			include '../admin/includes/retsimport_vars.php';// loads up all cities etc.

			$gethash = md5('58300774'.$mls);
			$jsonfeed = curl_get_file_contents($importurl.'admin/api/listing.php?hash='.$gethash.'&mls='.$mls, 'GET');

			$json = json_decode($jsonfeed, true); // fetch from the listing API from main server.
			if ($json['code']==1) {
				$listing = $json['listing'][0]; // isolate the $listing var using teh listing portion only if result was good.
				/* Decide what city & subarea to fall under */
				$cityareafound = 0; // first, set cityareafound flag to false.
				if (count($subareaswithpolygon)>0 && is_array($subareaswithpolygon)) {
					// there are polygoned results, let's check homes against it.
					reset($subareaswithpolygon);
					foreach($subareaswithpolygon as $subareawithpolygon) {
						if($subareawithpolygon->listing_in_polygon($listing['lat'].','.$listing['long'])) {
							$listing['area_alt'] = $subareawithpolygon->id;
							$listing['city'] = $subareawithpolygon->area; // select the city that this subarea is supposed to belong to according to owner of site.
							$cityareafound = 1;
							log_error($listing['lat'].",".$listing['long']." was found in to ".$subareawithpolygon->name.". (for home: ".$listing['mls']."): \n");
							echo $listing['lat'].','.$listing['long'].' was found in to '.$subareawithpolygon->name.'.<br />';
						}
					}
				}

				$value_data['city'] = $listing['cityname'];
				$value_data['area'] = $listing['areaname']; // preparing $value_data pair to run through match_cities() function.

				if ($cityareafound==0) {
					// polygon search results didn't return.. match by string name.
					list($listing['area'], $listing['city']) = match_cities($value_data, $cities, $subareas); // regular city/area as per MLS.
				} else {
					// polygon found something, but still get the primary area in.
					list($listing['area'], $discard['city']) = match_cities($value_data, $cities, $subareas); // the area becomes the default MLS area, while area_alt has the custom subarea based on polygon. City is kept the same was what polygon belongs in.
				}
				$listing['timestamp'] = $now;
				$listing['source'] = BRIX_LISTING_MLS; // MLS integrated listings are source=1 as well
				$listing['publish'] = 1; // MLS integrated listings are source=1 as well
				$homeid_modified = form_to_table($destinationtable,$listing);
				if(!is_numeric($homeid_modified)) {
					$code = 0;
					$message = 'Failed to internalize MLS # '.$mls.' from '.$importurl.': '.gettype($homeid_modified).'.';
				}
			} else {
				$code = 0;
				$homeid_modified = false;
				$message = 'The MLS # '.$mls.' was not found locally nor on '.$importurl.'.';
			}
		}

		// bump down order of rest to put this feature at top.
		$result = $mysqli->query("SELECT source, ord FROM homes WHERE `mls`='".$mls."'");
		$resultArray = $result->fetch_assoc();

		if ($resultArray['source'] == BRIX_LISTING_MLS) {
			if ($_REQUEST['value'] == 1) {
				// Featuring this listing so push down all source=1 feature=1 listings +1 (push down)
				$ord = 1;
				$increment = '+1';
				$sqlAppend = '';
			} else {
				// Woudl this ever happen on this? This is for that "Feature a new MLS" pop up, not the feature/unfeature toggle..
				$ord = 0;
				$increment = '-1';
				$sqlAppend = ' AND ord > '.$resultArray['ord'];
			}

			$sql = "UPDATE homes SET ord = ord ".$increment." WHERE (source = 0 OR (source = 1 AND feature = 1))".$sqlAppend; // We should also account for featured MLS listings.
			log_error("EXECUTING SQL QUERY: ".$sql);
			$mysqli->query($sql);
		}

		$sql = 'UPDATE '.$destinationtable.' SET `feature`="'.$_REQUEST['value'].'", `publish`=1, `ord`='.$ord.' WHERE `mls`="'.$mls.'"';
		$execute = $mysqli->query($sql);

		if ($mysqli->affected_rows==1) {
			$code = 1;
			$idsql = "SELECT `id`, `city` FROM `homes`  WHERE `mls`='".$mls."'";
			$idresult = $mysqli->query($idsql);
			$data = $idresult->fetch_assoc();
			$homeid_modified = $data['id']; // get the ID of the home row (we queried the listing by MLS, not ID, so need it here to return.
			/*
			if($_REQUEST['value']==1) {
				// now we need to set the area under this home to be publish!
				$areasql = "UPDATE `areas` SET `publish`=1 WHERE `id`='".$data['city']."'";
				$mysqli->query($areasql);
				echo $areasql;
			}
			*/
			$message = 'Listing '.$mls.' feature status updated to '.($_REQUEST['value']==1 ? 'FEATURED' : 'NOT FEATURED').'.';
		} else {
			$code = 0;
			if($message!='') {
				$message = 'Failed to change ID '.$_REQUEST['mls'].' feature status. Error: '.$mysqli->error.', affected rows '.$mysqli->affected_rows.'.';
			}
		}
		break;


	case "source":
		if ($mls!='') {
			$homesql = "SELECT `id` FROM `".$destinationtable."` WHERE `mls`='".$mls."'";
			$homeresult = $mysqli->query($homesql);
			if ($homeresult->num_rows==0) {
				// nothing found, fetch from remote then import. If it got to this point, the listing must exist.
				if ($settings['mls_import_url']!='') {
					// if separate MLS import url is set such as kamloops or other region...
					$importurl = $settings['mls_import_url'];
				} else {
					// otherwise default to demo.brixwork.com which is master_url, for MLS from REBGV MLS feed.
					$importurl = 'https://vancouver.brixwork.com/';
				}

				include '../cron/cron_functions.php';// loads up all cities etc.
				include '../admin/includes/retsimport_vars.php';// loads up all cities etc.

				$gethash = md5('58300774'.$_REQUEST['mls']);
				$listing_fetch_url = $importurl.'admin/api/listing.php?hash='.$gethash.'&mls='.$mls;
				$jsonfeed = curl_get_file_contents($listing_fetch_url, 'GET');

				$json = json_decode($jsonfeed, true); // fetch from the listing API from main server.
				if ($json['code']==1) {
					$listing = $json['listing'][0]; // isolate the $listing var using teh listing portion only if result was good.
					/* Decide what city & subarea to fall under */
					$cityareafound = 0; // first, set cityareafound flag to false.
					if (count($subareaswithpolygon)>0 && is_array($subareaswithpolygon)) {
						// there are polygoned results, let's check homes against it.
						reset($subareaswithpolygon);
						foreach($subareaswithpolygon as $subareawithpolygon) {
							if($subareawithpolygon->listing_in_polygon($listing['lat'].','.$listing['long'])) {
								$listing['area_alt'] = $subareawithpolygon->id;
								$listing['city'] = $subareawithpolygon->area; // select the city that this subarea is supposed to belong to according to owner of site.
								$cityareafound = 1;
								log_error($listing['lat'].",".$listing['long']." was found in to ".$subareawithpolygon->name.". (for home: ".$listing['mls']."): \n");
								echo $listing['lat'].','.$listing['long'].' was found in to '.$subareawithpolygon->name.'.<br />';
							}
						}
					}

					$value_data['city'] = $listing['cityname'];
					$value_data['area'] = $listing['areaname']; // preparing $value_data pair to run through match_cities() function, since polygon failed.

					if ($cityareafound==0) {
						// polygon search results didn't return.. match by string name.
						list($listing['area'], $listing['city']) = match_cities($value_data, $cities, $subareas); // regular city/area as per MLS.
					} else {
						// polygon found something, but still get the primary area in.
						list($listing['area'], $discard['city']) = match_cities($value_data, $cities, $subareas); // the area becomes the default MLS area, while area_alt has the custom subarea based on polygon. City is kept the same was what polygon belongs in.
					}
					$listing['timestamp'] = $now;
					$listing['source'] = BRIX_LISTING_MLS;
					// Keep as source=1 as well - keep it that way so remote photo fetch works via JSON, until convert_ownlisting() runs.
					$updatephotos = 1;
					$insertid = form_to_table($destinationtable,$listing);
					// echo "Inserted new home ".$insertid."<br />".PHP_EOL;
					if ($insertid) {
						$newhome = new home;
						$newhome->initialize($insertid);
						// echo "Photo Count: ".(count($newhome->photos))."<br />".PHP_EOL;
						list($code, $homeid_modified, $message) = $newhome->convert_ownlisting();
					} else {
						$code = 0;
						$homeid_modified = false;
						$message = 'The MLS # '.$mls.' was found on '.$importurl.' but ';
					}

				} else {
					$code = 0;
					$homeid_modified = false;
					$message = 'The MLS # '.$mls.' was not found locally nor on '.$importurl.'.';
				}
			} else {
				// found the row local, process it over!
				$homearray = $homeresult->fetch_assoc();
				$homeid = $homearray['id'];
				$newhome = new home;
				$newhome->initialize($homeid);
				// echo "Photo Count: ".count($newhome->photos)."<br />".PHP_EOL;
				list($code, $homeid_modified, $message) = $newhome->convert_ownlisting();
				if($code==1) {
					$memcache_params = array(
						'type'=>'home',
						'listingsource'=>1,
						'mlsnum'=>$mls
					);
					get_memcache($memcache_params, 'delete');
				}
			}
		} else {
			// mls value seems to be blank!
			$code = 0;
			$homeid_modified = false;
			$message = "Invalid MLS Value: ".$mls." sent to server.";
		}
		break;


	case "order":
		// order can either go up or down, and it can also make something go straight to the top or straight to the bottom
		if ($_REQUEST['perpage']!='' && $_REQUEST['page']!='') {
			$homes = get_properties('',array('ownlisting'=>1), 'ord', 'ASC',$_REQUEST['perpage'],$_REQUEST['page']);
			$ordstart = ($_REQUEST['perpage']*($_REQUEST['page']-1))+1; // figure out where the order scheme starts depending on which page people are on.
			if ((count($_REQUEST['home'])==count($homes)) || $_REQUEST['reorder'] == 1 ) {
				$updatecount = 0;
				// only execute if the # of photos found on the home equals the length of the order array.
				foreach($_REQUEST['home'] as $ord=>$homeid) {
					$updatesql = "UPDATE `homes` SET ord='".$ordstart."' WHERE id='".$homeid."'";
					$updateresult = $mysqli->query($updatesql);
					if(!$updateresult) {
						$message.='Query Error: '.$updatesql;
					} else {
						$updatecount++;
					}
					$ordstart++;
				}
				if (count($_REQUEST['home'])==$updatecount) {
					$code = 1; // 1 for success
					$homeid_modified = $updatecount;
					$message = 'Reorder successful.';
				} else {
					$code = 0; // 0 for failure, something got missed.
					$homeid_modified = false;
					$message = 'Count was off - '.$updatecount.' homes modified, but found '.count($_REQUEST['home']).' homes based on query.';
				}
			} else {
				$code = 0;
				$homeid_modified = false;
				$message = 'Invalid request - please refresh the page and try again.';
			}
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = 'Invalid request - page data is necessary for an order change request.';
		}
		break;


    case "order_by_keyboard":
        $direction      = $_REQUEST['value'];   // this will be either "up" or "down"
        $selected_id    = $_REQUEST['idr'];     // home id to reorder

        $code = 1;
        $homeid_modified = $_REQUEST['idr'];
        $message = 'Order by keyboard';
        break;



	case "youtube":
		$videoid = getyoutubeid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$idr."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$homeid_modified = $idr;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = $mysqli->error;
		}
		break;

	case "vimeo":
		$videoid = getvimeoid($_REQUEST['value']);
		$sql = "UPDATE ".$destinationtable." SET `".$_REQUEST['field']."`='".$mysqli->real_escape_string($videoid)."' WHERE id='".$idr."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$homeid_modified = $idr;
			$message = ($videoid ? $videoid : ''); // return blank if its blank..
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = $mysqli->error;
		}
		break;

	case "virtualtour":
		// required field name = virtualtour
		$src_link = $_REQUEST['value'];
		$sql = "UPDATE ".$destinationtable." SET `virtualtour`='".$mysqli->real_escape_string($src_link)."' WHERE id='".$idr."'";
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$homeid_modified = $idr;
			$message = ($src_link ?: ''); // return blank if its blank...
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = $mysqli->error;
		}
		break;

	case "pdf_label":
		$sql = 'SELECT pdf_labels FROM '.$destinationtable.' WHERE id = '.$idr;
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['pdf_labels']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET pdf_labels = '$labels' WHERE id = ".$idr;
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$homeid_modified = $idr;
			$message = $labels."\n";
			$message .= 'AJAX Updated pdf label key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for building '.$idr;
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = $mysqli->error;
		}
		break;


	case "alt_tags":
		$sql = 'SELECT alt_tags FROM '.$destinationtable.' WHERE id = '.$idr;
		$result = $mysqli->query($sql);

		$labels = null;
		if ($array = $result->fetch_assoc()) {
			$labels = unserialize($array['alt_tags']);
		}

		$labels[$_REQUEST['key']] = $_REQUEST['value'];
		ksort($labels);

		$labels = $mysqli->real_escape_string( serialize( $labels ) );

		$sql = "UPDATE $destinationtable SET alt_tags = '$labels' WHERE id = ".$idr;
		$result = $mysqli->query($sql);
		if ($mysqli->affected_rows>0) {
			$code = 1;
			$homeid_modified = $idr;
			$message = $labels."\n";
			$message .= 'AJAX Updated Alt Tags key = '.$_REQUEST['key'].' and val = '.$_REQUEST['value'].' for page '.$idr;
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = $mysqli->error;
		}
		break;

	case "delete":
		// delete home function here!
		log_error("Deleting home ID ".$idr." through admin by user ".$_COOKIE['username']." from IP ".$_SERVER['REMOTE_ADDR'].".".PHP_EOL);

		if ($idr!='') {
			$result = $mysqli->query('SELECT ord FROM homes WHERE id = '.$idr);
			$resultArray = $result->fetch_assoc();
			$current_order = $resultArray['ord'];

			$sql = "UPDATE `homes` SET ord = ord - 1 WHERE (source = 0 OR (source = 1 AND feature = 1)) AND ord > ".$current_order;

			$result = $mysqli->query($sql);

			$removeresult = remove_home($idr);
		} else {
			$removeresult=false;
		}
		if ($removeresult) {
			$code = 1;
			$homeid_modified = $idr;
			$message = 'Successfully removed home '.$idr.'.';
		} else {
			$code = 0;
			$homeid_modified = false;
			$message = 'Failed to remove home '.$idr.'- error from MySQL was '.$mysqli->error.'.';
		}
	break;

	default:
		$code = 0;
		$message = 'Invalid change request: '.$_REQUEST['change'];
		break;
} // end of the switch statement

// finally package it all to a JSON output and spit it out! 
$json_array = array('code'=>$code, 'id'=>$homeid_modified, 'message'=>$message);
echo json_encode($json_array);

require_once 'ajax_footer.php';