<?php
/**
Filename: ajax_resizephoto.php

Method: AJAX
Output: raw text. 

Description: Allows brixwork admins to quickly resize photos, mainly called by the admin_resizephoto.php system.  

*/
ob_implicit_flush(true);

include 'start.php';
// start.php runs validate_login() function.
if($_REQUEST['folder']=='buildings') {
	$destinationfolder = 'buildings';
} else {
	$destinationfolder = 'homes';
}

$destinationfolder = $_REQUEST['folder'];

$tmp_folder = $_SERVER['DOCUMENT_ROOT'].'/tmp/';
if ($_REQUEST['objectid']!='' && $destinationfolder!='') {

	switch ($destinationfolder) {
		case 'homes':
			$object = new home;
			$object->initialize($_REQUEST['objectid']);
			$objecttitle = $object->fulladdress;
			break;

		case 'buildings':
			$object = new building;
			$object->initialize($_REQUEST['objectid']);
			$objecttitle = $object->name;
			break;

		case 'pages':
			$object = new page;
			$object->initialize($_REQUEST['objectid']);
			$objecttitle = $object->title;
			break;

		case 'agents':
			$object = new agent;
			$object->initialize($_REQUEST['objectid']);
			$objecttitle = $object->displayname;
			break;
	}

	$object->getphotos(); // this is universal for all object types.

	$files = array();// prepare empty array of files we will re-upload.
	$treference = substr($destinationfolder, 0, strlen($destinationfolder)-1);// remove s from end.. so instead of homes, we have home, for referencing to the field in $photo var.

	if ($object->photos) {
		// loop through!
		echo 'Preparing to loop through '.count($object->photos).' for '.$destinationfolder.' ID '.$object->id.' ('.$objecttitle.')<br />';
		foreach($object->photos as $photokey=>$photo) {
			$original_file_path = $photo['originalfilepath'];
			if($original_file_path!='') {
				$tmpfilename = $destinationfolder . '_' . $object->id . '_' . $photokey; // location of temporary JPG.
				$jpgcontent = curl_get_file_contents($original_file_path, "GET", '', 10000); // get the S3 JPG content.
				file_put_contents($tmp_folder.$tmpfilename, $jpgcontent); // save this JPG into the tmp folder, prepare.

				// now check integrity of the JPG file.

				if(file_exists($tmp_folder.$tmpfilename)) {
					$tmpcontent = file_get_contents($tmp_folder.$tmpfilename);
					if($jpgcontent==$tmpcontent) {
						$files[]  = array(
							'id'=>$photo['id'],
							'filename'=>$photo['filename'],
							'title'=>$photo['title'],
							'tmpfilename'=>$tmpfilename,
							$treference => $object->id
						);
					} else {
						echo '<span style="color:#f00;">File id '.$photo['id'].' ('.$photo['filename'].') tmp JPG failed, skip. <br />';
						unlink($tmp_folder.$filename);
					}
				}
			}
		}

		// we stored all the temporary JPGs!
		// dupliate what happens in ajax_receivephoto.php
		foreach($files as $file) {
			// remove old images first.
			$tmp_file = $tmp_folder.$file['tmpfilename']; // make sure to set folder right.

			echo 'Removing old gallery ID '.$file['id'].' ('.$file['filename'].')<br />';

			echo 'Uploading '.$file['tmpfilename'].' for object type '.$destinationfolder.' for ID '.$object->id.'<br />';
			remove_gallery_photos($file, $destinationfolder);

			$presult = attach_gallery_image($destinationfolder, $object->id, $file['filename'], $tmp_file, $file['title']); // admin_functions.php has it.

			$filepath = getS3FilePath( $settings, $object->id, $destinationfolder ).'/mobile/';

			$filename = sanitize_filename_for_s3_and_return($settings['s3_bucket'], $filepath, $file['filename']);
			$key = $filepath.$filename;

			waitUntilObjectExists( $settings['s3_bucket'], $key ); // this prevents execution of the echo below until this is good.

			echo 'Successfully loaded '.$presult['photoupload'][1]['web']['ObjectURL'].'<br />';

			unlink($tmp_file); // remove the TMP original JPG, lots of space wasted otherwise.
			ob_flush();
		}

		echo 'Finished '.count($files).' photos.<br /><br />';

	} else {
		echo 'No photos exist for '.$destinationfolder.' ID '.$object->id.' ('.$objecttitle.')<br />';
	}
} else {
	echo "Not enough data!<br />\r\n";
	print_r($_REQUEST);
}

require_once 'ajax_footer.php';