<?php
include 'start.php';

// UPDATED UPLOAD CODE FOR NEW TINYMCE
/***************************************************
 * Only these origins are allowed to upload images *
 ***************************************************/
//$accepted_origins = array($settings['sitepath']);

/*********************************************
 * Change this line to set the upload folder *
 *********************************************/
$imageFolder = $_SERVER['DOCUMENT_ROOT']."/uploads/";
if(!file_exists($imageFolder))  {
    mkdir($imageFolder);
}

//if (isset($_SERVER['HTTP_ORIGIN'])) {
//    // same-origin requests won't set an origin. If the origin is set, it must be valid.
//    if (in_array($_SERVER['HTTP_ORIGIN'], $accepted_origins)) {
//        header('Access-Control-Allow-Origin: ' . $_SERVER['HTTP_ORIGIN']);
//    } else {
//        header("HTTP/1.1 403 Origin Denied");
//        return;
//    }
//}

// Don't attempt to process the upload on an OPTIONS request
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    header("Access-Control-Allow-Methods: POST, OPTIONS");
    return;
}

reset($_FILES);
$temp = current($_FILES);
if (is_uploaded_file($temp['tmp_name'])) {
    /*
      If your script needs to receive cookies, set images_upload_credentials : true in
      the configuration and enable the following two headers.
    */
    // header('Access-Control-Allow-Credentials: true');
    // header('P3P: CP="There is no P3P policy."');

    // Sanitize input
    if (preg_match("/([^\w\s\d\-_~,;:\[\]\(\).])|([\.]{2,})/", $temp['name'])) {
        header("HTTP/1.1 400 Invalid file name.");
        return;
    }

    // Verify extension
    if (!in_array(strtolower(pathinfo($temp['name'], PATHINFO_EXTENSION)), array("gif", "jpg", "png"))) {
        header("HTTP/1.1 400 Invalid extension.");
        return;
    }

    // Accept upload if there was no origin, or if it is an accepted origin
    $filetowrite = $imageFolder . $temp['name'];
    move_uploaded_file($temp['tmp_name'], $filetowrite);

    // Determine the base URL
    //$protocol = isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? "https://" : "http://";
    //$baseurl = $protocol . $_SERVER["HTTP_HOST"] . "/";

    // Respond to the successful upload with JSON.
    // Use a location key to specify the path to the saved image resource.
    // { location : '/uploads/file'}
    echo json_encode(array('location' => '/uploads/'.$temp['name']));
} else {
    // Notify editor that the upload failed
    header("HTTP/1.1 500 Server Error");
}


// OLD CODE FOR OLD TINYMCE
//$json = array();
//$json['code'] = 0;  // negative (fail) by default.
//// Ensure the file was posted
//if($_SERVER['REQUEST_METHOD'] == 'POST' && isset($_FILES['file']['name'])){
//
//	// Define the upload path
//	$dir = $_SERVER['DOCUMENT_ROOT']."/uploads/";
//	if(!file_exists($dir))  {
//		mkdir($dir);
//	}
//
//	if(!is_writable($dir)) {
//		$chmodresult = chmod($dir, 0755);
//	} else {
//		$chmodresult = true;
//	}
//
//	if(!$chmodresult) {
//		$json['message'] = 'Upload folder permission failed - please contact Brixwork support!';
//	} else {
//		$filename = basename($_FILES['file']['name']);
//		$filePath = $dir . $filename; // upload path including public_html/ etc.
//
//		$fileURL = '/uploads/'.$filename; // path to /uploads from webroot.
//
//		$isjpg = false;
//		$ispdf = false;
//		$fileInfo = getimagesize($_FILES['file']['tmp_name']);
//		if ($fileInfo !== false) {
//			// Check MIME type
//			if ($fileInfo['mime'] == 'image/jpeg') {
//				// File is a JPEG image
//				$isjpg = true;
//				$json['message'] = 'JPG upload!';
//			} else {
//				$finfo = finfo_open(FILEINFO_MIME_TYPE); // return mime type
//				$mime = finfo_file($finfo, $_FILES['file']['tmp_name']);
//				if ($mime == 'application/pdf') {
//					$ispdf = true;
//					$json['message'] = 'PDF upload!';
//				}
//			}
//		}
//
//		if($isjpg==true || $ispdf==true && move_uploaded_file($_FILES['file']['tmp_name'], $filePath)) {
//			// Return JSON response
//			$json['code'] = 1;
//			$json['location'] = $fileURL;
//			$json['message'] .= ' - '.$filename.' was uploaded to '.$filePath;
//		} else {
//			$json['message'] .= 'Failed to upload file to '.$dir . $filePath;
//		}
//	}
//}
//
//echo json_encode($json);
?>