<?php
/*
Filename: ajax_uploadify.php
Location: /Volumes/Macintosh HD/Users/jeffkee/Documents/Work Docs/Brixwork/Brixwork-for-Realtors/dev/admin

Method: AJAX
Output: TEXT

Description: attach.php sends items here.. PDFs, main images etc. for all home/building/page etc. objects.

Author: Jeff Kee
*/

include 'start.php';
// start.php runs validate_login() function.

// Process $_POST variables ... these data come from brixwork_images.source.js uploadifive() function.
$idr = intval($_POST['idr']);
$destinationfolder = $mysqli->real_escape_string($_POST['destinationfolder']);
$filename = $_POST['filename'];

// Log
$log_file = 'logs/upload_'.$destinationfolder.'-'.$idr.'-'.$_FILES['Filedata']['name'].'_' . $now . '.log';
if (is_writable(dirname($log_file))) {
	$handle = fopen($log_file, 'a+');
} else {
	$handle = null;
}

//foreach ($_POST as $key=>$item) {
//    echo ($key.': '.$item);
//}
//echo 'local: '.$local;

$objectid = trim(remove_all_but_numbers($idr));
// process $_REQUEST vars into ... let's be less reliant on the $_REQUEST variables
//$destinationfolder = $mysqli->real_escape_string(trim($_REQUEST['destinationfolder']));
//$idr = $mysqli->real_escape_string($objectid);
//$filename = $mysqli->real_escape_string(trim($_REQUEST['filename']));

$image_url =  attach_files($destinationfolder, $idr, $filename, $_FILES['Filedata']); // in admin_functions.php

// update the table of the object to have the latest modified date.
$updatevar = array();
$updatevar['modify_date'] = $now;
$updatevar['timestamp'] = $now; // raw timestamp - this is what triggers the cloudfront URL to re-cache.
$uid = update_to_table($destinationfolder, $updatevar, $idr);

// memcache expiry for object rows.
// Do NOT confuse with get_photo_objects() and the pagephotos, agenthphotos cache - these are ONLY main images.
if($destinationfolder=='pages') {
	$memcache_params = array(
		'type'=>'pages'
	);
	get_memcache($memcache_params, 'delete');
} else {
	$objecttype = substr($destinationfolder, 0, strlen($destinationfolder)-1);
	$memcache_params = array(
		'type'=>$objecttype,
		'objectid'=>$idr
	);
	if($objecttype=='home') {
		$memcache_params['listingsource']=BRIX_LISTING_OWN;
		// there's never mainimages for BRIX_LISTING_MLS (source=1) listings anyawy.
	}
	get_memcache($memcache_params, 'delete');
}
echo s3_to_cloudfront($image_url).'?timestamp='.$local; // this is usually done by the home/building object but for the quick URL refresh we just create URL without another MySQL query.

// functions
function write_log ($msg) {
	global $handle;
	if (!empty($handle)) {
		fwrite($handle, $msg, strlen($msg));
	}
}

require_once 'ajax_footer.php';