<?php
include 'cronstart.php';

/*
 * Evolving this script to do more cleanups and purge of crap data.
 * 2024-05 Upgrades by Jeff Kee
 * THis can be run on a site by site basis while testing and applying on urgent needs,
 * But later we can set it to run from clients.brixwork.com one-time, like we did with php8lines.php.
 *
 * */

$log_file = 'logs/log.' . $now . '-homescleanup.log';
if (is_writable(dirname($log_file))) {
	$handle = fopen($log_file, 'a+');
} else {
	$handle = null;
}

/*
 * Removes duplicate cities and subareas.
 * After removing those areas, it keeps the IDs in an array.
 * Then it tidies up listings in the `homes` table by setting those city/area columns to 0,
 * and changes those modify_date to year 2000 as well for these listings,
 * thus forcing it to re-crawl on next retsimport.php run (or, client can update if its OWN listing).
 * */


$subareasquery = "SELECT `id`, `name`, `area`, COUNT(id) as cnt FROM `subareas` GROUP BY LOWER(`name`) HAVING cnt > 1";

$subareasresult = $mysqli->query($subareasquery);
if($subareasresult->num_rows > 0) {
	$duplicatesubareas = array();
	while($subarea = $subareasresult->fetch_assoc()) {
		$subquery = "SELECT s.id AS `id`, s.name AS `subareaname`, a.name AS `cityname`, s.area AS `cityid` 
				FROM `subareas` s 
				LEFT JOIN `areas` a ON s.area = a.id 
				WHERE LOWER(s.name)='".strtolower($mysqli->real_escape_string($subarea['name']))."' 
				ORDER BY s.area ASC, s.id ASC";
		$subresult = $mysqli->query($subquery);
		$subareascount = 0; // count duplicate subareas separately and do NOT delete the first one - keep it!
		while($subareas = $subresult->fetch_assoc()) {
			if($subareascount==0) {
				echo 'Keep primary subarea '.$subareas['id'].' for '.$subareas['subareaname'].' under '.$subareas['cityname'].' ('.$subareas['cityid'].')<br />';
				$cityid = $subareas['cityid'];
			} else {
				$homesundersubareasql = "SELECT `id`, `mls` FROM `homes` WHERE `area`='".$subareas['id']."' OR `area_alt` = '".$subareas['id']."'";
				$homesundersubarearesult = $mysqli->query($homesundersubareasql);
				if($cityid == $subareas['cityid'] || $homesundersubarearesult->num_rows>0) {
					// just in case there's a subarea with same name in a different city!
					echo 'DELETE subarea ID '.$subareas['id'].' named '.$subareas['name'].'<br />';
					$homequery = "UPDATE `homes` SET `modify_date`='2010-12-31 00:00:00' WHERE `area`='".$subareas['id']."'";
					$deletequery = "DELETE FROM `subareas` WHERE id='".$subareas['id']."'";
					if($_REQUEST['sql']=='1') {
						$mysqli->query($homequery);
						$mysqli->query($deletequery);
					}
					$duplicatesubareas[] = $subareas['id'];
				} else {
					// same subarea name, but different city - keep this one and only delete subsequent ones, if any.
					// no need to set $subareascount to 0 again, since this if/else block has already skipped the deletion.
					echo 'Different city ('.$subareas['cityname'].') detected for '.$subareas['id'].' for '.$subareas['subareaname'].'<br />';
					$cityid = $subareas['cityid'];
				}
			}
			$subareascount++;
		}
		echo '<br /><br />';
	}
} else {
	$duplicatesubareas = false;
	echo "No duplicate subareas found.";
}

/*
 * DUPLICATE or BLANK cities now!
 * */
$duplicateareas = array();
$areasquery = "SELECT `name`, COUNT(id) as cnt FROM `areas` GROUP BY `name` HAVING cnt > 1";
$areasresult = $mysqli->query($areasquery);
if($areasresult->num_rows>0) {
	while($area = $areasresult->fetch_assoc()) {
		$dupareasquery = "SELECT `id`, `name` FROM `areas` WHERE `name`='".$area['name']."' ORDER BY `id` ASC";
		echo "Detected duplicates for ".$area['name'].'. <br />';
		$dupareasresult = $mysqli->query($dupareasquery);
		$areascount = 0;
		while($areas = $dupareasresult->fetch_assoc()) {
			if($areascount==0) {
				echo 'Keep primary city '.$areas['id'].' for '.$areas['name'].'<br />';
			} else {

				$duplicateareas[$areas['id']] = $areas['name'];
			}
		}
	}
} else {
	echo "No duplicate city  names found!<br />";
}

$blankareaquery = "SELECT `name`, `id` FROM `areas` WHERE `name`='' OR `name`='0'";
$blankarearesult = $mysqli->query($blankareaquery);
if($blankarearesult->num_rows>0) {
	$blankarea = $blankarearesult->fetch_assoc();
	$duplicateareas[$blankarea['id']] = $blankarea['name'];
}

if(count($duplicateareas)>0) {
	// just in case there's a subarea with same name in a different city!
	foreach($duplicateareas as $areaid=>$areaname) {

		$homequery = "UPDATE `homes` SET `modify_date`='2010-12-31 00:00:00', `city`=0, `area`=0 WHERE `city`='".$areaid."'";
		echo 'DELETE area id '.$areaid.' named '.($areaname=='' ? 'BLANK' : $areaname).'<br />SQL: '.$homequery."<br />";
		$deletequery = "DELETE FROM `areas` WHERE id='".$areaid."'";
		if($_REQUEST['sql']=='1') {
			$mysqli->query($homequery);
			$mysqli->query($deletequery);
		}

	}

}

// now loop thorugh homes that are attached to non-existing cities & subareas, and set their modify date back.
$unlinkedareashomessql = "SELECT h.id, h.city, h.mls
FROM `homes` as h
LEFT JOIN `areas` as a
ON h.city = a.id
WHERE a.id IS NULL;";


$unlinkedareashomesresult = $mysqli->query($unlinkedareashomessql);
if($unlinkedareashomesresult->num_rows>0) {
	while($homes = $unlinkedareashomesresult->fetch_assoc()) {
		$updatesql = "UPDATE `homes` SET `modify_date`='2010-12-31 00:00:00', `city`=0 WHERE id='".$homes['id']."'";
		echo $updatesql;
		if($_REQUEST['sql']=='1') {
			$mysqli->query($updatesql);
		}
		echo '<br />';
	}
} else {
	echo "No listings connected to non-existent cities.<br />";
}

$unlinkedsubareashomessql = "SELECT h.id as id, h.city, h.area, h.mls
FROM `homes` as h
LEFT JOIN `subareas` as a
ON h.area = a.id
WHERE a.id IS NULL;";

$unlinkedsubareashomesresult = $mysqli->query($unlinkedsubareashomessql);
if($unlinkedsubareashomesresult->num_rows>0) {
	while($homes = $unlinkedsubareashomesresult->fetch_assoc()) {
		$updatesql = "UPDATE `homes` SET `modify_date`='2010-12-31 00:00:00', `area`=0 WHERE id='".$homes['id']."'";
		echo $updatesql;
		if($_REQUEST['sql']=='1') {
			 $mysqli->query($updatesql);
		}
		echo '<br />';
	}
} else {
	echo "No listings connected to non-existent subareas.<br />";
}


/*
 * BUILDINGS clean up!
 *
 * Too many sites had way too many duplicate buildings with empty names cropping up.
 * If any building has no name. and feature or publish is set to 0, at this point we're safer to just remove it.
 * Let groupbuildings.php run to re-set those going forward.
 *
 * */

$orphanbuildingssql = "SELECT b.id AS `bid`, b.number AS `number`, b.street AS `street`, a.name AS `cityname` FROM `buildings` b LEFT JOIN `areas` a ON b.city=a.id WHERE 
				 (b.mainid=0 OR b.mainid='' OR b.mainid=NULL)
				 AND b.name='' AND b.feature=0 AND b.publish=0 AND b.features='' AND b.description=''";


$orphanbuildingsresult = $mysqli->query($orphanbuildingssql);

if($orphanbuildingsresult->num_rows>0) {
	$orphaned = array();
	while($orphan = $orphanbuildingsresult->fetch_assoc()) {

		//echo "Processing " . $orphan['number'] . " " . $orphan['street'] . " at " . $orphan['cityname'] . " (ID: " . $orphan['bid'] . ")<br />";
		$homessql = "UPDATE `homes` SET `building`=0, `modify_date`='2010-01-01 00:00:00' WHERE `building`=" . $orphan['bid'];
		$orphaned[] = $orphan['bid'];
		$deletesql = "DELETE FROM `buildings` WHERE `id`='".$orphan['bid']."'";



		echo "Building delete SQL: ".$deletesql."<br />";
		if($_REQUEST['sql']=='1') {
			$mysqli->query($homessql);
			$mysqli->query($deletesql);
		}
	}
}

/*
 * BUILDINGS clean up!
 *Some buildings had `street_name` columns remain blank, while `street` was filled.
 * i.e. `street` = 'Ontario street', `street_name` = ''.
 *
 *
 * */


if ($mysqli->connected) {
	$mysqli->close();
}

?>