<?php
/*
Filename: header.php

Method: Include
Output: Direct HTMl

Description: this is the header file for all admin pages.

Author: Jeff Kee
*/
// WEBSITE SUSPENDED ... REDIRECT
if ($settings['suspend_website']==1 && validate_login() && $_COOKIE['username']!='brixwork') {
	logoff();
	header('Location: '.$GLOBALS[BRIX_FORWARD_DESTINATION_URL], TRUE, 302);
	exit();
} ?>
<!DOCTYPE html>
<html lang="en">
<head>

<title>Brixwork for Realtors [<?=(is_array($settings['owner']) ? $settings['title'] : $settings['owner'])?>]</title>
<meta http-equiv="Content-Type" content="text/html; charset=<?= $encoding;?>">

<link rel="shortcut icon" href="images/favicon.ico">
<link rel="apple-touch-icon" sizes="57x57" href="images/apple-touch-icon-57x57.png">
<link rel="apple-touch-icon" sizes="114x114" href="images/apple-touch-icon-114x114.png">
<link rel="apple-touch-icon" sizes="72x72" href="images/apple-touch-icon-72x72.png">
<link rel="apple-touch-icon" sizes="144x144" href="images/apple-touch-icon-144x144.png">
<link rel="apple-touch-icon" sizes="60x60" href="images/apple-touch-icon-60x60.png">
<link rel="apple-touch-icon" sizes="120x120" href="images/apple-touch-icon-120x120.png">
<link rel="apple-touch-icon" sizes="76x76" href="images/apple-touch-icon-76x76.png">
<link rel="apple-touch-icon" sizes="152x152" href="images/apple-touch-icon-152x152.png">
<link rel="apple-touch-icon" sizes="180x180" href="images/apple-touch-icon-180x180.png">
<link rel="icon" type="image/png" href="images/favicon-192x192.png" sizes="192x192">
<link rel="icon" type="image/png" href="images/favicon-160x160.png" sizes="160x160">
<link rel="icon" type="image/png" href="images/favicon-96x96.png" sizes="96x96">
<link rel="icon" type="image/png" href="images/favicon-16x16.png" sizes="16x16">
<link rel="icon" type="image/png" href="images/favicon-32x32.png" sizes="32x32">
<meta name="msapplication-TileColor" content="#da532c">
<meta name="msapplication-TileImage" content="images/mstile-144x144.png">
<meta name="msapplication-config" content="images/browserconfig.xml">

<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">
<?php
$versionappend = '?v='.$brixwork_version;
if($settings['sitepath']=='http://dev.brixwork.com/' || $settings['sitepath']=='https://dev.brixwork.com/') {
	// temporarily override master_url to dev.brixwork.com for testing. 
	$settings['master_url'] = 'https://dev.brixwork.com/';
	$versionappend = '?v='.rand(0,999);
}
?>
<link rel="preconnect" href="https://fonts.googleapis.com"><link rel="preconnect" href="https://fonts.gstatic.com" crossorigin><link href="https://fonts.googleapis.com/css2?family=Montserrat:wght@300;400;500;600;700&family=Roboto:wght@300;400;500&display=swap" rel="stylesheet">
<link rel="stylesheet" type="text/css" media="all" href="<?= $settings['master_url']?>css/common.css<?=$versionappend;?>" />
<link rel="stylesheet" type="text/css" media="all" href="<?= $settings['master_url']?>css/common_mobile.css<?=$versionappend;?>" />

<!--BOOTSTRAP 5 INCLUDES - CSS & ICONS .... JAVASCRIPT IS INCLUDED IN THE FOOTER & TINYMCE IS THE JS CODE THAT WILL ENABLE EDITING ON THE TEXTAREA -->
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.3/font/bootstrap-icons.css">
<script src="../packages_8/vendor/tinymce/tinymce/tinymce.min.js" referrerpolicy="origin"></script>

<link rel="stylesheet" type="text/css" media="all" href="css/layout.css<?=$versionappend;?>" />

<!-- JQUERY INCLUSIONS ... CANNOT USE 3.6.1 BECAUSE OF UPLOADIFIVE -> find an alternative first before upgrading JQuery -->
<script type="text/javascript" src="<?=$settings['google_code_api_url']?>jquery/1.11.1/jquery.min.js"></script>
<script type="text/javascript" src="<?=$settings['google_code_api_url']?>jqueryui/1.11.0/jquery-ui.min.js"></script>

<!-- Latest compiled and minified CSS -->
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/css/bootstrap-select.min.css">

<!-- Latest compiled and minified JavaScript -->
<script type="text/javascript" src="<?=$settings['sitepath']?>admin/js/bootstrap-select.js"></script>
<link rel="stylesheet" type="text/css" media="all" href="<?=$settings['master_url']?>admin/css/jquery.Jcrop.0.9.15.css<?=$versionappend;?>" />
<link rel="stylesheet" type="text/css" media="all" href="<?=$settings['sitepath']?>admin/js/uploadifive/uploadifive.css<?=$versionappend;?>" />
<script type="text/javascript" src="<?=$settings['master_url']?>admin/js/uploadifive/jquery.uploadifive.js<?=$versionappend;?>"></script>
<script type="text/javascript" src="<?=$settings['master_url']?>admin/js/jquery.number.js<?=$versionappend;?>"></script>
<script type="text/javascript" src="<?=$settings['master_url']?>admin/js/jquery.touchpunch.js<?=$versionappend;?>"></script>
<script type="text/javascript" src="<?=$settings['master_url']?>admin/js/jcrop.js<?=$versionappend;?>"></script>
<script type="text/javascript" src="<?=$settings['master_url']?>js/holder.js"></script>
<script type="text/javascript" src="<?=$settings['sitepath']?>admin/js/basics.source.js"></script>
<?php
// if an external custom script is called into a specific page, this is where we load her.
if ($scriptinclude!='') {
	if (is_array($scriptinclude)) {
		foreach($scriptinclude as $include) {
			echo '<script type="text/javascript" src="'.$settings['sitepath'].'admin/js/'.$include.$versionappend.'"></script>
			';
		}
	} else {
	echo '<script type="text/javascript" src="'.$settings['sitepath'].'admin/js/'.$scriptinclude.$versionappend.'"></script>';
	}
}

// if script is to be embedded rather than included, here it is. The $scriptinsert var must start and end with full <script> tags.
if ($scriptinsert!='') {
	echo $scriptinsert;
}
?>
<script type="text/javascript">
    if (!window.console) console = { log: function() {} };
    // enable console to work without causing error on IE.

    let getvar = [];

    <?php     // loop through all $_GET variables and convert them into window.getvar[varname]
    foreach ($_GET as $key=>$value) {
        echo 'getvar["'.$key.'"] = "'.$value.'";';
    } ?>

    window.getvar = getvar;
    window.sitepath = "<?=$settings['sitepath']?>";
</script>
<?php
// after JS loading is done, turn back the master url
// $settings['master_url'] = 'http://demo.brixwork.com/master/';
?>
</head>

<?php // OPEN BODY TAG ... ?>
<body>

<?php // Step 1: Include the JavaScript SDK on your page once, ideally right after the opening body tag. ?>
<div id="fb-root"></div>
<script async defer crossorigin="anonymous" src="https://connect.facebook.net/en_US/sdk.js#xfbml=1&version=v16.0" nonce="Iojo6rfV"></script>
<input type="hidden" id="mls_integrated" value="<?= ($settings['mls_integrated']==1 ? '1' : '0');?>">