<?php // BASIC INFO TAB - LISTING DETAILS
global $settings;
?>
<div class="d-flex justify-content-between flex-wrap">
    <?php // MAIN DETAILS ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Main Details</h3>

        <div class="row">
            <div class="col-xl-4 col-md-6 mb-4 mt-auto">
                <label for="name" class="control-label orange">Name of Building</label>
                <input type="text" name="name" id="name" class="form-control" tabindex="0" value="<?=(!$building->defaultname ? $building->name : ($_GET['name']!=''? $_GET['name'] : ''))?>" placeholder="Enter the name of building or townhome complex" />
            </div>

            <div class="col-xl-4 col-md-6 mb-4 mt-auto">
                <label for="builder" class="control-label orange">Developed By</label>
                <input type="text" name="builder" id="builder" class="form-control" tabindex="0" value="<?=$building->builder?>" placeholder="Polygon Homes, Cressey etc." />
            </div>

            <div class="col-xl-4 col-md-6 mb-4 mt-auto">
                <label for="status" class="control-label orange">Status</label>
                <select class="form-select" name="status" id="status">
                   <?php
                   if (isset($settings['building_status_display']) && is_array($settings['building_status_display'])):
                       foreach ($settings['building_status_display'] as $key => $each_building_status):
                           $selected = $building->data['status'] == $key ? 'selected' : '';
                           ?>
                           <option value="<?=$key?>" <?=$selected?>><?=$each_building_status?></option>
                       <?php
                       endforeach;
                   endif;
                   ?>
                </select>
            </div>

            <div class="col-xl-4 col-md-6 mb-4 mt-auto">
                <label for="rental" class="control-label orange">Long Term Rentals</label>
                <select name="rental" id="rental" class="form-select">
                    <option value="0">Not Allowed</option>
                    <option value="1"<?=($building->data['rental']=='1' ? 'selected="selected"' : '')?>>Allowed</option>
                </select>
            </div>

            <div class="col-xl-4 col-sm-6 mb-4 mt-auto">
                <label for="short_term_rental" class="control-label orange">Short Term Rentals</label>
                <select name="short_term_rental" id="short_term_rental" class="form-select">
                    <option value="0">Not Allowed</option>
                    <option value="1"<?=($building->data['short_term_rental']=='1' ? 'selected="selected"' : '')?>>Allowed</option>
                </select>
            </div>

            <div class="col-xl-4 col-sm-6 mb-4 mt-auto">
                <label for="pets" class="control-label orange">Pets</label>
                <select name="pets" id="pets" class="form-select">
                    <option value="0">No Pets</option>
                    <option value="1"<?=($building->data['pets']=='1' ? 'selected="selected"' : '')?>>Allowed</option>
                </select>
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="air_conditioning" class="control-label orange">Building A/C</label>
                <select name="air_conditioning" id="air_conditioning" class="form-select">
                    <option value="">Not Specified</option>
                    <option value="0">Not Included</option>
                    <option value="1"<?=($building->data['air_conditioning']=='1' ? 'selected="selected"' : '')?>>Included</option>
                </select>
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="ev_charging" class="control-label orange">E/V Charging</label>
                <select name="ev_charging" id="ev_charging" class="form-select">
                    <option value="">Not Specified</option>
                    <option value="0">Not Included</option>
                    <option value="1"<?=($building->data['ev_charging']=='1' ? 'selected="selected"' : '')?>>Included</option>
                </select>
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="construction" class="control-label orange">Construction</label>
                <input type="text" class="form-control trim_input" id="construction" name="construction" placeholder="i.e. Wood, Concrete..." value="<?=$building->construction?>" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="land_title" class="control-label orange">Land Title</label>
                <select name="land_title" id="land_title" class="form-select">
                    <?php
                    foreach ($settings['building_land_title_display'] as $land_title_key => $land_title_display) {
                        $text = $land_title_display ?: 'Not Provided';
                        $selected = $building->land_title == $land_title_display ? 'selected' : '';
                        echo "<option value='$land_title_key' $selected>$text</option>";
                    }
                    ?>
                </select>
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="storeys" class="control-label orange">Storeys</label>
                <input type="number" inputmode="numeric" class="form-control" id="storeys" name="storeys" placeholder="i.e. 28" value="<?=$building->storeys?>" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="suites" class="control-label orange">Number of Suites</label>
                <input type="number" inputmode="numeric" class="form-control" id="suites" name="suites" placeholder="i.e. 305" value="<?=$building->suites?>" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="year" class="control-label orange">Year Built</label>
                <input type="number" inputmode="numeric" class="form-control" id="year" name="year" placeholder="i.e. 2008" value="<?=$building->year?>" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="strataid" class="control-label orange">Strata/HOA ID</label>
                <input type="text" class="form-control" id="strataid" name="strataid" placeholder="i.e. ST78978" value="<?=$building->strataid?>"  />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="min_beds" class="control-label orange">Min Bedrooms</label>
                <input type="number" inputmode="numeric" name="min_beds" id="min_beds" class="form-control trim_input " value="<?=$building->data['min_beds']?>" placeholder="i.e. 3" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="max_beds" class="control-label orange">Max Bedrooms</label>
                <input type="number" inputmode="numeric" name="max_beds" id="max_beds" class="form-control trim_input " value="<?=$building->data['max_beds']?>" placeholder="i.e. 3" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="min_baths" class="control-label orange">Min Bathrooms</label>
                <input type="number" inputmode="numeric" name="min_baths" id="min_baths" class="form-control trim_input " value="<?=$building->data['min_baths']?>" placeholder="i.e. 3" />
            </div>

            <div class="col-xl-3 col-sm-6 mb-4 mt-auto">
                <label for="max_baths" class="control-label orange">Max Bathrooms</label>
                <input type="number" inputmode="numeric" name="max_baths" id="max_baths" class="form-control trim_input " value="<?=$building->data['max_baths']?>" placeholder="i.e. 3" />
            </div>

            <div class="col-xl-6 col-sm-12 mb-4 mt-auto">
                <label for="min_price" class="control-label orange">Min Price $</label>
                <input type="text" name="min_price" id="min_price" class="form-control trim_input " value="<?=$building->data['min_price']?>" placeholder="i.e. $100,000" />
            </div>

            <div class="col-xl-6 col-sm-12 mb-4 mt-auto">
                <label for="max_price" class="control-label orange">Max Price $</label>
                <input type="text" name="max_price" id="max_price" class="form-control trim_input " value="<?=$building->data['max_price']?>" placeholder="i.e. $3,100,000" />
            </div>
        </div>
    </div>

    <?php // Building Description ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Building Description</h3>

        <div class="row">
            <div class="col-xl-6 col-sm-12">
                <div class="col-12 mb-4 mt-auto">
                    <label for="heading" class="control-label orange">Heading</label>
                    <input type="text" name="heading" id="heading" class="form-control trim_input" size="40" value="<?=htmlspecialchars($building->heading ?: '')?>" placeholder="i.e. Gorgeous House Overlooking..." />
                </div>

                <?php // SECOND LANGUAGE ENABLED
                if ($settings['description2on'] == 1): ?>
                <div class="col-12 mb-4 mt-auto">
                    <label for="heading2" class="control-label orange">Heading 2</label>
                    <input type="text" name="heading2" id="heading2" class="form-control trim_input" size="40" value="<?=htmlspecialchars($building->heading2 ?: '')?>" placeholder="i.e. 2nd language heading" />
                </div>
                <?php
                endif; ?>

                <div class="col-12 mb-4 mt-auto">
                    <label for="description" class="control-label orange">Description</label>
                    <textarea name="description" id="description" class="form-control rich_editor"><?=$building->data['description']?></textarea>
                </div>

                <?php // SECOND LANGUAGE ENABLED
                if ($settings['description2on'] == 1): ?>
                    <div class="col-12 mb-4 mt-auto">
                        <label for="description2" class="control-label orange">Description 2</label>
                        <textarea name="description2" id="description2" class="form-control rich_editor"><?=$building->data['description2']?></textarea>
                    </div>
                <?php
                endif; ?>
            </div>

            <div class="col-xl-6 col-sm-12">
                <div class="col-12 mb-4 mt-auto">
                    <label for="remarks" class="control-label orange">Remarks</label>
                    <input type="text" name="remarks" id="remarks" class="form-control trim_input" size="40" value="<?=htmlspecialchars($building->data['remarks'] ?: '')?>" placeholder="i.e. 50% sold out!" />
                </div>

                <?php // SECOND LANGUAGE ENABLED
                if ($settings['description2on'] == 1): ?>
                <div class="col-12 mb-4 mt-auto">
                    <label for="remarks2" class="control-label orange">Remarks 2</label>
                    <input type="text" name="remarks2" id="remarks2" class="form-control trim_input" size="40" value="<?=htmlspecialchars($building->data['remarks2'] ?: '')?>" placeholder="i.e. 2nd language remarks" />
                </div>
                <?php
                endif; ?>

                <div class="col-12 mb-4 mt-auto">
                    <label for="excerpt" class="control-label orange">Brief Excerpt</label>
                    <textarea name="excerpt" id="excerpt" class="form-control" rows="5" style="width:100%;"><?=$building->excerpt?></textarea>
                </div>

                <?php // SECOND LANGUAGE ENABLED
                if ($settings['description2on'] == 1): ?>
                    <div class="col-12 mb-4 mt-auto">
                        <label for="excerpt2" class="control-label orange">Brief Excerpt 2</label>
                        <textarea name="excerpt2" id="excerpt2" class="form-control" rows="5" style="width:100%;"><?=$building->excerpt2?></textarea>
                    </div>
                <?php
                endif; ?>
            </div>
        </div>
    </div>


    <?php // Unit Types Available ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Unit Types Available</h3>

        <div class="row mx-0">
            <?php
            if (is_array($settings['type'])):
                foreach ($settings['type'] as $type_id => $type_name):
                    if (!$type_name) continue;
                    $checked = is_array($building->unittypes) && in_array($type_name, $building->unittypes);
                    display_type_row($type_id, $type_name, $checked);
                endforeach;
            else: ?>

                <h5>No unit types to show - check listing settings</h5>
            <?php
            endif; ?>
        </div>
    </div>



    <?php // Building Features ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Building Features</h3>

        <?php
        // INIT & DISPLAY OBJECT FEATURES
        $featurearray = list_building_features() ?: array(); // encase this function returns false, fall back to empty array;
        $init_object = is_object($building) ? $building : new building;
        init_listing_features($init_object, $featurearray)
        ?>
    </div>



    <?php //CUSTOM FIELDS
    $brixwork_coder_tip = login_level_check(USER_LOGIN_BRIXWORK) ? 'data-bs-toggle="tooltip" data-bs-placement="left" data-bs-custom-class="brixwork-tooltip" data-bs-title="Coder Tip: The custom fields can be reordered by dragging!" ' : '';
    ?>
    <div id="custom_fields_table" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Custom Fields</h3>

        <?php
        $custom_field_object_type = $building;
        include 'includes/object_custom_field.php';
        ?>
    </div>
</div>