<?php // BASIC INFO TAB - LISTING DETAILS
global $settings;
?>
<div class="d-flex justify-content-between flex-wrap">
    <?php // Address of Building ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Address of Building</h3>

        <div class="row">
            <?php // ADDRESS INPUT COLUMN ?>
            <div class="col-lg-7">
                <div class="row">
                    <div class="col-xl-4 col-md-6 mb-4">
                        <label for="building_number" class="control-label orange">Street Number</label>
                        <input type="text" name="number" id="building_number" class="form-control" value="<?=($building->data['number']!='' ? $building->data['number'] : ($_GET['number'] ?: ''))?>" placeholder="Street #">
                    </div>

                    <div class="col-xl-3 col-md-6 mb-4" id="building_street_dir_container">
                        <label for="building_street_dir" class="control-label orange">Direction</label>
                        <input type="text" name="street_dir" id="building_street_dir" class="form-control" value="<?=($building->data['street_dir']!='' ? $building->data['street_dir'] : ($_GET['street_dir'] ?: ''))?>" placeholder="i.e. W">
                        <div class="pt-2">
                            <a class="street_dir_position_toggle" data-maptype="building">Switch Order</a>
                        </div>
                        <input type="hidden" id="building_street_dir_position" name="street_dir_position" value="<?=($_GET['mode']=='new' ? $settings['street_dir_position_default'] : $building->data['street_dir_position'])?>" />
                    </div>

                    <div class="col-xl-5 col-md-12 mb-4" id="building_street_name_container">
                        <label for="building_street" class="control-label orange">Street Name</label>
                        <input type="text" name="street" id="building_street" class="form-control" value="<?=($building->data['street']!='' ? $building->data['street'] : ($_GET['street'] ?: ''))?>" placeholder="ABC Street" />
                    </div>

                    <div class="col-12 mb-4 mt-auto order-3">
                        <label for="city" class="control-label orange">City</label>
                        <select name="city" id="building_city" class="form-select">
                            <option value="">Choose a City</option>
                            <?php
                            $cities = get_published_cities($building);
                            select_published_cities($cities, $building, 'city'); ?>
                        </select>
                        <input type="hidden" name="location" id="location" value="<?=($settings['location']!='' ? $settings['location'] : ($settings['province']!='' ? $settings['province'] : 'BC, Canada') )?>" />
                    </div>

                    <div class="col-12 mb-4 mt-auto order-4">
                        <label for="building_area" class="control-label orange">Subarea</label>
                        <select name="area" id="building_area" class="form-select">
                            <option value="">Choose a Subarea</option>
                            <?php
                            if ($building->data['city']!="" || $_GET['city']!='') {
                                $subareas = get_subareas($building->data['city']);
                                foreach($subareas as $subarea_id) {
                                    $subarea = new subarea;
                                    $subarea->initialize($subarea_id);
                                    $selected_text = ($building->data['area'] == $subarea_id) ? 'selected' : '';
                                    echo '<option value="'.$subarea_id.'"'.$selected_text.'>'.$subarea->name.'</option>';
                                }
                            } ?>
                        </select>
                    </div>
                </div>
            </div>

            <?php
            // MAP DISPLAY COLUMN
            // if building does not exist, fallback to default value
            $default_lat_long = explode(',', $settings['baselatlong']);
            if (is_object($building) && $building->lat != '' && $building->long != ''):
                $building_lat   = $building->lat;
                $building_long  = $building->long;
            else:
                $building_lat  = $default_lat_long[0];
                $building_long  = $default_lat_long[1];
            endif;
            ?>
            <div class="col-lg-5">
                <label class="control-label orange">Map For Precise Location</label>
                <div id="buildingmapcontainer" class="listingmapcontainer box-shadow" data-lat="<?=$building_lat?>" data-long="<?=$building_long?>">
                    <div id="buildingmap" class="listingmap" data-maptype="building"></div>
                </div>

                <div class="map_functions_wrapper mt-4">
                    <button type="button" class="btn btn-admin find_address_on_map" data-maptype="building">Find Address</button>
                    <button type="button" class="btn btn-admin light_blue reset_map" data-maptype="building">Reset Map</button>
                </div>
            </div>

            <input type="hidden" name="lat" id="building_lat" class="form-control" value="<?=$building->data['lat']?>"/>
            <input type="hidden" name="long" id="building_long" class="form-control" value="<?=$building->data['long']?>"/>
        </div>
    </div>


    <?php // ATTACHING SUB-BUILDING
    // This function requires an IDR of currently modifying building, so not available for new building. Create the new building first by clicking "Save Building"
    if ($_REQUEST['mode'] == 'modify' || $_REQUEST['idr']) :
    ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Attach Sub-Buildings</h3>

        <div class="row">
            <div class="col-lg-7">
                <div id="subbuildings">
                    <?php // filled with ajax call fetch_subbuildings(); ?>
                </div>

                <?php // SUB BUILDING SEARCH FORM ?>
                <div class="row mb-4">
                    <div class="col-xl-4 col-sm-6 mt-auto">
                        <label for="search_number" class="control-label orange">Street Number</label>
                        <input type="text" name="search_number" id="search_number" class="form-control" placeholder="i.e. 1234">
                    </div>

                    <div class="col-xl-2 col-sm-6 mt-auto">
                        <label for="search_street_dir" class="control-label orange">Direction</label>
                        <input type="text" name="search_street_dir" class="form-control input-sm trim_input" id="search_street_dir" value="<?=$building->data['street_dir']?>" placeholder="i.e. W">
                    </div>

                    <div class="col-xl-4 col-sm-6 mt-auto">
                        <label for="search_street" class="control-label orange">Street Name</label>
                        <input type="text" name="search_street" id="search_street" class="form-control input-sm trim_input" value="<?=$building->data['street']?>" placeholder="i.e. ABC Street" />
                    </div>

                    <div class="col-xl-2 col-sm-6 mt-auto">
                        <button class="btn btn-admin" id="search_submit">Search</button>
                    </div>
                </div>

                <?php // RESULT OF THE BUILDING SEARCH ?>
                <div class="row">
                    <div class="col-12" id="building_search_list">
                        <?php // FILLED WITH AJAX ?>
                    </div>
                    <input type="hidden" id="building_attach_this" name="building_attach_this"/>
                    <input type="hidden" id="building_attach_destination" name="building_attach_destination"/>
                </div>
            </div>

            <div class="col-lg-5 px-5" id="gallery_tip">
                <?php
                $svg_append = 'images/admin_function_icon/';
                echo get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true));
                ?>
                <p class="my-4">
                    Attaching sub-buildings allows listings under multiple addresses to appear under this building. <br><br>
                    To start, search for an address of the building you want to attach or create a new building with the matching address.
                </p>
            </div>
        </div>
    </div>
    <?php
    endif; // do not show if new or no id ?>
</div>