<?php
// BUILDINGS LEADS & ACCESS TAB
// THIS TAB IS ONLY VISIBLE IF AGENT MODULE IS ACTIVE
global $settings;
global $login_user;
?>
<div class="d-flex justify-content-between flex-wrap">
    <?php // LEADS & SALES ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Leads</h3>

        <div class="row">
            <div class="col-lg-6">
                <label class="control-label orange">Agents</label>
                <?php
                /**
                 * @var $building building  Current building object.
                 * @var $building_agent agent   Current agent object in the loop.
                 * At this point, already checked agent module is active or not ... get agent list!
                 * Create 3 dropdowns with Agent names
                 *
                 * 1. Get all billable agents.
                 */
                $agents = list_agents(array('publish' => 1, 'billable' => 1), 'ord', 'ASC', 100, 1);
                for ($agent_count = 1; $agent_count <= $num_dropdown = 3; $agent_count++):
                    $agent_order = "agent_$agent_count"; // to get $building->agent_1, ->agent_2, ... already an agent object, no need to initialize.
                    $building_agent = $building->$agent_order;
                    if (in_array($building_agent->id, $login_user->getAgents()) || !$building_agent || login_level_check(USER_LOGIN_MANAGER)) {
                        // if building's agent is associated with login user OR not set OR user is Manager/Admin: show dropdown. ?>
                        <select name="<?=$agent_order?>" id="<?=$agent_order?>" class="selectpicker w-100 mb-2 agent_dropdown" data-live-search="true" aria-label="Agent Select <?=$agent_count?>">
                            <?php
                            echo "<option value=''>Select Agent</option>";

                            foreach ($agents as $agent_id):
                                $each_agent = new agent;
                                $each_agent->initialize($agent_id);
                                /**
                                 * Skip condition
                                 * 1. no display name
                                 * 2. not associated agent to login user. (does not affect Admin or Manager login)
                                 */
                                if ($each_agent->displayname == "" || (!login_level_check(USER_LOGIN_MANAGER) && !in_array($agent_id, $login_user->getAgents()))) continue;
                                $selected = ($building_agent->id == $agent_id) ? 'selected' : '';
                                ?>
                                <option value="<?=$agent_id?>" data-email="<?=$each_agent->email?>" <?=$selected?>><?=$each_agent->displayname?></option>
                            <?php
                            endforeach; ?>
                        </select>
                    <?php
                    } else {
                        // the building's agent is NOT associated with login user - display only... do the same for listings! ?>
                        <div class="user_agent_list mb-2">
                            <h6><?=$building_agent->displayname?></h6>
                            <input type="hidden" name="<?=$agent_order?>" id="<?=$agent_order?>" value="<?=$building_agent->id?>">
                        </div>
                    <?php
                    }
                endfor; ?>
            </div>

            <div class="col-lg-6 mt-4 mt-lg-0">
                <label for="email" class="control-label orange">Lead Emails</label>
                <input type="text" name="email" id="email" class="form-control trim_input" size="40" value="<?= $building->email ? htmlspecialchars($building->email) : ''?>" placeholder="i.e. links.townhomes@followupbossme.com, alex@century21.com..." />

                <h5 class="mt-4">NOT ALL WEBSITES ARE SET UP FOR THIS</h5>
                <p class="my-2 fs-6">Leave this blank if you want the leads from this building to go to the site-wide default lead emails, specified under the Settings -> Contact tab.</p>
            </div>
        </div>
    </div>
</div>