<?php // BUILDINGS SHOWROOM TAB
global $settings;
?>
<div class="d-flex justify-content-between flex-wrap">
    <?php // Address of Showroom ?>
    <div id="building_basic_details" class="each_tab__category brixwork_inner_spacing w-100">
        <h3 class="each_tab__category_title">Showroom Address</h3>

        <div class="row">
            <?php // INFO BLOCK ?>
            <div class="col-lg-7">
                <div class="row">
                    <div class="col-xl-4 col-sm-6 mb-4">
                        <label for="showroom_number" class="control-label orange">Street Number</label>
                        <input type="text" name="showroom_number" id="showroom_number" class="form-control" value="<?=$building->data['showroom_number']?>" placeholder="i.e. 1234" />
                    </div>

                    <div class="col-xl-3 col-sm-6 mb-4" id="showroom_street_dir_container">
                        <label for="showroom_street_dir" class="control-label orange">Direction</label>
                        <input type="text" name="showroom_street_dir" id="showroom_street_dir" class="form-control" value="<?=$building->data['showroom_street_dir']?>" placeholder="i.e. W">
                        <div class="pt-2">
                            <a class="street_dir_position_toggle" data-maptype="showroom">Switch Order</a>
                        </div>
                        <input type="hidden" id="showroom_street_dir_position" name="showroom_street_dir_position" value="<?=($_GET['mode']=='new' ? $settings['street_dir_position_default'] : $building->data['showroom_street_dir_position'])?>" />
                    </div>

                    <div class="col-xl-5 col-md-12 mb-4" id="showroom_street_name_container">
                        <label for="showroom_street" class="control-label orange">Street Name</label>
                        <input type="text" name="showroom_street" id="showroom_street" class="form-control trim_input" value="<?=$building->data['showroom_street']?>" placeholder="i.e. ABC Street" />
                    </div>

                    <div class="col-12 mb-4 mt-auto order-3">
                        <label for="showroom_city" class="control-label orange">City</label>
                        <select name="showroom_city" id="showroom_city" class="form-select">
                            <option value="">Choose a City</option>
                            <?php
                            $cities = get_published_cities($building);
                            select_published_cities($cities, $building, 'showroom_city');
                            ?>
                        </select>
                    </div>

                    <div class="col-12 mb-4 mt-auto order-4">
                        <label for="showroom_area" class="control-label orange">Subarea</label>
                        <select name="showroom_area" id="showroom_area" class="form-select">
                            <option value="">Choose a Subarea</option>
                            <?php
                            if ($building->data['showroom_city'] != '' || $_GET['city'] != '') {
                                $subareas = get_subareas($building->data['showroom_city']);
                                foreach($subareas as $subarea_id) {
                                    $subarea = new subarea;
                                    $subarea->initialize($subarea_id);
                                    $selected_text = ($building->data['showroom_area'] == $subarea_id) ? 'selected' : '';
                                    echo '<option value="'.$subarea_id.'"'.$selected_text.'>'.$subarea->name.'</option>';
                                }
                            } ?>
                        </select>
                    </div>

                    <div class="col-12 mb-4 mt-auto order-5">
                        <label for="showroom_hours" class="control-label orange">Showroom Hours</label>
                        <textarea rows="1" name="showroom_hours" id="showroom_hours" class="form-control" placeholder="i.e. Mon: 10AM ~ 6PM..."><?=$building->data['showroom_hours']?></textarea>
                    </div>
                </div>
            </div>

            <?php
            // MAP LOCATION BLOCK
            // if building does not exist, fallback to default value
            $default_lat_long = explode(',', $settings['baselatlong']);
            if (is_object($building) && $building->showroom_lat != '' && $building->showroom_long != ''):
                $showroom_lat   = $building->showroom_lat;
                $showroom_long  = $building->showroom_long;
            else:
                $showroom_lat   = $default_lat_long[0];
                $showroom_long  = $default_lat_long[1];
            endif;
            ?>
            <div class="col-lg-5">
                <label class="control-label orange">Showroom Location</label>
                <div id="showroommapcontainer" class="listingmapcontainer box-shadow" data-lat="<?=$showroom_lat?>" data-long="<?=$showroom_long?>">
                    <div id="showroommap" data-maptype="showroom" class="listingmap"></div>
                </div>

                <div class="map_functions_wrapper mt-4">
                    <button type="button" class="btn btn-admin find_address_on_map" data-maptype="showroom">Find Address</button>
                    <button type="button" class="btn btn-admin light_blue reset_map" data-maptype="showroom">Reset Map</button>
                </div>

                <input type="hidden" name="showroom_lat" id="showroom_lat" class="form-control input-sm" value="<?=$building->data['showroom_lat']?>" />
                <input type="hidden" name="showroom_long" id="showroom_long" class="form-control input-sm" value="<?=$building->data['showroom_long']?>" />

            </div>
        </div>
    </div>
</div>