<?php // BASIC INFO TAB - LISTING DETAILS ?>

<div id="listing_details" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Listing Overview</h3>

    <div class="row">
        <div class="each_tab__section col-lg-6 mb-4 mb-lg-0">
            <label for="heading" class="each_tab__section_title orange">Main Heading</label>
			<?php // PHP 8 ERROR CATCHING: Deprecated:  htmlspecialchars(): Passing null to parameter #1 ($string) of type string is deprecated in /home/brix_mls/public_html/2023/admin/homes_mod.php on line 201 ?>
            <input type="text" name="heading" id="heading" class="form-control trim_input mb-4" size="40" value="<?=($home->data['heading']!='' ? htmlspecialchars($home->data['heading']) : ''); ?>" placeholder="i.e. Gorgeous House Overlooking..." />
			<?php // enable second heading if second language option is enabled
			if ($settings['description2on'] == 1): ?>
                <label for="heading2" class="orange" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="Use case: Same heading in different language or additional heading for the listing - depending on configuration of your website">2nd Heading</label>
                <input type="text" name="heading2" id="heading2" class="form-control trim_input mb-4" size="40" value="<?=($home->data['heading']!='' ? htmlspecialchars($home->data['heading2']) : ''); ?>" placeholder="The header in another language ... or just another header!" />
			<?php
			endif; ?>

            <textarea aria-label="home description" name="description" id="description" class="form-control rich_editor" rows="15" placeholder="Describe the property!"><?= $home->data['description']; ?></textarea>
			<?php // enable second text area if second language option is enabled
			if ($settings['description2on'] == 1): ?>
                <label for="description2" class="orange mt-4" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="Use case: Same description in different language or additional description - depends on configuration of your website">2nd Description</label>
                <textarea aria-label="home description" name="description2" id="description2" class="form-control rich_editor" rows="15" placeholder="Same description in different language or additional description - depends on configuration of your website"><?= $home->data['description2']; ?></textarea>
			<?php
			endif; ?>
        </div>

        <div class="each_tab__section col-lg-6">
            <div class="row">
                <div class="col-lg-6 mb-4 mt-auto">
                    <label for="mls" class="each_tab__section_title orange">MLS&reg; Number</label>
                    <input autocomplete="off" type="text" name="mls" id="mls" class="form-control input-md trim_input" tabindex="0" value="<?= htmlspecialchars($home->mls) ?>" placeholder="Enter MLS&reg; #" />
                </div>

                <div class="col-lg-6 mb-4 mt-auto">
                    <label for="price" class="each_tab__section_title orange">Listed Price</label>
                    <input type="text" name="price" id="price" class="form-control input-md trim_input" value="<?=($_GET['mode']=='new' ? '' : $home->data['price'])?>" placeholder="$123,456" />
                </div>

				<?php // RESIDENTIAL OR COMMERCIAL - DISABLED FORM IF COMMERCIAL IS DISABLED FROM THE SETTINGS PAGE
				$control = $settings['commercial_enabled'] == 0 ? 'disabled' : '';
				$commercial_tooltip = $settings['commercial_enabled'] == 0 ? 'data-bs-toggle="tooltip" data-bs-title="To enable Commercial Module, Please contact support"' : '';
				?>
                <div class="col-lg-6 mb-4 mt-auto">
                    <label for="is_comm" class="control-label orange" data-bs-custom-class="brixwork-tooltip" <?=$commercial_tooltip?>>Res / Comm</label>
                    <select name="is_comm" id="is_comm" class="form-select" <?=$control?>>
                        <option value="0">Residential</option>
                        <option value="1"<?php if($home->data['type']>=50){echo ' selected';}?>>Commercial</option>
                    </select>
                </div>

				<?php // UNIT TYPE ?>
                <div class="col-lg-6 mb-4 mt-auto">
                    <label for="type" class="each_tab__section_title orange">Property Type</label>
                    <select name="type" id="type" class="form-select">
						<?php
						$commercial_yes = $settings['commercial_enabled'] == 1 && $home->data['is_comm'] == 1;
						foreach ($settings['type'] as $key=>$type):
							if ($key < 50):
								$disabled = $commercial_yes ? 'disabled' : '';
								$selected = ($home->data['type']==$key ? 'selected' : '');
								$residential_rel = ((is_array($settings['building_type']) && in_array($key, $settings['building_type'])) || is_numeric($settings['building_type']) && $settings['building_type']==$key) ? 'rel="building"' : 'rel="detached"';
								$label = $type ?: 'Choose Type';
								echo "<option value='$key' $selected $residential_rel $disabled >$label</option>";
							endif;
						endforeach;

						if (is_array($settings['type_commercial'])):
							echo '<optgroup label="----------------"></optgroup>'; // start showing commercial options ... show the cut line

							foreach($settings['type_commercial'] as $key=>$type):
								if ($key > 50): // skip empty string
									$disabled = $commercial_yes ? '' : 'disabled';
									$selected = ($home->data['type']==$key ? 'selected' : '');
									$commercial_rel = ((is_array($settings['building_type']) && in_array($key, $settings['building_type'])) || is_numeric($settings['building_type']) && $settings['building_type']==$key) ? 'rel="building"' : 'rel="detached"';
									$label = $type ?: 'Choose Type';
									echo "<option value='$key' class='type_commercial' $selected $commercial_rel $disabled>$label</option>";
								endif;
							endforeach;
						endif; // check type_commercial is array before running array functions
						?>
                    </select>
                </div>

				<?php // LISTING REMARKS ?>
                <div class="col-md-6 mb-4 mt-auto">
                    <label for="remarks" class="each_tab__section_title orange">Label</label>
                    <select name="remarks" id="remarks" class="selectpicker w-100" data-live-search="true">
						<?php
						foreach ($settings['remarks'] as $key=>$each_remark) {
							$selected_remark = ($home->data['remarks'] == $key) ? 'selected' : '';
							echo "<option value='$key' $selected_remark>$each_remark</option>";
						} ?>
                    </select>
                </div>

				<?php // HIDE ADDRESS ?>
                <div class="col-md-6 mb-4 mt-auto" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-placement="right" data-bs-title="Hide Address and replace with unique and special name.">
                    <label for="showaddress" class="control-label orange">Address Privacy</label>
                    <select name="showaddress" id="showaddress" class="form-select">
                        <option value="1">Show Address (Default)</option>
                        <option value="0"<?=($home->data['showaddress']=='0' ?' selected' : '')?>>Hide Address</option>
                    </select>
                </div>

				<?php // NICKNAME - REPLACES ADDRESS WHEN SELECTED
				$input_status = ($home->data['showaddress']=='0' ? '' : 'disabled');
				$custom_name_tooltip = 'Must select [Hide Address] first before giving this listing a custom name';
				?>
                <div class="col-lg-12 mb-4 mt-auto">
                    <label for="custom_display_name" id="custom_display_name__label" class="control-label orange" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-placement="right" data-bs-title="<?=$custom_name_tooltip?>">Address Display Preview</label>
                    <input autocomplete="off" type="text" name="name" class="form-control trim_input" id="custom_display_name" value="<?=htmlspecialchars($home->data['name'])?>" data-hide-address-note="<?=$settings['hideaddressnote']?>" placeholder="<?=$home->fulladdress?>" <?=$input_status?>/>

					<?php
					if ($settings['description2on'] == 1): // ENABLE 2ND CUSTOM NAME ?>
                        <label for="custom_display_name2" id="custom_display_name__label2" class="control-label orange mt-4" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="<?=$custom_name_tooltip?>">2nd Address Display Preview</label>
                        <input autocomplete="off" type="text" name="name2" class="form-control trim_input" id="custom_display_name2" value="<?=htmlspecialchars($home->data['name2'])?>" data-hide-address-note="<?=$settings['hideaddressnote']?>" placeholder="Additional Custom Name for the Listing" <?=$input_status?>/>
					<?php
					endif; ?>
                </div>

				<?php // OPEN HOUSE DATA ?>
                <div class="col-lg-12 mb-4 mt-auto">
                    <label for="openhouse" class="orange">Upcoming Open House</label>
                    <input type="text" name="openhouse" id="openhouse" class="form-control trim_input mb-4" size="40" value="<?=htmlspecialchars($home->openhouse ?: ''); ?>" placeholder="i.e. Saturday, Nov 24th 2-4PM" />
                </div>
            </div>
        </div>
    </div>
</div>


<div id="listing_details" class="each_tab__category brixwork_inner_spacing">
    <h3 class="each_tab__category_title">Listing Status</h3>

    <div class="row">
		<?php // PUBLISH STATUS ?>
        <div class="col-lg-3 col-sm-6 mb-4 mt-auto" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-placement="right" data-bs-title="Hide this listing from public while editing">
            <label for="publish" class="control-label orange">Publish</label>
            <select name="publish" id="publish" class="form-select">
                <option value="1" <?=($home->data['publish']=='1' || $_GET['mode']=='new' ? ' selected':'')?>>Show Listing</option>
                <option value="0" <?=($home->data['publish']=='0' ? 'selected':'')?>>Hide Listing</option>
            </select>
        </div>

		<?php // SALE STATUS ?>
        <div class="col-lg-3 col-sm-6 mb-4 mt-auto">
            <label for="sold" class="control-label orange">Sale Status</label>
            <select name="sold"  id="sold" class="form-select input-md">
                <option value="0" <?php if($home->data['sold']=='0'){echo "selected";}?>>Active</option>
                <option value="1" <?php if($home->data['sold']=='1'){echo "selected";}?>>Sold / Rented</option>
                <option value="2" <?php if($home->data['sold']=='2'){echo "selected";}?>>Show on Both</option>
            </select>
        </div>

		<?php // FOR SALE OR RENTAL/LEASE - DISABLE FORM IF RENTAL IS DISABLED FROM THE SETTINGS PAGE
		$rental_enabled = $settings['rental_enabled'] == 1;
		$control = $rental_enabled ? '' : 'disabled';
		$rental_tooltip = $rental_enabled ? '' : 'data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-title="To enable Rental Module, Please contact support"';
		$for_rent = $home->data['for_rent'] == 1;
		?>
        <div class="col-lg-3 col-sm-6 mb-4 mt-auto">
            <label for="for_rent" class="control-label orange" data-bs-custom-class="brixwork-tooltip" <?=$rental_tooltip?>>Sale or Rent/Lease</label>
            <select name="for_rent" id="for_rent" class="form-select" <?=$control?>>
                <option value="0" <?= $for_rent ? '' : ' selected' ?>>For Sale</option>
                <option value="1" <?= $for_rent ? 'selected' : ' ' ?>>Rent / Lease</option>
            </select>
        </div>


    </div>
</div>

<?php // BASIC INFO TAB - LOCATION ?>
<div id="listing_details" class="each_tab__category brixwork_inner_spacing row mx-0">
    <h3 class="each_tab__category_title">Listing Address</h3>
    <div class="each_tab__section col-lg-7">
		<?php // ROW STREET NUMBER + DIRECTION + STREET NAME ?>
        <div class="row">
            <div class="col-lg-4 mb-4">
                <label for="number" class="control-label orange">Street Number</label>
                <input type="text" name="number" id="number" class="form-control trim_input" value="<?=$home->data['number'];?>" placeholder="i.e. 2338">
            </div>
            <div class="col-lg-3 col-4 mb-4" id="listing_street_dir_container">
                <label for="street_dir" class="control-label orange">Direction</label>
                <input type="text" name="street_dir" class="form-control trim_input" id="street_dir" value="<?=$home->data['street_dir'];?>" placeholder="i.e. W, East">
                <div class="pt-2">
                    <a id="street_dir_position_toggle">Switch Order</a>
                </div>
                <input type="hidden" id="listing_street_dir_position" name="street_dir_position" value="<?=($_GET['mode']=='new' ? $settings['street_dir_position_default'] : $home->data['street_dir_position'])?>" />
            </div>
            <div class="col-lg-5 col-8 mb-4" id="listing_street_name_container">
                <label for="street" class="control-label orange">Street Name</label>
                <input type="text" name="street" id="street" class="form-control trim_input" value="<?=$home->data['street_name'].' '.$home->data['street_type'];?>" placeholder="i.e. Willow Street" />
            </div>
        </div>

		<?php // ROW UNIT NUMBER & BUILDING ?>
        <div class="row">

            <div class="col-4 mb-4 mt-auto">
                <label for="unit" class="control-label orange">Unit Number</label>
                <input autocomplete="off" type="text" name="unit" class="form-control trim_input" id="unit" value="<?=$home->data['unit'];?>" placeholder="Unit #" />
            </div>

            <div class="col-8 mb-4 mt-auto">
                <label for="building" class="control-label orange">Building</label>
                <select name="building" id="building" class="form-select">
                    <option value="">Select Building</option>
					<?php
					if(is_object($home) && $home->building!='') {
						echo '<option value="'.$home->bldg->id.'" selected="selected">'.$home->building.'</option>';
					} ?>
                </select>
            </div>
        </div>

		<?php // ROW CITY + SUBAREA?>
        <div class="row">
            <div class="col-lg-6 mb-4">
                <label for="city" class="control-label orange">City</label>
                <select name="city" id="city" class="form-select">
                    <option value="">Choose a City</option>
					<?php
					$query['publish'] = 1;
					if($home->data['city']!='') {
						$query['id'] = $home->data['city'];
					}
					$cities = get_areas($query);

					foreach($cities as $city_id) {
						$city = new area;
						$city->initialize($city_id);
						$selected_text = ($home->data['city'] == $city_id) ? ' selected' : '';

						echo '<option value="'.$city_id.'"'.$selected_text.'>'.$city->name.'</option>';
					}
					?>
                </select>
                <input type="hidden" name="location" id="location" value="<?=($settings['location']!='' ? $settings['location'] : ($settings['province']!='' ? $settings['province'] : 'BC, Canada') ); ?>" />
            </div>
            <div class="col-lg-6 mb-4">
                <label for="area" class="control-label orange">Subarea</label>
                <select name="area" id="area" class="form-select w-100">
                    <option value="">Choose a Subarea</option>
					<?php
					if($home->data['city']!='') {
						$subareas = get_subareas($home->data['city']);

						foreach($subareas as $subarea_id) {
							$subarea = new subarea;
							$subarea->initialize($subarea_id);
							$selected_text = ($home->data['area'] == $subarea_id) ? ' selected' : '';

							echo '<option value="'.$subarea_id.'"'.$selected_text.'>'.$subarea->name.'</option>';
						}
					}
					?>
                </select>
            </div>
        </div>
    </div>

	<?php
	$default_lat_long = explode(',', $settings['baselatlong']);
	if (is_object($home) && is_numeric($home->lat) && is_numeric($home->long)):
		$home_lat   = $home->lat;
		$home_long  = $home->long;
	else:
		$home_lat   = $default_lat_long[0];
		$home_long  = $default_lat_long[1];
	endif;
	?>
    <div class="each_tab__section col-lg-5">
        <label class="control-label orange">Map For Precise Location</label>
        <div id="listingmapcontainer" class="listingmapcontainer box-shadow" data-lat="<?=$home_lat?>" data-long="<?=$home_long?>">
            <div id="listingmap" class="listingmap"></div>
        </div>

        <div class="map_functions_wrapper mt-4">
            <button type="button" class="btn btn-admin" id="find_address_on_map">Find Address</button>
            <button type="button" class="btn btn-admin light_blue" id="reset_map">Reset Map</button>
        </div>

        <input aria-label="Listing Latitude to generate Map" type="hidden" name="lat" id="lat" class="form-control" value="<?=$home_lat?>"/>
        <input aria-label="Listing Longitude to generate Map" type="hidden" name="long" id="long" class="form-control" value="<?=$home_long?>"/>
    </div>
</div>


<?php
/**
 * AGENTS & BROKERAGES TAB
 * - The dropdown only shows "associated agents" of the login user.
 * - Does not apply to Admin/Manager.
 *
 * Procedures
 * 1. At least one agent must be associated with each listing.
 * 2. The arrangement should not matter - the one agent can be in agent_1, agent_2, or agent_3 section.
 * 3. If there are no agent, warn the user & disable submit button - this is done through Javscript.
 *
 * Assumptions
 * 1. This assumes that upon MLS sync, the agent is automatically assigned and selected.
 * 2. There's a difference between $home->agent_1 data AND $home->realtor_id_1 data. (Please acknowledge)
 * 2-1. $home->agent_1 is the internal ID, whereas $home->realtor_id_1 is the MLS realtor ID (i.e. V12345)
 *
 * Why so complicated?
 * 1. Because this had to be made with the mindset that some of our clients will not have MLS sync.
 * 2. There's no guarantee that every user/agents will have Realtor ID ... some website may not even be a realtor website all together.
 * 2. If the listing is entered in manually, still need to associate to an agent profile.
 */
global $login_user;
$agents = list_agents(array('publish' => 1, 'billable' => 1), 'ord', 'ASC', 10000, 1); // get all billable agents.

echo brixwork_alert("<p><b>Warning!</b> Listings must have at least one agent associated.</p>", 'error agent_error_div my-2');
?>
<div id="listing_details" class="each_tab__category brixwork_inner_spacing row mx-0">
    <h3 class="each_tab__category_title">Agents &amp; Brokerage</h3>
    <div class="each_tab__section col-lg-6 mb-4 mb-lg-0">
        <label for="agent" class="control-label orange">Listed by</label>
		<?php
		for ($i = 1; $i <= $max_agent = 3; $i++):
			// get current iteration agent
			$agent_order = 'agent_'.$i;
			$realtor_order = 'realtor_'.$i;
			$home_agent = $home->$agent_order;
			$home_realtor = $home->$realtor_order;

			// show either dropdown or display name only depending on condition.
			if ($settings['multiagents'] == 1) {
				// first, multi-agents must be activated
				if (in_array($home_agent->id, $login_user->getAgents()) || !$home_agent || login_level_check(USER_LOGIN_MANAGER)) {
					// if home's agent is associated with login user OR not set: show dropdown. ?>
                    <select name="<?=$agent_order?>" id="<?=$agent_order?>" class="selectpicker mb-2 w-100" data-live-search="true" aria-label="agent_<?=$i?>">>
						<?php
						echo '<option value="">Choose a Listing Agent #'.$i.'</option>';

						foreach($agents as $agent_id):
							$agent = new agent;
							$agent->initialize($agent_id);
							/**
							 * Skip condition
							 * 1. no display name
							 * 2. not associated agent to login user. (does not affect Admin or Manager login)
							 */
							if ($agent->displayname == "" || (!login_level_check(USER_LOGIN_MANAGER) && !in_array($agent_id, $login_user->getAgents()))) continue;
							$selected = ($home_agent->id == $agent->id) ? 'selected' : '';
							$agent_id_string = $agent->agentid ? ' ('.$agent->agentid.')' : '';
							echo '<option value="'.$agent->id.'" '.$selected.'>'.$agent->displayname.$agent_id_string.'</option>';
						endforeach; ?>
                    </select>
					<?php
				} else {
					// the home's agent is NOT associated with login user - display only ?>
                    <div class="user_agent_list mb-2">
                        <h6><?=$home_agent->displayname?></h6>
                        <input type="hidden" name="<?=$agent_order?>" id="<?=$agent_order?>" value="<?=$home_agent->id?>">
                    </div>
					<?php
				}
			} elseif ($home_realtor) {
				// multi-agent is disabled, attempt to display MLS realtor name! ?>
                <div class="user_agent_list mb-2">
                    <h6><?=$home_realtor?></h6>
                </div>
				<?php
			}
		endfor; ?>
    </div>

    <div class="each_tab__section col-lg-6">
		<?php
		$max_brokerage = 3;
		for ($each_brokerage = 1; $each_brokerage <= $max_brokerage; $each_brokerage++):
			?>
            <div class="row">
                <div class="col-sm-6 mb-2">
					<?php // only show label for first input
					if ($each_brokerage == 1) {
						echo "<label for='firm_$each_brokerage' class='control-label orange'>Brokerage Name</label>";
					} ?>
                    <input disabled type="text" name="firm_<?=$each_brokerage?>" id="firm_<?=$each_brokerage?>" class="form-control trim_input" size="30" value="<?= $home->data['firm_'.$each_brokerage];?>" placeholder="Auto-filled by MLS" aria-label="Brokerage Names"/>
                </div>
                <div class="col-sm-6 mb-2">
					<?php // only show label for first input
					if ($each_brokerage == 1) {
						echo "<label for='firm_$each_brokerage-id' class='control-label orange'>Brokerage ID</label>";
					} ?>
                    <input disabled type="text" name="firm_<?=$each_brokerage?>_id" id="firm_<?=$each_brokerage?>_id" class="form-control trim_input" size="30" value="<?= $home->data['firm_'.$each_brokerage.'_id'];?>" placeholder="Auto-filled by MLS" aria-label="Brokerage ID"/>
                </div>
            </div>
		<?php
		endfor; ?>
    </div>
</div>