<?php
// BASIC INFO TAB - LISTING DETAILS
global $settings;

/**
 * @var $closest_sibling_page   page    Set in the pages_mod.php
 * @var $parentpage             page    Set in the pages_mod.php
 * @var $page                   page
 */
$breed = 0;
if ($_GET['mode'] == 'new') {
    if (is_object($closest_sibling_page)) {
        $breed = $closest_sibling_page->data['breed'];
    }
    elseif (is_object($parentpage)) {
        $breed = $parentpage->data['breed'];
    }
} else {
    if (is_object($page)) {
        $breed = $page->breed == 1 ? 1 : 0;
    }
}

$embedded = $page->data['embedded'] == 1 || (($closest_sibling_page->embedded || $parentpage->embedded) && $_REQUEST['mode'] == 'new');
$enable_photo_gallery = $page->enable_photo_gallery == 1 || (($closest_sibling_page->enable_photo_gallery == 1 ) && $_REQUEST['mode'] == 'new');

// MAIN DETAILS ?>
<div id="listing_details" class="each_tab__category brixwork_inner_spacing mx-0">
    <h3 class="each_tab__category_title">Page Specific Functionality</h3>

    <div class="row pt-4">
        <?php
        // login_level_check(USER_LOGIN_BRIXWORK) - visible requirement
        $admin_only = login_level_check(USER_LOGIN_BRIXWORK) ? '' : 'd-none' ?>
        <div class="col-md-6 col-lg-4 mb-4 mt-auto <?=$admin_only?>">
            <div class="form-check form-switch">
                <input class="form-check-input" role="switch" type="checkbox" value="on" name="embedded" id="embedded" <?=$embedded ? 'checked' : ''?>>
                <label class="form-check-label orange m-0" for="embedded" id="">Embedded</label>
            </div>
        </div>

        <div class="col-md-6 col-lg-4 mb-4 mt-auto <?=$admin_only?>">
            <div class="form-check form-switch">
                <input class="form-check-input" role="switch" type="checkbox" value="on" name="breed" id="breed" <?=($breed==1 ? 'checked' : '')?>>
                <label class="form-check-label orange m-0" for="breed" id="">Allow User Subpage</label>
            </div>
        </div>

        <div class="col-md-6 col-lg-4 mb-4 mt-auto <?=$admin_only?>">
            <div class="form-check form-switch">
                <input class="form-check-input" role="switch" type="checkbox" value="on" name="enable_photo_gallery" id="enable_photo_gallery" <?=($page->enable_photo_gallery==1 ? 'checked' : '')?>>
                <label class="form-check-label orange m-0" for="enable_photo_gallery" id="">Enable Photo Gallery</label>
            </div>
        </div>

        <div class="col-lg-7 my-4 overflow_scroll <?=$admin_only?>">
            <?php
            // manual width height overwrite for page images.
            $page_object = ($_GET['mode'] == 'new' && is_object($closest_sibling_page)) ? $closest_sibling_page : $page; // get sibling's main title & dimensions.
            $num_photos = intval($settings['pages_mainphotonum']);

            for ($i = 0; $num_photos > $i; $i++) :
                $label_class = ($i != 0) ? 'd-none' : '';   // only the first iteration need labels.

                /**
                 * Sometimes just a single value - check for array fist before using array index.
                 * if it's array - use index
                 * not array - it's single value that's only applicable to the first iteration.
                 */
                if (!is_array($page_object->main_img_titles)) {
                    $page_main_title = ($i == 0) ? $page_object->main_img_titles : ''; // because it's a single value, only apply to the first iteration
                } else {
                    $page_main_title = $page_object->main_img_titles[$i];
                }
                if (!is_array($page_object->mainwidth)) {
                    $page_main_width = ($i == 0) ? $page_object->mainwidth : ''; // because it's a single value, only apply to the first iteration
                } else {
                    $page_main_width = $page_object->mainwidth[$i];
                }
                if (!is_array($page_object->mainheight)) {
                    $page_main_height = ($i == 0) ? $page_object->mainheight : ''; // because it's a single value, only apply to the first iteration
                } else {
                    $page_main_height = $page_object->mainheight[$i];
                }
                ?>
                <div class="page_dimension_edit">
                    <div class="page_dimension__title mb-2">
                        <label class="control-label orange <?=$label_class?>">Image Title</label>
                        <input type="text" name="main_img_titles[]" class="form-control" value="<?=$page_main_title?>" aria-describedby="maintitle_helper" aria-label="Main Image Title #<?=$i?>">
                    </div>
                    <div class="page_dimension__width mb-2">
                        <label class="control-label orange <?=$label_class?>">Width (px)</label>
                        <input type="text" name="mainwidth[]" class="form-control" size="5" value="<?=$page_main_width?>" aria-describedby="mainwidth_helper" aria-label="Main Image Width #<?=$i?>"/>
                    </div>
                    <div class="page_dimension__height mb-2">
                        <label class="control-label orange <?=$label_class?>">Height (px)</label>
                        <input type="text" name="mainheight[]" class="form-control" size="5" value="<?=$page_main_height?>" aria-describedby="mainwidth_helper" aria-label="Main Image Height #<?=$i?>"/>
                    </div>
                </div>
            <?php
            endfor; ?>
        </div>

        <label for="custom_pageurl" class="control-label orange">Page URL</label>
        <div class="col-12 mt-4 mt-auto input-group">
            <span class="input-group-text" id="at-addon"><?=$settings['sitepath']?></span>
            <?php
            $disabled = login_level_check(USER_LOGIN_BRIXWORK) ? '' : 'disabled';
            ?>
            <input type="text" name="custom_pageurl" id="custom_pageurl" class="form-control input-xs" size="5" value="<?=$page->data['custom_pageurl']?>" placeholder="Enter custom URL (after the domain) here" aria-describedby="custom_pageurl_helper" <?=$disabled?> />
        </div>
    </div>
</div>