<?php
// BASIC INFO TAB - LISTING DETAILS
global $settings

// MAIN DETAILS 
?>
<div class="d-flex justify-content-between flex-wrap">
    <div id="resource__main_details" class="each_tab__category brixwork_inner_spacing mx-0">
        <h3 class="each_tab__category_title">Main Details</h3>

        <div class="row pt-2">
            <div class="col-lg-6 mb-4">
                <?php // CONTACT PERSON
                admin_text_basic(array(
                    'name' => 'contact',
                    'value' => $link->contact,
                    'label' => 'Contact Person',
                    'placeholder' => 'i.e. Don Cherry'
                )); ?>
            </div>

            <div class="col-lg-6 mb-4">
                <label for="category" class="control-label orange">Category</label>
                <select name="category" id="category" class="form-select">
                    <option>Choose a Category</option>
                    <?php
                    $category_sql = "SELECT `id`, `title` FROM `resourcecategories` ORDER BY ord";
                    $category_result = $mysqli->query($category_sql);

                    while($category = $category_result->fetch_assoc()) {
                        $id = $category['id'];
                        $title = $category['title'];
                        $selected_text = ($link->data['category'] == $id || $category_id == $id) ? ' selected' : '';

                        echo "<option value='$id' $selected_text>$title</option>";
                    } ?>
                </select>
            </div>

            <div class="col-12 mb-4">
                <?php // COMPANY NAME
                admin_text_basic(array(
                    'name' => 'company',
                    'value' => $link->company,
                    'label' => 'Company',
                    'placeholder' => 'i.e. Dominion Lending',
                )); ?>
            </div>

            <div class="col-12 mb-4">
                <?php // ALTERNATE DISPLAY TITLE
                admin_text_basic(array(
                    'name' => 'title',
                    'value' => $link->title,
                    'label' => 'Alternate Display Title',
                    'placeholder' => 'i.e. John Smite (Mortgage Broker)',
                    'tooltip' => 'Default Title is `Contact Person (Company)`. For custom title, fill this input and save.'
                )); ?>
            </div>

            <div class="col-12 mb-4">
                <?php // RESOURCE WEBSITE LINK
                admin_text_basic(array(
                    'name' => 'url',
                    'value' => $link->url,
                    'label' => 'Resource Website',
                    'placeholder' => 'i.e. www.helpfulresource.com',
                    'tooltip' => 'Copy and paste the website link here'
                )); ?>
            </div>
            
            <div class="col-12 mb-4">
                <?php // COMPANY WEBSITE
                admin_text_basic(array(
                    'name' => 'url',
                    'value' => $link->url,
                    'label' => 'Website',
                    'placeholder' => 'i.e. www.examplelink.com',
                    'tooltip' => 'This will be turned into a link to the website'
                )); ?>
            </div>

            <div class="col-lg-6 mb-4 mb-lg-2">
                <?php // CELL PHONE
                admin_text_basic(array(
                    'name' => 'phone',
                    'value' => $link->phone,
                    'label' => 'Phone Num',
                    'placeholder' => 'i.e. (123) 456-7890'
                )); ?>
            </div>

            <div class="col-lg-6 mb-4 mb-lg-2">
                <?php // EMAIL
                admin_text_basic(array(
                    'name' => 'email',
                    'value' => $link->email,
                    'label' => 'Email',
                    'placeholder' => 'i.e. info@brixwork.com'
                )); ?>
            </div>
        </div>
    </div>

    <?php // LOCATION TAB ?>
    <div id="resource__location" class="each_tab__category brixwork_inner_spacing mx-0">
        <h3 class="each_tab__category_title">Location</h3>

        <div class="row pt-2">
            <div class="col-12 mb-4">
                <?php // ADDRESS 1
                admin_text_basic(array(
                    'name' => 'address1',
                    'value' => $link->address1,
                    'label' => 'Address 1',
                    'placeholder' => 'i.e. 314 W Cordova'
                )); ?>
            </div>

            <div class="col-12 mb-4">
                <?php // ADDRESS 2
                admin_text_basic(array(
                    'name' => 'address2',
                    'value' => $link->address2,
                    'label' => 'Address 2',
                    'placeholder' => 'i.e. #211'
                )); ?>
            </div>

            <div class="col-lg-6 mb-4">
                <label for="city" class="control-label orange">City</label>
                <select name="city" id="city" class="form-select">
                    <option value="">Choose a City</option>
                    <?php
                    $city_res = $mysqli->query("SELECT * FROM `areas` ORDER BY `name`"); // simply show all available cities. Client may have resources outside their primary MLS cities.
                    while($city = $city_res->fetch_assoc()) {
                        $selected_text = $link->data['city'] == $city['id'] ? ' selected' : '';
                        $id = $city['id'];
                        $name = $city['name'];

                        echo "<option value='$id' $selected_text>$name</option>";
                    } ?>
                </select>
                <input type="hidden" name="location" id="location" value="<?=$settings['location']!='' ? $settings['location'] : ($settings['province']!='' ? $settings['province'] : 'BC, Canada')?>" />
            </div>

            <div class="col-lg-6 mb-4">
                <label for="area" class="control-label orange">Subarea</label>
                <select name="area" id="area" class="form-select" data-bs-toggle="tooltip" data-bs-custom-class="brixwork-tooltip" data-bs-placement="bottom" data-bs-title="You need to select a city first, then this list will populate.">
                    <option value="">Choose a Subarea</option>
                    <?php
                    if($link->data['city'] != "") {
                        $area_res = $mysqli->query("SELECT * FROM `subareas` WHERE `area`='".$link->data['city']."' ORDER BY `name`");
                        while($area = $area_res->fetch_assoc()) {
                            $selected_text = $link->data['area'] == $area['id'] ? ' selected' : '';
                            $id = $area['id'];
                            $name = $area['name'];

                            echo "<option value='$id' $selected_text>$name</option>";
                        }
                    } ?>
                </select>
            </div>

            <div class="col-12 mb-2">
                <?php
                admin_text_basic(array(
                    'name' => 'postal',
                    'value' => $link->postal,
                    'label' => 'Postal Code',
                    'placeholder' => 'V6B 1E8'
                )); ?>
            </div>

        </div>
    </div>
</div>


<?php // DESCRIPTION ?>
<div id="resource__description" class="each_tab__category brixwork_inner_spacing mx-0">
    <h3 class="each_tab__category_title">Description</h3>

    <div class="row pt-2">
        <div class="col-lg-6 mb-4 mb-lg-2">
            <?php
            admin_textarea(array(
                'name' => 'desc',
                'value' => $link->desc,
                'class' => 'rich_editor'
            )); ?>
        </div>

        <div class="col-lg-6 px-5" id="gallery_tip">
            <?php
            $svg_append = 'images/admin_function_icon/';
            echo get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true));
            ?>
            <p class="my-4">
                Depending on the design of your website, this description may not be visible. If uncertain, leave this blank.
            </p>
        </div>
    </div>
</div>
