<?php // General Settings Tab
global $settings;
$brixwork_login = login_level_check(USER_LOGIN_BRIXWORK);
?>

<div id="settings_contact" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Contact Info</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php // only brixwork login can add or delete
            if ($brixwork_login) {
                settings_text_2023(array(
                    'name' => 'cell',
                    'value' => $settings['cell'],
                    'label' => 'Cell Phone'
                ));
            } else {
                admin_text_basic(array(
                    'name' => 'cell',
                    'value' => $settings['cell'],
                    'label' => 'Cell Phone'
                ));
            } ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // only brixwork login can add or delete
            if ($brixwork_login) {
                settings_text_2023(array(
                    'name' => 'email',
                    'value' => $settings['email'],
                    'label' => 'Email',
                    'placeholder' => 'i.e. your@email.com'
                ));
            } else {
                admin_text_basic(array(
                    'name' => 'email',
                    'value' => $settings['email'],
                    'label' => 'Email',
                    'placeholder' => 'i.e. your@email.com'
                ));
            } ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php // Lead Email Input
            admin_text_basic( array(
                'name' => 'contactemail',
                'value' => $settings['contactemail'],
                'label' => 'Lead Form Email(s), comma separated'))
            ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php 
            admin_dropdown( array(
                'name' => 'email_listing_agents_only',
                'value' => $settings['email_listing_agents_only'],
                'label' => 'Listing Detail Page Lead Form Email',
                'tooltip' => 'Select One',
                'value_variants' => array(
                    0 => "To lead email only regardless of assigned agents.",
                    1 => "To assigned agent(s)'s emails only (override)",
                    2 => "To the agents, as well as cc lead destination emails."
                )
            )) ?>
        </div>

        <div class="col-lg-6">
            <?php
            admin_switch( array(
                'name' => 'contact_realtorflag',
                'value' => $settings['contact_realtorflag'],
                'label' => 'Show "Are You a Realtor"',
                'tooltip' => 'Ask this question on the Contact Form'
            ));
            admin_text_basic( array(
                'name' => 'contact_realtorflag_intercept_url',
                'value' => $settings['contact_realtorflag_intercept_url'],
                'placeholder' => 'Realtors Denial Page URL goes here',
                'tooltip' => 'URL to send Realtors to, if detected',
            ));
            ?>
        </div>
    </div>
</div>

<div id="settings_crm_integration" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">CRM Integration</h3>

    <?php // MAILCHIMP ROW ?>
    <div class="row">
        <div class="col-lg-4 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'mailchimp_api_key',
                'value' => $settings['mailchimp_api_key'],
                'label' => 'MailChimp',
                'container_id' => 'settings_mailchimp_api_key_container',
                'placeholder' => 'MailChimp API Key',
            )); ?>
        </div>
        <div class="col-lg-5 col-sm-6 mt-auto mb-4" id="settings_mailchimp_api_list_container">
            <?php
            admin_dropdown( array(
                'name' => 'mailchimp_api_list',
                'value' => $settings['mailchimp_api_list'],
                'tooltip' => 'Select One',
                'value_variants' => array(
                    0 => "Create List using API key",
                )
            )) ?>
        </div>
        <div class="col-lg-3 col-sm-6 mt-auto mb-4">
            <?php
            admin_switch( array(
                'name' => 'mailchimp_sync',
                'value' => $settings['mailchimp_sync'],
                'label' => 'Sync Form Leads',
                'tooltip' => 'Contact Form Submission can be automatically entered into your MailChimp list'
            )); ?>
        </div>
    </div>

    <?php // this section appears when proper MailChimp API is detected. ?>
    <div class="row mb-4" id="mailchimp_merge_fields_container">
        <div class="col-lg-3 col-sm-6 mt-auto mb-4" id="settings_mailchimp_first_name_tag_container">
            <?php // value variants will be filled in by mailchimp.js
            admin_dropdown( array(
                'name' => 'mailchimp_first_name_tag',
                'label' => 'First Name',
                'value_variants' => array(
                    0 => "This will be auto-filled.",
                )
            )) ?>
        </div>

        <div class="col-lg-3 col-sm-6 mt-auto mb-4" id="settings_mailchimp_last_name_tag_container">
            <?php // value variants will be filled in by mailchimp.js
            admin_dropdown( array(
                'name' => 'mailchimp_last_name_tag',
                'label' => 'Last Name',
                'value_variants' => array(
                    0 => "This will be auto-filled.",
                )
            )) ?>
        </div>

        <div class="col-lg-3 col-sm-6 mt-auto mb-4" id="settings_mailchimp_phone_number_tag_container">
            <?php // value variants will be filled in by mailchimp.js
            admin_dropdown( array(
                'name' => 'mailchimp_phone_number_tag',
                'label' => 'Phone Number',
                'value_variants' => array(
                    0 => "This will be auto-filled.",
                )
            )) ?>
        </div>

        <div class="col-lg-3 col-sm-6 mt-auto mb-4" id="settings_mailchimp_message_tag_container">
            <?php // value variants will be filled in by mailchimp.js
            admin_dropdown( array(
                'name' => 'mailchimp_message_tag',
                'label' => 'Message',
                'value_variants' => array(
                    0 => "This will be auto-filled.",
                )
            )) ?>
        </div>
    </div>


    <?php // SPARKFORM ROW ... disable for now. NO JS SUPPORT ?>
    <?php
    /**
     * <div class="row">
    <div class="col-lg-4 mb-4">
    <?php
    admin_text_basic( array(
    'name' => 'spark_form_api_key',
    'value' => $settings['spark_form_api_key'],
    'label' => 'SparkForm',
    'placeholder' => 'SparkForm API Key',
    )); ?>
    </div>
    <div class="col-lg-5 col-sm-6 mt-auto mb-4">
    <?php // enable integration and show list ?>
    </div>
    <div class="col-lg-3 col-sm-6 mt-auto mb-4">
    <?php
    admin_switch( array(
    'name' => 'spark_form_sync',
    'value' => $settings['spark_form_sync'],
    'label' => 'Sync Form Leads',
    'tooltip' => 'Contact Form Submission can be automatically entered into your SparkForm list'
    )); ?>
    </div>
    </div>
     */
    ?>


    <?php // FOLLOWUP BOSS ROW  ?>
    <div class="row mb-2 mb-lg-0">
        <div class="col-lg-6 mb-2 mb-lg-4">
            <?php
            admin_text_basic( array(
            'name' => 'followupboss_api_key',
            'value' => $settings['followupboss_api_key'],
            'label' => 'FollowupBoss',
            'placeholder' => 'FollowupBoss API Key',
            )); ?>
        </div>
        <div class="col-lg-3 col-sm-6 mt-auto mb-2 mb-lg-4">
            <?php
            admin_switch( array(
            'name' => 'followupboss_sync',
            'value' => $settings['followupboss_sync'],
            'label' => 'Sync Form Leads',
            'tooltip' => 'Contact Form Submission can be automatically entered into your SparkForm list'
            )); ?>
        </div>
    </div>
    <?php
    // FUB tag manager is BETA ... only for Brixwork login for now.
    if ($brixwork_login) { ?>
        <div class="row mb-1">
            <div class="col-lg-8 mb-4 mb-lg-0">
                <label class="control-label orange">FUB Tag Manager</label>
                <input class='form-control' type="hidden" id='followupboss_tag_num' name='followupboss_tag_num' value='<?=$settings['followupboss_tag_num']?>' aria-label="Number of Rows"/>
                <?php
                admin_multi_input(array(
                    'row_name'      => 'fub_tag',
                    'name_array'    => array('followupboss_source_page', 'followupboss_tag'),
                    'value_array'   => array($settings['followupboss_source_page'], $settings['followupboss_tag']),
                    'tooltip'       => array('Where the Form is submitted from?', 'Tag to attach to Person'),
                    'input_class'   => array('large', 'large'),
                    'counter_id'    => 'followupboss_tag_num',
                    'counter'       => $settings['followupboss_tag_num']
                )); ?>
            </div>
        </div>
    <?php
    } ?>
</div>

<div id="settings_brokerage_info" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Brokerage Info</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <?php
            if ($brixwork_login) {
                settings_text_2023(array(
                    'name' => 'company',
                    'value' => $settings['company'],
                    'label' => 'Brokerage Name',
                    'placeholder' => 'i.e. ABC Realty'
                ));
            } else {
                admin_text_basic(array(
                    'name' => 'company',
                    'value' => $settings['company'],
                    'label' => 'Brokerage Name',
                    'placeholder' => 'i.e. ABC Realty'
                ));
            } ?>
        </div>

        <div class="col-lg-6 mb-4">
            <?php
            if ($brixwork_login) {
                settings_text_2023(array(
                    'name' => 'brokerage_url',
                    'value' => $settings['brokerage_url'],
                    'label' => 'Website',
                    'placeholder' => 'i.e. www.brokerage.com'
                ));
            } else {
                admin_text_basic(array(
                    'name' => 'brokerage_url',
                    'value' => $settings['brokerage_url'],
                    'label' => 'Website',
                    'placeholder' => 'i.e. www.brokerage.com'
                ));
            } ?>
        </div>

        <div class="col-lg-6 mb-5">
            <?php
            if ($brixwork_login) {
                settings_text_2023(array(
                    'name' => 'office',
                    'value' => $settings['office'],
                    'label' => 'Office Phone',
                    'placeholder' => 'i.e. 416.xxx.xxxx'
                ));
            } else {
                admin_text_basic(array(
                    'name' => 'office',
                    'value' => $settings['office'],
                    'label' => 'Office Phone',
                    'placeholder' => 'i.e. 416.xxx.xxxx'
                ));
            } ?>
        </div>

        <div class="col-lg-6 mb-5">
            <?php
            if ($brixwork_login) {
                settings_text_2023(array(
                    'name' => 'fax',
                    'value' => $settings['fax'],
                    'label' => 'Fax Number',
                ));
            } else {
                admin_text_basic(array(
                    'name' => 'fax',
                    'value' => $settings['fax'],
                    'label' => 'Fax Number',
                ));
            } ?>
        </div>

        <?php // BROKERAGE ADDRESS ?>
        <div class="col-lg-6 row" style="height: min-content">
            <div class="col-lg-6 mb-4">
                <?php
                admin_text_basic( array(
                    'name' => 'address1',
                    'value' => $settings['address1'],
                    'label' => 'Address',
                )); ?>
            </div>
            <div class="col-lg-6 mb-4">
                <?php
                admin_text_basic( array(
                    'name' => 'address_2',
                    'value' => $settings['address_2'],
                    'label' => 'Unit',
                    'placeholder' => 'i.e. Unit 305'
                )); ?>
            </div>
            <div class="col-lg-6 mb-4">
                <?php
                admin_text_basic( array(
                    'name' => 'office_city',
                    'value' => $settings['office_city'],
                    'label' => 'City',
                )); ?>
            </div>
            <div class="col-lg-6 mb-4">
                <?php
                admin_text_basic( array(
                    'name' => 'office_postal',
                    'value' => $settings['office_postal'],
                    'label' => 'Postal Code',
                )); ?>
            </div>
            <div class="col-lg-6 mb-4">
                <?php
                admin_dropdown( array(
                    'name' => 'province',
                    'value' => $settings['province'],
                    'label' => 'Province',
                    'value_variants' => $provinces
                )); ?>
            </div>
            <div class="col-lg-6 mb-4">
                <?php
                admin_dropdown( array(
                    'name' => 'country',
                    'value' => $settings['country'],
                    'label' => 'Country',
                    'value_variants' => $countries
                )); ?>
            </div>
        </div>

        <?php // BROKERAGE MAP
        if ($settings['office_lat'] && $settings['office_long']) {
            $office_lat  = $settings['office_lat'];
            $office_long = $settings['office_long'];
        }
        else {
            $default_lat_long = explode(',', $settings['baselatlong']);
            $office_lat   = $default_lat_long[0];
            $office_long  = $default_lat_long[1];
        }
        ?>
        <div class="col-lg-6">
            <label class="control-label orange">Office Location</label>
            <div id="officemapcontainer" class="listingmapcontainer box-shadow" data-lat="<?=$office_lat?>" data-long="<?=$office_long?>">
                <div id="officemap" class="listingmap"></div>
            </div>

            <div class="map_functions_wrapper mt-4">
                <button type="button" class="btn btn-admin" id="find_address_on_map">Find Address</button>
                <button type="button" class="btn btn-admin light_blue" id="reset_map">Reset Map</button>
            </div>

            <input aria-label="Listing Latitude to generate Map" type="hidden" name="office_lat" id="lat" class="form-control" value="<?=$settings['office_lat']?>"/>
            <input aria-label="Listing Longitude to generate Map" type="hidden" name="office_long" id="long" class="form-control" value="<?=$settings['office_long']?>"/>
        </div>
    </div>
</div>