<?php // General Settings Tab
global $settings;
?>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-instagram"></i> Instagram</h3>

    <div class="row pt-2 mb-3">
        <div class="col-lg-6">
            <div class="mb-4">
                <?php
                admin_text_basic( array(
                    'name' => 'instagram',
                    'value' => $settings['instagram'],
                    'label' => 'Instagram URL',
                    'placeholder' => 'https://instagram.com/brixwork'
                )); ?>
            </div>

            <?php // INSTAGRAM AUTHENTICATE PROCESS ?>
            <div class="authenticate_wrapper">
                <?php
                $oauth_query = 'instagram_oauth.php?';
                $login_hash = generate_remote_login_hash($settings['cpanel_username'].','.get_host($settings['sitepath']));
                $oauth_query.='remotelogin='.$login_hash;
                ?>
                <h4 style="color: #ffffff">Privacy Policy <span style="font-size: 1rem;">- full details link <a style="color: #ffffff;" href="/admin/privacy_policy.php">here</a>.</span></h4>
                <h5>Our app will request login & permission to your instagram account to:</h5>
                <ul>
                    <li>Read your public Instagram profile including your username & profile URL on Instagram.com.</li>
                    <li>Access the public posts feed including pictures/videos posted as well as the captions associated with it.</li>
                </ul>
                <h5>Removal of Personal Data</h5>
                <ul>
                    <li>Accounts on this site can be deleted at the users request. Click "Disconnect" below to request complete deletion of your Personal Data, and your Instagram user data (including ID, access token, and username) will be permanently deleted from our servers instantly.</li>
                </ul>
                <a class="btn btn-admin authenticate__btn" id="disconnect_instagram">Disconnect</a>
            </div>
        </div>

        <div class="col-lg-6 px-5" id="user_tips">
            <?php
            $svg_append = 'images/admin_function_icon/';
            echo get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true));
            ?>
            <div class="my-4">
                <h5>Make sure your business Instagram profile is set to be visible to the public.</h5>
                <h5>To enable your Instagram Widget</h5>
                <ul>
                    <li>Your website must have been designed with this add-on feature. If you wish to add this feature, please contact our support desk for a quote.</li>
                    <li>You will need to log into your Instagram account and authenticate the Brixwork Website.</li>
                    <li>You will be redirected to another page, then brought back here when confirmed.</li>
                </ul>
            </div>
        </div>
    </div>


    <div class="row">
        <div class="mb-4">
            <label class="control-label orange pt-5">Login to Instagram to Authenticate</label>
            <a href="<?= $settings['brixwork_api_url'].$oauth_query?>" class="btn btn-admin authenticate__btn" style="display: table-cell">Begin Authenticate</a>
        </div>

        <div class="col-sm-6 mb-4">
            <?php
            admin_text_basic(array(
                'name' => 'instagram_access_token',
                'value' => $settings['instagram_access_token'],
                'label' => 'Instagram Token',
                'placeholder' => 'Enter the code shown under Access Token.'
            )); ?>
        </div>

        <div class="col-sm-6 mb-4">
            <?php
            admin_text_basic(array(
                'name' => 'instagram_userid',
                'value' => $settings['instagram_userid'],
                'label' => 'Instagram User ID',
                'placeholder' => 'Auto-generated from the token'
            )); ?>
        </div>

        <div class="col-sm-6 mb-4">
            <?php
            admin_text_basic(array(
                'name' => 'instagram_search_tag',
                'value' => $settings['instagram_search_tag'],
                'label' => 'Display Tags',
                'tooltip' => 'Enter the tag (without #) to only show posts with said tag.'
            )); ?>
        </div>

        <div class="col-sm-6 mb-4">
            <?php
            admin_text_basic(array(
                'name' => 'instagram_access_token_expiry',
                'value' => $settings['instagram_access_token_expiry'],
                'label' => 'Token Expiry',
                'tooltip' => 'Auto-generated from the API.'
            )); ?>
        </div>
    </div>
</div>



<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-facebook"></i> Facebook</h3>

    <div class="row">
        <div class="col-lg-6 mb-4">
            <div class="mb-5">
                <?php
                admin_text_basic(array(
                    'name' => 'facebook',
                    'value' => $settings['facebook'],
                    'label' => 'Your Facebook Business Page URL',
                    'placeholder' => 'https://www.facebook.com/brixwork/',
                    'tooltip' => 'This must be a valid PAGE url, NOT your profile page.'
                )); ?>
            </div>

            <?php
            admin_dropdown(array(
                'name' => 'facebook_button_type',
                'value' => $settings['facebook_button_type'],
                'label' => 'Widget Type',
                'value_variants' => array(
                    'share' => 'Share',
                    'like' => 'Like (Share Optional)'
                )
            ));
            ?>
        </div>

        <?php // FACEBOOK PREVIEW DIV ?>
        <div class="col-lg-6 d-flex">
            <div class="mx-auto">
                <label class="control-label orange d-block">Widget Preview</label>
                <div class="fb-page" data-href="<?=$settings['facebook']?>" data-tabs="timeline" data-width="" data-height="400" data-small-header="false" data-adapt-container-width="true" data-hide-cover="false" data-show-facepile="true">
                    <blockquote cite="<?=$settings['facebook']?>" class="fb-xfbml-parse-ignore">
                        <a href="<?=$settings['facebook']?>"><?=$settings['title']?></a>
                    </blockquote>
                </div>
            </div>
        </div>
    </div>
</div>




<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-twitter"></i> Twitter</h3>

    <div class="row pt-2">
        <div class="col-lg-6">
            <div class="mb-5">
                <?php
                admin_text_basic( array(
                    'name' => 'twitter',
                    'value' => $settings['twitter'],
                    'label' => 'Your Twitter Handle (Username)',
                    'placeholder' => 'brixwork',
                    'tooltip' => 'Enter your username, without the @'
                )); ?>
            </div>

            <label for="twitter_widget" class="control-label orange">Twitter Widget Code (Generate)</label>
            <textarea class="form-control" id="twitter_widget" name="twitter_widget" rows="1"><?=$settings['twitter_widget']?></textarea>
        </div>

        <?php // TWITTER WIDGET PUBLISH ?>
        <div class="col-lg-6">
            <label class="control-label orange">Widget Preview</label>

            <?php
            if ($settings['twitter_widget'] != '') :
                echo $settings['twitter_widget'];

            else: ?>
                <div class="authenticate_wrapper">
                    <p>You need to set up your Twitter widget. Log in to your Twitter account, and use the following link:</p>

                    <a href="" class="btn btn-admin authenticate__btn">Generate Twitter Widget</a>
                </div>
            <?php
            endif; ?>

        </div>
    </div>
</div>


<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-linkedin"></i> LinkedIn</h3>

    <div class="row pt-2">
        <div class="col-lg-6 m-auto">
            <?php
            admin_text_basic( array(
                'name' => 'linkedin',
                'value' => $settings['linkedin'],
                'label' => 'LinkedIn Profile',
                'placeholder' => 'https://linkedin.com/in/jeffkee',
                'tooltip' => 'Enter your LinkedIn Profile URL'
            )); ?>
        </div>

        <div class="col-lg-6 px-5" id="user_tips">
            <?=get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true))?>
            <div class="my-4">
                <h5>
                    If you don't have a LinkedIn profile, please <a href="https://www.linkedin.com/" target="_blank">create one now</a>, it adds credibility.
                </h5>
            </div>
        </div>
    </div>
</div>


<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-youtube"></i> Youtube</h3>

    <div class="row pt-2">
        <div class="col-lg-6 m-auto">
            <?php
            admin_text_basic( array(
                'name' => 'youtube',
                'value' => $settings['youtube'],
                'label' => 'Youtube',
                'placeholder' => 'https://youtube.com/brixwork',
                'tooltip' => 'Enter your Youtube URL'
            )); ?>
        </div>

        <div class="col-lg-6 px-5" id="user_tips">
            <?=get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true))?>
            <div class="my-4">
                <h5>
                    Your own <a href="https://www.youtube.com/">YouTube</a> channel should be where all your listing videos are uploaded.
                </h5>
            </div>
        </div>
    </div>
</div>


<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-pinterest"></i> Pinterest</h3>

    <div class="row pt-2">
        <div class="col-lg-6 m-auto">
            <?php
            admin_text_basic( array(
                'name' => 'pinterest',
                'value' => $settings['pinterest'],
                'label' => 'Pinterest Profile',
                'placeholder' => 'https://pinterest.com/jeffkee',
                'tooltip' => 'Enter your pinterest profile page URL.'
            )); ?>
        </div>

        <div class="col-lg-6 px-5" id="user_tips">
            <?=get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true))?>
            <div class="my-4">
                <h5>
                    <a href="//pinterest.com/" target="_blank">Pinterest</a> is a great way to get exposure for your listings through photography.
                </h5>
            </div>
        </div>
    </div>
</div>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-tiktok"></i> Tiktok</h3>

    <div class="row pt-2">
        <div class="col-lg-6 m-auto">
            <?php
            admin_text_basic( array(
                'name' => 'tiktok',
                'value' => $settings['tiktok'],
                'label' => 'Tiktok Username',
                'placeholder' => 'brixwork',
                'tooltip' => 'Enter your Tiktok username.'
            )); ?>
        </div>

        <div class="col-lg-6 px-5" id="user_tips">
            <?=get_svg(file_get_contents($svg_append.'brixwork_lightbulb.svg', true))?>
            <div class="my-4">
                <h5>
                    Your <a href="//tiktok.com/" target="_blank">TikTok</a> account can be used to <a href="https://www.businessinsider.com/real-estate-agents-on-tiktok-advertise-rental-listings-virtual-showings-2021-4" target="_blank">engage with your audience</a>!
                </h5>
            </div>
        </div>
    </div>
</div>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title"><i class="bi bi-google"></i> Google Business</h3>

    <div class="row pt-2">
        <div class="col-lg-6">
            <?php
            admin_text_basic( array(
                'name' => 'googleplus',
                'value' => $settings['googleplus'],
                'label' => 'Google Business URL',
                'placeholder' => 'brixwork',
                'tooltip' => 'Enter your Google Business URL.'
            )); ?>
        </div>
    </div>
</div>