<?php // General Settings Tab
global $settings;
?>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Google Analytics</h3>

    <div class="row pt-2">
        <div class="col-sm-6 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'google_analytics',
                'value' => $settings['google_analytics'],
                'label' => 'Google Analytics Tag',
                'placeholder' => 'G-',
                'tooltip' => 'Enter the Tracking ID (G-XXX or UA-XXX) only, NOT the entire code!'
            )); ?>
        </div>

        <div class="col-sm-6 mb-4">
            <?php
            admin_text_basic( array(
                'name' => 'google_webmaster_tools',
                'value' => $settings['google_webmaster_tools'],
                'label' => 'Search Console',
                'placeholder' => '88ljRtBTGlpSlHS7Jmic5BKElvYiORQyDl4SFsy70BU',
                'tooltip' => 'Enter the HTML meta tag provided under Alternative Methods'
            )); ?>
        </div>

        <div class="col-sm-6 mb-4 mb-sm-0">
            <?php
            admin_text_basic( array(
                'name' => 'google_adwords_tracking',
                'value' => $settings['google_adwords_tracking'],
                'label' => 'Google Adwords Tag',
                'placeholder' => 'AW-',
                'tooltip' => 'Enter the AW-XXXX tag only, NOT the entire code!'
            )); ?>
        </div>

        <div class="col-sm-6 mb-4 mb-sm-0">
            <?php
            admin_text_basic( array(
                'name' => 'google_tag_manager',
                'value' => $settings['google_tag_manager'],
                'label' => 'Google Tag Manager',
                'placeholder' => 'GTM-',
                'tooltip' => 'Enter the ID (GTM-) only, NOT the entire code!'
            )); ?>
        </div>
    </div>
</div>

<div id="settings_listing__general" class="each_tab__category brixwork_inner_spacing w-100">
    <h3 class="each_tab__category_title">Extra Javascript Sections</h3>

    <div class="row">
        <div class="col-sm-6">
            <div class="brixwork_info_grid">
                <i class="bi bi-exclamation-circle"></i>
                <div class="brixwork_info__text_wrapper">
                    <h6>Only include Javascript in the sections below!</h6>
                    <p>Entering wrong tracking code or activation code can break your entire site. After adding snippets, please test your website's front-end. If it's broken, remove the added code, save again, and contact our support centre.</p>
                </div>
            </div>
        </div>
    </div>

    <div class="row pt-5">
        <div class="col-lg-6">
            <?php
            admin_textarea(array(
                'name' => 'header_js',
                'value' => $settings['header_js'],
                'label' => 'Head Tracking Javascript',
                'placeholder' => 'Enter Javascript Code Only!',
                'rows' => 6
            )); ?>
        </div>

        <div class="col-lg-6 mt-4">
            <p>Do not repeat Google Analytics, Google Tag Manager snippet or Google Search Console tags here - look above. Other tracking code such as Facebook tracking code, or any other javascript snippet to place before the &lt;/head&gt; can be placed here.</p>
        </div>
    </div>

    <div class="row pt-5">
        <div class="col-lg-6">
            <?php
            admin_textarea(array(
                'name' => 'body_top_js',
                'value' => $settings['body_top_js'],
                'label' => 'Body Top Tracking Javascript',
                'placeholder' => 'Enter Javascript Code Only!',
                'rows' => 6
            )); ?>
        </div>

        <div class="col-lg-6 mt-4">
            <p>Do not repeat Google Analytics, Google Tag Manager snippet or Google Search Console tags here - look above. Other tracking code such as Facebook tracking code, or any other javascript snippet to place before the &lt;body&gt; can be placed here.</p>
        </div>
    </div>

    <div class="row pt-5">
        <div class="col-lg-6">
            <?php
            admin_textarea(array(
                'name' => 'footer_js',
                'value' => $settings['footer_js'],
                'label' => 'Footer Tracking Javascript',
                'placeholder' => 'Enter Javascript Code Only!',
                'rows' => 6
            )); ?>
        </div>

        <div class="col-lg-6 mt-4">
            <p>Facebook Messenger Chat Widgets and other similar widgets can be entered here.</p>
            <a href="http://support.brixwork.com/support/solutions/articles/8000074517-add-facebook-chat-widget-to-your-website" target="_blank" class="btn btn-admin light_blue px-4">FB Chat Widget</a>
        </div>
    </div>
</div>