$(document).ready(function(){
	list_areas();
});


function list_areas() {
	let random_number = Math.floor(Math.random()*101);

	$('#areas_list').html(window.ajax_loader);
	$.post("ajax_listareas.php", {rand: random_number},
		function(data){

			$('#areas_list').html(data);
			activate_areas()
			activate_subareas()
			activate_collapse_control()

			// enable tooltips for ajax created content
			const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
			const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl))
		}
	);
}


function modifyarea(change,idr,value){
	let random_number = Math.floor(Math.random()*101)

	$.post("ajax_modifyareas.php", { idr: idr, value: value, change: change, rand: random_number },
		function(data){
			if(data.code === 0) {
				console.log(data.message);
			} else {
				let classtoremove = '';
				let classtoadd = '';

				switch(change) {
					// now process classes etc. depending on what was done!
					case 'publishstatus':
						if(value === 1) {
							classtoremove = '';
							classtoadd = 'areas_publish';
						} else {
							classtoremove = 'areas_publish';
							classtoadd = '';
						}
						break;

					case 'featurestatus':
						if(value === 1) {
							classtoremove = '';
							classtoadd = 'areas_feature';
						} else {
							classtoremove = 'areas_feature';
							classtoadd = '';
						}
						break;

					case 'delete':
						list_areas()
						break;
				}
				$('#area_' + idr + ' .each_list').removeClass(classtoremove).addClass(classtoadd);
			}
		},
		'json');
}



function modifysubarea(change, idr, value){
	let random_number = Math.floor(Math.random()*101)

	$.post("ajax_modifysubareas.php", { idr: idr, value: value, change: change, rand: random_number },
		function(data){
			if(data.code === 0) {
				console.log(data.message);
			}
			else {
				let classtoremove = '';
				let classtoadd = '';
				switch(change) {
					// now process classes etc. depending on what was done!					
					case 'delete':
						list_areas()
						break;
				}
				$('#area_' + idr + ' .each_list').removeClass(classtoremove).addClass(classtoadd);
			}
		},
		'json');
}


function activate_areas() {

	$('#new_area_btn').click(function(){
		if (parseInt($('#mls_integrated').val()) === 1) {
			$('#add_area_mls').modal('show');
			return false;
		} else {
			$('#add_area_non_mls').modal('show');
			return true;
		}
	});


	// Area Publish Status on or off AJAX
	$('.area_publish_toggle').each(function(){
		$(this).change(function(){
			let area_id = $(this).attr('rel')

			modifyarea('publishstatus', area_id, $(this).val());
			// toggle class for opacity update
			$('#area_' + area_id + ' .each_list').toggleClass('hidden_list')
		});
	});


	// Area Feature Status on or off AJAX
	$('.area_feature_toggle').each(function(){
		$(this).click( function() {
			let area_id = $(this).attr('rel')
			let area_feature = $(this).attr('data-feature')
			let new_value = parseInt(area_feature) === 1 ? 0 : 1

			modifyarea('featurestatus', area_id, new_value);
			$(this).attr('data-feature', new_value)
		});
	});

	// Area and Subarea delete modal popup
	$('.each_area__delete').each(function(){
		$(this).click(function(){
			let num_listings = parseInt($(this).attr('data-listings'));

			if(num_listings > 0) {
				console.log(num_listings + ', so cannot delete')
			}
			else {
				// determine if we are deleting AREA or SUBAREA
				let category = $(this).attr('data-category')
				let delete_modal = $('#delete_area')
				delete_modal.find('.delete_area__btn').attr('rel', $(this).attr('rel'))
				delete_modal.find('.delete_area__btn').attr('data-category', category)
				delete_modal.modal('show')
			}
			return false;
		});
	});

	// Actual AJAX call to delete Area or Subarea
	$('.delete_area__btn').each(function () {
		$(this).click(function () {
			let area_to_delete = $(this).attr('rel')

			let category = $(this).attr('data-category')
			$('#delete_area').modal('hide')

			if (category === 'area') {
				console.log('deleting area #' + area_to_delete)
				modifyarea('delete', area_to_delete);
			}
			else if (category === 'subarea') {
				console.log('deleting subarea #' + area_to_delete)
				modifysubarea('delete', area_to_delete)
			}
		})
	})
}



function activate_subareas() {

	$('.add_new_subarea_button').each(function() {
		$(this).click(function() {
			// update the data of the modal
			let city_clicked = $(this).attr('data-city')
			let mod_link = $(this).attr('data-href')

			if(parseInt($('#mls_integrated').val()) === 1) {
				let subarea_modal = $('#add_subarea_mls');
				subarea_modal.find('.modal-header h2').html('Create New Subarea Under ' + city_clicked)
				subarea_modal.find('.btn-admin').attr('href', mod_link)
				subarea_modal.modal('show');
			}
			else {
				let subarea_modal = $('#add_subarea_non_mls');
				subarea_modal.find('.modal-header h2').html('Create New Subarea Under ' + city_clicked)
				subarea_modal.find('.btn-admin').attr('href', mod_link)
				subarea_modal.modal('show');
			}
		});
	});
}