/*
Filename: gallery.js

Method: JS include

Description: Dictates the 

Author: Jeff Kee
*/

$(document).ready(function(){
	loadphotolist();
	
	$('#deletephotos').click(function(){
		console.log('initialize multi delete sequence');
		deletephotos();
	});
	
	var gvertical = $("#galleryinput_container").offset().top;
	gvertical = gvertical-20;
	// var gvertical = gposition.top;
	
	$(window).scroll(function(){
		if(window.windoww<768) {
			$("#galleryinput_container").css({
				"top": '0px',
			});
		} else {
			var scrolltop = $(this).scrollTop();
			if(scrolltop>gvertical) {
				console.log('scroll broke '+gvertical);
				$("#galleryinput_container").css({
					"top": scrolltop-gvertical+'px',
				});
			} else {
				console.log('scroll came back below '+gvertical);
				$("#galleryinput_container").css({
					"top": '0px',
				});
			}
		}
	});

	$('#galleryinput').uploadifive({
		'uploadScript' : 'ajax_receivephoto.php',
		'auto' : true,
		'buttonClass': 'btn btn-block uploadifiveinput',
		'buttonText': 'Select or Drag and Drop',
		'method': 'post',
		'multi':true,
		'fileObjName': 'file',
		'debug':true,
		'height': '120',
		'width': 'auto',
		'fileType': ['image/jpeg', 'image/jpg'],
		'removeCompleted': true,
		'queueID': 'galleryqueue',
		'simUploadLimit':1,
		'itemTemplate' : '<p class=\"uploadifive-queue-item bg-success\">Currently Uploading <span class=\"filename\"></span> <span class=\"close\"></span>:</p>',
		'formData': {'destfolder':window.destinationfolder,'idr':window.idr},
		'onSelect': function(queue) {
			$('#uploadbutton').fadeOut(); return true;
		},
		
		'onAddQueueItem' : function(file) {
			console.log('uploading file check');
			
			var fileName = file.name;
			var file_ext = fileName.substring(fileName.lastIndexOf(".")+1,fileName.length); // Extract EXT
			file_ext = file_ext.toLowerCase();
			console.log('checcking ext: '+file_ext);
			switch (file_ext) {
				case 'jpg':
				case 'jpeg':
					console.log('filetype ok');
				break;
				default:
					$('#galleryinput').uploadifive('cancel', file); // cancel current upload, 
					$('#filetype_jpg').modal('show');
				break;
			}
		},
		
		'onProgress': function (file, e) {
			var percentage = (e.loaded/e.total)*100;
			
			$('#galleryprogressbar').css('width', percentage+'%').attr('aria-valuenow', percentage);
			
		}, 
		
		'onCancel': function() {
			$('#galleryprogressbar').css('width', '0%').attr('aria-valuenow', 0);
		},
		
		'onQueueComplete': function (uploads) {
			$('#galleryprogressbar').css('width', '100%').attr('aria-valuenow', 100).delay(1000).css('width', '0%').attr('aria-valuenow', 0);
			setTimeout(function(){loadphotolist();}, 3000);
		},
		
		'onUploadComplete': function(file, data, response) {
        	console.log('The file was saved to: ' + data);
    	}		
		
	});

	$('#uploadifive-galleryinput').bind('dragover', function(){
		$(this).addClass('dragover');
	});
	$('#uploadifive-galleryinput').bind('dragleave', function(){
		$(this).removeClass('dragover');
	});
	$('#uploadifive-galleryinput').bind('drop', function(){
		$(this).removeClass('dragover');
	});
	
});


function deletephotos() {
	// new multi-delete function
	// get the IDs selected first. 
	window.deletearray = [];
	var deletenum = 0;
	$('input[name="deletephotos"]').each(function(){
		if($(this).prop('checked')) {
			window.deletearray[deletenum] = $(this).val();
			deletenum++;
		}
	});
	if(deletenum>0) {
		$('#delete_confirm').modal('show');
		confirmation_display('Are you sure you want to remove the selected photos?','Photo Removal','trash','delete_multi_photos(window.deletearray)', '');
	} else {
		// turn on the popover on the first DELETE checkbox? 
		$('.checkbox').popover('show');
		setTimeout(function(){ $('.checkbox').popover('hide'); }, 3000);
	}
	return false;
}

function delete_multi_photos(array) {
	modal_processing(true);
	window.deletecount = 0;
	for (i = 0; i < array.length; i++) { 
		var photoid = array[i];
		var randomnumber=getrandomnumber();
		$.get("ajax_modifyphotos.php", { idr: photoid, rand: randomnumber, change:'delete', folder: window.destinationfolder},
			function(data){
   				console.log(photoid+ ' being removed');
   				window.deletecount++;
   				if(window.deletecount == array.length) {
   					console.log(window.deletecount+' counts deleted from target of '+array.length+', reloading.');
	   				window.setTimeout("loadphotolist();", 500);
	   				modal_processing(false);
   				} else {
	   				console.log(window.deletecount+' counts from '+array.length+' so NOT reloading yet.');
   				}
   			},
   		'json');
	}
}


function modifyimage(change,idr,value,homeid){
		var randomnumber=getrandomnumber();
		
		$.post("ajax_modifyphotos.php", { idr: idr, change: change, value:value, homeid:homeid, folder: window.destinationfolder},
  			function(data){
				
			}, 'json'
		);
}

function loadphotolist()	{
	let randomnumber = getrandomnumber();

	$('#photolist').html(window.ajax_loader);
	$.get('ajax_listphotos.php', { homeid: getvar['idr'], folder: window.destinationfolder, rand: randomnumber},
		function(data){
			$('#photolist').html(data);

			// setBlankImage();
			$( "#photolist" ).sortable({
				items: ".photo_row",
				handle: ".orderhandle",
				cursor: 'move',
				update: function(event, ui) {
					var photoordervars = $("#photolist").sortable('serialize');
					$.post("ajax_modifyphotos.php", photoordervars+'&change=order&idr='+getvar['idr']+'&folder='+getvar['folder'],
						function(data){
							console.log(data);
							if(data.code==0) {
								console.log('Error '+data.code+': '+data.message);
								$("#phototable").sortable('cancel');
							} else {
								// successful. Let's re-set the taborders!
								var tabindex = 1; // start at 1, 0 means disabled!
								$('#photolist .photo_title').each(function(){
									$(this).attr('tabindex', tabindex);
									tabindex++;
								});
							}
						},
					'json'
					);
				}
			});

			$('#photolist .photo_row').each(function(){
				$(this).find('img.orderhandle').disableSelection();
			});

			$('#photolist input.photo_title').each(function(){
				$(this).popover();
				$(this).change(function(){
					modifyimage('title', $(this).attr('rel'), $(this).val(), getvar['idr']);
					return false;
				})

				$(this).keyup(function (e) {
					if(e.keyCode==13) {
						// skip to the next console element!
						var titlecount = $('.photo_title').length; // get the total count.
						var tabindex = $(this).attr('tabindex');
						console.log('you got enter on tabindex '+tabindex);
						tabindex++;

						if(tabindex>titlecount) {
							// next tab index larger than total # of fields, so recycle to top one!
							tabindex = 1;
						}

						$('[tabindex=' + tabindex + ']').focus().select();
					}
				});

			});

			$('#delete_toggle').unbind('click').click(function() {
				console.log("unbound click handler");
				//addToCart($(this).attr("id"));
			});


			console.log('attaching toggle action');
			$('#delete_toggle').click(function() {
				// trigger select or deselect ALL
				console.log("delete toggle");
				let checkcount = 0;
				let checkedstatus = true;
				$('input[name="deletephotos"]').each(function(){
					if(checkcount === 0) {
						// check status of the first checkbox, whether is checked on or off
						checkedstatus = !$(this).prop('checked');
					}

					$(this).prop('checked', checkedstatus);

					checkcount++;
				});

			});
		}
	);
}

function refresh() {

loadphotolist();

}

function setBlankImage () {
  console.log('in set blank');
  $('.orderhandle').each(function (index) {
    $(this).on('error', function () {
	    var originalURL = $(this).attr('src');
	    
	    var key = originalURL.slice(originalURL.indexOf(window.bucket) + window.bucket.length + 1);
	    
	    $(this).attr('src', window.basePath+'ajax-loader.gif');
	    console.log( 'URL: '+window.basePath+'ajax-loader.gif');
	    
	    var $image = $(this);
		  
		AWS.config.update({
		  	signatureVersion: 'v4',
		  	region: 'ca-central-1'
		});
		
		/* Username in AWS IAM: gallery_image_checker  */
		var s3 = new AWS.S3({
			accessKeyId: 'AKIAZXDVQ6Q6B2Q2XSVI',
			secretAccessKey: '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'
		});
		
		var params = { Bucket: window.bucket, Key: key }
		// TODO: re-enable following, or at least have a gracefull fallback in case it fails more than 3 times?
		// TODO: Pain in the ass when troubleshooting.
		// var maxs3waitcount = 10;
		// var request = s3.waitFor('objectExists', params, function(err, data) {
		// 	if (err) console.log(err, err.stack);
		//
		// 	else {
		// 		console.log(data);
		// 		$image.attr('src', originalURL);
		// 	}
		//
		// });
		
		request.
			on('error', function(response) {
				console.log(response);
				$image.attr('src', window.basePath+'noimage.jpg');
			})
		
		});
  })
}
