$(document).ready(function(){
	window.page = 1;

	console.log('homes.source.js running')
	listhomes(window.page);

	$('#perpage').change(function(){
		window.page = 1; // new filter, back to page 1
		listhomes(window.page);
	});

	$('#homes_filter_trigger').click(function(){
		window.page = 1; // new filter, back to page 1
		listhomes(window.page);
	});

	$('#homes_filter_clear').click(function(){
		$('.homes_filter').each(function(){
			$(this).val('');
		});
		window.page = 1;// new filter, start with page 1!
		listhomes(window.page);
	});


	init_duplicate_modal()


	$("#homeslist").on("click", ".gaSummary", function() {
		$("#modal_processing").modal('show');
		$.get("ajax/ajax_ana_modal.php", {
			listing_id: $(this).data('id')
		}, function(data) {
			if (data) {
				$("#anaData").html(data);
				$("#modal_processing").modal('hide');
				$("#GoogleAnalytics").modal();
			} else {
				$("#modal_processing").modal('hide');
			}
		})
	});


	// SEARCH THE MLS TO ADD AS NEW LISTING
	const form = document.getElementById('mls_number')
	let mls_input_field = document.getElementById('mls');

	$('#mls_search_trigger').click(function () {
		let add_listing_modal = bootstrap.Modal.getInstance(document.getElementById('add_listing_modal'));

		// VALIDATED FORM FIRST! NEED SOME INPUP
		form.addEventListener('submit', event => {
			event.preventDefault() // PREVENT THE SUBMIT BUTTON TO REFRESH BROWSER
			if (!form.checkValidity()) {
				event.stopPropagation()
			}
			else {
				console.log('valid mls number ... searching the db');
				let mlsnum = mls_input_field.value;
				$.post("ajax_countrows.php", {
						'filterfields[]': ['mls', 'source'],
						'filtervalues[]': [mlsnum, '1'],
						table: "homes"
					},
					function (data) {
						if (data.code === 2) {
							add_listing_modal.hide();
							$('#mls_failed').modal('show');
							remove_form_validation()
						} else if (data.code === 1) {
							add_listing_modal.hide();
							$('#mls_found').modal('show');
						} else if (data.code === 0) {
							add_listing_modal.hide();
							$('#mls_failed').modal('show');
							remove_form_validation()
						}
						return false;
					}, 'json'
				);
			}

			form.classList.add('was-validated')
		}, false)
	});

	// RESET INPUT VALIDATION ON CLICK
	mls_input_field.addEventListener('focus', remove_form_validation);

	// CONVERT TO OWN OR FEATURE LISTING ON CLICK
	let mls_found_convert = document.getElementById('mls_found_convert');
	let mls_found_feature = document.getElementById('mls_found_feature');
	mls_found_convert.param = 'source'
	mls_found_feature.param = 'feature'
	mls_found_convert.addEventListener('click', convertlisting_wrapper)
	mls_found_feature.addEventListener('click', convertlisting_wrapper)

	// APPEND MLS NUMBER TO HREF SO HOMES_MOD.PHP WILL HAVE ACCESS TO USER TYPED MLS NUMBER
	let add_manually_buttons = document.querySelectorAll('#add_manually_button');
	add_manually_buttons.forEach(add_manually_button => {
		add_manually_button.addEventListener('click', function () {
			let url = new URL(add_manually_button.href);	// homes_mod.php/

			const add_params = {
				mode	: "new",
				mls		: mls_input_field.value ? String(mls_input_field.value) : false, // user typed mls number
			}

			const new_params = new URLSearchParams([
				...Array.from(url.searchParams.entries()), // [["a","hello"],["b","world"]]
				...Object.entries(add_params), // [["c","a"],["d","2"],["e","false"]]
			]).toString();

			add_manually_button.href = new URL(`${url.origin}${url.pathname}?${new_params}`);
		})
	})

	// delete home function in a modal
	let home_delete_btn = document.querySelectorAll('#delete_home_btn');
	home_delete_btn.forEach(e => e.addEventListener('click', function () {
		$('#delete_home').modal('hide');
		modifyhome('delete', e.dataset.homeId, 1)
	}));
});


function listhomes(page) {
	$('#homeslist').html(window.ajax_loader); // this is just the loading gif

	let filters = {}; // start array
	let filtersset = false;
	$('.homes_filter').each(function(){
		if($(this).val()!=='') {
			filtersset = true;
			filters[$(this).attr('name')] = $(this).val();
		}
	});

	// console.log('homes_filter', $('.homes_filter'))
	// console.log(filters)
	// filters = {};

	// Access a specific parameter
	const urlParams = new URLSearchParams(window.location.search);
	const reorder_mode = urlParams.get('reorder') ? 1 : 0;

	let randomnumber=Math.floor(Math.random()*101);
	let perpage = $('#perpage').val();

	if (reorder_mode) {
		window.page = 1;	// there's only 1 page in reorder mode
		perpage = 100000;	// perpage is unlimited for reorder mode.
		console.log('Re-order Mode: Loading '+perpage+' homes, page number '+page)
	} else {
		window.page = page;
		console.log('Loading '+perpage+' homes, page number '+page);
	}

	$.get("ajax_listhomes.php", { page:page, perpage:perpage, filters:filters, rand:randomnumber, reorder:reorder_mode, debug:0 },
		function(data) {
			$('#homeslist').html(data);

			activate_homes_toggles();
			if(filtersset===false) {
				$("#homestable").sortable({
					items: ".each_admin_listing",
					handle: ".orderhandle",
					cursor: 'move',
					update: function (event, ui) {
						let homeordervars = $("#homestable").sortable('serialize');
						$.get("ajax_modifyhomes.php", homeordervars + '&change=order&perpage=' + perpage + '&page=' + window.page,
							function (data) {
								console.log(data);
								if (data.code == 0) {
									console.log('Error ' + data.code + ': ' + data.message);
									$("#homestable").sortable('cancel');
								}
							},
							'json'
						);
					}
				});

				$('#homestable .each_admin_listing').each(function () {
					$(this).find('.orderhandle').disableSelection(); // so that you cannot accidentally SELECT the iamge instead of using it to DRAG.
				});

				$('.orderhandle').each(function () {
					$(this).click(function () {
						return false;
					});
				})
			}

			// MAKES PAGINATION WORK
			$('.homes_pagelink').each(function(){
				$(this).click(function(){
					window.page = $(this).attr('rel');
					listhomes(window.page);
					return false;
				});
			});

			// reorder mode
			reorder_mode_functions();
		});
}

function activate_homes_toggles() {
	// $('[data-bs-toggle="tooltip"]').tooltip(); // tooltip need re-enabling for freshly loaded DOM.
	const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
	const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl))

	$('.home_publish_toggle').each(function(){
		$(this).change(function(){
			console.log('publish status change on '+$(this).attr('rel'));
			modifyhome('publishstatus',$(this).attr('rel'),$(this).val());
		});
	});
	
	$('.home_sold_toggle').each(function(){
		$(this).change(function(){
			console.log('sold status change on '+$(this).attr('rel'));
			modifyhome('soldstatus',$(this).attr('rel'),$(this).val());
		});
	});

	// pure javascript
	document.querySelectorAll('#home_feature_switch').forEach(each_listing => {
		each_listing.addEventListener('click', function () {
			console.log('feature status change on '+ each_listing.getAttribute('rel'));
			if(parseInt(each_listing.getAttribute('value')) === 0) {
				each_listing.setAttribute('value', '1');
			} else {
				each_listing.setAttribute('value', '0');
			}
			modifyhome('featurestatus', each_listing.getAttribute('rel'), each_listing.getAttribute('value'));
		})
	})
	
	$('.home_delete').each(function(){
		$(this).click(function(){
			let delete_home_modal = $('#delete_home')

			let home_id = $(this).attr('rel');
			let home_address = $('#home_'+home_id+' .full_address').html().replace(/(<([^>]+)>)/gi, " ");
			let modal_html = '<p>Are you sure you want to delete '+home_address+'? <br>It is recommended to hide it instead.</p>'

			$('#delete_home_btn').attr('data-home-id', home_id);
			delete_home_modal.find('.modal-body').html(modal_html);
			delete_home_modal.modal('show');
			return false;
		});
	});
}

function modifyhome(change, idr, value){
	// only "Delete" function takes long enough to require processing modal
	if (change === 'delete') {
		modal_processing(true);
	}
	let randomnumber = Math.floor(Math.random()*101)
	
	$.get("ajax_modifyhomes.php", { idr: idr, value: value, change: change, rand: randomnumber },
		function(data){
			if(parseInt(data.code) === 0) {
				alert(data.message);
			}
			else {
				// now process classes etc. depending on what was done!
				let classtoremove = '';
				let classtoadd = '';
				switch(change) {
					case 'publishstatus':
						if(parseInt(value) === 1) {
							classtoremove = '';
							classtoadd = 'home_publish';
						} else {
							classtoremove = 'home_publish';
							classtoadd = '';
						}
						break;

					case 'featurestatus':
						if(parseInt(value) === 1) {
							classtoremove = '';
							classtoadd = 'home_feature';
						}
						if (parseInt(value) === 0){
							classtoremove = 'home_feature';
							classtoadd = '';
						}

						if(!$('#home_'+idr).hasClass('source_0')) {
							// MLS featured listing, so this means we need to hide this!
							$('#home_'+idr).slideUp(300, function(){
								$(this).remove();
							}); // deleted, get rid of this row!
						}
						break;

					case 'soldstatus':
						if(parseInt(value) === 1 || parseInt(value) === 2) {
							classtoremove = '';
							classtoadd = 'home_sold';
						} else {
							classtoremove = 'home_sold';
							classtoadd = '';
						}
						break;

					case 'delete':
						$('#home_'+idr).slideUp(300, function(){
							$(this).remove();
						}); // deleted, get rid of this row!
						break;

					// Work in Progress...
					case 'order_by_keyboard':
						console.log('item moved.');
						const home1 = document.getElementById('home_' + idr);
						const home2 = document.getElementById('home_39407');
						const parent = document.getElementById('homestable');

						if (value === 'down') {
							parent.insertBefore(home2, home1);
						} else if (value === 'up') {
							parent.insertBefore(home1, home2);
						}
						break;

				} // end switch
				$('#home_'+idr).removeClass(classtoremove).addClass(classtoadd);
			}
			modal_processing(false);
		},'json'
	);
}

function remove_form_validation() {
	const form = document.getElementById('mls_number')
	form.classList.remove('was-validated')
}


// MLS data related functions
function convertlisting_wrapper(button) {
	convertlisting(button.currentTarget.param);
}
function convertlisting(change) {
	if(change === 'source') {
		var fieldvalue = 0;
	} else if(change === 'feature') {
		var fieldvalue = 1;
	}
	var mlsnum = $('#mls').val();
	console.log('changing '+change+' to '+fieldvalue+' now.');
	// function to either convert to FEATURED or OWN depending on feed.
	modal_processing(true);

	$.post("ajax_modifyhomes.php", { mls: mlsnum, value: fieldvalue, change:change},
		function(data) {
			if(data.code==0) {
				modal_processing(false);
				$('#mls_failed').find('.modal-body').html('<p>An error occurred - please contact the Brixwork Support Team and include the following error message:</p><p><strong>'+data.message+'</strong>.</p>');
				$('#mls_failed').modal('show');
			} else if(data.code==1) {
				// MLS # was successfully converted!
				window.leaveflag=1;
				if(change=='source') {
					// converted to OWN listing, take to homes screen.
					window.location = 'homes_mod.php?idr='+data.id+'&mode=modify';
				} else {
					// just featured MLS listing, go back to homes list.
					window.location = 'homes.php';
				}
			}
		},
		'json');
}


function init_duplicate_modal() {
	// add click event ... this part of function runs on window load ... always start with modal #1.
	let resolve_modal_trigger = $('.duplicate_homes_resolve_trigger')
	resolve_modal_trigger.click(function () {
		$('#resolve_dup_listing_1').modal('show')
	})

	let resolve_modal_count = resolve_modal_trigger.attr('rel') // total counter for instances of duplicate homes

	let resolve_modal_index = 1;
	//console.log('#resolve_dup_listing_' + resolve_modal_index)

	// ACTUALLY DELETING DUPLICATE LISTINGS
	$('.resolve_dup_homes').each(function(){
		$(this).click(function(){
			modal_processing(true);
			let mls = $(this).attr('rel');
			let selected_home_id = $('input:radio[name='+mls+']:checked').val();
			console.log('#resolve_dup_listing_'+resolve_modal_index)

			$.post("ajax_resolveduplicates.php", {mls:mls, selectedhome:selected_home_id, table:'homes'},
				function(data){
					if(parseInt(data.code) === 0) {
						console.log(data.message);
					} else {
						// refresh the list of homes ... also need to update the warning.
						listhomes()

						resolve_modal_index++	// open next modal
						resolve_modal_count--	// 1 less duplicate instances

						// update warning label
						if (resolve_modal_count > 0) {
							let duplicate_warning_string = resolve_modal_count > 1 ? resolve_modal_count + ' Duplicate Homes' : resolve_modal_count + ' Duplicate Home'
							resolve_modal_trigger.html(duplicate_warning_string + ' Found. Click here to resolve.')
						}
						else {
							$('#duplicate_warning_js').remove()
						}

						// remove existing event listener to add a new one.
						resolve_modal_trigger.off('click')
						resolve_modal_trigger.click(function () {
							$('#resolve_dup_listing_'+resolve_modal_index).modal('show')
						})
					}
					modal_processing(false);
				}
				,'json'
			);
		});
	});
}



function reorder_mode_functions() {
	// Move to Top button
	$('.reorder_moveto_top').each(function(){
		$(this).click(function(){
			let home_id = $(this).attr('rel');
			let home_div = $('#home_'+home_id);

			// move the home div to first child of parent element. (display only)
			home_div.prependTo("#homestable");

			// update the database `order` column to match the display.
			let homeordervars = $("#homestable").sortable('serialize');
			$.get("ajax_modifyhomes.php", homeordervars + '&change=order&perpage=100000&page=1',
				function (data) {
					console.log(data);
					if (data.code == 0) {
						console.log('Error ' + data.code + ': ' + data.message);
					}
				}, 'json'
			);
		});
	});

	//reorder_with_keyboard();
}



// Move listing with keyboard - Work in Progress
function reorder_with_keyboard() {
	const radioButtons = document.querySelectorAll('.form-check-input');
	// Loop through each radio button and add event listener
	radioButtons.forEach(function(radioButton) {
		radioButton.addEventListener('change', function() {
			if (this.checked) {
				// Log data-home-id attribute when radio button is checked
				console.log(this.getAttribute('data-home-id'));
				let home_idr = this.getAttribute('data-home-id');

				// checked... now wait for keyboard input
				this.addEventListener("keydown", function(event) {
					event.preventDefault();
					if (event.key === "ArrowDown") {
						// Your code to handle the down arrow key press
						console.log("Down arrow key pressed");
						modifyhome('order_by_keyboard', home_idr, 'down')

					} else if (event.key === "ArrowUp") {
						console.log("Up arrow key pressed");
						modifyhome('order_by_keyboard', home_idr, 'up')
					}
				});
			}
		});
	});
}