$(document).ready(function(){
	listlinks();
	
	$('#add_new_category_button').click(function(){
		$('#add_category').modal('show');
		return false;
	});
});



function listlinks() {
	$('#linkslist').html(window.ajax_loader);
	var randomnumber=Math.floor(Math.random()*101);
	$.post("ajax_listlinks.php", { rand:randomnumber },
		function(data){
		$('#linkslist').html(data);
		// trigger re-order options with drag & drop sortables.
		activate_category_reorders();

		// set up resources display toggle on category + buttons.
		activate_resource_expands();
		
		// resource publish on or off AJAX
		$('.resource_publish_toggle').each(function(){
			$(this).change(function(){
				console.log('publish status change on '+$(this).attr('rel'));
				modifyresource('publishstatus',$(this).attr('rel'),$(this).val());
			});
		});
		
		// set up category modify AJAX functions
		$('.category_mod').each(function(){
			$(this).click(function(){
				var categoryid = $(this).attr('rel')
				window.mod_category_id = categoryid;
				$('#mod_category_name').val($('#category_'+categoryid+' .category_title').text());
				$('#mod_category').modal('show');
				return false;
			});
		});
	
		// set up resource deletion links
		$('.resource_delete').each(function(){
			$(this).click(function(){
				var resourceid = $(this).attr('rel');
				var resourcetitle = $('#resource_'+resourceid+' .resource_title').text();
				console.log(resourcetitle+' ID '+resourceid+' delete triggered');
				window.resource_delete_id = resourceid;
				$('#delete_resource').find('.modal-body').html('<p>Are you sure you want to delete <strong>'+resourcetitle+'</strong> (#'+resourceid+')? You can set this to be hidden for now instead.</p>');
				$('#delete_resource').modal('show');
				return false;
			});
		});
		
		// set up category deletion links
		$('.category_delete').each(function(){
			$(this).click(function(){
				var categoryid = $(this).attr('rel');
				var categorytitle = $('#category_'+categoryid+' .category_title').text();
				console.log(categorytitle+' ID '+categoryid+' delete triggered');
				window.category_delete_id = categoryid;
				$('#delete_category').find('.modal-body').html('<p>Are you sure you want to delete <strong>'+categorytitle+'</strong> (#'+categoryid+')? If you have no links below it, it will not show to anyway.</p>');
				$('#delete_category').modal('show');
				return false;
			});
		});
		
	});

}


function add_category() {
	var category_name = $('#category_name').val();
	$.post("ajax_modifyresourcecategories.php", { change:'add', category_name:category_name},
		function(data) {
			if(data.code==1) {
				listlinks();
			} else {
				alert('error! '+data.message);
			}
		}, 'json'
	);
	return false;
}



function activate_resource_expands() {
	$('.resources_toggle').each(function(){
		$(this).click(function(){
			$(this).blur();
			var targetid = $(this).attr('rel');
			return expand_resources_row(targetid);
		});
	});
}


function expand_resources_row(rel) {
	console.log('opening up '+rel);
	$('#resources_'+rel).stop().slideToggle(400);
	return false;
}




function activate_category_reorders() {
	// first, destroy all sortables so we start fresh. Otherwise we'll have duplicate triggers!
	var linkslist = $('#linkslist');
	if(linkslist.sortable('instance')!==undefined) {
		linkslist.sortable('destroy');
	}
	
	linkslist.sortable({
	 	items: "> div.row",
	 	handle: ".category_title",
	 	cursor: 'move',
	 	update: function(event, ui) {
	 		var categoryordervars = $(this).sortable('serialize');
	 		console.log(categoryordervars);
	 
	 		$.post("ajax_modifyresourcecategories.php", categoryordervars+'&change=order',
					function(data){
					console.log(data);
				},
			'json'
			);
	 	}
	});
	
	activate_resources_reorders();
}



function activate_resources_reorders() {
	// first, destroy all sortables so we start fresh. Otherwise we'll have duplicate triggers!
	$('.resources_set').each(function(){
		console.log('activating resource reodrer');
		if($(this).sortable('instance')!==undefined) {
			$(this).sortable('destroy');
		}
		
		var categoryid = $(this).attr('rel');
		$(this).sortable({
		 	items: "> div.row",
		 	handle: ".resource_title",
		 	cursor: 'move',
		 	update: function(event, ui) {
		 		var resourceordervars = $(this).sortable('serialize');
		 		console.log(resourceordervars);
		 		console.log(categoryid);
		 		$.post("ajax_modifyresources.php", resourceordervars+'&change=order&category='+categoryid,
						function(data){
						console.log(data);
					},
				'json'
				);
		 	}
		});
	});
}



function modifyresource(change,idr,value){
	var randomnumber=Math.floor(Math.random()*101)
	
	$.post("ajax_modifyresources.php", { idr: idr, value: value, change: change, rand: randomnumber },
		function(data){
  		
  		if(data.code==0) {
			console.log(data.message);
		} else {
			var classtoremove = '';
			var classtoadd = '';
			switch(change) {
				// now process classes etc. depending on what was done!
				 case 'publishstatus':
			    	
			    	if(value==1) {
			    		classtoremove = '';
						classtoadd = 'resource_publish';
			    	} else {
						classtoremove = 'resource_publish';
						classtoadd = '';
			    	}
			        
				break;
				
				case 'delete':
					$('#resource_'+idr).slideUp(300, function(){
						$(this).remove();
					}); // deleted, get rid of this row!
				break;
			}
			$('#resource_'+idr).removeClass(classtoremove).addClass(classtoadd);
		}
		

	}, 'json');
}



function modifycategory(change,idr,value){
	var randomnumber=Math.floor(Math.random()*101)
	modal_processing(true);
	$.post("ajax_modifyresourcecategories.php", { idr: idr, value: value, change: change, rand: randomnumber },
		function(data){
  		
  		if(data.code==0) {
			console.log('Error '+data.code+': '+data.message);
		} else {
			var classtoremove = '';
			var classtoadd = '';
			switch(change) {
				// now process classes etc. depending on what was done!
				case 'delete':
					$('#category_'+idr).slideUp(300, function(){
						$(this).remove();
					}); // deleted, get rid of this row!
				break;
				
				case 'add':
					$('#category_'+idr).slideUp(300, function(){
						$(this).remove();
					}); // deleted, get rid of this row!
				break;
				
				case 'title':
					$('#category_'+idr+' .category_title').html(value) // deleted, get rid of this row!
				break;
			}
			$('#category_'+idr).removeClass(classtoremove).addClass(classtoadd);
			modal_processing(false);
		}
		

	}, 'json');
}
