$(document).ready(function(){
	
	$("#loadhomes_form").keydown(function(event){
		//preventing the return key to accidentally submit the form before we've started entering all the information!
    	if(event.keyCode == 13) {
			event.preventDefault();
			return false;
    	}
	});
	
	$('.city_select:eq(0)').change(function(){
		updatesubarea(false, '.city_select:eq(0)', '.area_select:eq(0)');
	});
	
	window.sourcediv = $('.loadhomes_row:eq(0)');
	window.relcount = 0;	
	
	$('#loadhomes_row_add_button').click(function(){
		generate_loadhome_row();
		return false;
	});
	
	$('.desc_textarea').bind('input propertychange', function(){
		loadhomes_striptags($(this), "br");
		console.log('running');
	})
	
	$('#loadhomes_rows_container').on("click", '.set_map', function(){
		find_address_on_map($(this));
	});

});

function setmap() {
	
}

function generate_loadhome_row() {
	// get data of last city/area selected. 
	var cityval = $('.city_select:eq('+window.relcount+')').val();
	var areaval = $('.area_select:eq('+window.relcount+')').val();
	var soldval = $('.sold_select:eq('+window.relcount+')').val();
	var for_rentval = $('.for_rent_select:eq('+window.relcount+')').val();
	var remarksval = $('.remarks_select:eq('+window.relcount+')').val();
	
	
	window.relcount++;
	
	var html = '<div class="loadhomes_row" rel="'+window.relcount+'">'+window.sourcediv.html()+'</div>';

	$('#loadhomes_rows_container').append(html);

	$(html).sortable({
		connectWith: "#loadhomes_rows_container"
	}).disableSelection();

	
	// apply the last city/area selected in previous row!
	$('.city_select:eq('+window.relcount+')').val(cityval);
	updatesubarea(areaval, '.city_select:eq('+window.relcount+')', '.area_select:eq('+window.relcount+')');
	
	$('.sold_select:eq('+window.relcount+')').val(soldval);
	$('.for_rent_select:eq('+window.relcount+')').val(for_rentval);
	$('.remarks_select:eq('+window.relcount+')').val(remarksval);
	
	var currentcount = window.relcount;
	$('.city_select:eq('+currentcount+')').change(function(){
		updatesubarea(false, '.city_select:eq('+currentcount+')', '.area_select:eq('+currentcount+')');
	});
}

function loadhomes_striptags(obj, whitelist) {
	//var whitelist = "p"; // for more tags use the multiple selector, e.g. "p, img"
    var content = obj.val();
    $(this).val(strip_tags(content, '<br><br/>'));
}

function strip_tags(input, allowed) {


	var allowed =
  		(
	  		((allowed || '') + '')
			.toLowerCase()
			.match(/<[a-z][a-z0-9]*>/g) || []
		).join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)

		var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
			commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
		
		return input.replace(commentsAndPhpTags, '')
					.replace(tags, function($0, $1) {
						return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
				    });
}

function find_address_on_map(obj) { 

	var number = obj.siblings("input[name='number[]']").val();
	var street_dir = obj.siblings("input[name='street_dir[]']").val();
	var street = obj.siblings("input[name='street[]']").val();
	if(street_dir!='') {
		street = street_dir+' '+street;
	}
	var city = obj.parents('.loadhomes_row').find("select[name='city[]'] option:selected").text();
	var Location = $('#location').val();
	
	var url = number +"+"+ street +","+city+","+Location;

	url = url.replace(new RegExp(" ", 'g'), "+");

	console.log("https://maps.googleapis.com/maps/api/geocode/json?address="+url);

	if(number!='' && street!='') {
		
		$.getJSON( "https://maps.googleapis.com/maps/api/geocode/json?address="+url , function(data) {
			/*
			console.log(data.results[1].geometry.location.lat);
			console.log(data.results[1].geometry.location.lng);
			*/
			console.log(data);
			
			obj.siblings("input[name='lat[]']").val(data.results[0].geometry.location.lat);
			obj.siblings("input[name='long[]']").val(data.results[0].geometry.location.lng);
		});

	} else {
		console.log('no address');
		//not found code
	}
}
