$(document).ready(function(){
	list_pages(); // load default list!
});

$(document).on('click', '.change_page_parent', function(){
	$(this).change(function(){ // #1 attach function to an event - such as changing field.
		console.log('changing parent id')
		modifypage($(this).data('change'), $(this).attr('rel'), $(this).val() ); // #2 run the element in question that ran. 
	});	
});



function list_pages(parent = '') {
	let randomnumber=Math.floor(Math.random()*101);
	let $_GET = {};

	document.location.search.replace(/\??(?:([^=]+)=([^&]*)&?)/g, function () {
	    function decode(s) {
	        return decodeURIComponent(s.split("+").join(" "));
	    }
	    $_GET[decode(arguments[1])] = decode(arguments[2]);
	});

	let targetdiv, depth
	if (parent !== '') {
		 targetdiv = $('#pages_'+parent);
		 depth = targetdiv.data('depth');
	}
	else {
		 targetdiv = $('#pageslist');
		 depth = 0;
	}

	targetdiv.html(window.ajax_loader);

	$.get("ajax_listpages.php", { rand:randomnumber, parent:parent, depth:depth, brix_view:$_GET["brix_view"] },
        function(data){
			targetdiv.html(data);
			activate_collapse_control();
			activate_page_reorders();
			activate_image_trigger();
			$('[data-toggle="tooltip"]').tooltip(); // boostrap tooltip

			$('.page_publish_toggle').each(function(){
				$(this).change(function(){
					modifypage('publishstatus',$(this).attr('rel'),$(this).val());
				});
			});

			$('.each_list__delete').each(function(){
				$(this).click(function(){
					// Show the modal for deleting page
					let page_id = $(this).val()
					let page_title = $('#page_'+page_id+' .each_list__title').html()
					console.log('Deleting: ' + page_title)

					let page_delete_modal = $('#delete_page')
					page_delete_modal.find('#page_delete_btn').val(page_id)
					page_delete_modal.find('.modal-body').html('<p>Are you sure you want to delete <strong>'+page_title+'</strong>?<br />It is advised to set the page to HIDDEN instead</p>')
					page_delete_modal.modal('show')
				});
			});
        }
    );

	$('#page_delete_btn').on('click', function () {
		$('#delete_page').modal('hide')
		modal_processing(true);
		modifypage('delete', $(this).val(),1)
		modal_processing(false)
		setTimeout(function () {
			list_pages()
		}, 500);
	})
}





function activate_image_trigger() {
	$('.each_page__img_wrapper').each(function(){
		let page_hover_image_trigger = $(this).find('.page_hover_image_trigger');
		let page_hover_image_trigger_display = $(this).find('.page_hover_image_trigger_display');
	});
}


function activate_page_reorders() {
	// first, destroy all sortables so we start fresh. Otherwise we'll have duplicate triggers!
	$('.collapse_wrapper').each(function(){
		if($(this).sortable('instance')!==undefined) {
			$(this).sortable('destroy');
		}

		let parent_id = $(this).attr('rel');
		$(this).sortable({
		 	items: '> div', // or .each_page
		 	handle: ".each_list__title",
		 	cursor: 'move',
		 	update: function(event, ui) {
		 		let page_order_vars = $(this).sortable('serialize');
		 		
		 		$.get("ajax_modifypages.php", page_order_vars+'&change=order&parent='+parent_id,
					function(data){
					},
				'json'
				);
		 	}
		});
	});
}



function modifypage(change,idr,value) {
	let randomnumber=Math.floor(Math.random()*101)

	$.post("ajax_modifypages.php", { idr: idr, value: value, change: change, rand: randomnumber },
    function(data){
        if (parseInt(data.code) === 0) {
			console.log('Error '+data.code+': '+data.message);
		} 
		else {
			// now process classes etc. depending on what was done!
			let class_to_remove = '';
			let class_to_add = '';
			let page = $(".each_list#page_"+idr);
			let collapse = $('#collapse_'+idr);

			switch(change) {
				case 'publishstatus':
					$(page).toggleClass('hidden_list')
					$(collapse).toggleClass('hidden_list')

				break;

				case 'delete':
					// no action needed as it will run list_pages() function after
				break;
			}
			// $(page).removeClass(class_to_remove).addClass(class_to_add);
		}

	}, 'json');
}


function change_parent(change,idr,value) {
	var randomnumber=Math.floor(Math.random()*101)
	
	if(change!='' && idr!='' && idr>0) {
		$.post("ajax_modifypages.php", { idr: idr, value: value, change: change, rand: randomnumber },
			function(data){
				if(data.code==0) {
					console.log('Error '+data.code+': '+data.message);
					return false;
				} else {
					return true;
				}
			}, 'json'
		);
	}
}