/*
Filename: setup_contact.js
Location: admin/js

Method: JS
Output: JS

Description: JS file specific for settings (contact) screen

Author: Jeff Kee
*/
$(document).ready(function(){
	// load up the office location map for centering!


	loadmap();

	$('#resetmap').click(function(){
		reset_map();
		return false;
	});

	$('#findaddress').click(function(){
		find_address_on_map();
		return false;
	});
});


var latlng;
var geocoder;
var map;



function loadmap() {
	geocoder = new google.maps.Geocoder();

	var office_lat = $('input[name^="office_lat"]').val()*1;
	var office_long = $('input[name^="office_long"]').val()*1;

	if(office_lat!='' && office_long!='') {
		latlng = new google.maps.LatLng(office_lat, office_long);
	} else {
		latlng = new google.maps.LatLng(49.283637,-123.109562);
	}
	var myOptions = {
		zoom: 16,
		center: latlng,
		scrollwheel: false,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		streetViewControl:true
	};
	map = new google.maps.Map(document.getElementById('listingmap'), myOptions);
	google.maps.event.addListener(map, 'dragend', function() {get_coordinates(); } );
	google.maps.event.addListener(map, 'zoom_changed', function() {get_coordinates(); } );
}



function find_address_on_map() {
	var address1 = $('input[name^="address1"]').val();
	var address2 = $('input[name^="address2"]').val();

	var city = $('input[name^="office_city"]').val();
	var province = $('select[name^="province"] option:selected').html();
	var country = $('select[name^="country"] option:selected').html();
	console.log(province);
	console.log(country);

	var addressstring = address1+(city!='' ? ', '+city: '')+(province!='' ? ', '+province: '')+(country!='' ? ', '+country: '');

	console.log(addressstring);
	if(address1!='') {

		geocoder.geocode( { 'address': addressstring}, function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
				map.setCenter(results[0].geometry.location);
				map.setZoom(16);
				get_coordinates();
			} else {
				$('#map_address_notfound').modal('show');
			}
		});
	} else {
		$('#map_address_notfound').modal('show');
	}
}

function reset_map() {
	map.setCenter(latlng);
	map.setZoom(16);
	get_coordinates();
}

function get_coordinates() {
	var currentlocation = map.getCenter();
	console.log(currentlocation.lat());
	$('input[name^="office_lat"]').val(currentlocation.lat());
	$('input[name^="office_long"]').val(currentlocation.lng());
}
