$(document).ready(function(){

	// prevent "Enter" key from submitting form
	$(window).keydown(function(event){
		if(event.keyCode === 13) {
			event.preventDefault();
			return false;
		}
	});


	// Form to apply custom Bootstrap validation styles to
	const form = document.querySelector('.needs-validation')
	form.addEventListener('submit', event => {
		if (!form.checkValidity() || !validatePassword()) {
			// some input is not valid, do not submit form
			event.preventDefault()
			event.stopPropagation()
		}

		form.classList.add('was-validated')
	})

	// upon editing, remove was-validated
	const form_inputs = document.querySelectorAll(".form-control, .form-check-input")
	Array.from(form_inputs).forEach(form_input => {
		form_input.addEventListener('focus', function() {
			form.classList.remove('was-validated')
		})
	})


	// SWITCH TO ENABLE RESET PASSWORD
	let form_switch = document.getElementById('reset_pw_switch')
	let password_1 = document.getElementById('password1')
	let password_2 = document.getElementById('password2')
	if (form_switch) {
		form_switch.addEventListener('click', function () {
			// toggle d-none
			document.getElementById('password_reset_wrapper').classList.toggle('d-none')

			// on button click, toggle attributes "required" and "disabled"
			toggle_pw_input_attributes(password_1)
			toggle_pw_input_attributes(password_2)
		})
	}
});

function validatePassword(){
	let password_1 = document.getElementById('password1')
	let password_2 = document.getElementById('password2')

	if(password_1.value !== password_2.value) {
		password_2.setCustomValidity("Passwords Don't Match");
		return false;
	} else {
		password_2.setCustomValidity('');
		return true;
	}
}


function toggle_pw_input_attributes(input) {
	// toggle attribute "required"
	if (input.hasAttribute('required')) {
		input.removeAttribute('required')
	} else {
		input.setAttribute('required', '')
	}

	// toggle attribute "disabled"
	if (input.hasAttribute('disabled')) {
		input.removeAttribute('disabled')
	} else {
		input.setAttribute('disabled', '')
		input.value = ''
	}
}

/**
 * Get value of the selected option
 * @param element	<select> html
 * @return {*}		value, usually int
 */
function get_option_val(element) {
	return element.options[element.selectedIndex].value
}

/**
 * Fill description section in html
 * @param level		user access level to describe
 */
// function fill_role_desc(level) {
// 	let desc_html = document.getElementById('role_desc')
// 	let desc;
//
// 	console.log(level)
// 	switch (parseInt(level)){
// 		case 0:
// 		case 1:
// 			desc = 'Brixwork Login - DO NOT ASSIGN TO CLIENT'
// 			break
//
// 		case 2:
// 			desc = 'Site Admin - add more description in users_mod.source.js'
// 			break
//
// 		case 4:
// 			desc = 'Manager - add more description in users_mod.source.js'
// 			break
//
// 		case 6:
// 			desc = 'Agent - add more description in users_mod.source.js'
// 			break
//
// 		case 8:
// 			desc = 'Content Manager - add more description in users_mod.source.js'
// 			break
//
// 		default:
// 			console.log('default')
// 			desc = ''
// 	}
//
// 	desc_html.innerHTML = desc
// }