<?php
/*
Filename: loadhomes.php
Location: /admin

Method: Direct
Output: Direct

Description: Allow mass-adding of homes all in one go. 

Author: Jeff Kee
*/
include_once 'start.php';
validate_login(7);

$scriptinclude = 'loadhomes.js';

$destinationfolder = 'homes';
$destinationtable = 'homes';

include 'header.php';

// this part validates whether the user is logged in as a administrator or not
?>
<div class="container">
	<div class="row">
		<div class="col-md-6">
			<h1 class="text-center">Multi-Load Homes</h1>
		</div>
	</div>
</div>
<?php
	if($_POST['submit']) {
		// process the entries. 
		$totalhomes = count($_POST['area']); // get total count of all. 
		$sql = "UPDATE `homes` SET `ord` = `ord`+".$totalhomes." WHERE `source`=0";
		
		$mysqli->query($sql); // make room in the `ord` column for new homes!
		
		$startord = $totalhomes; // start ord will be the highest number... then work the way back.  	
		
		// set up common/default values
		$insert['create_date'] = $now;
		$insert['modify_date'] = $now;
		$insert['phpfile'] = $_SERVER['SCRIPT_NAME'];
		$insert['publish'] = 1;
		$insert['source'] = 0;
		$insert['ord'] = $startord;
		
		for ($i = 0; $i < $totalhomes; $i++) {
			$insert['ord'] = $insert['ord']-1;
			
			foreach($_POST as $key=>$array) {
				if(is_array($array) && $key!='mainimage') {// exclude mainimage but map all $_POST arrays into $insert by the key ID. 
					$insert[$key] = $array[$i]; // map all POST var arrays here. 
				}
			}
			
			// figure out street names
			list($insert['street'], $insert['street_type'], $street_dir) = separate_streetname($_POST['street'][$i]); // separate these guys!
			
			$insert['description'] = ($_POST['desc'][$i]!='' ? '<p>'.$_POST['desc'][$i].'</p>' : '&nbsp;');
			
			$insert['street_dir'] = ($_POST['street_dir'][$i]=='' && $street_dir!='' ? $street_dir : $_POST['street_dir'][$i]);
			
			foreach($insert as $name=>$value) {
				echo $name.' : '.$value.'<br />';
			}
			$insertid = form_to_table($destinationtable,$insert);
			
			if($insertid) {
				// create folders to hold media assets. 
				$successmessage .= '<strong>Success!</strong> Your listing data has been '.($_GET['mode']=='modify' ? 'updated' : 'created').' successfully for ID '.$insertid.'.';

				echo $_FILES['mainimage']['name'][$i].' is the filename';
				if($_FILES['mainimage']['name'][$i]!='') {
					echo attach_gallery_image($destinationfolder, $insertid, $_FILES['mainimage']['name'][$i], $_FILES['mainimage']['tmp_name'][$i]);
				}
			}
		}
	}
	?>
<form method="post" role="form" id="loadhomes_form" class="form-inline" enctype="multipart/form-data" action="<?php echo $_SERVER['PHP_SELF'];?>">
	<div class="container-fluid" id="loadhomes_rows_container">
				
		<div id="loadhomes_row_add_button_container">
			<a class="btn btn-primary btn-lg" id="loadhomes_row_add_button"><span class="glyphicon glyphicon-plus"></span></a>
		</div>
		
		<div class="loadhomes_row" rel="0">
			<div class="row">
				<div class="col-sm-2 form-group">
					<select name="city[]" class="form-control input-sm city_select bottom_5">
					 	<option value="">Select A City</option>
                        <?php
						$query = array('publish'=>1);
						$cities = get_areas($query);
						foreach($cities as $cityid) {
							$city = new city;
							$city->initialize($cidyid);
							echo '<option value="'.$city->id.'">'.$city->name.'</option>';
						}
						?>
					</select>
					<div class="clear"></div>
					<select name="area[]" class="form-control input-sm area_select bottom_5" data-toggle="tooltip" data-trigger="hover" data-placement="bottom" title="You need to select a city first, then this list will populate.">
					 	<option value="">Choose Area</option>
					</select>
				</div>
				
				<div class="col-sm-1 form-group">
					<select name="sold[]" class="form-control input-sm sold_select bottom_5">
						<option value="0">Active</option>
						<option value="1">Sold/Rented</option>
						<option value="2">Show on Both</option>
					</select>
					<select name="remarks[]" class="form-control  input-sm bottom_5 remarks_select">
                        <?php
						foreach($settings['remarks'] as $key=>$remark) {
							if($home->data['remarks']==$key){$selected = "selected";}
							else {$selected = '';}
							echo '<option value="'.$key.'" '.$selected.'>'.$remark.'</option>';
						}
						?>
					</select>
					<select name="for_rent[]" class="form-control  input-sm bottom_5 for_rent_select">
						<option value="0">For Sale</option>
                        <?php
						if($settings['rental_enabled']==1) {
						// show the rental option ONLY if rental is enabled, so that people cannot override it by tabbing their way onto field then htiting arrow up/down! Despite the .coverup div using Keywords it is possible to manipulate
						?>
						<option value="1"<?php if($home->data['for_rent']=='1'){echo ' selected';}?>>For Rent</option>
                            <?php
						}
						?>
					</select>
				</div>
				
				<div class="col-sm-4 form-group">
					<input name="unit[]" class="form-control input-sm" type="text" placeholder="Unit #" size="4" />&nbsp;
					<input name="number[]" class="form-control input-sm" type="text" placeholder="Num" size="5" />&nbsp;
					<input name="street_dir[]" class="form-control input-sm" type="text" placeholder="Dir" size="2" />&nbsp;
					<input name="street[]" class="form-control input-sm" type="text" placeholder="Street" size="16" />&nbsp;&nbsp;
					
					<input type="hidden" id="street_dir_position" name="street_dir_position" value="<?=($settings['street_dir_position_default']!='' ? $settings['street_dir_position_default'] : 0)?>" />
					
					<input name="bedroom[]" class="form-control input-sm" type="text" placeholder="Bdr" size="2" />&nbsp;
					<input name="bathroom[]" class="form-control input-sm" type="text" placeholder="Bth" size="2" />&nbsp;
					<input name="sqft[]" class="form-control input-sm" type="text" placeholder="Sqft" size="4" />&nbsp;
					<input name="lot[]" class="form-control input-sm" type="text" placeholder="Lot Size" size="6" />&nbsp;
<!-- 					<input name="frontage[]" class="form-control input-sm" type="text" placeholder="Frontage" size="6" />&nbsp; -->
<!-- 					<input name="depth[]" class="form-control input-sm" type="text" placeholder="Depth" size="6" /> -->
					
					<div class="clear bottom_5"></div>
					
					<select name="type[]" id="type" class="form-control input-sm type_select">
                        <?php
						if($settings['commercial_enabled']==1 && $home->data['is_comm'] == 1 ) {
							$commercial_yes = true;
						}	
						
						foreach($settings['type'] as $key=>$type) {
							if ($key < 50) {
								if ($commercial_yes) $disabled = 'disabled'; else $disabled = '';
								$rel = (in_array($key,$settings['building_type']) ? ' rel="building"' : ' rel="detached"');
								echo '<option value="'.$key.'" '.$rel.' '.$disabled.'>'.($type!='' ? $type : 'Choose Type').'</option>';
							}
						}
						

						foreach($settings['type_commercial'] as $key=>$type) {
							if ($key >= 50) {
								if ($commercial_yes) $disabled=''; else $disabled='disabled';
								$rel = (in_array($key,$settings['building_type']) ? ' rel="building"' : ' rel="detached"');
								echo '<option value="'.$key.'" '.$rel.' class="type_commercial" '.$disabled.''.($type!='' ? '>'.$type : ' disabled>-------').'</option>';
							}
						}
						?>
					</select>
					
					<input name="price[]" class="form-control input-sm" type="text" placeholder="Price" size="12" val="$" />&nbsp;
					<input name="mls[]" class="form-control input-sm" type="text" placeholder="MLS #" size="10" val="$" />&nbsp;
					<input name="maintenance[]" class="form-control input-sm" type="text" placeholder="Maintenance" size="8" val="$" />&nbsp;
					<input name="tax[]" class="form-control input-sm" type="text" placeholder="Taxes" size="8" val="$" />&nbsp;
					<input name="year[]" class="form-control input-sm" type="text" placeholder="Year" size="4" val="$" />&nbsp;
					
					<div class="clear bottom_5"></div>
					
					<input type="map_latlng" name="map_latlng" value="Set Map" class="btn btn-sm btn-warning set_map" />
					
					<input name="lat[]" class="form-control input-sm" type="text" placeholder="lat" size="16" />&nbsp;&nbsp;
					<input name="long[]" class="form-control input-sm" type="text" placeholder="long" size="16" />&nbsp;&nbsp;

				</div>
				<div class="col-sm-3 form-group">
					<textarea name="desc[]" class="form-control input-sm desc_textarea" placeholder="Description" rows="3"></textarea>
				</div>			
				
				<div class="col-sm-2 form-group">
					<input name="mainimage[]" class="mainimage_input" type="file" />
				</div>
			</div>
		</div>
				
	</div>
	
	<div class="conatiner">	
		<div class="row">
			<div class="col-md-3 col-md-push-9">	
				<input type="hidden" name="location" id="location" value="<?php echo($settings['location']!='' ? $settings['location'] : ($settings['province']!='' ? $settings['province'] : 'BC, Canada') ); ?>" />
				<input type="submit" name="submit" value="Enter All These" class="btn btn-lg btn-success" />
			</div>	
		</div>
	</div>
</form>


<?php
include 'footer.php';
?>