<?php
include 'start.php';
// caching prevention PHP script
global $settings;
$error = '';

if($_POST['submit'] || $_REQUEST['remotelogin']!='') {
	// REMOTE LOGIN: accessing site backend from "clients.brixwork.com"
	$remotelogin = false;
	$_POST['dur'] = ($_POST['dur']!='' ? $_POST['dur'] : '3600');

	if ($_REQUEST['remotelogin'] != '') {
        // REMOTE LOGIN OVERRIDE
		// remote login was sent. Let's see if this is successful?
		$remotelogin_hash = api_export_decrypt($mysqli->real_escape_string($_REQUEST['remotelogin']));
		$allowed_timelapse = 10; // keys expire after cetain time.. 10 seconds?
		list($cpanel_username, $remotelogintimestamp) = explode(',', $remotelogin_hash);

		if ($settings['cpanel_username']==$cpanel_username && ($local-$remotelogintimestamp)<$allowed_timelapse) {
			$remotelogin = true;
			$_POST['username'] = 'brixwork';// override to brixwork.
			$_POST['password'] = ''; // remote login, so no password needed.
			$_POST['dur'] = '1209600';
		} else {
			$error = '<p><b>Remote Login Failed!</b>  Wrong key, or timed out. Please generate a new link.</p>';
		}
	}

    // PROCESSING NORMAL LOGIN.
    // PASSWORD & USERNAME TYPED IN BY USER.
	$password = md5($mysqli->real_escape_string($_POST['password']));
	$username = $mysqli->real_escape_string($_POST['username']);

	$user_match = "SELECT * FROM `users` WHERE `username`='".$username."' OR `email`='".$username."'";
	$result = $mysqli->query($user_match);

	if ($result->num_rows != 1) {
		$error = '<p><b>No Such User!</b> Please check your username or email address attached to your account.</p>';
	} else {
        // FOR SOME REASON, THE PROCESS HERE IS VERY SLOW.
        // USERNAME EXISTS ...
		$user_data = $result->fetch_assoc();
        $user = new user($user_data, $mysqli, $settings);

        // verify input password
		if ($user->matchPassword($password) || $remotelogin === true) {
            $_SESSION['login_success_message'] = '<p><b>Login Success!</b> Welcome '.$user->getFullName() ?: $user->getEmail().'</p>';

            // set cookie duration
            $duration       = intval($mysqli->real_escape_string($_POST['dur']));
            $expiry         = date($mysql_time['full'], $local + $duration);
            $cookie_expiry  = $local + $duration;

            // Generating Hash should be BROWSER specific - i.e. same login from different browser should create new HASH.
            $hash = $_COOKIE['hash'] ?: md5($user->getID().$expiry.rand(0, 99));

            // LOOK FOR THE ID AND HASH OF THE LOGGED-IN USER TO SET OR UPDATE HASH.
            $status = update_login_table(array(
                'id' => $user->getID(),
                'hash' => $hash,
                'duration' => $duration,
                'expiry' => $expiry
            ));

            if ($status['code'] == 1) {
                // cookie for current browser.
                setcookie('hash', $hash, $cookie_expiry, '/');
                setcookie('userid', $user->getID(), $cookie_expiry, '/');
                setcookie('username', ($user->getUsername() ?: $user->getEmail()), $cookie_expiry, '/' ); // try to retire this.

                $_SESSION['logged'] = "valid";

                // get url for redirect ... the $_GET['req'] variable is created from validate_login() function.
                $url = ($_GET['req'] != '') ? $settings['sitepath'].str_replace('/admin/', 'admin/', $_GET['req']) : $settings['sitepath'].'admin/index.php';
                header('Location:'.$url);
                exit();

                /** these cookies were being set before `user` class was created. Don't think it's necessary anymore?
                 * setcookie('loginid',$loginid,$local+1209600,'/');
                 * setcookie('duration',$duration,$local+1209600,'/');
                 */
            } else {
                $error = '<p><b>Error Validating User Login</b> Check login info or contact Brixwork support with this message: '.$status['message'].'</p>';
            }

		} else {
			$error = '<p><b>Invalid Password!</b> Please try again. If you forgot your password, you can <a href="'.$settings['sitepath'].'admin/lost_password.php">reset it via email</a>.</p>';
		}
	}
} // end of the part that processes log in and then takes back to index.php

include 'header.php';

if ($_SESSION['reset-success']) {
    echo "<div id='login_form_wrapper' class='row container pt-3'>";
    echo brixwork_alert($_SESSION['reset-success']);
    echo "</div>";
}

if ($error) {
    echo "<div id='login_form_wrapper' class='row container pt-3'>";
    echo brixwork_alert($error, 'error');
    echo "</div>";
}

// start the login form
?>
<div id="login_form_wrapper" class="row container">
	<div class="col-md-4 col-sm-6">
        <form class="form-horizontal" role="form" method="post" name="login" id="loginform" enctype="multipart/form-data" action="<?= $PHP_SELF;?>" autocomplete="off">
            <h1 id="login_form_title">Brixwork Admin Login</h1>
            <div class="form-group" id="login_username_container">
                <label for="username" class="control-label">
                    E-Mail (Username)
                    <input type="text" name="username" autocapitalize="off" value="<?php if($_COOKIE['username']!='') {echo $_COOKIE['username'];} ?>" class="form-control input-lg" required autofocus>
                </label>
            </div>

            <div class="form-group" id="login_password_container">
                <label for="password" class="control-label">
                   Your Password
                    <input type="password" name="password" class="form-control input-lg">
                </label>
                <small><a href="<?=$settings['sitepath']?>admin/lost_password.php">Forgot your password?</a></small>
            </div>


            <div id="login_duration_radio">
                <label for="dur" class="control-label">Stay Logged In</label>
                <div id="login_radio_wrapper">
                    <label for="dur_300">
                        <input name="dur" type="radio" value="300" id="dur_300" />
                        Short (5 minutes)
                        <span class="checkmark"></span>
                    </label>

                    <label for="dur_3600">
                        <input name="dur" type="radio" value="3600" id="dur_3600" <?=($_SERVER['REMOTE_ADDR']!='174.6.108.205' || $_COOKIE['username']=='brixwork' ? 'checked="checked"' : '')?> />
                        Medium (1 hour)
                        <span class="checkmark"></span>
                    </label>

                    <label for="dur_1209600">
                        <input name="dur" type="radio" value="1209600" id="dur_1209600" <?=($_SERVER['REMOTE_ADDR']=='174.6.108.205' || $_COOKIE['username']=='brixwork' ? 'checked="checked"' : '')?> />
                        Perpetual (2 weeks)
                        <span class="checkmark"></span>
                    </label>
                </div>
            </div>

            <div id="submit_login" class="form-group">
                <input type="submit" name="submit" id="submit" value="Log Into Admin" class="btn btn-admin text-center btn-lg btn-block">
                <small><a href="https://www.brixwork.com/realtors/terms-and-conditions/" target="_blank">Terms &amp; Conditions</a></small>
            </div>
        </form>
    </div>
</div>

<?php
// clear form data upon page refresh ... cus this message only need to show up once.
if ($_SERVER['REQUEST_METHOD'] == 'GET' && isset($_SESSION['reset-success'])) {
    unset($_SESSION['reset-success']);
}

$footer_position = "center";
include 'footer.php';