<?php
include 'start.php';
global $settings, $local;

// first process the GET vars
$hash = md5($_GET['hash'].$_GET['exp']); // hash to reference by

$scriptinclude = 'lost_password_reset.js';
include 'header.php';

/**
 * $_REQUEST['exp'] = expiry time, 24 hours were added to the time when the email was sent.
 * $local           = current time of the opening the email.
 */
if ((int)$_REQUEST['exp'] < $local):
    // link expired ... do not run any reset process.
    echo "<div id='login_form_wrapper' class='row container'>";
    echo brixwork_alert("<p><b>Expired Link!</b> This password reset link is expired. Please send another reset request through \"Forgot Password\" link.</p>", 'error');
    echo "</div>";
else:
    $error = '';
    if ($_POST && $_POST['idr']!='') :

        // password is already verified in the client side form ... but just verify again
        $pass_verify = $_POST['password1'] == $_POST['password2'];

        if ($pass_verify) {
            $_POST['password'] = md5($_POST['password1']); // process password
            $_POST['hash'] = ''; // blank out hash so that no more resets can be triggered for this user anymore.

            $update_id = form_to_table('users', $_POST, $_POST['idr']);

            if (is_numeric($update_id)) {
                $_SESSION['reset-success'] = "<p><b>Success!</b> Password reset successful. Login again.</p>";

                // REDIRECT TO LOGIN PAGE.
                header('Location:'.$settings['sitepath'].'admin/login.php');
                exit();
            } else {
                $error = "<p><b>Error!</b> Please send support ticket to info@brixwork.com with this id: $update_id</p>";
            }

        } else {
            $error = "<p><b>Error!</b> There was error trying to process password reset. Make sure to enter same password twice.</p>";
        }
    endif;

    // link not expired ... check for user .
    $user_res = $mysqli->query("SELECT `id` FROM `users` WHERE `hash`='".$hash."'");
    if ($user_res->num_rows == 0) :
        // No user Match
        echo "<div id='login_form_wrapper' class='row container pt-3'>";
        echo brixwork_alert("<p><b>Invalid URL</b> The URL is not valid anymore. Please send another reset request through \"Forgot Password\" link.</p>", 'error');
        echo "</div>";
    else:
        // found the users... proceed!
        $user_array = $user_res->fetch_assoc();

        if ($error) {
            echo "<div id='login_form_wrapper' class='row container pt-3'>";
            echo    brixwork_alert($error, 'error');
            echo "</div>";
        }
        ?>

        <div id="login_form_wrapper" class="row container">
            <div class="col-md-4 col-sm-6">

                <form class="form-horizontal needs-validation" role="form" method="post" name="login" id="password_form" enctype="multipart/form-data" action="<?=$PHP_SELF?>" autocomplete="off" novalidate>
                    <h1 id="login_form_title">Reset Your Password</h1>

                    <div class="mb-4">
                        <label for="password1" class="control-label orange">New Password</label>
                        <div class="mb-2">
                            <input type="password" name="password1" id="password1" class="form-control" placeholder="Min 6 Characters" minlength="6">
                            <div class="invalid-feedback">
                                Password must be at least 6 characters long.
                            </div>
                        </div>
                        <input type="password" name="password2" id="password2" class="form-control"  placeholder="Enter Again" aria-label="Enter Password Again">
                        <div class="invalid-feedback">
                            Please enter a matching password.
                        </div>
                    </div>

                    <div class="d-flex justify-content-end">
                        <div class="pt-2">
                            <input type="hidden" name="idr" value="<?=$user_array['id']?>" />
                            <input type="submit" name="submit" id="submit" value="Change Password" class="btn btn-admin px-4">
                        </div>
                    </div>
                </form>

            </div>
        </div>
    <?php
    endif; // endif if ($user_res->num_rows == 0) :

endif;


//$fixpassword = "$('#password2').val('').focus();";
//$resetpassword = "$('#password1, #password2').val(''); $('#password1').focus();";
//
//modal_html('Password Mismatch', 'The passwords you entered do not match. Please double check your entries and try again.', 'password_mismatch', $labelyes='Got It!', $labelno=false, $fixpassword);
//modal_html('Password Too Short', 'We require at least 6 characters for your password. If it\'s too short, it\'s too easy to guess and break in.', 'password_tooshort', $labelyes='Got It!', $labelno=false, $resetpassword);


$footer_position = "center";
include 'footer.php';