<?php
/*
Filename: attach.php
DEPRECATED: NOT USED IN 2023 V5 BACKEND

Method: Direct
Output: Direct

Description: Master file that handles all the file uploads for main images, PDFs, youtube attachment etc. Not to be confused with the Gallery upload module!

Author: Jeff Kee
*/

include 'start.php';
if($_REQUEST['folder']=='') {
	// if table is not set, default to homes.
	$destinationtable = 'homes';
	$destinationfolder = 'homes';
} else {
	$destinationtable = $_REQUEST['folder'];
	$destinationfolder = $_REQUEST['folder'];
}

if($destinationtable=='pages') {
	$page = new page;
	$page->initialize($_REQUEST['idr']);
	$subject = $page->title;
	$object = $page;
	$returnurl = 'pages.php';
} else if($destinationtable=='resources') {
	$resource = new resource;
	$resource->initialize($_REQUEST['idr']);
	$subject = $resource->title;
	$object = $resource;
	$returnurl = 'links.php';
} else if($destinationtable=='agents') {
	$agent = new agent;
	$agent->initialize($_REQUEST['idr']);
	$subject = $agent->displayname;
	$object = $agent;
	$returnurl = 'agents.php';
} else if($destinationtable=='buildings') {
	$building = new building;
	$building->initialize($_REQUEST['idr']);
	$subject = $building->name;
	$object = $building;
	$returnurl = 'buildings.php';
} else if($destinationtable=='homes') {
	$home = new home;
	$home->initialize($_REQUEST['idr']);
	$subject = $home->fulladdress;
	$object = $home;
	$returnurl = 'homes.php';
} else {
	die('invalid object type!');
}

if(!$object) { // invalid object, bounce them out!
	header('Location: '.$settings['sitepath'].'admin/');
}

if(is_object($page)) {
    // in case of pages only the # of attached images can be set separately.
    if(is_array($page->mainwidth) && $page->mainheight) {
		$minnum = min(count($page->mainwidth), count($page->mainheight));
    } else {
        $minnum = 1;
    }

    $mainimagenum = ($minnum>0 ? $minnum : 1);
} else {
    $mainimagenum = ($settings[$destinationtable.'_mainphotonum']!='' ? $settings[$destinationtable.'_mainphotonum'] : 1);
}


$scriptinsert = "<script type=\"text/javascript\">";

// define the variables used throughout the JS UI modules.
$scriptinsert .= "

window.destinationfolder = '".$destinationfolder."';
window.idr = '".$_GET['idr']."';

window.img_original_height = new Array();
window.img_original_width = new Array();

";

while($count<$mainimagenum) {
    // when count is 0, the suffix for the ids and classes are blank, so that everything just ends wihtout numbers. We only add the numbers once we get to 1.
    $suffix = ($count==0 ? '' : $count); // first div ID has no suffix, the subsequent ones do!

    $scriptinsert.="
			 
                        $(document).ready(function(){
                            
                            
                            $('.alt_tags$suffix').bind('change keyup input', function(){
                                $('#update_alt_tags$suffix').removeClass('disabled').addClass('btn-primary');	
                            })  
                            
                            $('.alt_tags$suffix').click(function(){
                                target = $(this).data('input');
                                var val = $(target).val();
                                var key = $(this).data('key');
                                update_alt_tags(val, key); 
//                                $(this).addClass('disabled').removeClass('btn-primary').blur();
                            });
                            
                        });
                        ";
    $count++;
}
$scriptinsert.='</script>';
// determine number of main images.






$scriptinclude = 'mainimage.js';

include 'header.php';



?>

	<div class="container">
		<div class="row bottom_40">
			<div class="col-md-12">
				<h1 class="text-center">Manage Main Images for "<?php echo $subject; ?>"</h1>
				<a href="<?=$returnurl?>" class="btn btn-default btn-lg"><span class="glyphicon glyphicon-arrow-left"></span>&nbsp;&nbsp;&nbsp;Back to The List</a>
			</div>
		</div>
		<div class="row">
			<?php

            if(is_object($page)) {
                // in case of pages only the # of attached images can be set separately.
                $alt_tags_sql = 'SELECT alt_tags FROM '.$destinationtable.' WHERE id = '.$_GET['idr'];
                $alt_tags_result = $mysqli->query($alt_tags_sql);
                $alt_tags = null;
                if ($array = $alt_tags_result->fetch_assoc()) {
                    $alt_tags = unserialize($array['alt_tags']);
                }
            } else {
                $mainimagenum = ($settings[$destinationtable.'_mainphotonum']!='' ? $settings[$destinationtable.'_mainphotonum'] : 1);
            }

			// Loop through the number of main images we need. This is determinedin $mainimagenum way up there before header.php is included. Most sites have 1 main image per item - some may have more.
			$count = 0;
			check_s3_attachments($destinationtable, $object->id, 'mainphoto', true);

			while($count<$mainimagenum) {
				// when count is 0, the suffix for the ids and classes are blank, so that everything just ends wihtout numbers. We only add the numbers once we get to 1.
				$suffix = ($count==0 ? '' : $count);

				if(is_object($page)) {
					$mainimagewidth = (is_array($page->mainwidth) ? $page->mainwidth[$count] : $page->mainwidth );//$page->data['mainwidth'];
					$mainimageheight = (is_array($page->mainheight) ? $page->mainheight[$count] : $page->mainheight );//$page->data['mainheight'];
					// if the sizes are NOT set by the page, default to settings.
					// if we are on image #2 or #3, and the sizes are not set on the page level, default to $settings, or even the first count of the settings.
					if($mainimagewidth=='' || $mainimagewidth===false || $mainimagewidth==0 || !isset($mainimagewidth)) {
						$mainimagewidth = ($settings[$destinationtable.'_mainphotowidth'][$count]!='' ? $settings[$destinationtable.'_mainphotowidth'][$count] : $settings[$destinationtable.'_mainphotowidth'][0]);
					}
					// repeat for height.
					if($mainimageheight=='' || $mainimageheight===false || $mainimageheight==0 || !isset($mainimageheight)) {
						$mainimageheight = ($settings[$destinationtable.'_mainphotoheight'][$count]!='' ? $settings[$destinationtable.'_mainphotoheight'][$count] : $settings[$destinationtable.'_mainphotoheight'][0]);
					}
				} else {
					$mainimagewidth = $settings[$destinationtable.'_mainphotowidth'][$count];
					$mainimageheight = $settings[$destinationtable.'_mainphotoheight'][$count];
				}
				$mainimagewidthheightdisplay = $mainimagewidth.' x '.$mainimageheight;
				$filename = ($settings[$destinationtable.'_mainphotofilename'][$count]!='' ? $settings[$destinationtable.'_mainphotofilename'][$count] : 'main'.$suffix.'.jpg');

				$ext = get_image_extension($filename); // whether it's jpeg, jpg, it truncates here to 3 letter format.
                // override to jpeg/jpg?
				$mimetype = get_image_mimetype($ext);
				$mainimagespath[$count] = $object->get_main_images_path($count, false, false);
                $destinationtable = $destinationtable;

                $labels_sql = 'SELECT alt_tags FROM '.$destinationtable.' WHERE id = '.$_GET['idr'];
                $labels_result = $mysqli->query($labels_sql);
                $alt_tags = null;
                if ($array = $labels_result->fetch_assoc()) {
                    $alt_tags = unserialize($array['alt_tags']);
                }

				?>
				<div class="row">
					<div class="col-sm-12">
						<h4><?=$settings[$destinationtable.'_mainphotoname'][$count]?> (<?=$mainimagewidthheightdisplay?>)</h4>
					</div>

                    <?php



                    ?>
                    <div class="col-xs-8">
                        <input class="bottom_10 form-control trim_input alt_tags<?=$suffix?>" name="alt_tags<?=$suffix?>"  id="alt_tags<?=$suffix?>" data-key="<?=$count?>" placeholder="Describe the image here" value="<?=(is_array($alt_tags) && isset($alt_tags[$count]) && is_string($alt_tags[$count]) && !is_null($alt_tags[$count]) ? htmlentities($alt_tags[$count]) : '')?>" />
                    </div>
                    <div class="col-xs-4">
                        <button align="left" type="button" class="btn btn-inline-block update_label disabled alt_tags<?=$suffix?>" data-input="#alt_tags<?=$suffix?>" data-key="<?=$count?>" id="update_alt_tags<?=$suffix?>" value="Update Alt Tags">Update Tags</button>
                    </div>

                    <div class="clearfix"></div>
					<div class="col-sm-4 col-xs-12 bottom_20">
						<input type="File" name="mainimageinput<?=$suffix?>" class="mainimageinput" id="mainimageinput<?=$suffix?>" data-filename="<?=$filename?>" data-width="<?=$mainimagewidth?>" data-height="<?=$mainimageheight?>" data-ext="<?=$ext?>" data-mimetype="<?=$mimetype?>" rel="<?=$suffix?>" accept="image/*" />
					</div>

					<div class="col-sm-8 col-xs-12 bottom_20">
						<div class="progress">
							<div id="mainimageprogressbar<?=$suffix?>" class="progress-bar mainimageprogressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" role="progressbar" style="width:0%;"></div>
						</div>
						<div class="row">
							<div class="col-md-12 uploadifivequeue mainimagequeue" id="mainimagequeue<?=$suffix?>"></div>
                            <?php if($_COOKIE['username']=='brixwork') {?><a href="#" class="btn btn-warning"onclick="$('#mainimageinput<?php echo $suffix;?>').uploadifive('debug');">Debug</a><?php } ?>
						</div>
					</div>
					<div class="clearfix"></div>
					<div class="col-sm-2 col-xs-6 bottom_40">
						<button align="left" type="button" class="btn btn-warning btn-block maincrop" name="maincrop<?=$suffix?>" id="maincrop<?=$suffix?>" rel="<?=$suffix?>">Crop To Selection</button>					</div>
					<div class="col-sm-2 col-xs-6 bottom_40">
						<button align="left" type="button" class="btn btn-danger btn-block removemainimage" name="removemainimage<?=$suffix?>" id="removemainimage<?=$suffix?>" rel="<?=$suffix?>" value="Remove Image"><span class="glyphicon glyphicon-minus"></span>&nbsp;&nbsp;&nbsp;Remove File</button>
					</div>
					<div class="col-sm-8 col-xs-12">
						<input type="hidden" size="4" id="main<?=$suffix?>x" />
						<input type="hidden" size="4" id="main<?=$suffix?>y" />
						<input type="hidden" size="4" id="mainx<?=$suffix?>2" />
						<input type="hidden" size="4" id="mainy<?=$suffix?>2" />
						<input type="hidden" size="4" id="main<?=$suffix?>w" />
						<input type="hidden" size="4" id="main<?=$suffix?>h" />
					</div>

					<div id="current_main_image<?= $suffix;?>" class="col-xs-12 current_main_image <?=($mainimagespath[$count] && $ext=='png' ? 'png_bg' : '')?>">
                        <?php
						if($mainimagespath[$count]) {
							?>
							<img src="<?=$mainimagespath[$count]?>" class="img-responsive" />
                            <?php
						} else {
							?>
							No Image Yet
                            <?php
						}
						?>
					</div>
				</div>
				<hr class="bottom_40" />
                <?php
				$count++;
			}
			?>

		</div>
	</div>

<?php
modal_html('Filetype Not Accepted!', '<p>We need a JPG file here.</p>', 'filetype_jpg', 'Got it!', false, false);
modal_html('Filetype Not Accepted!', '<p>We need a PNG file here.</p>', 'filetype_png', 'Got it!', false, false);

include 'footer.php';
?>