<?php
/**
Filename: pageurls.php
Location: /admin

Method: Direct
Output: Direct

Description: Lists all pages with custom url to allow multiple editing from a single page.
 */
include 'start.php';
$scriptinclude = 'pageurls.js';

$destinationfolder = 'pages';
$destinationtable = 'pages';

include 'header.php';
include 'includes/header_html.php';
?>
<div id="" class="brixwork_admin_container title">
    <h1 id="admin_page__title">Custom Url & SEO</h1>

	<div class="row">
        <?php
			$toppages = get_brixwork_pages(false, -1, false);
			echo urls_display($toppages);
		?>
	</div>
</div>
<?php
include 'footer.php';



function urls_display ($array, $lv = 0, $indent = 0) {
    switch ($lv) {
        case 1: $bg = '#eee';
            break;

        case 2: $bg = '#ddd';
            break;

        case 3: $bg = '#ccc';
            break;

        case 4: $bg = '#bbb';
            break;

        case 5: $bg = '#aaa';
            break;

        default: $bg = '';
            break;
    }

    $return = ''; // start blank return for this instance.
    foreach ($array as $id=>$page) {
        if ($page['embedded'] != 1) {

            $rowclass = ($page['publish']==1 ? '' : 'opacity70');

            $the_page = new page; $the_page->initialize($page['id']);

            $return .= '<div class="'.$rowclass.' py-4 " style="background: '.$bg.'; padding-left: '.$indent.'px; box-sizing: border-box">
						
							<div class="row pb-1">		
							    <div class="col-sm-1 m-auto">
								    <h4 class="m-0">ID: '.$page['id'].'</h4>
                                </div>			
                                	
								<div class="col-sm-3">
									<textarea name="title" id="title_'.$page['id'].'" rel="'.$page['id'].'" data-change="title" class="form-control input-sm trim_input change_page_attr" rows="1" placeholder="page title" >'.$page['title'].'</textarea>
								</div>';

            $return .= '
								<div class="col-sm-2">
									<input type="text" name="menu_title" id="menu_title_'.$page['id'].'" rel="'.$page['id'].'" data-change="menu_title" class="form-control input-sm trim_input change_page_attr" value="'.$page['menu_title'].'" placeholder="menu title" />
								</div>';

            $return .= '
								<div class="col-sm-6" xmlns="http://www.w3.org/1999/html">
									<textarea name="custom_pageurl" id="custom_pageurl_' .$page['id'].'" rel="'.$page['id'].'" data-change="custom_pageurl" class="form-control input-sm trim_input change_page_attr" rows="1" placeholder="custom url">'.$page['custom_pageurl'].'</textarea>
								</div>
						    </div>';

            $return .= '
							<div class="row py-1">				
								<div class="col-sm-3 position-relative">
									<textarea name="metatitle" id="metatitle_'.$page['id'].'" rel="'.$page['id'].'" data-change="metatitle" class="form-control input-sm trim_input change_page_attr" rows="2" placeholder="meta title">'.($the_page->data['metatitle'] != '' ? $the_page->data['metatitle'] : '').'</textarea>
									<div style="display: " id="metatitle_count_'.$page['id'].'" class="metatitle_count" data-maxchar="55"></div>
								</div>
								<div class="col-sm-6 position-relative">
									<textarea name="description" id="description_'.$page['id'].'" rel="'.$page['id'].'" data-change="description" class="form-control input-sm trim_input change_page_attr" rows="2" placeholder="meta desc" >'.($the_page->data['description'] != '' ? $the_page->data['description'] : '').'</textarea>
									<div style="display: " id="metadesc_count_'.$page['id'].'" class="metadesc_count" data-maxchar="157"></div>									
								</div>
								<div class="col-sm-3">
									<textarea name="slug" id="slug_'.$page['id'].'" rel="'.$page['id'].'" data-change="slug" class="form-control input-sm trim_input change_page_attr" rows="2" placeholder="url slug">'.($the_page->data['slug'] != '' ? $the_page->data['slug'] : '').'</textarea>
								</div>							
							</div>
						
						</div>
						';
        }
        if ($page['children'] != '') $return .= urls_display ($page['children'], ($lv+1), ($indent+20));
    }
    return $return;
}