<?php
/**
 * Filename: users.php
 * Description: Display users - which user to display is determined by the AJAX. ajax_listusers.php
 *
 * Accessibility: all users have access.
 */
include 'start.php';

// TODO: minify to users.js
$scriptinclude_footer = 'users.source.js';
include 'header.php';
// header_html is separated from header.php on purpose.
include 'includes/header_html.php';

$visibility = login_level_check(USER_LOGIN_ADMIN) ? '' : 'display: none'; // 2 = site admin
?>
    <div id="users_gallery_intro" class="brixwork_admin_container title">
        <h1 id="admin_page__title">Admin Users List</h1>
        <p>These users are not team members displayed on your website.</p>

        <div id="users_function_wrapper" style="<?=$visibility?>">
            <a class="btn btn-admin light_blue" href="users_mod.php?mode=new">Create New User</a>
        </div>


        <div class="brixwork_inner_spacing" id="userslist">
            <?php // AJAX FILLS USERS HERE?>
        </div>
    </div>
    
    
<?php
// Delete Modal
$delete_user_modal__body   = 'Auto Filled';
$delete_user_modal__footer = '
    <button type="button" class="btn btn-admin" data-bs-dismiss="modal">Keep User</button>
    <button type="button" class="btn btn-admin light_blue" id="delete_user_btn">Delete User</button>';
$delete_user_modal__options = array(
    'header_content' => 'Delete a Member',
    'body_content' => $delete_user_modal__body,
    'footer_content' => $delete_user_modal__footer,
    'id' => 'user_remove'
);
brixwork_modal_html($delete_user_modal__options);

include 'footer.php';