<?
include '../start.php';

// caching mechanism is needed. AJAX loops are too slow.
$getfeed = false; // default to false.
$instagram_cache_file = '../cache/instagram_feed.txt';
$expirytime = 60*60; // 60 mins.. 1hr.
if (file_exists($instagram_cache_file) && (time() - filemtime($instagram_cache_file)) < $expirytime) {
		// feed from the cache file.

		$image_data = json_decode(file_get_contents($instagram_cache_file), TRUE);
		$json_array['code'] = 1;
		$json_array['data'] = $image_data;
		$json_array['message'] = count($image_data).' feed images returned!';
} else if($settings['instagram_userid']!='' && $settings['instagram_access_token']!='') {

	// if access stuff is set
	// how many photos? 
	$count = ($_REQUEST['count'] != '' ? $_REQUEST['count'] : 3); // default is 3
//
//	if ($settings['instagram_search_tag'] != '') {
//		//going off specific hashtag for the photos
//		$URL = 'https://graph.instagram.com/v1/tags/'.$settings['instagram_search_tag'].'/media/recent/?access_token='.$settings['instagram_access_token'].'&count='.$count;
//	}

	//otherwise just grabbing recent ones

	$feed_url = 'https://graph.instagram.com/'.$settings['instagram_userid'].'/media?fields=id&access_token=' . $settings['instagram_access_token']."&count=".$count;
	// echo $feed_url.PHP_EOL;
	$itemcount = 0;
	$items = array();
	$loops = 0;
	$maxloops = 10; // hard limit!
	while ($itemcount < ($count+3)) {  // in case some of the results are garbage.
		if($loops>=$maxloops) {
			break;
		}
		$feed = curl_get_file_contents($feed_url, 'GET', '', 3000);

		$result = json_decode($feed, TRUE);
		$feed_url = $result['paging']['next']; // get next page and keep looping.

		if(isset($result['error'])) {
			$feederror = true;
			$json_array['code'] = 0;
			$json_array['message'] = $result['error']['message'];
			$itemcount = $count; // stop loop.
			break;
		} else if (!empty($result['data'])) {
			foreach ($result['data'] as $feeditem) {
				$items[] = $feeditem['id']; // keep adding IDs to it.
				$itemcount++;
			}
		}
		$loops++;
	}
	if(count($items)>0) {
		$image_data = array();
		foreach ($items as $item) {
			$item_url = 'https://graph.instagram.com/' . $item . '?fields=id,media_type,permalink,caption,media_url,thumbnail_url,username,timestamp&access_token=' . $settings['instagram_access_token'];
			$item_array = json_decode(curl_get_file_contents($item_url, 'GET', '', 3000), TRUE);
			// place into image_data to match the javascript nodes.
			/*
			 * {
  "id": "17895695668004550",
  "media_type": "IMAGE",
  "media_url": "https://fb-s-b-a.akamaihd.net/...",
  "username": "jayposiris"
  "timestamp": "2017-08-31T18:10:00+0000"
}
			 * */
			if($item_array['id']!='' && count($image_data)<$count) {
				// every once in a while the feed chokes. i.e. Captions that start with an Emoji, it skips all data.
				$image_array = array(
					'id' => $item_array['id'],
					'media_type' => $item_array['media_type'],
					'caption' => $item_array['caption'],
					'link' => $item_array['permalink'],
					'user' => $item_array['username'],
					'imgurl' => ($item_array['media_type']=='VIDEO' ? $item_array['thumbnail_url'] : $item_array['media_url']),
					'likes' => array(
						'count'=>'0' // no longer fed by IG, so default to 0. ONly keeping array for backwards compat.
					),
					'comments' => array(
						'count'=>'0' // no longer fed by IG, so default to 0. ONly keeping array for backwards compat.
					),
					'images' => array(
						'standard_resolution'=>array(
							'url'=>($item_array['media_type']=='VIDEO' ? $item_array['thumbnail_url'] : $item_array['media_url']), // no longer fed by IG, so default to 0. ONly keeping array for backwards compat.
							'height'=>'0'
						)
					)
				);

				/*
				 * Javascript in common.source.js converts these to vars like this:
				 *
				 *
				 * var imgurl = image.imgurl;
					var imghref = image.link;
					var imgcaption = image.caption;
					var username = image.username;
					var imgcaption = imgcaption!== null ? imgcaption : 'photo by '+username;
		imgcaption = imgcaption.replace(/<(?:.|\n)*?>/gm, '');
				 * */
				$image_data[] = $image_array;
			}
		}

		$json_array['code'] = 1;
		$json_array['data'] = $image_data;
		$json_array['message'] = count($image_data).' feed images returned!';

		$cachefile = fopen($instagram_cache_file, "w");
		fwrite($cachefile, json_encode($image_data));
		fclose($cachefile);
	} else if($feederror) {
		// leave error message from above as it is..
	} else {
		$json_array['code'] = 0;
		$json_array['message'] = 'User is valid, but could not get photos from '.$feed_url.PHP_EOL;
	}
} else {
	$json_array['code'] = 0;
	$json_array['message'] = 'Check access token and user ID settings.';
}

$return = json_encode($json_array);
echo $return;

include_once $_SERVER['DOCUMENT_ROOT'].'/end.php';

?>