<?php
include '../start.php';
include '../includes/msg.inc';
include '../includes/dropdown.inc';
require_once $_SERVER['DOCUMENT_ROOT'].'/'.($settings['rootpath']!='' ? $settings['rootpath'] : '/')."includes/mls_search_form_vars.php";

if($_SERVER['HTTP_X_REQUESTED_WITH']!='XMLHttpRequest') {
	echo "Invalid Request.";
} else {
	$array = array();

	if(!isset($max_row_return)) {
		$max_row_return = 50; // if max rows is missing,. default to 50!
	}

	$query = "SELECT * FROM 
			(SELECT `lat`, `long`, `price`, `unit`, `number`, `id`, `sold`, 
				`street`,  `bedroom`, `bathroom`, `sqft`, `type`, `building`,
				CAST(REPLACE(REPLACE(`sqft`, ',', ''), ' ', '') AS UNSIGNED) as `i_sqft`,
				CAST(REPLACE(REPLACE(`price`, ',', ''), '$', '') AS UNSIGNED) as `i_price`,
				CAST(REPLACE(REPLACE(`bedroom`, ',', ''), ' ', '') AS UNSIGNED) as `i_bedroom`,
				CAST(REPLACE(REPLACE(`bathroom`, ',', ''), ' ', '') AS UNSIGNED) as `i_bathroom`
			FROM `homes`
			WHERE `publish` = '1') a ";


//conditions that shoud be default.. active and with lat/lng value.
	$conditions = array(" `sold` = 0 ", " `lat` != '' ");

// position
	$conditions[] = sprintf(" `lat` BETWEEN %f AND %f ", $_GET['y2'], $_GET['y1']);
	$conditions[] = sprintf(" `long` BETWEEN %f AND %f ", $_GET['x2'], $_GET['x1']);

	if ($_GET['square_from'] > $_GET['square_to'] && $_GET['square_to'] > 0) {
		die ($g_msg['error.incorrect_square']);
	}

	if ($_GET['min_price'] > $_GET['max_price'] && $_GET['max_price'] > 0) {
		die ($g_msg['error.incorrect_price']);
	}

// type
	if(is_countable($_GET['property_type'])) {
		$types = $_GET['property_type'];
	} else {
		$types = array();
	}


	if (is_countable($types) && count($types) > 0) {
		$conditions[] = " `type` IN (" . implode(', ', $types) . ")";
	}

// square
	if (is_array($square) && array_key_exists($_GET['square_from'], $square)) {
		$conditions[] = " i_sqft >= '" . intval($square[$_GET['square_from']]) . "'";
	}

	if (array_key_exists($_GET['square_to'], $square)) {
		$conditions[] = " i_sqft <= '" . intval($square[$_GET['square_to']]) . "'";
	} else if ($_GET['square_to'] == count($square) + 1) {
		$conditions[] = " i_sqft >= '" . intval($square[$_GET['square_to'] - 1]) . "'";
	}

// price
	if (is_array($price) && array_key_exists($_GET['min_price'], $price)) {
		$conditions[] = " i_price >= '" . intval($price[$_GET['min_price']]) . "'";
	}

	if (is_array($price) && array_key_exists($_GET['max_price'], $price)) {
		$conditions[] = " i_price <= '" . intval($price[$_GET['max_price']]) . "'";
	} else if ($_GET['max_price'] == count($price) + 1) {
		$conditions[] = " i_price >= '" . intval($price[$_GET['max_price'] - 1]) . "'";
	}

// bed
	if (is_array($bed) && array_key_exists($_GET['bed'], $bed)) {
		$conditions[] = " i_bedroom >= '" . intval($bed[$_GET['bed']]) . "'";
	}

// bath
	if (array_key_exists($_GET['bath'], $bath)) {
		$conditions[] = " i_bathroom >= '" . intval($bath[$_GET['bath']]) . "'";
	}

	if (!empty($conditions)) {
		$query .= " WHERE " . implode (' AND ', $conditions);
	}

// echo $query."\n";

	$res = $mysqli->query($query);
	$total_rows = $mysqli->num_rows;

	$i = 1;
	while ($data = $res->fetch_assoc()) {

		// display maximun allowed results
		if ($i > $max_row_return) break;
		$i++;

		$building = trim($data['building']);
		$building_id = !empty($building) ? trim($data['building']) : ('s_' . $data['id']);

		$home = new home;
		$home->initialize($data['id']);
		$data = $home->data;
		$data['link'] = $home->get_property_link('mls','showlisting/');
		$data['address'] = $home->address;
		$data['city'] = $home->city;
		$data['area'] = $home->area;
		$data['areacity'] = $home->areacity;
		$data['propertytype'] = $home->type;
		$data['firm_1'] = $home->firm_1;
		$data['firm_2'] = $home->firm_2;
		$data['img'] = $home->get_main_image_path();
		$data['sqft'] = $home->sqft;
		// process building title etc.
		if(is_object($home->bldg)) {
			// process building name display.
			// if bulding name is a default name,
			// the name shuld be blank and only pass address.
			if($home->bldg->defaultname==true) {
				$data['building_name'] = '';
			}
		}

		$data['firminfo'] = $home->providedby;

		if(strpos($settings['mls_import_url'], 'edmonton')!=false && $home->source==1) {
			// override firm info with full agent name etc.
			$disclaimer_options['tag'] = false;
			$disclaimer_options['prepend'] = 'Courtesy of ';
			$disclaimer_options['append'] = ' ('.$home->mls.')';
			$disclaimer_options['showagent'] = true;
			$disclaimer_options['agent_separator'] = ' of ';

			$data['firminfo'] = $home->generate_providedby_display($disclaimer_options);
		}

		$array[$building_id][] = $data;
	}

	if ($total_rows > $max_row_return) {
		$array['msg'] = sprintf($g_msg['info.many_results'], $max_row_return, $total_rows);
	}

	header('Content-type: application/json');
	echo json_encode($array);
}