<?php
$seconds_to_cache = 0;
include '../start.php';
global $settings; // really to avoid error messages in phpstorm. It's already global.

if(isset($_POST['g-recaptcha-response'])) {
	// new module! RECAPTCHA V2
	/*
        require_once '../includes/rcautoload.php';

        $recaptcha = new \ReCaptcha\ReCaptcha($settings['captcha_private_key']);
        $resp = $recaptcha->verify($_POST['g-recaptcha-response'], $_SERVER['REMOTE_ADDR']);

    */
	$google_url = "https://www.google.com/recaptcha/api/siteverify";

	$postvars['secret'] = $settings['captcha_private_key'];
	$postvars['response'] = $_POST['g-recaptcha-response'];
	$postvars['remoteip'] = $_SERVER['REMOTE_ADDR'];

	$google_response = curl_get_file_contents($google_url, 'POST', $postvars);
	$google_result = json_decode($google_response, TRUE);

	if($google_result['success']!='true') {
		$captchapass = false;
		// defined error codes as per Google's Recaptcha
		$captcha_errors = array(
			'missing-input-secret'=>'Secret parameter is missing. Please contact support. ',
			'invalid-input-secret'=>'Secret parameter is invalid. Please contact support. ',
			'missing-input-response'=>'Please use the verification tool to prove you are a human.',
			'invalid-input-response'=>'There was an error in receiving your request. Please find our email address directly.',
		);

		$errorcount = 0;
		if(is_array($google_result['error-codes'])) {
			foreach ($google_result['error-codes'] as $key=>$code) {
				$message. ($errorcount>0 ? ', ' : '').$captcha_errors[$code];
				$errorcount++;
			}
		}

		if($message=='') {
			$message = 'Human verification entry has failed. Please try again.';
		}

	} else {
		$captchapass = true;
	}
} else {
	// old one! RECAPTCHA V1 with ugly squigly text shit.
	require_once('../includes/recaptchalib.php');
	$resp = recaptcha_check_answer ($settings['captcha_private_key'],$_SERVER["REMOTE_ADDR"],$_REQUEST["recaptcha_challenge_field"],$_REQUEST["recaptcha_response_field"]);
	if(!$resp->is_valid) {
		$captchapass = false;
		$message = 'Human verification entry has failed. Please try again.';
	} else {
		$captchapass = true;
	}
}

foreach($_REQUEST as $keyname=>$value) {
	if(is_array($value)) {
		foreach($value as $keynum=>$array) {
			$value[$keynum] = $mysqli->real_escape_string($array);
		}
		$_REQUEST[$keyname] = $value;
	} else {
		$_REQUEST[$keyname] = $mysqli->real_escape_string($value);
	}
}

$_REQUEST['message'] = str_replace(array('\n', '\r'), array("\n", "\r"), $_REQUEST['message']);

if(strpos($_REQUEST['message'], 'Invisible Recaptcha failed')!==false) {
	// override for recaptcha key error warning.
	// only used whne the invisible recaptcha is being tested, and to override failures to allow email sending still.
	$captchapass = true;
}

if (!$captchapass) {
	$code = 0; // 0 for negative result
	// message was defined above as per the $resp result.

} else if($_REQUEST['email']=='' || is_email_format($_REQUEST['email'])===false) {
	// invalid email
	$code = 0;
	$message = 'We need your email address to contact you!';
} else {

	// send the email.
	// but lets process some stuff first!

	$visitor = new visitor;
	$visitor->initialize($_COOKIE['sessionid']); // get visitor loaded up

	list($fname, $lname) = split_name($_REQUEST['name']); // smarter visitor tracking.
	$visitordata = array(
		'fname'=>$fname,
		'lname'=>$lname,
		'email'=>$_REQUEST['email'],
		'phone'=>$_REQUEST['phone']
	);
	$visitor->register_visitor($visitordata);

	if($_REQUEST['homeid']!='') {

		$home = new home;
		$home->initialize($_REQUEST['homeid']);

		$homedata = array(
			'id' => $home->id,
			'mls' => $home->mls,
			'fulladdress'=>$home->fulladdress,
			'cityid' => $home->data['city'],
			'areaid' => $home->data['area'],
			'typeid' => $home->data['type'],
			'price' => $home->price,
			'bed' => $home->data['bedroom'],
			'bath' => $home->data['bathroom'],
			'sqft' => $home->data['sqft']
		);
		$visitor->listing_action($homedata, 'contact');
	}

	if($settings['mailchimp_api_key']!='' && $settings['mailchimp_sync']=='1' && $settings['mailchimp_api_list']!='') {

		$client_mailchimp = mailchimp_get_api($settings['mailchimp_api_key']);
		if(is_object($client_mailchimp)) {
			if ($_REQUEST['name'] != '') {
				if ($_REQUEST['name'] == trim($_REQUEST['name']) && strpos($_REQUEST['name'], ' ') !== false) {
					list($mc_options['fname'],$mc_options['lname']) = explode(' ', $_REQUEST['name']);
				} else {
					$mc_options['fname'] = $_REQUEST['name'];
				}
			}

			$mc_options['email'] = $_REQUEST['email'];
			$mc_options['phone'] = $_REQUEST['phone'];
			$mc_options['message'] = $_REQUEST['message'];
			$mc_options['listid'] = $settings['mailchimp_api_list'];

			if($mc_options['listid']!='') {
				$mc_result = mailchimp_add_subscriber($client_mailchimp, $mc_options);
				if($mc_result['result']===true) {
					// TODO: trigger an email indicating somebody was added to their Mailchimp list?
					// This can go to the site owner's email address I guess?
					// is it super creepy if we send a copy to leads@brixwork.com to keep track?
					// actually let's do that. Then we can brag "We addec XX to our clients' mailchimp lists!"githu
				}
			} else {
				// if API key si set, but no list specified, not much we can do either..
				// trigger a warning email to website owner (realtor) to make sure that they create a list
				// AND they need to select the list from the ID.
			}

			/* Returns:
			 * array(4) {
	  ["id"]=>
	  string(32) "8a5240ad72a0cb732e5ba7034713435e"
	  ["result"]=>
	  bool(true)
	  ["status"]=>
	  string(10) "subscribed"
	  ["message"]=>
	  string(72) "Successfully added sonikastudios@gmail.com to Mailchimp list 4ed98ac88d."
	}
			 * */
		} else {
			// do internal error log of a failed MC Object initialization? Wrong Key? Connection issue?

		}


	}

	if($_REQUEST['followupboss_disable']!='1' && $settings['followupboss_api_key']!='') {
		// attempt FU Boss ping!
		$fub_options['type'] = 'General Inquiry'; // default.

		$fub_options['fname'] = $fname;
		$fub_options['lname'] = $lname;
		$fub_options['email'] = $_REQUEST['email'];
		$fub_options['phone'] = $_REQUEST['phone'];
		$fub_options['message'] = $_REQUEST['message'];

		if(is_object($home)) {
			$fub_options['type'] = 'Property Inquiry';
			$fub_options['street'] = $home->address;
			$fub_options['city'] = $home->city;
			// TODO: is there a neighbourhood at FollowupBoss?
			$fub_options['province'] = $settings['province'];
			$fub_options['postal'] = $home->postal;
			$fub_options['mls'] = $home->mls;
			$fub_options['price'] = remove_all_but_numbers($home->price);
			$fub_options['for_rent'] = ($home->for_rent);
			$fub_options['url'] = $_REQUEST['origin_url']; // most likely contains the $ogtags['url']
			$fub_options['property_type'] = $home->type;
			$fub_options['bedroom'] = $home->bedroom;
			$fub_options['bathroom'] = $home->bathroom;
			$fub_options['area'] = $home->sqft;
			$fub_options['lot'] = $home->lot;
			$fub_options['tags'] = array("Buyer", "More Information");
		}

		// print_r($fub_options);

		$fub_result = followupboss_api_action($fub_options);

		// print_r($fub_result);
	}

	if($_REQUEST['spark_form_disable']!='1' && $settings['spark_form_sync']=='1' && $settings['spark_form_api_key']!='') {
		// attempt Spark ping!
		$spark_options['fname'] = $fname;
		$spark_options['lname'] = $lname;
		$spark_options['email'] = $_REQUEST['email'];
		$spark_options['phone'] = $_REQUEST['phone'];
		$spark_options['message'] = $_REQUEST['message'];
		$spark_options['origin'] = $_REQUEST['origin_url'];
		$spark_options['agent'] = isset($_REQUEST['realtorflag']) && $_REQUEST['realtorflag'] == '2';
		$spark_options['answers'] = '';

		// TODO dynamically set up answers by ID or don't
//		if(is_object($home)) {
//			$spark_options['answers'] = (object) array(
//				5770 => ['Where did you hear about us?' => $_REQUEST['origin_url']],
//			);
//		}

		$spark_result = spark_form_api_action($spark_options, 'POST');

//		 var_dump($spark_result);
	}

	// TODO: introduce a new email $_REQUEST key value that contains both name and address at the contact form PHP leve.
	$sendgrid_tos = array(); // declare blank array first for the new Sendgrid API system format.

	// get the default TO name from the $settings['owner'] var.
	if(is_array($settings['owner']) && $settings['owner'][0]!='') {
		$owner_name = $settings['owner'][0];
	} else if(is_string($settings['owner']) && $settings['owner']) {
		$owner_name = $settings['owner'];
	} else {
		$owner_name = 'Brixwork Client';
	}

	// if manual email_to_name is set (agent name?) then override.
	if($_REQUEST['email_to_name']!='') {
		$to_name = $_REQUEST['email_to_name'];
	} else {
		$to_name = $owner_name;
	}


	if ($_REQUEST['email_to'] != '') {
		$sendgrid_tos = prepare_emailto_array($_REQUEST['email_to'], $to_name);

		// for the ajax result to say "Your email was sent to ______!": strictly for display.
		$tostring = $mysqli->real_escape_string(str_ireplace(';', ',', $_REQUEST['email_to']));

	} else {
		//otherwise to field uses $settings['contactemail']
		$sendgrid_tos = prepare_emailto_array($settings['contactemail'], $owner_name);
		$tostring = '';
		foreach($sendgrid_tos as $email => $name) {
			$tostring.=($key>0 ? ', ' : '').$email;
		}
	}

	$sendgrid_ccs = false; // declare to false for now.
	if ($_REQUEST['email_cc'] != '') {
		// there should only be ONE email here most of the time anywa.
		$sendgrid_ccs = prepare_emailto_array($_REQUEST['email_cc'], $owner_name);
	}

	foreach($sendgrid_ccs as $cc_email=>$cc_name) {
		if(array_key_exists($cc_email, $sendgrid_tos)) {
			// avoid dupilcate emails, remove from CC. Otehrwise sendgrid will reject.
			unset($sendgrid_ccs[$cc_email]);
		}
	}

	$subject = "New Web-generated Email lead from ".$_REQUEST['name'];

	$form_origin = '';
	switch ($_REQUEST['form_origin']) {
		case 'about_page':
			$form_origin = '<em>From The About Page:</em><br/><br/>';
			break;

		case 'listing_detail':
			$form_origin = '<em>From The Listing Detail Page:</em><br/><br/>';
			break;

		case 'contact_page':
			$form_origin = '<em>From The Contact Page:</em><br/><br/>';
			break;

		case 'index_page':
			$form_origin = '<em>From The Home Page:</em><br/><br/>';
			break;

		case 'listing_page':
			$form_origin = '<em>From The Listing Gallery:</em><br/><br/>';
			break;

		case 'notfound':
			$form_origin = '<em>From The Not Found Page:</em><br/><br/>';
			break;

		case 'other':
			$form_origin = '<em>Custom Pages:</em><br/><br/>';
			break;

		default:
			$form_origin = '';
	}

	// always append the source page URL:
	$origin_url = ($_REQUEST['origin_url']!='' ? $_REQUEST['origin_url'] : $_SERVER['HTTP_REFERER']);
	$form_origin .= '<br />URL: <a href="'.$origin_url.'" target="_blank">'.$origin_url.'</a><br />';

	if($_REQUEST['realtorflag']!='0' && isset($_REQUEST['realtorflag']) && $_REQUEST['realtorflag']!='') {
		// clicked "Yes, I am"
		$form_origin.="<strong>Lead indicated they are currently working with a Realtor&reg;!</strong><br /><br />";
	}
	else {
		// clicked "No, I am not"
		$form_origin.="<strong>Lead indicated No Realtor&reg; relationship</strong><br /><br />";
	}

	$email_params['body'] = $content .= nl2br($_REQUEST['message'])."<br /><br />Name: ".trim($_REQUEST['name'])."<br /><br />Phone: ".trim($_REQUEST['phone'])."<br /><br />Email: ".trim($_REQUEST['email'])."<br /><br />Source: Website<br />".$form_origin;
	$email_params['subject'] = $subject;
	$email_params['encoding'] = "text/html";
	$email_params['fromemail'] = 'leads@brixwork.com';
	$email_params['fromname'] = $_REQUEST['name'];

	$email_params['replyto_email'] = $_REQUEST["email"]; // so that the reply-to (if you hit CTRL R) goes to the customer, not leads@brixwork.com!
	$email_params['replyto_name'] = $_REQUEST['name'];

	$email_params['to_emails'] = $sendgrid_tos; // alreaddy processed in this case?
	$email_params['to_names'] = $settings['owner']; //

	if($sendgrid_ccs!==false) {
		$email_params['cc_emails'] = $sendgrid_ccs; // alreaddy processed in this case?
		$email_params['cc_names'] = $settings['owner']; //
	}

	$email_params['bcc_emails'] = 'leads@brixwork.com'; // alreaddy processed in this case?
	$email_params['bcc_names'] = 'Brixwork System'; //

//	// Create the message
//	$email = new \SendGrid\Mail\Mail();
//	$email->setFrom('leads@brixwork.com', $_REQUEST['name']);
//	$email->setSubject($subject);
//	$email->setReplyTo($_REQUEST["email"], $_REQUEST['name']); // Ensure the quick Command+R goes to the client, not brixwork!
//
//
//
//	// finally, process the ccs and tos.
//	$email->addTos($sendgrid_tos);
//	if($sendgrid_ccs!==false && count($sendgrid_ccs)>0) {
//		$email->addCcs($sendgrid_ccs);
//	}
//
//	$email->addBcc('leads@brixwork.com', 'Brixwork System');
//	$email->addContent("text/html", $content);
//
//	// initialize API
//	$sendgrid = new \SendGrid($settings['sendgrid_api_key'] );

	$sql_log = array(
		'visitor'		=> $visitor->id,
		"home"			=> (isset($_REQUEST['homeid']) ? $_REQUEST['homeid'] : ''),
		"building"		=> (isset($_REQUEST['buildingid']) ? $_REQUEST['buildingid'] : ''),
		'url_source'	=> $origin_url,
		'message'		=> $_REQUEST["message"],
		'sent_to'		=> $to,
		"crm_mailchimp"	=> $mc_result,
		"crm_fub"		=> $fub_result,
		"crm_spark" 	=> $spark_result,
		'create_date'	=> $now,
		'modify_date'	=> $now,
		'read_status'	=> 0,
	);

	// Send the message
	$email_result = send_email($email_params);

	if($email_result['result'] == true) {
		if(strpos($tostring, ',')!==false) {
			// get just the first email address.
			$to_array = explode(',', $tostring );
			$to_display = $to_array[0].'!';
		} else {
			$to_display = $tostring.'.';
		}

		$response = $email_result['response'];

		if($email_result['statuscode']>=200 && $email_result['statuscode']<300) {
			// 2xx is success

			$code = 1;
			$message = 'Your message has been successfully sent to '.$to_display;
			$sql_log['success'] = $code;
			$sql_log['log'] = $response;
		} else {
			// print_r($response->headers());
			$code = 0;
			if(isset($response)) {
				// valid $response from Sendgrid indicates good connection with API at least so the error is from their system.
				$message = 'There was an error with our email system (code: '.$response->statusCode().', message: '.$response->body().' - If this error persists, please contact support@brixwork.com.';
			} else {
				//use the raw message from our own PHP internal error of sorts from the try-catch statement.
				$message = $email_result['message'];
			}
			$sql_log['success'] = $code;
			$sql_log = $message;
		}

	}
}

if(is_array($sql_log)) {
	foreach ($sql_log as $column => $value) {
		if (is_array($value)) {
			$sql_log[$column] = implode(';  ', $value);
		} else if (is_object($value)) {
			$sql_log[$column] = '';
			foreach ($value as $key => $val) {
				$sql_log[$column] .= " $key: " . implode(', ', $val) . "; ";
			}
		}
	}
}

$json_array = array('code'=>$code, 'message'=>$message);
echo json_encode($json_array);

if(is_object($visitor)) {
	$visitor->enter_lead_email($sql_log);
}

include_once $_SERVER['DOCUMENT_ROOT'].'/end.php';
?>
