<?php
// map number columns to text columns in MLS server 
$reboard = array(
	'76', // Ottawa Real Estate Board
	'77', // Pembroke area (NW of Ottawa)
	'93' // ?

); // Ottawa Real Estate Board.

$columns_map_res = array(
	'@attributes' => array(
		'ID' => 'sysid',
		'LastUpdated' => 'lastupdated'
	),
	
	'ListingID' => 'mls_no',
	'AgentDetails' => array(
		'@attributes' => array(
			'ID' => 'realtor_1_id'
		),
		'Name' => 'realtor_1_name',
		'Phones' => array(
			'Phone' => 'realtor_1_phone'
		),
		'Office' => array(
			'@attributes' => array(
				'ID' => 'firm_1_code'
			),
			'Name' => 'firm_1_name'
		)
	),
	'Board' => 'reboard', // was 76 for OTtawa
	'Business' => array(), // dunno here anymore!
	'Building' => array(
		'BathroomTotal' => 'total_bath',
		'BedroomsTotal' => 'total_bed',
		'BedroomsAboveGround' => 'bed_aboveground',
		'Amenities' => 'amenities', // Storage - Locker, Laundry - In Suite, Exercise Centre
		'Appliances' => 'appliances',
		'BasementDevelopment' => 'basementstate',
		'BasementType' => 'basementtype',
		'ConstructedDate' => 'approx_year_built',
		'ConstructionStyleAttachment' => 'constructionstyle',
		'CoolingType' => 'coolingtype',
		'ExteriorFinish' => 'exteriorfinish',
		'FireplaceFuel' => 'fireplace_fuel',
		'FireplacePresent' => 'fireplace', // True of False
		'FireplaceTotal' => 'num_fireplaces',
		'FireProtection' => 'fire_protection',
		'FoundationType' => 'foundation_type',
		'HalfBathTotal'=>'half_bath',
		'HeatingFuel' => 'heating_fuel',
		'HeatingType' => 'heating_type',
		'Rooms' => array(
			'Room' => 'rooms_array', // override this to 'brixwork_array' so that it just keeps it as array in the $listing, and our code will have to parse through the variable length of arrays. 
/*
				(
					[0] => array(
						[Type] => Living room
						[Width] => 30 ft
						[Length] => 15 ft
						[Level] => Main level
						[Dimension] => 15 ft x 30 ft
					)

					[1] => array(
							[Type] => Dining room
							[Width] => 15 ft
							[Length] => 18 ft
							[Level] => Main level
							[Dimension] => 18 ft x 15 ft
						)
	
*/
	
		),
		'SizeInterior'=>'floor_area_gtotal',
		'StoriesTotal' => 'storey',
		'Type' => 'propertytype',
		'UtilityWater' => 'water_type'
	),
	
	'Land' => array(
		'SizeTotal' => 'lot', // if it has |Unknown, enter blank rather than 0. 
		'SizeTotalText' => 'lottext',
		'AccessType' => 'lotaccess',
		'Acreage' => 'acreage',
		'Amenities' => 'amenities',
		'SizeIrregular' => 'sizeirregular'
	),
	
	'Address' => array(
		'StreetAddress' => 'saddress',
		'AddressLine1' =>'address',
		'City' => 'city',
		'Province' => 'prov',
		'PostalCode' => 'postal',
		'Country' => 'country',
		'Neighbourhood' => 'area'
	),
	
	'AlternateURL' => array(
		'PhotoLink' => 'virtualtour'
	),
	
	'AmmenitiesNearBy' => 'amenities',
	'CommunicationType' => 'comm_type',
	'Features' => 'location_features', // such as Balcony etc.
	'MunicipalId' => 'municipalid', // was 360000060
	'ListingContractDate' => 'create_date',// 13/03/2016
    'MaintenanceFee' => 'maintenance',// 505.00
    'MaintenanceFeePaymentUnit' => 'maintenance_unit', // Monthly
	'OwnershipType' => 'title',// Freehold, or Condominium/Strata etc.
	'ParkingSpaces' => array(
		'Parking' =>'parking_array'
	),
  	'ParkingSpaceTotal' => 'parking_total',
	'Photo' => array(
		'PropertyPhoto' => 'photos_array', // same, loop through photos...
	/*
				'0' => array(
					'SequenceId' => 1
					'LastUpdated' => 15/06/2014 12:49:07 AM
				),
		
				'1' => array(
						'SequenceId' => 2
						'LastUpdated' => 15/06/2014 12:49:07 AM
				),
	*/
		
	
	),

	'Price' => 'price',
	'PropertyType' => 'type',
	'PublicRemarks' => 'description',
	'Structure' => 'exterior_features',
	'TransactionType' => 'transactiontype', // Ottawa feed said "For sale" as status for this field. 
	'UtilitiesAvailable' => array(), // ??
	'ViewType'=>'view',
	'WaterFrontType' => 'waterfront',// for wf it said Waterfront
	'ZoningDescription' => 'zoning' // this one said Rural


);


$agent_info_map = array(// multi agent 1.
	array(
		'@attributes' => array(
			'ID' => 'realtor_1_id'
		),
		'Name' => 'realtor_1_name',
		'Phones' => array(
			'Phone' => 'realtor_1_phone'
		),
		/*
				'Websites' => array(
					'Website' => 'agent_website'
				),
		*/
		'Office' => array(
			'@attributes' => array(
				'ID' => 'firm_1_code'
			),
			'Name' => 'firm_1_name'
		)
	),
	array(
		'@attributes' => array(
			'ID' => 'realtor_2_id'
		),
		'Name' => 'realtor_2_name',
		'Phones' => array(
			'Phone' => 'realtor_2_phone'
		),
		/*
				'Websites' => array(
					'Website' => 'agent_website'
				),
		*/
		'Office' => array(
			'@attributes' => array(
				'ID' => 'firm_2_code'
			),
			'Name' => 'firm_2_name'
		)
	),
	array(
		'@attributes' => array(
			'ID' => 'realtor_3_id'
		),
		'Name' => 'realtor_3_name',
		'Phones' => array(
			'Phone' => 'realtor_3_phone'
		),
		/*
				'Websites' => array(
					'Website' => 'agent_website'
				),
		*/
		'Office' => array(
			'@attributes' => array(
				'ID' => 'firm_3_code'
			),
			'Name' => 'firm_3_name'
		)
	),
);

$fixed_columns_res = array('sold'	=>	0, 'showaddress'=>1, 'feature'	=>	0, 'source'	=>	1, 'prevprice'	=>	NULL, 'tax'=>NULL,
						'openhouse'	=>	NULL, 'videolink'	=>	NULL, 'youtube'	=>	NULL, 'youtube1'	=>	NULL,
						'remarks'	=>	0, 'sqftup'	=>	NULL, 'sqftmain'	=>	NULL, 'sqftdown'	=>	NULL,
						'firm_fax_1'=> '', 'firm_fax_2'=> '', 'firm_fax_3'=> '', 
						'firm_phone_1'=>'', 'firm_phone_2'=>'', 'firm_phone_3'=>'',
						'kitchen'	=>	NULL, 'fireplace'	=>	NULL, 'storage'	=>	NULL,
						'rearexposure'	=>	NULL, 'suite'	=>	NULL, 'balcony'	=>	NULL, 'rental'	=>	NULL,
						'description2'	=>	NULL, 'dimension'	=>	NULL,
						'heading'	=>	NULL, 'publish'	=>	1, 'views'	=>	0, 'warranty'	=>	'',
						'building'	=>	'');

// mapped columns from server to table home
$columns_map2_res = array(
'mls_no' => 'mls',
'sysid'=>'sysid',
'reboard'=>'board',
'create_date' => 'create_date',
'lastupdated'=>'modify_date', 
'title' => 'land_title',
'price' => 'price',
'postal' => 'postal',
'total_bed' => 'bedroom',
'total_bath' => 'bathroom',
'city'=>'city',
'area'=>'area',
'storey'=>'story',
'half_bath'=>'halfbath',
'parking_total'=>'parking',
'foundation_type'=>'construction',
'floor_area_gtotal' => 'sqft', 'floor_area_main_floor'=>'sqftmain', 'lot' => 'lot', 'depth' => 'depth', 'view' => 'view', 'basement_area'=>'basement',
						'frontage' => 'frontage', 'approx_year_built' => 'year', 'description' => 'description', 'virtual_tour_url'=>'virtualtour',
						
						'firm_1_code'=>'firm_1_id', 'firm_2_code'=>'firm_2_id', 'realtor_3_office_id'=>'firm_3_id',
						'firm_1_name' => 'firm_1', 'firm_1_phone' => 'firm_phone_1',
						'firm_2_name' => 'firm_2', 'firm_2_phone' => 'firm_phone_2',
						
						'realtor_3_office_name' => 'firm_3',
						
						'realtor_1_id'=>'realtor_id_1', 'realtor_1_name' => 'realtor_1', 'realtor_1_phone' => 'realtor_phone_1',
						'realtor_2_id'=>'realtor_id_2', 'realtor_2_name' => 'realtor_2', 'realtor_2_phone' => 'realtor_phone_2',
						'realtor_3_id'=>'realtor_id_3', 'realtor_3_name' => 'realtor_3', 'realtor_3_phone' => 'realtor_phone_3'
						);

// dwelling type data map
$dwelling_type_map_res = array(
	'House' => 1,
	'Apartment' => 2,
	'Row / Townhouse' => 3,
	'1/2 Duplex' => 4,
	'Other' => 1,
	'Duplex' => 4,
	'Triplex' => 5,
	'Vacant Land'=>7,
	'Land Only'=>7
);


$openhouse_map = array(
'OH_UniqueID'=>'sysid',
'L_DisplayId'=>'mls',
'OH_StartDate'=>'date',
'OH_StartTime'=>'starttime',
'OH_EndTime'=>'endtime',
//2213=>'type',
'OH_CreateDateTime'=>'create_date',
'OH_UpdateDateTime'=>'modify_date'
);


$disabledareas = array(
	'ALM0MTE',
	'ALMONTE0', // 1378
);

/*
	
(
	[Count] => SimpleXMLElement Object
		(
			[0] => 3882
		)

	[Properties] => Array
		(
			[0] => Array
				(
					[@attributes] => Array
						(
							[ID] => 14559683
							[LastUpdated] => Thu, 15 Oct 2015 04:36:57 GMT
						)

					[ListingID] => 916081
					[AgentDetails] => Array
						(
							[@attributes] => Array
								(
									[ID] => 1952474
								)

							[Name] => JEREMY LEVITT
							[Phones] => Array
								(
									[Phone] => (613) 716-2220
								)

							[Websites] => Array
								(
									[Website] => http://www.jeremylevitt.com
								)

							[Office] => Array
								(
									[@attributes] => Array
										(
											[ID] => 272686
										)

									[Name] => SOTHEBY'S INTERNATIONAL REALTY CANADA
									[Address] => Array
										(
											[StreetAddress] => 12 YORK STREET
											[AddressLine1] => 12 YORK STREET
											[City] => OTTAWA
											[Province] => ON
											[PostalCode] => K1N5S6
										)

									[Phones] => Array
										(
											[Phone] => Array
												(
													[0] => (613) 860-3644
													[1] => (613) 860-3689
												)

										)

									[Franchisor] => Sotheby's
								)

							[Position] => Salesperson
						)

					[Board] => 76
					[Business] => Array
						(
						)

					[Building] => Array
						(
							[BathroomTotal] => 3
							[BedroomsTotal] => 3
							[BedroomsAboveGround] => 3
							[Appliances] => Stove, Refrigerator, Washer, Dryer, Dishwasher, Microwave, Barbeque
							[BasementDevelopment] => Unfinished
							[BasementType] => Partial (Unfinished)
							[ConstructedDate] => 1832
							[ConstructionStyleAttachment] => Detached
							[CoolingType] => Central air conditioning
							[ExteriorFinish] => Stone
							[FireplaceFuel] => Gas,Wood
							[FireplacePresent] => True
							[FireplaceTotal] => 3
							[FireProtection] => Alarm system
							[FoundationType] => Stone
							[HeatingFuel] => Propane, Electric
							[HeatingType] => Forced air, Baseboard heaters
							[Rooms] => Array
								(
									[Room] => Array
										(
											[0] => Array
												(
													[Type] => Living room
													[Width] => 30 ft
													[Length] => 15 ft
													[Level] => Main level
													[Dimension] => 15 ft x 30 ft
												)

											[1] => Array
												(
													[Type] => Dining room
													[Width] => 15 ft
													[Length] => 18 ft
													[Level] => Main level
													[Dimension] => 18 ft x 15 ft
												)

											[2] => Array
												(
													[Type] => Kitchen
													[Width] => 18 ft
													[Length] => 12 ft
													[Level] => Main level
													[Dimension] => 12 ft x 18 ft
												)

											[3] => Array
												(
													[Type] => Family room
													[Width] => 13 ft
													[Length] => 18 ft
													[Level] => Main level
													[Dimension] => 18 ft x 13 ft
												)

											[4] => Array
												(
													[Type] => Den
													[Width] => 8 ft
													[Length] => 7 ft
													[Level] => Main level
													[Dimension] => 7 ft x 8 ft
												)

											[5] => Array
												(
													[Type] => Master bedroom
													[Width] => 20 ft
													[Length] => 16 ft
													[Level] => Second level
													[Dimension] => 16 ft x 20 ft
												)

											[6] => Array
												(
													[Type] => Bedroom 2
													[Width] => 17 ft
													[Length] => 15 ft
													[Level] => Second level
													[Dimension] => 15 ft x 17 ft
												)

											[7] => Array
												(
													[Type] => Bedroom 3
													[Width] => 15 ft
													[Length] => 17 ft
													[Level] => Second level
													[Dimension] => 17 ft x 15 ft
												)

											[8] => Array
												(
													[Type] => Laundry room
													[Width] => 5 ft
													[Length] => 13 ft
													[Level] => Main level
													[Dimension] => 13 ft x 5 ft
												)

											[9] => Array
												(
													[Type] => Partial bathroom
													[Width] => 5 ft
													[Length] => 6 ft
													[Level] => Main level
													[Dimension] => 6 ft x 5 ft
												)

											[10] => Array
												(
													[Type] => Full bathroom
													[Width] => 6 ft
													[Length] => 8 ft
													[Level] => Second level
													[Dimension] => 8 ft x 6 ft
												)

											[11] => Array
												(
													[Type] => 4pc Ensuite bath
													[Width] => 11 ft
													[Length] => 9 ft
													[Level] => Second level
													[Dimension] => 9 ft x 11 ft
												)

											[12] => Array
												(
													[Type] => Solarium
													[Width] => 14 ft
													[Length] => 30 ft
													[Level] => Main level
													[Dimension] => 30 ft x 14 ft
												)

											[13] => Array
												(
													[Type] => Storage
													[Width] => 11 ft
													[Length] => 11 ft
													[Level] => Main level
													[Dimension] => 11 ft x 11 ft
												)

											[14] => Array
												(
													[Type] => Foyer
													[Width] => 31 ft
													[Length] => 9 ft
													[Level] => Main level
													[Dimension] => 9 ft x 31 ft
												)

										)

								)

							[StoriesTotal] => 2
							[Type] => House
							[UtilityWater] => Drilled Well
						)

					[Land] => Array
						(
							[SizeTotal] => 187 ac
							[SizeTotalText] => 187 ac
							[AccessType] => Water access
							[Acreage] => true
							[Amenities] => Water Nearby, Golf Course
							[SizeIrregular] => 187
						)

					[Address] => Array
						(
							[StreetAddress] => 771 Kingston Mills Rd
							[AddressLine1] => 771 Kingston Mills Rd
							[City] => Kingston
							[Province] => Ontario
							[PostalCode] => K7L4V3
							[Country] => Canada
							[Neighbourhood] => Kingston
						)

					[AlternateURL] => Array
						(
							[PhotoLink] => http://tours.virtualtoursottawa.com/208794?idx=1
						)

					[AmmenitiesNearBy] => Water Nearby, Golf Course
					[CommunicationType] => High Speed Internet
					[Features] => Acreage, Private setting, Treed, Wooded area, Other
					[MunicipalId] => 360000060
					[OwnershipType] => Freehold
					[ParkingSpaces] => Array
						(
							[Parking] => Array
								(
									[Name] => Detached garage
									[Spaces] => 2
								)

						)

					[ParkingSpaceTotal] => 8
					[Photo] => Array
						(
							[PropertyPhoto] => Array
								(
									[0] => Array
										(
											[SequenceId] => 1
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[1] => Array
										(
											[SequenceId] => 2
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[2] => Array
										(
											[SequenceId] => 3
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[3] => Array
										(
											[SequenceId] => 4
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[4] => Array
										(
											[SequenceId] => 5
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[5] => Array
										(
											[SequenceId] => 6
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[6] => Array
										(
											[SequenceId] => 7
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[7] => Array
										(
											[SequenceId] => 8
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[8] => Array
										(
											[SequenceId] => 9
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[9] => Array
										(
											[SequenceId] => 10
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[10] => Array
										(
											[SequenceId] => 11
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[11] => Array
										(
											[SequenceId] => 12
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[12] => Array
										(
											[SequenceId] => 13
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[13] => Array
										(
											[SequenceId] => 14
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[14] => Array
										(
											[SequenceId] => 15
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[15] => Array
										(
											[SequenceId] => 16
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[16] => Array
										(
											[SequenceId] => 17
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[17] => Array
										(
											[SequenceId] => 18
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[18] => Array
										(
											[SequenceId] => 19
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[19] => Array
										(
											[SequenceId] => 20
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[20] => Array
										(
											[SequenceId] => 21
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[21] => Array
										(
											[SequenceId] => 22
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[22] => Array
										(
											[SequenceId] => 23
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[23] => Array
										(
											[SequenceId] => 24
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

									[24] => Array
										(
											[SequenceId] => 25
											[LastUpdated] => 15/06/2014 12:49:07 AM
										)

								)

						)

					[Price] => 1549000.00
					[PropertyType] => Single Family
					[PublicRemarks] => Originally built in 1832, this updated 3 bed, 3 bath Executive Estate sits on 187 acres of beautiful unspoiled wooded land with extensive frontage on the Rideau Canal. Wrapped in authentic grey stone and professionally renovated with selected first-quality details. A mix of traditional elegance and modern touches. Separate structure with studio(with electricity). Other features include a 4-season solarium & double garage with workshop.
					[Structure] => Deck, Patio(s)
					[TransactionType] => For sale
					[UtilitiesAvailable] => Array
						(
						)

					[WaterFrontType] => Waterfront
					[ZoningDescription] => Rural
					[AnalyticsClick] => <![CDATA[<script type='text/javascript'>
 function redirect() { 
var event = new RlEvent('crealocation');
event.viewedProperty(14559683,14735,[1952474],[272686],[1952425],[268707]);
event.set('event', 'type', 'click');
event.record();
setTimeout("window.location = 'http://www.realtor.ca/PropertyDetails.aspx?PropertyId=14559683'",500);}
</script>]]>
					[AnalyticsView] => <![CDATA[<script src='http://analytics.crea.ca/crearl.js' type='text/javascript'></script>
<script type='text/javascript'>
var event = new RlEvent('crealocation');
event.viewedProperty(14559683,14735,[1952474],[272686],[1952425],[268707]);
event.set('event', 'type', 'view');
event.record();
</script>]]>
					[MoreInformationLink] => http://www.realtor.ca/PropertyDetails.aspx?PropertyId=14559683
				)

		)

)
*/