<?php

/*

Author: Jeff Kee
*/

require_once '../start.php';
require_once 'crea_ddf.php'; // credentials for RETS access
require_once 'column_map_'.$rets_region.'.php';
require_once '../admin/admin_functions.php'; // only thing that's NOT in the public start.php


require_once 'creaddf_includes/crearesults.php';
require_once 'creaddf_includes/creaparser.php';
require_once 'creaddf_includes/creastrategy.php';

require_once 'cron_functions.php';
header('Content-Type: text/html; charset=iso-8859-1');

include 'creaddf_includes/creaddf_initialize.php'; // gets the query chunk & date range, connects to RETS etc.


foreach ($class_array as $type => $type_name) {
	// hook up to residential related fields. Ottawa just has residential feed for now.
	$columns_map['single_agent'] = $columns_map_res;
	$columns_map_res['AgentDetails'] = $agent_info_map; // replace the fucking multi-agent array portion! damn it.
	$columns_map['multi_agent'] = $columns_map_res;

	$fixed_columns = $fixed_columns_res;
	$columns_map2 = $columns_map2_res;
	$dwelling_type_map = $dwelling_type_map_res;


	// default is false, we query by date ranges, not single MLS #s.


	// DMQL query build & execute.
	$rets_options_custom = array(
		//		'Format'=>'COMPACT' // for CREA DDF really no rason to chnage from the STANDARD-XML since we installed the new parse strategy.
	);


	include 'creaddf_includes/creaddf_build_dmql.php'; // gets the query chunk & date range, first property fetch from RETS to see if there's items to query or not.

	$dmql_query_count = 0;
	// now loop through each listing.. if $numlisting is >1.
	while ($numlistings>0) {
		// $numlistings is the # off results on each DMQL query block with 100 listings, so once it runs out, it becomes 0.

		if ($outofdaterange == true) {
			// this continue will happen for every single
			write_log("Previous offset already breached the date range, skipping " . $startOffset . " altogether until end.\r\n");
			echo ' Skipping ' . $startOffset . ' and on until end.<br />' . PHP_EOL;
			retsrunning_close();
			break;
		}

		include 'creaddf_includes/creaddf_fetch_xml.php';
		echo "start loop for ".count($listings)." listings.<br />";
		foreach ($listings as $listingkey => $listing) {
			$value_data = $fixed_columns;
			$listingcount++;

			$listing_json = $listing; // copy array over just for writing stuff, to keep it pure!

//			if ($outofdaterange == true) {
//				// this continue will happen for every single
//				write_log("Not continuing the loop since the date was blown, abandoning at " . $startOffset . ".\r\n");
//				echo date($mysql_time['full'], $listing_timestamp) . ' is over the max range to look for, so we are cutting out the feed and stopping here since otherwise it will go all the way to TODAY! Thank you CREA for creating a fucked up system that made me to extra work to put a max cap timestamp manually.';
//				retsrunning_close();
//				break;
//			}

			echo "Processing :".$listing['ListingID']."<br />".PHP_EOL;

			$listing_timestamp = strtotime(substr($listing['@attributes']['LastUpdated'], 5));
			// Thu, 15 Oct 2015 04:36:57 GMT is the shitty format we get. We remove 5 chars ("Fri, ")
			// write_listing_json($listing_json, $listing['@attributes']['ID'], $ranges);

			echo "Raw mod date was ".$listing['@attributes']['LastUpdated']." (MLS ".$listing['ListingID'].")<br />".PHP_EOL;

			if (!in_array($listing['Board'], $reboard)) {
				echo "Board: ".$listing['Board']." not in array, skip MLS ".$listing['ListingID']."<br />\r\n";
				// write_log("Skip RE Board " . $listing['Board'] . " (city: " . $listing['Address']['City'] . ") since it mismatches the RE Board arrays..\r\n");
				$boardskip++;
				continue;
			}

			if ($listing_timestamp > $ranges_timestamp) {
				// date range is beyond what we wanted, so stop it here - otherwise the CREA system will start from whatever beginning all the way to the END date.
				echo "Todays range of " . $ranges_timestamp . " (".$ranges.") is too old compared to " . $listing_timestamp . " (modified: " . $listing['@attributes']['LastUpdated'] . ". Skip Listing ".$listing['ListingID']."!<br />" . PHP_EOL;
				write_log("Todays range of " . $ranges_timestamp . " is too old compared to " . $listing_timestamp . " (modified: " . $listing['@attributes']['LastUpdated'] . ". Skip ".$listing['ListingID']."!\r\n");
				$outofdaterange = true;
				continue; // this will only skip to the next foreach block, so need the mother loop to stop searching on.
			} else {
				write_log("Within Range - " . date($mysql_time['full'], $ranges_timestamp) . " query limit, listing date is " . date($mysql_time['full'], $listing_timestamp) . " (modified: " . $listing['@attributes']['LastUpdated'] . ". Process!\r\n");
			}

			if ($listing['TransactionType'] != 'For sale') {
				// Skip, it's a non-sale transaction.
				echo "Skip rental listing.<br />" . PHP_EOL;
				write_log("Trasaction type is " . $listing['TransactionType'] . ", not for sale. Skip.\r\n");
				continue;
			}

			if (in_array($listing['Neighbourhood'], $disabledareas)) {
				echo "skip this neighbourhood<br />\r\n";
				write_log("Skip this hood, " . $listing['Neighbourhood'] . " is no good.\r\n");
				continue;
			}

			/* For Ottawa,
			For Sales listings,
			Excluded (dummy) neighbourhoods, are all sorted out.
			Date ranges paseed check ($ranges and above, but not too far away)
			We are safe to count this as a valid listing.
			*/


			$summary[$type_name][$ranges]++;
			// add to the # of listings processed. This doesn't mean updated - it means this listing is valid for check/entry for this chunk date range.

			if (array_key_exists('@attributes', $listing['AgentDetails'])) {
				echo "There are " . count($listing['AgentDetails']) . " items and we deteted @attributes, single agent.<br />\r\n";
				$data = flatten_array_map($listing, $columns_map['single_agent']); // convert raw data to singular array $data and entry-ready $value_data where applicable. This is only for CREA since it has a multi level fucked up array.
			} else {
				echo "There are " . count($listing['AgentDetails']) . " items and we think this is multi agents.<br />\r\n";
				$data = flatten_array_map($listing, $columns_map['multi_agent']);
			}

			$photos_array = array(); // declare array first.
			if (isset($data['photos_array'])) {
				if (isset($data['photos_array']['PhotoURL']) && is_string($data['photos_array']['PhotoURL'])) {
					$photos_array[0] = $data['photos_array'];
					/*
					 * CREA DDF is messed up..
					 * If there's only 1 photo, it just shoves the first photo array (sequence ID, URL and all) as the first key.
					 * Note: Use "PhotoLastUpdated" to ensure accurate timestamp. This one is more strict than the dd/mm/yyyy format without a timezone.
					 * Multi photos array(
					 * 	[0] => array(
					 * 		["SequenceId"]=> "1",
					 * 		["LastUpdated"]=> "31/07/2020 01:27:28 AM",
					 * 		["PhotoLastUpdated"]=> "Fri, 31 Jul 2020 06:27:28 GMT",
					 *  	["ThumbnailURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/lowres/7/185027_1.jpg",
					 * 		["PhotoURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/medres/7/185027_1.jpg",
					 * 		["LargePhotoURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/highres/7/185027_1.jpg"
					 * ),
					 * 	[0] => array(
					 * 		["SequenceId"]=> "2",
					 * 		["LastUpdated"]=> "31/07/2020 01:27:28 AM",
					 * 		["PhotoLastUpdated"]=> "Fri, 31 Jul 2020 06:27:28 GMT",
					 *  	["ThumbnailURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/lowres/7/185027_2.jpg",
					 * 		["PhotoURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/medres/7/185027_3.jpg",
					 * 		["LargePhotoURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/highres/7/185027_3.jpg"
					 * 	)
					 * )
					 *
					 * Single PHoto array(
					 * 	["SequenceId"]=> "1",
					 * 	["LastUpdated"]=> "31/07/2020 01:27:28 AM",
					 * 	["PhotoLastUpdated"]=> "Fri, 31 Jul 2020 06:27:28 GMT",
					 *  ["ThumbnailURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/lowres/7/185027_1.jpg",
					 * 	["PhotoURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/medres/7/185027_1.jpg",
					 * 	["LargePhotoURL"]=> "https://ddfcdn.realtor.ca/listings/TS637317556489630000/reb8/highres/7/185027_1.jpg"
					 * )
					 * */
				} else {
					$photos_array = $data['photos_array'];
				}
				echo "Photo URLs fetched. " . count($photos_array) . " photo items detected.<br />" . PHP_EOL;
			}

			foreach ($data as $dkey => $dval) {
				if (array_key_exists($dkey, $columns_map2)) {
					$value_data[$columns_map2[$dkey]] = $dval;
				}
			}

			// Ottawa doesn't feed rental listings anyway but leaving this filter just in case.
			// note that we exclude rental listings, look above in the skip filters.
			if ($data['transactiontype'] == 'For sale') {
				$value_data['for_rent'] = 0;
			} else {
				$value_data['for_rent'] = 1;
				$value_data['price'] = '';
			}

			$value_data['modify_date'] = date($mysql_time['full'], strtotime($data['lastupdated']));

			write_log("Value data mod date: " . $value_data['modify_date'] . PHP_EOL);

			$data['last_image_trans_date'] = date($mysql_time['full'], strtotime(convert_crea_ddf_photo_timestamp($photos_array[0]['LastUpdated']) . ' GMT-4')); // this format is fucked. 15/06/2014 12:49:07 AM
			write_log("Modify date: " . $value_data['modify_date'] . ", raw LastUpdated photo timestamp: " . $photos_array[0]['LastUpdated'] . PHP_EOL);
			write_log("Photo time converted to " . convert_crea_ddf_photo_timestamp($photos_array[0]['LastUpdated']) . ", then to " . $data['last_image_trans_date'] . "." . PHP_EOL);

			// for integrity of photo updated timestamp & listing modify date to be separate, and avoid data charges, we separate these.
			//$value_data['modify_date'] = (strtotime($value_data['modify_date']) >= strtotime($data['last_image_trans_date']) ? $value_data['modify_date'] : $data['last_image_trans_date']);

			write_log("Processing MLS #" . $value_data['mls'] . "\n");

			$mls_numbers[] = $value_data['mls'];
			$get_position = true; // set $get_position to tru by default for googl emaps query.

			$condition = " WHERE `mls` = '{$value_data['mls']}'";
			$e_res = $mysqli->query("SELECT * FROM `$table` $condition LIMIT 0, 1");
			$exists = $e_res->num_rows > 0;

			// clean up city/subarea strings since CREA is a fucking mess.
			$cleanpattern[0] = '/\s+/'; // multiple spaces remove.
			$cleanpattern[1] = '/^"|"$/'; // quotations at beginning or end!

			$cleanreplace[0] = ' ';
			$cleanreplace[1] = '';

			$value_data['city'] = preg_replace($cleanpattern, $cleanreplace, trim($value_data['city']));
			$value_data['area'] = preg_replace($cleanpattern, $cleanreplace, trim($value_data['area']));

			/*
				$data var:
			[StreetAddress] => 771 Kingston Mills Rd
			[AddressLine1] => 771 Kingston Mills Rd
			[City] => Kingston
			[Province] => Ontario
			[PostalCode] => K7L4V3
			[Country] => Canada
			[Neighbourhood] => Kingston
			*/

			$address = $data['saddress'] . ' ' . $data['area'] . ', ' . $data['city'];

			$skiplisting = false;

			if ($exists) {
				$old_data = $e_res->fetch_assoc();

				if (strtotime($old_data['modify_date']) >= strtotime($value_data['modify_date'])) {
					write_log("Skipping: Property last updated " . $old_data['modify_date'] . ", new mod date is " . $value_data['modify_date'] . "\n");
					continue;
				}

				if ($value_data['create_date'] == '') {
					// create_date was blank, meaning this is a commercial listing.
					$value_data['create_date'] = $old_data['create_date']; // keep original date.
				}


				// compare address
				$o_address = "$old_data[number] $old_data[street_dir] $old_data[street], $old_data[area], $old_data[city]";


				$value_data['lat'] = $old_data['lat'];
				$value_data['long'] = $old_data['long'];

				// should we connect to Google for lat/long? If lat/long is missing, let's try. It means we may have timed out on the last run.
				if ($old_data['lat'] != '' && $old_data['long'] != '') {
					$get_position = false;
				} else {
					$get_position = true;
				}

				if ($old_data['city'] == 0 || $old_data['area'] == 0) {
					echo 'modifying old home data!<br />';

					list($value_data['area'], $value_data['city']) = match_cities($value_data, $cities, $subareas);

					$value_data['modify_date'] = $now;

					if ($value_data['city'] == 0) {
						write_log("Incorrect city (Area can be blank, city cannot). area:" . $value_data['area'] . ', city:' . $value_data['city'] . ' for mls: ' . $value_data['mls'] . ", Modify failed.\r\n");
						$skiplisting = true;
					}
				} else {
					$value_data['area'] = $old_data['area'];
					$value_data['city'] = $old_data['city'];
					echo 'keeping old shit: ' . $old_data['city'] . ', ' . $old_data['area'] . '<br />';
				}

				$value_data['ord'] = $old_data['ord'];
			} else {
				// this is a brand new listing - lets set the city area etc.
				// city
				echo 'brand new home data!<br />';

				if ($value_data['create_date'] == '') {
					// create_date was blank, meaning this is a commercial listing.
					$value_data['create_date'] = $value_data['modify_date']; // for brand new commercvial listing, use the modified date as the newest date.
				}

				list($value_data['area'], $value_data['city']) = match_cities($value_data, $cities, $subareas);

				if ($value_data['lat'] != '' && $value_data['long'] != '') {
					$get_position = false; // lat/long provided from MLS, no need to run our own geocode.
				}

				if ($value_data['area'] == 0 || $value_data['city'] == 0 || $value_data['area'] == '' || $value_data['city'] == '') {
					write_log("Incorrect area/city. area:" . $value_data['area'] . ', city:' . $value_data['city'] . ' for mls: ' . $value_data['mls'] . ", Add failed.\r\n");
					$skiplisting = true;
				}
			}


			if (array_key_exists($data['propertytype'], $dwelling_type_map)) {
				$value_data['type'] = $dwelling_type_map[$data['propertytype']]; // try the specific building type first.
			} else if ($data['type'] == 'Vacant Land') {
				$value_data['type'] = 7;
			} else if ($data['type'] == 'Multi-family') {
				$value_data['type'] = 9;
			} else if ($data['type'] == 'Industrial') {
				$value_data['type'] = 13;
			} else if ($data['type'] == 'Agriculture') {
				$value_data['type'] = 12;
			} else if ($data['type'] == 'Single Family') {
				$value_data['type'] = 1;
			} else if ($data['type'] == 'Business') {
				$value_data['type'] = 51; // 51 is business type major.
			} else if ($data['type'] == 'Office') {
				$value_data['type'] = 52; // 51 is business type major.
			} else {
				write_log("Unknown type at propertytype:" . $data['propertytype'] . ', type:' . $data['type'] . ' for mls: ' . $value_data['mls'] . "\r\n");
				$skiplisting = true;
				// die('unknown type at propertytype:'.$data['propertytype'].', type:'.$data['type']);
				// $value_data['type'] = 99; // default to house?
			}


			$value_data['lot'] = (strpos($value_data['lot'], '|Unknown') !== false ? '' : $value_data['lot']);

			if (stripos($data['saddress'], 'UNIT#') !== false) {
				// has unit #.
				list($saddress, $value_data['unit']) = explode('UNIT#', $data['saddress']);
				$value_data['unit'] = trim($value_data['unit']); // remove excess space etc.
				$saddress = trim($saddress);
			} else {
				$saddress = $data['saddress']; // use full string for address.
			}
			// separate street number from street name.

			echo "Street address to work with :".$saddress."<br />".PHP_EOL;

			list($value_data['unit'], $value_data['number'], $value_data['street']) = separate_unit_number($saddress);
			list($value_data['street_name'], $value_data['street_type'], $value_data['street_dir'], $value_data['street_suffix']) = separate_streetname($value_data['street']);

			$value_data['fullbath'] = $value_data['bathroom'] * 1 - $value_data['halfbath'] * 1;

			if (stripos($data['location_features'], 'Balcony') !== false) {
				$value_data['balcony'] = 'Balcony';
			}

			if (is_array($data['parking_array']) && $value_data['parking'] != '') {
				$value_data['parking'] .= ' (';
				// then loop through types
				if (count($data['parking_array']) == 1) {
					$value_data['parking'] .= $data['parking_array']['Name'];
				} else {
					foreach ($data['parking_array'] as $parkingcount => $parkingspot) {
						if ($parkingcount > 0) $value_data['parking'] .= ', ';
						$value_data['parking'] .= $parkingspot['Name'];
					}
				}
				$value_data['parking'] .= ')';
			}

			if ($data['fireplace'] == 'True') {
				/*
				'FireplaceFuel' => 'fireplace_fuel',
				'FireplacePresent' => 'fireplace', // True of False
				'FireplaceTotal' => 'num_fireplaces',
				'FireProtection' => 'fire_protection'
				*/
				$value_data['fireplace'] = $data['num_fireplaces'] . ($data['fireplace_fuel'] != '' ? ' ' . $data['fireplace_fuel'] : '');
			}

			$value_data['waterfront'] = ($data['waterfront'] == 'Waterfront' ? 1 : 0);

			// process room dimensions.
			/*
			[0] => Array
			(
			[Type] => Master bedroom
			[Width] => Array
			    (
			    )

			[Length] => Array
			    (
			    )

			[Level] => Main level
			[Dimension] => 12' x 17' 2"
			)


        	*/
			if (is_array($data['rooms_array']) && count($data['rooms_array']) > 0) {
				foreach ($data['rooms_array'] as $roomcount => $roomarray) {
					if (is_string($roomarray['Dimension'])) {
						$value_data['dimension'] .= str_replace(';', '', str_replace(':', '', htmlspecialchars($roomarray['Type'], ENT_NOQUOTES))) . ":"
							. str_replace(';', '', str_replace(':', '', htmlspecialchars($roomarray['Dimension'], ENT_NOQUOTES))) . ";";
					}
				}
			}

			$value_data['dimension'] = $mysqli->real_escape_string($value_data['dimension']);
			$value_data['description'] = $mysqli->real_escape_string($value_data['description']);


			if ($get_position) {
				// connect to Google for lat/long
				list($value_data['lat'], $value_data['long']) = google_geocode($data, $value_data);
			}

			$value_data['price'] = preg_replace('/\.00$/', '', dollar_amount_display(remove_all_but_numbers($value_data['price'])));
			// remove the silly .00 at the end!

			$value_data['lot'] = remove_all_but_numbers($value_data['lot']);
			$value_data['frontage'] = remove_all_but_numbers($value_data['frontage']);
			$value_data['depth'] = remove_all_but_numbers($value_data['depth']);
			$value_data['timestamp'] = $now;
			$value_data['phpfile'] = $_SERVER['SCRIPT_NAME'];

			foreach ($value_data as $vdkey => $vdval) {
				if(is_string($vdval)) {
					$value_data[$vdkey] = $mysqli->real_escape_string($vdval); // clean it all up!
				} else {
					echo "Value data returned an array instead of string? <br />".PHP_EOL;
					var_dump($vdval);
				}
			}

			// do update or insert
			if ($skiplisting == false) {
				if ($exists) {
					$update = array();
					foreach ($value_data as $key => $value) {
						$update[] = "`$key` = '$value'";
					}
					write_log("Updating old row " . $old_data['id'] . ", for " . $value_data['mls'] . ".\n");
					$query = "UPDATE `$table` SET " . implode(', ', $update) . " " . $condition;
					$result = $mysqli->query($query);
					$home_id = $old_data['id'];
				} else {
					// insert new record
					write_log("Entering new row for " . $value_data['mls'] . ".\n");
					$query = "INSERT INTO `$table` (`" . implode('`, `', array_keys($value_data)) . "`) VALUES ('" . implode("', '", $value_data) . "')";
					$result = $mysqli->query($query);
					if ($result === false) echo $mysqli->error;
					$home_id = $mysqli->insert_id;
				}
			} else {
				$result = false;
			}


			if ($result!==false) {
				// PHOTO

				// check current photo set timestamp
				$current_timestamp = get_object_gallery_timestamp('home', $home_id);
				$server_timestamp = strtotime(str_replace('T', ' ', $data['last_image_trans_date'])); // CREA has T in there.
				echo "Server photo timestamp: ".$server_timestamp."<br />".PHP_EOL;
				if ($current_timestamp < $server_timestamp || strtotime($old_data['modify_date'])<=strtotime($value_data['modify_date'])) {

//					flush_photo_json($home_id);

					// we don't use rets_get_photos() for CREA DDF, since the photo URLs are returned in a nested array.
					// We don't nee dto make a getObject query for "Photos" in CREA DDF settings.

					if (is_array($photos_array) && count($photos_array) > 0) {
						echo "Writing " . count($photos_array) . " photos into the system for " . $home_id . " (" . $value_data['mls'] . ")<br />";
						$rets_import_params['rets_timestamp'] = $server_timestamp;
						$rets_import_params['use_external_url'] = true; // CREA RETS uses raw data!
						$rets_import_params['idr'] = $home_id;
						$rets_import_params['address'] = $address;
						$photos = crea_photos_to_rets_format($photos_array, $rets_import_params);

						$rets_import_result = rets_import_photos($photos, $rets_import_params, true);

//						foreach ($photos as $pcount => $photo) {
//
//
//							$number = $pcount . ''; // just start from 0, now ignoring the SequenceId as it seems unreliable?
//							write_log("Processing # {$number} of " . count($photos_array) . " photos for home ID: $home_id (MLS: " . $value_data['mls'] . ")\n");
//
//							$file_name = url_format($address . ' ' . ($number < 10 ? '0' . $number : $number)) . '.jpg';
//							if ($photo['LargePhotoURL'] != '') {
//								$file_name = url_format($address . ' ' . ($number < 10 ? '0' . $number : $number)) . '.jpg';
//
//								// this is the new URL based feed from CREA DDF, without feeding the JPG binary content as a long string.
//								$tmp_path = $photo['LargePhotoURL'];
//								echo "Processing raw URL into S3: " . $photo['LargePhotoURL'] . "<br />" . PHP_EOL;
//
//								write_log("Fetching URL: {$photo['LargePhotoURL']} into {$home_id}/{$file_name}\n");
//
//								$gallery_image = attach_gallery_image('homes', $home_id, $file_name, $tmp_path, 'Photo ' . $number);
//								// $w_ok = @file_put_contents("{$image_dir}{$home_id}/{$file_name}", $photo['Data']);
//								if ($pcount == 0) {
//									$mls_photo_sql = "UPDATE `homes` SET `mls_photo`='" . $photo['LargePhotoURL'] . "' WHERE `id` = '$home_id'";
//									$mysqli->query($mls_photo_sql);
//								}
//								write_log("processing image ({$file_name}) into S3 bucket for $home_id\n");
//
//								if ($gallery_image !== false) {
//									write_log("insert image ({$file_name}) for $home_id\n");
//								} else {
//									write_log("image insert failed on for  photo # {$number} for $home_id\n");
//								}
//								if (file_exists($tmp_path)) unlink($tmp_path); // remove temp file!
//							} else {
//								write_log("Invalid JPG at {$photo['LargePhotoURL']}, reply codes: {$photo['ReplyCode']} = {$photo['ReplyText']}\n");
//							}
//						}

						$json_photos = get_object_photos('homes', $home_id);
						if(is_array($json_photos)) {
							write_log("Freshly downloaded ".count($json_photos)." photos and wrote JSON for home ID ".$home_id.PHP_EOL);
							write_photo_json($home_id, $json_photos);
						} else {
							write_log("JSON Write failed. $json_photos returned type ".gettype($json_photos)." for home ID ".$home_id.PHP_EOL);
						}

					} else {
						// no new photos, skipping the loop result from the RETS server for $photos var
						echo "No photos for " . $home_id . '<br />';
					}
				} else {
					// photo timestamp has not been updated - leave photos as is.
					echo "Photos did not change at all for " . $home_id . "<br />";
				}
			} else {
				write_log($data['sysid'] . ' - ' . $mysqli->error . $query . "\n");
			}
			ob_flush();
		}
	}
}

// log summary
foreach ($summary as $type => $type_data) {
	foreach ($type_data as $range => $value) {
		$log = sprintf("%-30s %-30s %5d\n", $type, $range, $value);
		write_log($log);
	}
}

retsrunning_close();
$stop_time = time();
$execute_time = ($stop_time - $start_time) / 60;
write_log("Execution time: $execute_time mins\n");

// close connections
if (!empty($handle)) {
	fclose($handle);
}

$rets->Disconnect();

if ($mysqli->ping()) {
	$mysqli->close();
}


