<?
/*
gathers non-building linked detached homes.
*/
if($_GET['hash']=='58300774') {
	require_once '../start.php';
	require_once '../admin/admin_functions.php';

	// Log, override from whats in cron_functions.php
	$log_file = 'logs/groupbuilding_' . $now . '.log';
	if (is_writable(dirname($log_file))) {
		$handle = fopen($log_file, 'a+');
	} else {
		$handle = null;
	}

	require_once 'cron_functions.php';

	getRetsRunning(); // it will kill this instance, if another one is running already.

	include '../admin/includes/retsimport_vars.php';// loads up all cities etc.

	// gather property types that should have building types
	// (`type`=2 OR `type`=3 OR `type`=4 OR `type`=6)
	$bulidingtypequery = '(';
	foreach($settings['building_type'] as $key=>$buildingtype) {
		if($key>0) {
			$bulidingtypequery.=' OR ';
		}
		$bulidingtypequery.='`type`='.$buildingtype;
	}
	$bulidingtypequery.=')';

	$binsertcount = 0;
	$binsertmax = 1000;// cap it at 1000 per day.

	$hmatchcount = 0;
	$hmatchmax = 10000;// cap it at 1000 per day.
	foreach($cities as $cityid=>$cityname) {
		// loop through one city at a time.

		/*
		The next block gathers all buildings into an array, much similar to the load_cities() function so that we don't need multiple queries each time a building is crawled.
		*/
		$query['cityid'] = $cityid;
		$orderby = array('mainid','feature', 'id');
		$orderasc = array('DESC', 'DESC', 'DESC');
		$buildingresults = get_buildings($query, $orderby, $orderasc, 1000000, '', false, true);
		// get buildings in city ID first.
		if(is_array($buildingresults) && count($buildingresults)>0) {
			foreach ($buildingresults as $bkey => $bdata) {
				$thisbuilding = new building;
				$thisbuilding->initialize($bdata['id'], $bdata); // load off data array,much faster.

				$buildings[$thisbuilding->id] = array(
					'name' => $thisbuilding->name,
					'streetname' => strtolower($thisbuilding->street_name),
					'streettype' => strtolower($thisbuilding->street_type),
					'street_dir' => strtolower($thisbuilding->street_dir),
					'street_suffix' => strtolower($thisbuilding->street_suffix),
					//'street_number' => $thisbuilding->number,
                    'address' => strtolower($thisbuilding->number . ' ' . strtolower($thisbuilding->street_name) . ' ' . strtolower($thisbuilding->street_type)) ?: "", // explicitly fallback to empty string
					'id' => $thisbuilding->id,
					'feature' => ($thisbuilding->feature == 1 || $thisbuilding->data['mainid'] > 0 ? true : false)
				);
			}
		}

		write_log("Found ".(is_countable($buildingresults) ? count($buildingresults) : '0')." count of buildings in city ".$cityname." (".$cityid.") \r\n");

		$homessql = "SELECT COUNT( * ) AS cnt, GROUP_CONCAT( CAST( Id AS CHAR ) ) AS ids 
	FROM `homes` WHERE `city`='".$cityid."' AND `number`!='' AND (`building`='' OR `building`=0 OR `building` IS NULL) AND ".$bulidingtypequery." AND `publish`=1 GROUP BY `number`, `street_name`, `city`, `street_dir` ORDER BY `feature` DESC, `create_date` DESC, `id` DESC"; // gather all home IDs by blank building ID, and that are either condo/townhome/home.
	// note that for situations like Tracey where multiple addresses of HOUSES are part of a complex, the $buildingtypequery must e modified by changing $settings['building_type'] to include houses as well.. will slow things down a bit but what can we do...
		$homesresult = $mysqli->query($homessql);
		if($homesresult->num_rows>0) {
			while($homes = $homesresult->fetch_assoc()) {
				if($hmatchcount>$hmatchmax) {
					write_log("No more home matches today as we reached ".$hmatchcount." for the day.\r\n");
					continue;
				}
				unset($homesarray);
				// because we are grouping homes by address, and returning the list of IDs as array, we cannot use the data=true method for preload.
				$homesarray = explode(',',$homes['ids']);
				$home = new home;
				$home->initialize($homesarray[0]); // pick out first home as object so we can start processing the values on it.
				// now process the street name stuff.
				list($street_name, $street_type, $street_dir, $street_suffix) = separate_streetname($home->street); // this will contain the direction, type etc. all!
				$homeaddress = strtolower($home->number.' '.$street_name.' '.$street_type); // for conciseness, we compare the number/street separately, then compare the suffixes, types through better array matching. For xample, if we do straigth string comparison, ave and Avenue will mis-mach.

				$buildingmatch = 0; // set buidling match to false by default.

				$comparisonmessage = "Checking home ".$home->id." at ".$home->street." (MLS#: ".$home->mls."), using comparison string ".$homeaddress." and dir: ".($home->data['street_dir']!='' ? $home->data['street_dir'] : '[blank]').($street_suffix!='' ? ', suffix:'.$street_suffix : '[blank]')." against all buildings.";

				write_log($comparisonmessage."\r\n");

				foreach($buildings as $bid=>$barray) {
					if($buildingmatch==0) {

						if($barray['address']==$homeaddress
							&& ($street_dir=='' || compare_street_dir($street_dir, $barray['street_dir'] )==true)
							&& ($street_suffix=='' || compare_street_dir($street_suffix, $barray['street_suffix'])==true)
						) {
							$buildingmatch = $barray['id']; // found an address match!
							// echo '<strong>'.$barray['address'].($barray['street_suffix']!='' ? ' '.$barray['street_suffix'] : '[blank]').'</strong> = building address ===== MATCHED home address <strong>'.$homeaddress.($street_suffix!='' ? ', suffix '.$street_suffix : '[blank]').'</strong> and building ID is '.$buildingmatch.'<br />';
							write_log("Building at ".$barray['address']." MATCHED home address ".$homeaddress.", street dirs were home: ".($home->data['street_dir']!='' ? $home->data['street_dir'] : '[blank]') .($street_suffix!='' ? ', Suffix: '.$street_suffix : '[blank]')." and building: ".($barray['street_dir']!='' ? $barray['street_dir'] : '[blank]').", Suffix: ".($barray['street_suffix']!='' ? $barray['street_suffix'] : '[blank]')." so setting to ".$buildingmatch." for home address ".$home->fulladdress."\r\n");
						} else {
							// did not match.. do nothing, unless we want to log this mis-match for troubleshooting purposes.
	/*
							if($home->id==33243) {
								write_log("Building at ".$barray['address']." DID NOT MATCH home address ".$homeaddress.", street dirs were home: ".$home->data['street_dir'].", and building: ".$barray['street_dir']." \r\n");
							}
	*/
						}
					}
				}

				if($buildingmatch) {
					// matching building in the city has been found!
					// echo "Found building id ".$buildingmatch." at address ".$buildings[$buildingmatch]['address']." for listing ".$home->address.".<br />";
					$buildingid = $buildingmatch; // set up $buildingid to the matched building so that it can be udpated later down.
				} else if($binsertcount<$binsertmax) {
					if($home->data['number']!='' && $home->data['street']!='') {
						$streetinsert = $mysqli->real_escape_string($home->street);
						$streetnameinsert = $mysqli->real_escape_string($home->street_name);
						$streettypeinsert = $mysqli->real_escape_string($home->street_type);
						$streetsuffixinsert = $mysqli->real_escape_string($home->street_suffix);

						$building = array(
							'number'=>$home->data['number'],
							'street_dir'=>$home->data['street_dir'],
							'street'=>$streetinsert,
							'street_name'=>$streetnameinsert,
							'street_type'=>$streettypeinsert,
							'street_suffix'=>$streetsuffixinsert,
							'city'=>$home->data['city'],
							'area'=>$home->data['area'],
							'lat'=>$home->data['lat'],
							'long'=>$home->data['long'],
							'create_date'=>$now,
							'modify_date'=>$now,
							'timestamp'=>$now,

						);

						$buildingid = insert_to_table('buildings',$building);

						if(is_numeric($buildingid)) {
							$binsertcount++;

							$thisbuilding = new building;
							$thisbuilding->initialize($buildingid);

							// add new building to the $buildings array that initially retrieved buildings, avoids entry of multiple buildings.
							$buildings[$thisbuilding->id] = array(
								'streetname'=>strtolower($thisbuilding->street_name),
								'streettype'=>strtolower($thisbuilding->street_type),
								'street_dir'=>strtolower($thisbuilding->street_dir),
								'street_suffix'=>strtolower($thisbuilding->street_suffix),
								//'street_number' => $thisbuilding->number,
								'address'=>strtolower($thisbuilding->number.' '.strtolower($thisbuilding->data['street_name']).' '.strtolower($thisbuilding->street_type)),

								'id'=>$thisbuilding->id,
								'feature'=>false
							); // push to building array in case there's other listings that match with slight variations of street directions etc.

							// echo 'No matching building between '.$home->fulladdress.'; Inserted new building '.$insertsql.'<br />';
							write_log("Inserted new building (".$insertsql.") generating building id ".$thisbuilding->id." after ".$home->fulladdress."). This building address is ".$thisbuilding->fulladdress." \r\n");
						} else {
							write_log("Error: Building insert SQL failed: ".$buildingid.")\r\n");
						}

					} else {
						write_log("Error: New building NOT created from home ID #".$home->id.", full address: ".$home->fulladdress."). Incomplete data!\r\n");
					}


				} else {
					write_log("No more inserts today as we reached ".$binsertcount." for the day.\r\n");
					// echo $binsertcount.' inserts for day, aborting new inserts, only matches.!';
				}

				// FINALLY update the homes at this address IF the building ID is valid
				if($buildingid!='' && $buildingid!=false && $binsertcount<$binsertmax) {
					$homeidcount = 0;
					$homeidfilter = '';
					$hmatchcount++;

					foreach($homesarray as $homeid) {
						if($homeidcount>0) {
							$homeidfilter.= ' OR ';
						}
						$homeidfilter.=" `id`='".$homeid."'";
						$homeidcount++;
					}
					$hmatchcount = $hmatchcount + $homeidcount;
					$updatesql = "UPDATE homes SET building='".$buildingid."' WHERE ".$homeidfilter;
					$mysqli->query($updatesql);
					$memcache_params = array(
						'type'=>'building',
						'objectid'=>$buildingid
					);
					get_memcache($memcache_params, 'delete');
				}
			}
		} else {
			write_log("No attached types of homes at ".$cityname." (".$cityid.") found to be detached.\r\n");
		}
	} // end of loopiong thorugh cities.
	echo "{success}Scanned through ".count($cities)." and matched them up.<br />\n";
	echo "{created}".$binsertcount."<br />\n";
	echo "{attached}".$hmatchcount."<br />\n";
} else {
	echo "{failure}Hash validation failed?";
}

$mysqli->close();

retsrunning_close();

$stop_time = time();
$execute_time = ($stop_time - $start_time) / 60;
write_log("Execution time: $execute_time mins\n");


?>