<?php

require_once '../start.php';
require_once '../admin/admin_functions.php';

$centos_db = '44.225.158.42:3306';

$twodays = date($mysql_time['day'], strtotime('-1 day'));

mysqli_report(MYSQLI_REPORT_STRICT);
try {
//	echo "User: ".$mysql_user."<br />".PHP_EOL;
//
//	echo "Pass: ".$mysql_pass."<br />".PHP_EOL;
//
//	echo "Table: ".$mysql_table."<br />".PHP_EOL;
//
//	echo "SErver: ".$centos_db."<br />".PHP_EOL;

	$mysqli_centos = new mysqli($centos_db, $mysql_user, $mysql_pass, $mysql_table);
	// If connection is successful, assign $mysqli_rds to $mysqli
} catch (mysqli_sql_exception $e) {
	echo $e->getMessage();
	echo "<br />";
	// Catch errors related to the RDS connection
	if(strpos($e->getMessage(), 'Access denied')!==false || strpos($e->getMessage(), 'Connection refused')!==false) {
		echo "Check the database settings! (" . $mysqli_centos->connect_errno . ") " . $mysqli_centos->connect_error;
		die("Centos DB connection failed.");
	} else {
		echo "Unknown MySQL Error: ".$e->getMessage();
		die("");
	}
}
$mysqli_centos->query("SET SESSION sql_mode = 'NO_ENGINE_SUBSTITUTION,NO_AUTO_CREATE_USER';");

$targets = array(
	'pages'=>array(
		'fetch_columns'=> array(
			'title',
			'title2',
			'menu_title2',
			'content',
			'content2',
			'excerpt2'
		),
		'replace_columns' => array(
			'title2',
			'menu_title2',
			'content2',
			'excerpt2'
//			'content'
		),
		'timestamp'=>'modify_date',
	),
	'homes'=>array(
		'fetch_columns'=> array(
			'street',
			'heading2',
			'description2'
		),
		'replace_columns'=>array(
			'heading2',
			'description2'
		),
		'timestamp'=>'modify_date',
	),

	'agents'=>array(
		'fetch_columns'=> array(
			'fname2',
			'lname2',
			'mname2'
		),
		'replace_columns'=>array(
			'fname2',
			'lname2',
			'mname2'
		),
		'timestamp'=>'modify_date',
	)
);

foreach($targets as $table => $target) {
	$sql = "SELECT `id`";
	foreach($target['fetch_columns'] as $columncount => $column) {
		$sql.=", `".$column."`";
	}
	$sql.=" FROM `".$table."` WHERE `id`!='' ";

	if(isset($target['timestamp'])) {
		$sql.=" AND `".$target['timestamp']."`<'".$twodays."'";
	}

	if(isset($target['where']) && is_array($target['where'])) {
		$sql.=" AND `".$target['where']['column']."`".$target['where']['condition'];
	}

	if(isset($target['notblank'])) {
		$sql.=" AND `".$target['notblank']."` !='' ";
	}
	// Query build complete, execute to get old one from CENTOS and new one from local.
	$centos_result = $mysqli_centos->query($sql);
	if($centos_result->num_rows>0) {
//		$centos_data[$table] = array();
		while($centos_rows = $centos_result->fetch_assoc()) {
			$centos_data[$table][$centos_rows['id']] = $centos_rows;
		}
	} else {
		$centos_data[$table] = false;
	}

	$local_result = $mysqli->query($sql);
	if($local_result->num_rows>0) {
//		$local_data[$table] = array();
		while($local_rows = $local_result->fetch_assoc()) {
			$local_data[$table][$local_rows['id']] = $local_rows;

		}
	} else {
		$centos_data[$table] = false;
	}
}


foreach($centos_data as $table=>$rows) {
	$local_rows = $local_data[$table];
	foreach($rows as $rowid => $row) {
		// can do row by row comparison!
		if(isset($rowid) && $rowid>0) {

			$updatesql = "UPDATE `".$table."` SET ";
			$changecount = 0;
			foreach($targets[$table]['replace_columns'] as $replacecolumn) {
				if(isset($local_rows[$rowid]) && $row[$replacecolumn] != $local_rows[$rowid][$replacecolumn] && $row[$replacecolumn]!='') {
					echo $replacecolumn." (Centos): ".$row[$replacecolumn]."<br />".PHP_EOL;
					echo $replacecolumn." (AlmaDB): ".$local_rows[$rowid][$replacecolumn]."<br />".PHP_EOL;
					$updatesql .= ($changecount>0 ? ", " : "")."`".$replacecolumn."`='".$mysqli->real_escape_string($row[$replacecolumn])."'";
					$changecount++;
				}
			}

			if($changecount>0) {
				if(isset($targets[$table]['timestamp'])) {
					$updatesql .= ", `".$targets[$table]['timestamp']."`='".$now."'";
				}
				$updatesql.=" WHERE `id`=".$rowid;

				echo "ID: ".$rowid." (".$table.")<br />".PHP_EOL;
				echo $updatesql."<br />";
				if(isset($_REQUEST['commit']) && $_REQUEST['commit']==1) {
					$updateresult = $mysqli->query($updatesql);
					if (!$updateresult) {
						// Query failed, display the error message
						echo "Error executing (ID: ".$rowid."): " . $mysqli->error . "<br />";
					}
				}
				echo PHP_EOL.PHP_EOL;
			}
		}
	}
}

echo "<h4>Custom Fields:</h4>";
$custom_fields_sql = "SELECT `id`, `page`, `name`, `value` FROM `custom_fields` WHERE `value` !='' ORDER BY `page` ASC";
$custom_fields_result = $mysqli_centos->query($custom_fields_sql);

while($custom_field = $custom_fields_result->fetch_assoc()) {
	echo $custom_field['id']." on page ".$custom_field['page']." (".$custom_field['name']."): ".$custom_field['value']."<br />".PHP_EOL;
}

?>