<?php
/*
Filename: retsimport.php

Method: CRON or DIRECT
Output: RAW TEXT & WRITE LOG

Description: Fetches listings from MLS main servers in JSON, then enters it into child websites.

*/

$seconds_to_cache = 0; // override to 0 cache! this has to be fresh each time!

$addonly = (isset($_REQUEST['addonly']) && $_REQUEST['addonly']==1 ? true : false); // see if we are just adding today's listings only!

if($_GET['hash']=='58300774') {
	require_once '../start.php';
	require_once '../admin/admin_functions.php';

	require_once 'cron_functions.php';

	getRetsRunning(); // it will kill this instance, if another one is running already.


	// Log this import instance.
	$log_file = 'logs/import_'.($addonly===true ? 'today_'.$today : str_ireplace(' ', '_', $now)).'.log';
	if (is_writable(dirname($log_file))) {
		$handle = fopen($log_file, 'a+');
	} else {
		$handle = null;
	}


	if($settings['mls_integrated']!=1) { // this also checks if MySQL connection is successful or not.
		retsrunning_close();
		die('{disabled}NO RETS ENABLED!');
	} else {
		echo "{mlsurl}".$settings['mls_import_url'].PHP_EOL;
		write_log("Fetching via ".$settings['mls_import_url'].PHP_EOL);
	}


	include '../admin/includes/retsimport_vars.php';// loads up all cities etc.
	$table = 'homes';

	/* CITY/SUBAREA upgrades on vancouver.brixwork.com!
	East Vancouver
	Grandview VE => Grandview Woodland
	*/

	/*

	$homescleansql = "UPDATE `homes` SET `modify_date`='2000-11-01 00:00:00' WHERE `area`='0'";
	// SELECT * FROM `homes`  WHERE `city`='45' OR `area`='328'
	// UPDATE `homes` SET `modify_date`='2000-11-01 00:00:00' WHERE `city`='45' OR `area`='328'
	$mysqli->query($homescleansql);
	write_log("Running ".$homescleansql." to clean out area=0 homes and affected ".$mysqli->affected_rows." rows!\n");
	*/


	/* 2019-06 - TEMPORARY FIX FOR Edmonton MLS with Granville_EDMO type of subares cleaned to Granville
	// remove asinine subarea names like Granville_EDMO to Granville
	if(strpos($settings['mls_import_url'], 'edmonton')>0 && strpos($settings['mls_import_url'], 'edmonton')!==false) {
		$four_char_pattern = '/_[A-Za-z]{4}$/';

		$sql = "SELECT `id`, `name` FROM `subareas`";
		$result = $mysqli->query($sql);
		while($areas = $result->fetch_assoc()) {

			$preg_result = preg_match($four_char_pattern, $areas['name']);
			// echo 'Check ID '.$areas['id'].'<br />';
			if($preg_result===1) {
				$newname = preg_replace($four_char_pattern, '', $areas['name']);
				// echo $areas['name'].' to '.$newname.'<br />';
				$updatesql = "UPDATE `subareas` SET `name`='".$newname."' WHERE `id`='".$areas['id']."'";
				//echo $updatesql.'<br />';
				$mysqli->query($updatesql);
			}
		}
	}

	*/

	// get the IDs and the MLS # in an array
	// preload id, mls# and source for processing later.
	$sql = "SELECT `id`, `mls`, `source`, `masterid`, `publish`, `feature`, `agent_1`, `agent_2`, `agent_3`, `create_date`, `modify_date`, `price`, `openhouse`, `mls_photo_timestamp`, `mls_photo`, `city`, `area`, `lat`, `long` FROM `homes` WHERE `mls`!=''";
	// only compare listings with proper MLS data input.
	// we include source=0 listings in this case as well inc ase there's price changes from MLS.
	// OWN listings (source=0) are still appended to a certain degree.
	$ownhomes = array(
		'published'=>0,
		'hidden'=>0,
	);
	$mlshomes = array(
		'published'=>0,
		'hidden'=>0,
	);

	$insertcount = 0;

	$memcache_params = array(
		'type'=>'listing'
		// memcache foundation.
		// For different rows we can set 'listingsource' to 0 or 1,
		// 'objectid' or 'mlsnum' as parameters, depending on 'listingsource' value.
	);


	$result = $mysqli->query($sql);
	if($result->num_rows>0) {
		while($array = $result->fetch_assoc()) {
			$homes[$array['mls']] = array(
				'id'=>$array['id'],
				'exists'=>false, // for now set this to false - so that if the remote JSON feed does not contain this, this is marked for disable then removal.
				'publish'=>$array['publish'],
				'feature'=>$array['feature'],
				'source'=>$array['source'],
				'city'=>$array['city'],
				'area'=>$array['area'],

				'lat'=>$array['lat'],
				'long'=>$array['long'],

				'masterid'=>$array['masterid'],
				'agent_1'=>$array['agent_1'],
				'agent_2'=>$array['agent_2'],
				'agent_3'=>$array['agent_3'],
				'modify_date'=>$array['modify_date'],
				'price'=>$array['price'],
				'openhouse'=>$array['openhouse'],
				'mls_photo_timestamp'=>$array['mls_photo_timestamp'],
				'mls_photo'=>$array['mls_photo']
			);
			// prepare count for logging to do before/after comparison!
			if($array['source']=='1') {
				if($array['publish']==1) {
					$mlshomes['published']++;
				} else {
					$mlshomes['hidden']++;
				}
			} else {
				if($array['publish']==1) {
					$ownhomes['published']++;
				} else {
					$ownhomes['hidden']++;
				}
			}
		}
	} else {
		$homes = array(); // blank array, probaly only for the very first run.
	}

	if($addonly===true) {
		write_log($now . PHP_EOL);
		write_log( "### - Start addonly MLS Sync - ###".PHP_EOL);
	}

	write_log("Start source=1 homes: ".($mlshomes['published'] + $mlshomes['hidden'])." (published: ".$mlshomes['published']."/ hidden: ".$mlshomes['hidden'].")<br />\r\n");
	write_log("Start source=0 homes: ".($ownhomes['published'] + $ownhomes['hidden'])." (published: ".$ownhomes['published']."/ hidden: ".$ownhomes['hidden'].")<br />\r\n");

	$hiddencitycleancount = 0;
	foreach($hiddencities as $cityid=>$cityname) {
		if($hiddencitycleancount<2) {// only 2 at a time...
			$hiddencitypublishsql = "UPDATE `homes` SET `modify_date`='2000-01-01 00:00:00' WHERE `city`='".$cityid."'";
			$hiddencitypublishresult = $mysqli->query($hiddencitypublishsql);
			$affected_rows = $mysqli->affected_rows;
			if($affected_rows>0) {
				// only 2 at a time so keep adding to $hiddencitycleancount as we get more headcounts of clean up.
				$hiddencitycleancount++;
			}
		}
	}


	$agent_ids = array();

	// prepare agent IDs from agents table.
	$agentsql = "SELECT id, agentid FROM `agents` WHERE publish=1";
	$agentsresult = $mysqli->query($agentsql);
	if($agentsresult->num_rows>0) {
		while($agents = $agentsresult->fetch_assoc()) {
			if($agents['agentid']!='') {
				$agent_ids[$agents['id']] = strtolower($agents['agentid']); // lowercase it for comparison.
			}
		}
	}


// get agent IDs to match against from settings table ONLY if multi agent module is NOT enabled.
	if(is_array($settings['agent_id'])) {
		foreach($settings['agent_id'] as $aid) {
			$agent_ids[] = $aid;
		}
	} else if($settings['agent_id']!='') {
		$agent_ids[] = $settings['agent_id'];
	}

	// first try to get files from the new Cloudfront->S3 URL'd versions!
	// Then fall back?
	echo "Fetch original URL from ".$settings['mls_import_url']."<br />".PHP_EOL;

	// Get URL & Timestamp from the raw source (cannot cloudfront this, we need lateasts timestamp).
	$retsexport_url = curl_get_file_contents($settings['mls_import_url'].'admin/api/retsexport.php?hash=58300774&retsexport_url=1','GET', '', 10000);

	if(preg_match('/^{success}/',$retsexport_url)) {
		$retsexport_url = substr($retsexport_url,9,strlen($retsexport_url)-9);
		echo "ZIP file located at ".$retsexport_url."<br />".PHP_EOL;
	} else {
		echo "{failure}Failed to fetch ZIP file URL!<br />\n";
		retsrunning_close();
		die('Failed to acquire ZIP file URL, got '.$retsexport_url.' from retsexport.php from '.$settings['mls_import_url']);
	}

	// Will get something like:
	// https://d2c1z9m2a98rxn.cloudfront.net/vancouver.brixwork.com/retsexport/2019-08-11/retsexport.zip

	$tmppath = '../tmp/';
	if(!is_writable($tmppath)) {
		$chmodresult = chmod($tmppath, 0755);
	} else {
		$chmodresult = true;
	}

	if($chmodresult) {
		echo "temp folder permission fine.<br />\n";
	} else {
		echo "temp folder permission <strong>Broken - failed to update</strong>.<br />\n";
		retsrunning_close();
		die('Abort, public_html/tmp folder cannot accept download of retsexport.zip.');
	}

	$contents = curl_get_file_contents(trim($retsexport_url),'GET', '', 10000);

	$filename = 'retsexport.zip';
	echo "Saving ZIP to ".$tmppath.$filename."<br />".PHP_EOL;

	if(stripos($contents, '</html>') || stripos($contents, '<Code>NoSuchKey</Code>')) {
		echo '{Failure:'.$contents."}<br />\r\n";
	} else {
		$zipfile = fopen($tmppath.$filename, "w");
		fwrite($zipfile, $contents);
		fclose($zipfile);
		write_log("Successfully saved local ZIP at ".$tmppath.$filename." - onto extract.".PHP_EOL);

		// unzip the archive!
		$extractcount = 0;

		$zip = new ZipArchive;
		$res = $zip->open($tmppath.$filename);

		if($res===TRUE){
			$tree = "";
			$ziprow = 0;
			while($zip_entry = $zip->statIndex($ziprow)) {
				if(preg_match('/\.log$/', $zip_entry['name'])) {
					if (strpos($zip_entry['name'], DIRECTORY_SEPARATOR) !== false) {
						// filepath contains directory separator such as /
						$last = strrpos($zip_entry['name'], DIRECTORY_SEPARATOR); // get the last slash.. so we can get teh filename out.
						$dir = substr($zip_entry['name'], 0, $last); // this is the folder path before file.
						$file = substr($zip_entry['name'], strrpos($zip_entry['name'], DIRECTORY_SEPARATOR) + 1);
						if (!is_dir($tmppath . $dir)) {
							// echo $zip_entry['name']." - Create Folder!<br />";
							@mkdir($tmppath . $dir, 0755, true) or die("Unable to create $dir<br />");
						}
						if (strlen(trim($file)) > 0) {
							// echo $zip_entry['name']." - Write!<br />";
							$filecontent = $zip->getFromIndex($ziprow);

							if (strlen($filecontent) == 0) {
								$filecontent = ' '; // empty file, but do NOT return FALSE, force it to be a string so that file_put_contents doesn't return an error.
							}
							$return = @file_put_contents($tmppath . $dir . "/" . $file, $filecontent); // -3, -4, -5...

							if ($return == false || $return == 0) {
								// echo 'return did not work well?';
								die("{failure}Unable to write file " . $tmppath . $dir . "/" . $file . "<br />" . PHP_EOL);
							} else {
								$extractcount++;
							}
						}
					} else {
						$file = $zip_entry['name'];
						file_put_contents($tmppath . $file, $zip->getFromIndex($ziprow));
						$extractcount++;
					}
				} else {
					echo "Cannot write anything but .log files here, skipping ".$zip_entry['name'].PHP_EOL;
				}
				ob_flush();
				$ziprow++;
			}
			$zipdelete = unlink($tmppath.$filename);
			write_log(($zipdelete==true ? 'Successfully deleted' : 'Failed to delete')." ".$tmppath.$filename.PHP_EOL);
		}

		$zip->close();
		write_log("Unzipped ".$extractcount." .log files!".PHP_EOL);
		echo "{success}retsexport.zip file processed in tmp with ".$extractcount." logs extracted!<br />\n";
	}

	// now unzip this?

	write_log("Starting starting snc. current timestamp is ".$now.PHP_EOL);

	// first get area/city mainframe!
	$retsfolder = 'retsexport/';
	$citiesarrayfile = 'citiesarray.log';

	$filecontents = file_get_contents($tmppath.$retsfolder.$citiesarrayfile);
	$mlsdefaultareas = unserialize($filecontents);
	if(is_array($mlsdefaultareas)) {
		write_log("Fetched ".count($mlsdefaultareas)." default MLS areas, continuing.".PHP_EOL);
		echo "Fetched ".count($mlsdefaultareas)." default MLS areas, continuing.<br />".PHP_EOL;
		unlink($tmppath.$retsfolder.$citiesarrayfile);
	} else {
		write_log("Failed to JSONify ".$settings['sitepath']."tmp/".$retsfolder.$citiesarrayfile.", abort.".PHP_EOL);

		retsrunning_close();
		die('Cities array JSONification failed!');
	}

	foreach($mlsdefaultareas as $mlscityname=>$subareasarray) {
		// $mlscityname contains full city name such as 'vancouver west'
		// subareasarray is keyed polygon.
		if(is_array($subareaswithpolygon)) {
			foreach($subareaswithpolygon as $subareakey=>$subareawithpolygon) { // now loop WITHIN the polygonned subareas (presumably this list will shrink a LOT with each iteration.

				//echo 'comparing '.strtolower($subareawithpolygon->city).' and '.strtolower($subareawithpolygon->name).' with '.$mlscityname.'<br/>';

				if(
					in_array(strtolower($subareawithpolygon->name), $subareasarray)
					&& strtolower($subareawithpolygon->city) == $mlscityname
				) {
					// compare the lowercase of CITY & SUBAREA to ensure that they are both match.. soem cities have same subarea names across different cities! For example Abbotsford has the balls to call their town centre "Downtown"  with more tractor dealerships than other parts of Abby.
					//echo 'Match found, unsetting<br/>';
					unset($subareaswithpolygon[$subareakey]);// unset this array?

				} else {
					//echo 'NO MATCH FOUND, CUSTOM SUBAREA!<br/>';
				}
			}
		}
	}

	if($addonly===true) {
		write_log("Adding new listings only, nothing old.\n");
	}


	// connect to RETS server
	$blanksubareacount = 0;
	$importcount = 0; // start total imported homes count at 0.
	$chunkcount = 0; // start at chunkccount 0.
	$endoffiles = false;
	while($endoffiles===false) {
		$retsfilename = 'export-'.$today.'-'.$chunkcount.'.log'; // cycle thorugh each log file under it.
		// $filecontents = curl_get_file_contents($importurl.'admin/api/retsexport.php?hash=58300774&chunk='.$chunkcount,'GET', '', 10000);
		if(file_exists($tmppath.$retsfolder.$retsfilename)) {
			$filecontents = file_get_contents($tmppath.$retsfolder.$retsfilename);
			$array = unserialize($filecontents);
			if(is_array($array)) { // make sure it starts with "{success}" to validate feed,
				echo 'Opened '.$retsfilename.' and retrieved '.count($array)." feed items.<br /><br />\n";
				write_log('Opened '.$retsfilename.' and retrieved '.count($array)." feed items at ".PHP_EOL);
				// process the new entries..
				foreach ($array as $key => $listing) {
					$agentmatch = false;// first set to false by default.

					if($settings['commercial_enabled']!=1 && $listing['type']>=50) {
						// write_log("Commercial listing skip ".$listing['mls']." (Local: ".$homes[$listing['mls']]['id'].", Master: ".$homes[$listing['mls']]['masterid'].") : Property last updated ".$homes[$listing['mls']]['modify_date'].", since commercial_enabled is ".$settings['commercial_enabled']."\n");
						continue; 	// skip this loop of property IF the modified date comparison shows that it doesn't need to be updated.
					} else {
						// commerical IS enabled.. see if we block residential in converse?
						if($settings['residential_disabled']==1 && $listing['type']<50) {
							// write_log("Residential listing skip ".$listing['mls']." (Local: ".$homes[$listing['mls']]['id'].", Master: ".$homes[$listing['mls']]['masterid'].") : Property last updated ".$homes[$listing['mls']]['modify_date'].", since residential_disabled is ".$settings['residential_disabled']."\n");
							continue; 	// skip this loop of property IF the modified date comparison shows that it doesn't need to be updated.
						}
					}

					if($addonly!==true) {
						write_log("Found MLS Number " . $listing['mls'] . PHP_EOL);
					}

					// now trigger the custom filters on each site
					// certain client sites can filter out specific listings they want to keep the database lean.
					// This can be custom programmed into includes/config.php?
					$endoffilter = 0;
					$filterallow = 1;
					$lastfilter = '';
					if(isset($mls_override_filter) && is_array($mls_override_filter) && count($mls_override_filter)>0) {
						foreach($mls_override_filter as $filter) {
							if($listing[$filter[0]]==$filter[1] && $endoffilter == 0) {
								$filterallow = $filter[2]; // set whether this listing is allowed to go through or not.
								$lastfilter = $filter[0].'='.$filter[1];
								if($filter[3]==1) {
									$endoffilter = 1;
								}
							}
						}
					}

					if($filterallow == 0) {
						write_log("Skipping ".$listing['mls'].", Filter matched for ".$lastfilter.".\n");
						echo "Skipping ".$listing['mls'].", Filter matched for ".$lastfilter.".<br />\n";
						continue;
					} else if($lastfilter!='') {
						write_log("Including ".$listing['mls']." as exception, Filter matched for ".$lastfilter.".\n");
						echo "Including ".$listing['mls']." as exception, Filter matched for ".$lastfilter.".<br />\n";
					}

					if(array_key_exists($listing['mls'], $homes)) {
						$homes[$listing['mls']]['exists']=true; // mark home as existing so it doesn't get disabled!
					}


					// compare listings to $settings['agent_id'] array, or aggregate of the `agents` table in MySQL.
					if(is_array($agent_ids) && count($agent_ids)>0) {

						if(array_key_exists($listing['mls'], $homes)) {
							// if listing already exists in local, then port in the current agent ID (internal reference to `agents` table.
							$listing['agent_1'] = $homes[$listing['mls']]['agent_1'];
							$listing['agent_2'] = $homes[$listing['mls']]['agent_2'];
							$listing['agent_3'] = $homes[$listing['mls']]['agent_3'];
						} else {
							// start by blank agent IDs fro INTERNAL reference (note these are NOT the board assigned agent IDs).
							$listing['agent_1'] = '';
							$listing['agent_2'] = '';
							$listing['agent_3'] = '';
						}

						// Then start comparing agent IDs provided by board, to local agent IDs.
						if(in_array(strtolower($listing['realtor_id_1']), $agent_ids) && $listing['realtor_id_1'] != '') {
							$agentmatch = true;
							$listing['agent_1'] = array_search(strtolower($listing['realtor_id_1']), $agent_ids);
							write_log("Agent match found on realtor 1: ".$listing['agent_1']." (ID: ".$listing['realtor_id_1'].") for MLS ".$listing['mls'].".\n");
							echo "Agent match found on realtor 1: ".$listing['agent_1']." (ID: ".$listing['realtor_id_1'].") for ".$listing['mls'].".<br />\n";
						}
						if(in_array(strtolower($listing['realtor_id_2']), $agent_ids) && $listing['realtor_id_2'] != '') {
							$agentmatch = true;
							$listing['agent_2'] = array_search(strtolower($listing['realtor_id_2']), $agent_ids);
							write_log("Agent match found on realtor 2: ".$listing['agent_2']." (ID: ".$listing['realtor_id_2'].") for ".$listing['mls'].".\n");
							echo "Agent match found on realtor 2: ".$listing['agent_2']." (ID: ".$listing['realtor_id_2'].") for ".$listing['mls'].".<br />\n";
						}
						if(in_array(strtolower($listing['realtor_id_3']), $agent_ids) && $listing['realtor_id_3'] != '') {
							$agentmatch = true;
							$listing['agent_3'] = array_search(strtolower($listing['realtor_id_3']), $agent_ids);
							write_log("Agent match found on realtor 3: ".$listing['agent_3']." (ID: ".$listing['realtor_id_3'].") for ".$listing['mls'].".\n");
							echo "Agent match found on realtor 3: ".$listing['agent_3']." (ID: ".$listing['realtor_id_3'].") for ".$listing['mls'].".<br />\n";
						}
					}

                    // prep data - add fallback to the data
                    $listing['openhouse'] = $listing['openhouse'] ?? '';

					$listing['publish'] = 1; // pubish is 1 by default

					unset($update); // unset the update var so nothing weird happens - flush the whole var array out!
					$updatephotos = 0; // set photo update flag to negative by default. If this listing is OWN listing, it shouldn't get photos overridden.

					/* First check if polygon match occured. polygons are all custom subareas, so assume this needs to be published. Decide what city & subarea to fall under */
					$cityareafound = false; // first, set cityareafound flag to false.
					if(count($subareaswithpolygon)>0) {
						// there are polygoned results, let's check homes against it.
						reset($subareaswithpolygon); // go back to beginning of array.
						foreach($subareaswithpolygon as $subareawithpolygon) {
							if($subareawithpolygon->listing_in_polygon($listing['lat'].','.$listing['long'])) {
								$listing['area_alt'] = $subareawithpolygon->id; // keep the polygon as area_alt, then keep it the same.
								$listing['city'] = $subareawithpolygon->area; // select the city that this subarea is supposed to belong to according to owner of site.
								$cityareafound = true;
								write_log($listing['lat'].",".$listing['long']." found in custom polygon subarea ".$subareawithpolygon->name.". (for home: ".$listing['mls']."): \n");
								echo $listing['lat'].','.$listing['long'].' was found in to '.$subareawithpolygon->name.".<br />\n";
							}
						}
					}

					$value_data['city'] = $listing['cityname'];
					$value_data['area'] = $listing['areaname']; // areaname will be kept as per default MLS area names, custom polygons are under area_alt.

					if($listing['areaname']=='') {
						$blanksubareacount++;
//						echo "blank subarea count++ on ".$listing['areaname']."<br />";
					}

					// custom polygon search of city didn't return, so do conventional match of city/area.
					// if the Agent ID is found, it should publish it anyway (and set the city to publish=1) since it's his/her own listing.
					if($cityareafound===false) {
						// polygon search results didn't return.. match by string name, the conventional way.
						// Match up city/area first.
						list($listing['area'], $listing['city']) = match_cities($value_data, $cities, $subareas); // regular city/area as per MLS.

						if(in_array(strtolower($value_data['city']), $hiddencities) &&
							(
								// if listings already imported (local source=1) but the listing is not yet featured,
								(array_key_exists($listing['mls'], $homes) && $homes[$listing['mls']]['feature']==0)
								||
								// or sipmly a brand new listing that is not local yet,
								!array_key_exists($listing['mls'], $homes)
							)
						) {
							// then we check if the listing needs to be kept unpublished if its' a hidden city listing, UNLESS the agent match happened. 
							// Listing is in a hidden city, AND the realtor hasn't bothered to feature this reciprocity listing.
							if($agentmatch===true) {
								// agent has a listing, but teh city is currently hidden.
								// publish the city!
								$city_publish_sql = "UPDATE `areas` SET `publish`=1 WHERE `id`='".$listing['city']."'";
								$mysqli->query($city_publish_sql);
								write_log("Enabling city ".$listing['city']." for ".$value_data['city']." since agent has a listing there.\n");
								echo $city_publish_sql."<br />".PHP_EOL;
							} else {
								$homes[$listing['mls']]['exists']=false; // trigger removal by setting the exists flag as FALSE if this listing was found in hidden city.. UNLESS the listing is featured!
								// write_log("Hidden city found at ".$value_data['city']." for ".$listing['cityname']." so marking this old listing for removal.\n");
								continue; // skip this!
							}
						}
					} else {
						// polygon found something, but still get the primary area in.
						list($listing['area'], $discard['city']) = match_cities($value_data, $cities, $subareas); // the area becomes the default MLS area, while area_alt has the custom subarea based on polygon. City is kept the same was what polygon belongs in.
						if($listing['area']==$listing['area_alt'] && $discard['city']==$listing['city']) {
							// area alt and area both identical... don't bother with alt area?
							// it already perfectly matches the MLS setting
							unset($listing['area_alt']);
						}
					}

					/*
					 * Finally, compare the modify date and price/lat/lng for source=1 listings to see if it needs to be udpated or not.
					 * If the unpublished city filter has kicked in to set this listting to exists==false, it will remove near the end of script.
					 * DO NOT alter the exists==true/false flag here at all.
					 * */
					// finally check date of modification - see if it even needs update or not,
					// write_log("Modify date check for RETS Master ID: ".$listing['masterid'].") , Local UID: ".$homes[$listing['mls']]['id'].": \n");
					if($addonly===true && array_key_exists($listing['mls'], $homes) && $homes[$listing['mls']]['source']==1) {
						// we're seeking to rapidly add new listings only quickly.
						$homes[$listing['mls']]['exists']=true;
						// echo "Adding new listings only, leave exisitng ones alone without comparison.<br />\n";
						continue;
					} else if(
						array_key_exists($listing['mls'], $homes)
						&& strtotime($homes[$listing['mls']]['modify_date'])==strtotime($listing['modify_date'])
						&& $homes[$listing['mls']]['mls_photo_timestamp']==$listing['mls_photo_timestamp']
						&& $homes[$listing['mls']]['lat']==$listing['lat']
						&& $homes[$listing['mls']]['long']==$listing['long']
						&& $homes[$listing['mls']]['masterid'] == $listing['masterid']
						&& $homes[$listing['mls']]['mls_photo'] == $listing['mls_photo']
						&& $homes[$listing['mls']]['publish']==1
						&& $homes[$listing['mls']]['city']!='0'
						&& (
							($homes[$listing['mls']]['openhouse']==$listing['openhouse']
							&& $homes[$listing['mls']]['source']==BRIX_LISTING_MLS)
							||
							($listing['openhouse']==''
								&& $homes[$listing['mls']]['source']==BRIX_LISTING_OWN)
						)
						&& $agentmatch === false
					) {
						/*
						 * Skip this listing update if it should exist and the modify date is fine.
						 * */
						// write_log("Skip ".$listing['mls']." (ID: ".$homes[$listing['mls']]['id'].", MID: ".$homes[$listing['mls']]['masterid'].") : Local mod: ".$homes[$listing['mls']]['modify_date'].", server mod: ".$listing['modify_date'].". MLS Photo local: ".$homes[$listing['mls']]['mls_photo_timestamp'].", MLS photo server: ".$listing['mls_photo_timestamp']."\n");
						continue; 	// skip this loop of property IF the modified date comparison shows that it doesn't need to be updated.
					}

					write_log("Fully process RETS listing: " . $listing['mls'] . " (Local ID: " . (array_key_exists($listing['mls'], $homes) && $homes[$listing['mls']]['id'] != '' ? $homes[$listing['mls']]['id'] : 'New') . ", Master ID: " . $listing['masterid'] . "): \n");

					// if virtual tour URL is Youtube or vimeo, CONVERT to youtube and DITCH virtual tour!
					if(getyoutubeid($listing['virtualtour'])!==false) {
						$listing['youtube'] = getyoutubeid($listing['virtualtour']);
						$listing['virtualtour'] = '';
					} else if(getvimeoid($listing['virtualtour'])!==false) {
						$listing['vimeo'] = getvimeoid($listing['virtualtour']);
						$listing['virtualtour'] = '';
					}

					// actual time/date when it was processed into THIS website.
					// Note that create_date and modify_date reflect the activities of source=1 listings on the
					// MLS mainframe servers such as vancouver.brixwork.com or toronto.brixwork.com, not the local site.
					// This timestamp gives us insight on WHEN it was imported into the CLIENT's individual site, regardless of when it was popped up on the MLS mainframe.
					$listing['timestamp'] = date($mysql_time['full'],time()); // don't use $now, since this might take a few minutes so use the real time eaach moment.

					// echo 'MLS ('.$listing['mls'].') photo timestamp: '.$listing['mls_photo_timestamp'].", Local timestamp: {$homes[$listing['mls']]['mls_photo_timestamp']}<br />\n";

					if(!array_key_exists($listing['mls'], $homes) || !is_array($homes)) {
						// none found on local `homes` table, import this row.
						// set up additional data such as modify date etc.

						$listing['source'] = 1; // MLS integrated listings are source=1 as well
						$homeid = form_to_table($table,$listing);
						if(is_int($homeid)) {
							$homes[$listing['mls']]['exists']=true; // mark as exists = true to avoid removal.
							$homes[$listing['mls']]['id']=$homeid;
							$homes[$listing['mls']]['source'] = 1;
							$insertcount++;
							$mlshomes['published']++; // add 1 to MLS published homes.
							write_log("Freshly Inserted ".$homeid." for ".$listing['mls'].".\n");
						} else {
							write_log("Failed to insert MLS# ".$listing['mls'].", msg: ".$homeid.PHP_EOL);
						}

					} else if($addonly!==true) { // the previous $addonly filter should prevent the script from even getting to this point!
						$homes[$listing['mls']]['exists']=true; // mark as exists = true to avoid removal.
						// listing found with the MLS # in the client's website - determine method of overwriting!
						if($homes[$listing['mls']]['source']==BRIX_LISTING_MLS) {
							// source 1 = override it all, update it.
							unset($listing['ord']);// excludes the 'ord' column from the  array, therefore NOT overriding it.
							$homeid = form_to_table($table,$listing,$homes[$listing['mls']]['id']);
							if(is_numeric($homeid)) {
								$memcache_params['listingsource'] = 1;
								$memcache_params['mlsnum'] = $listing['mls'];
								get_memcache($memcache_params, 'delete');
								write_log("Updated ".$homeid." as source=1 listing. (".$listing['mls'].", Source: ".$homes[$listing['mls']]['id'].", MLS photo timestamp:".$listing['mls_photo_timestamp'].").".PHP_EOL);
							} else {
								write_log("Error updating source=1 listing. (".$listing['mls']."): ".$homeid.PHP_EOL);
								if($homeid===false) {
									write_log("MySQL Error: ".$mysqli->error.PHP_EOL);
								}
							}
						} else {
							// source=0 lisitngs, limited updates
							// so we dont' override heading or desc that was expanded beyond MLS restrictions.
							$listingupdate = array(); // blank out previous!
							// source has been udpated to 0.. but updates such as price changes should be reflected.
							if(remove_all_but_numbers($homes[$listing['mls']]['price']) != remove_all_but_numbers($listing['price'])) {
								$listingupdate['price'] = $listing['price']; // update the price only.
							}

							if($homes[$listing['mls']]['openhouse']=='' && $listing['openhouse']!='') {
								// update openhouse ONLY if the openhouse on local is blank!
								// this is useful when the OH gets flushed out sunday night/monday morning by cron,
								// and teh agent isn't setting new ones each week. Then just take the MLS defaults.
								$listingupdate['openhouse'] = $listing['openhouse']; // Get new non-blank open house
							}
							if($agentmatch===true &&
								($homes[$listing['mls']]['agent_1']!=$listing['agent_1']
								|| $homes[$listing['mls']]['agent_2']!=$listing['agent_2']
								|| $homes[$listing['mls']]['agent_3']!=$listing['agent_3'])
							) { // disabling this.. why would the listing agent ever change?
								$listingupdate['agent_1'] = $listing['agent_1'];
								$listingupdate['agent_2'] = $listing['agent_2'];
								$listingupdate['agent_3'] = $listing['agent_3'];
							}
							if(count($listingupdate)>0) {
								$listingupdate['timestamp'] = $now;
								$listingupdate['phpfile'] = $_SERVER["SCRIPT_FILENAME"];
								$homeid = form_to_table($table,$listingupdate,$homes[$listing['mls']]['id']);
								if(is_numeric($homeid)) {
									$memcache_params['listingsource'] = 0;
									$memcache_params['objectid'] = $homes[$listing['mls']]['id'];
									get_memcache($memcache_params, 'delete');
									write_log("Updated ".$homeid." as source=0 listing. (".$listing['mls'].", Source: ".$homes[$listing['mls']]['id'].", MLS photo timestamp:".$listing['mls_photo_timestamp'].").".PHP_EOL);
								} else {
									write_log("Error updating source=0 listing. (".$listing['mls']."): ".$homeid.PHP_EOL);
									if($homeid===false) {
										write_log("MySQL Error: ".$mysqli->error.PHP_EOL);
									}
								}
							} else {
								write_log("No changes to ".$homeid." (source=0 listing). (".$listing['mls'].", Source: ".$homes[$listing['mls']]['id'].", MLS photo timestamp:".$listing['mls_photo_timestamp'].").".PHP_EOL);
							}
						}
					}

					// convert to own listing with agent ID match.
					if($agentmatch===true && $homes[$listing['mls']]['source']==1 && ($settings['autoconvert_agent_listings']!=0 && isset($settings['autoconvert_agent_listings'])===true)) {
						// matches this user, fresh input.
						$ownhome = new home;
						$ownhome->initialize($homeid);
						$convertresult = $ownhome->convert_ownlisting();
						// taken 1 count away from mlshomes, 1 added to ownhomes as we convert.
						$memcache_params['listingsource'] = 1;
						$memcache_params['mlsnum'] = $listing['mls'];
						get_memcache($memcache_params, 'delete'); // expire the mls type memecache.

						$ownhomes['published']++;
						$mlshomes['published']--;
						write_log("Converted ".$convertresult[1]." from input ".$homeid." to ownlisting with return code ".$convertresult[0].":\"".$convertresult[2]."\"\n");
						//write_log("Would have Converted input ".$insertid." for MLS ".$listing['mls']." to ownlisting.\n");
					}
				}
				$deletelog = unlink($tmppath.$retsfolder.$retsfilename);
				write_log("Finished chunk ".$chunkcount." and ".($deletelog===true ? 'deleted' : 'failed to delete')." ".$tmppath.$retsfolder.$retsfilename." .\n");
				$importcount = $importcount+count($array);

				ob_flush(); // empty cache?

				$chunkcount++;

			} else {
				// broken JSON file? Exists, but no dice!
				write_log('Bad JSON result from '.$retsfilename.': '.$array." returned from server. Killing.".PHP_EOL);
				retsrunning_close();
				die("{failure}Poor JSON result from log file, abort.<br />\n");
			}
		} else {
			$endoffiles = true;
			// end of .log files, move onto disable/removal filtration. Imports successful!!!
		}
	} // end of while loop for each 2,000 chunk or wahtever it is.

	$disablecount = 0;
	$deletecount = 0;
	if($importcount>12 && $addonly===false) {
		// we only run the home removal script after successful imports... at least a dozen.
		// also, $addonly should be false to run this (saves time on rapid per-hourly runs of new listings add.
		$disablesql = "UPDATE `".$table."` SET publish=0, modify_date='".$now."' WHERE source='1' AND (";
		$deletesql = "DELETE FROM `".$table."` WHERE source='1' AND (";

		foreach($homes as $key=>$home) {
			if($home['exists']==false && $home['source']==1) {
				// make sure we exclude the source=0 from this.. only source=1 listings get removed automatically.
				// home marked as non-existent from the master server, and modified more than 5 days ago. Delete it.
				if($home['publish']==0 && strtotime($home['modify_date'])+(3600*24*5)<$local) {
					if($deletecount>0) {
						$deletesql .=" OR ";
					}
					$deletesql .= "id='".$home['id']."'";
					unset($homes[$key]); // remove from the master array var for the final count
					// no need for remove_object() function since it does not have photos attached etc. Just Build the $deletesql.
					write_log("Removing ".$home['id']." with MLS # ".$key.", inactive since ".$home['modify_date']."  \n");

					$deletecount++;
				} else if($home['publish']==1) { // curently published. UN publish.
					if($disablecount>0) {
						$disablesql .=" OR ";
					}
					$disablesql .= "id='".$home['id']."'";
					$homes[$key]['publish'] = 0; // set publish to 0 on this one on master array.
					write_log("Disabling ".$home['id']." with MLS # ".$key.".<br />\n");


					$disablecount++;
				}
				// whether we delete, or disable, empty cache so publish=1 shows, or it delete whole thing.
				$memcache_params['listingsource'] = 1;
				$memcache_params['mlsnum'] = $key; // contains MLS # in array key.
				get_memcache($memcache_params, 'delete');

			}
		}
		$disablesql.=")";
		$deletesql.=")";
		if($disablecount>0) {
			$mysqli->query($disablesql);
			$affected_rows = $mysqli->affected_rows;
			// remove the disabled count from published, add it back to hidden.
			$mlshomes['published'] = $mlshomes['published'] - $disablecount;
			$mlshomes['hidden'] = $mlshomes['hidden'] + $disablecount;
			write_log("Disable query ran and unpublished ".$affected_rows." homes.\n");
			echo "{success}Disabled  ".$affected_rows." freshly inactive listings.<br />\n";
		}
		if($deletecount>0) {
			$mysqli->query($deletesql);
			$affected_rows = $mysqli->affected_rows;
			$mlshomes['hidden'] = $mlshomes['hidden'] - $deletecount;

			write_log("Deletion query ran and removed ".$affected_rows.".".PHP_EOL);
			echo "{success}Deleted  ".$affected_rows." long-time dormant listings.<br />\n";
		}
		echo "{success}MLS feed import successful from ".$chunkcount." txt file chunks.<br />\n";
	} else {
		echo "{".($addonly===true ? 'success' : 'failure')."}(".($addonly===true ? 'Adding new listings, added '.$insertcount.' rows.': 'Insufficient listing count, abort disable/removal.').")<br />\n";
		retsrunning_close();
		write_log("Not running listing disable/removal. ".($addonly===true ? 'Adding Only': 'Insufficient listing count.')."\n");
	}
	write_log("Insert count was ".$insertcount." <br />".PHP_EOL);
	write_log("New source=1 homes: ".($mlshomes['published'] + $mlshomes['hidden'])." (published: ".$mlshomes['published']."/ hidden: ".$mlshomes['hidden'].")".PHP_EOL);
	write_log("New source=0 homes: ".($ownhomes['published'] + $ownhomes['hidden'])." (published: ".$ownhomes['published']."/ hidden: ".$ownhomes['hidden'].")".PHP_EOL);

} else {
	echo "{failure}Unauthorized Access<br />\n";
	retsrunning_close();
}


retsrunning_close();

$stop_time = time();
$execute_seconds = $stop_time - $start_time;
write_log("Execution time: $execute_seconds seconds".PHP_EOL);

if($addonly===true) {
	write_log("".PHP_EOL.PHP_EOL);
}

echo "{duration}".$execute_seconds."<br />\n";

include_once $_SERVER['DOCUMENT_ROOT'].'/end.php';

?>