<?

/*
The agents_roster_prep.php is an interesting insertion.
Unlike listings_prep, or showlisting_prep, it's not a stand-alone - it should be added on TOP of a regular page.
The right structure would be to:
include $_SERVER['DOCUMENT_ROOT'].'/includes/pages_prep.php';
include $_SERVER['DOCUMENT_ROOT'].'agents_roster_prep.php';

*/

// first process the filename that is runnign this. Default is listings.php
$agentsfilename = str_ireplace('.php','', $filename);

if($agentsfilename=='') {
	$agentsfilename = 'agents'; // when it doubt... default to listings.php file.
}


// $body['id'] and $body['data']['pageid'] are set up by pages_prep.php loaded before agents_roster_prep.php = $thispage->id;
$body['type'] = BRIX_PAGE_TYPE_AGENT_ROSTER;
$body['data']['type'] = BRIX_PAGE_TYPE_AGENT_ROSTER;

$params =  parse_pagevars($agentsfilename); // parses URL variables to $param. Not filtered to $query yet.

if($_GET['debug']==1) {
	echo 'RAW PARAMS:<br />';
	if(is_array($params)) {
		foreach ($params as $pkey => $pvar) {
			echo '<strong>[' . $pkey . ']</strong> = ' . $pvar . '<br />';
		}
		reset($params);
	}
}

if(!isset($defaultperpage)) {
	$defaultperpage = 10; // default # of agents per page.
}


if(!isset($defaultquery)) {
	$defaultquery = array(
		'publish'=>1
	); // Default should be all published agents.
}

if(!isset($defaultorderby)) {
	$defaultorderby = array(
		'ord'
	); // MOst brokerages we have are smaller... so just 'ord' is fine.
}

if(!isset($defaultorderdirection)) {
	$defaultorderdirection = array(
		'ASC'
	); // Default $defaultorderby, used when it's just .com/listings/ 
}

if(!isset($searchfilter)) {
	$searchfilter = array(
	); // Default $searchfilter, in 99% of cases it will filter for homes that are set to sold=0 to show active listings during MLS searches. This can include cities etc. 
}

if(!isset($searchorderby)) {
	$searchorderby = array(
		'lname',
		'fname'
	); // Default $searchorderby, used if the user triggers a search.
}

if(!isset($searchorderdirection)) {
	$searchorderdirection = array(
		'ASC',
		'ASC'
	); // Default $searchorderdirection, used for MLS search results as default if not set. 
}

if(!isset($blanketfilter)) {
	$blanketfilter = array(
		'publish'=>1
	); // Default $blanketfilter, in 99% of cases it will filter for homes that are set to PUBLISH, naturally.
}


$perpage = $defaultperpage;

/* DEFAULTS SET UP COMPLETE! */

$query = param_to_query($params); // filter which of the $params work as listing $query vars. 


if(!is_array($query)) {
	// $query is blank, so fall back to default, featured listings of all sold statuses.
	$query = $defaultquery;
	$perpage = $ownlistingperpage;
	$order_by = $defaultorderby;
	$order_direction = $defaultorderdirection;
} else {// queries given, so process otherwise.

	if($params['order_by']!='') {
		$order_by = $params['order_by'];
	} else {
		$order_by = $searchorderby;
	}

	if($params['order_direction']!='') {
		$order_direction = $params['order_direction'];
	} else {
		$order_direction = $searchorderdirection;
	}
}

$query = array_merge($query, $blanketfilter); // put teh final blanket filter that should go on ALL websites.. mainly publish=1
// final query for agents!


if(DEBUG===true) {
	echo $order_by.' ,'.$order_direction;
	echo '<br />';
	echo $perpage.' per page.<br />';
	print_r($query);
}

?>