<?
	// determine body ID first. 
	if($body['id']!='') {
		$body_id = $body['id'];
	}
	
	if($body['type']!='') {
		$body_type = $body['type']; // is this a listing page? just a listing? building? 
	} else {
		$body_type = BRIX_PAGE_TYPE_GENERIC_PAGE; // assume it's a page.
	}

    $body_class = 'pagetype_'.$body_type; // start default pagetype_[type] class first.

    if($body_type == BRIX_PAGE_TYPE_GENERIC_PAGE) {
        // it's a generic page, so let's set classes based on hierarchy, parents etc.
        // This allows coding team to set styles of certain child pages to be a certain look etc.
        if(is_object($thispage) && $thispage->directparent!='') {
            $body_class .= ' page_directparent_'.$thispage->directparent;
        }

        if($thispage->topparent!='') {
            $body_class .= ' page_topparent_'.$thispage->topparent;
        }

        foreach($thispage->parents as $parentid) {
            $body_class .= ' page_parents_'.$parentid;
        }
    }

    // add in any additional classes specified by the coder on the template in question.
    if(is_array($body['classes'])) {
        // additional css classes fed in as array.
        foreach($body['classes'] as $class) {
            $body_class .= ' '.trim(removespecialquotes($class));
        }
    } else if($body['classes']!='') {
        $body_class .= ' '.trim(removespecialquotes($body['classes']));
    }

	$body_data = '';
	if(is_array($body['data'])) {
		// get data-homeid, etc. going!
		foreach($body['data'] as $datakey=>$dataval) {
			$body_data.=' data-'.$datakey.'="'.strip_tags(trim($dataval)).'"';
		}
	}

	if(isset($visitor) && is_object($visitor) && $visitor->sessionid!==false) {
		$body_data.=' data-sessionid="'.$visitor->sessionid.'"';
	}
	echo '<body id="'.$body_type.'_'.$body_id.'" class="'.$body_class.'"'.$body_data.'>
';
	global $google_tag_manager_id;
	if($google_tag_manager_id!=false) {
		// tag manager was extracted by ga.php
		?>
		<!-- Google Tag Manager (noscript) -->
		<noscript><iframe src="https://www.googletagmanager.com/ns.html?id=<?=$google_tag_manager_id?>">
						  height="0" width="0" style="display:none;visibility:hidden"></iframe></noscript>
		<!-- End Google Tag Manager (noscript) -->
		<?
	}

	// below Facebook code is what creates the basis for the Facebook SDK for the chat widget etc.
	// Other ones can be added manually t
?>
<script>
	window.fbAsyncInit = function() {
		FB.init({
			appId            : '<?=($settings['facebook_app_id']!='' ? $settings['facebook_app_id'] : '169674796472240')?>',
			autoLogAppEvents : true,
			xfbml            : true,
			version          : 'v3.2'
		});
	};

	(function(d, s, id){
		var js, fjs = d.getElementsByTagName(s)[0];
		if (d.getElementById(id)) {return;}
		js = d.createElement(s); js.id = id;
		js.src = "https://connect.facebook.net/en_US/sdk/xfbml.customerchat.js";
		fjs.parentNode.insertBefore(js, fjs);
	}(document, 'script', 'facebook-jssdk'));
</script>


<?
if($settings['body_top_js']!='') {
	echo PHP_EOL."<!-- START of body top JS included through admin -->".PHP_EOL.$settings['body_top_js'].PHP_EOL."<!-- END of body top JS included through admin -->".PHP_EOL;
}
?>
