<?
/*
Filename: buildings_prep.php
Location: /Volumes/Macintosh HD/Users/jeffkee/Documents/Work Docs/Brixwork/Brixwork-for-Realtors/dev/includes

Method: Include
Output: Included variables

Description: Prepares queries that load up buildings (not to be confused with files that load up listings UNDER a specific building, that is still handled by the listings_prep.php as they are a set of listings).
This is more for "collection of presales" type of pages. 

Author: Jeff Kee
*/

// first process the filename that is runnign this. Default is listings.php
$listingsfilename = str_ireplace('.php','', $filename);

if($listingsfilename=='') {
	$listingsfilename = 'presales'; // when it doubt... default to presales.php file.
}

$body['id'] = $thispage->id;
$body['type'] = BRIX_PAGE_TYPE_BUILDING_GALLERY;
$body['data']['type'] = BRIX_PAGE_TYPE_BUILDING_GALLERY;
$body['data']['pageid'] = $thispage->id;

$objecttype = 'building'; // to define that htis pulls in buildings, not listings! 

$params =  parse_pagevars($listingsfilename); // parses URL variables to $param. Not filtered to $query yet. 

if(!isset($defaultpageid) && $params['pageid']=='') {
	// page id has not been set, and there's no default page id for listings page either, so we need to get it.
	// It's recommended to NOT fall back to this, this is one more MySQL query that is NOT necessary. 
	$pagesquery = "SELECT `id` FROM `pages` where `custom_pageurl`='".$mysqli->real_escape_string($listingsfilename)."'";
	$pagesresult = $mysqli->query( $pagesquery);
	$pagesresult->data_seek(0);
	$pagerow = $pagesresult->fetch_row();
	$defaultpageid = $pagerow[0];
}

if(!isset($defaultperpage)) {
	$defaultperpage = 10; // default # of buildings per page. Call $defaultperpage under listings.php to set it otherwise. 
}

if(!isset($defaultquery)) {
	$defaultquery = array(
		'feature'=>1
	); // Default $query, show featured items when in doubt. 
}

if(!isset($defaultorderby)) {
	$defaultorderby = array(
		'ord',
		'name'
	); // Default $defaultorderby, used when it's just .com/buildings/ 
}

if(!isset($defaultorderdirection)) {
	$defaultorderdirection = array(
		'ASC',
		'ASC'
	); // Default $defaultorderby, used when it's just .com/buildings/ 
}

if(!isset($searchfilter)) {
	$searchfilter = array(
	); // Default $searchfilter, in 99% of cases it will filter for homes that are set to sold=0 to show active listings during MLS searches. This can include cities etc. 
}

if(!isset($searchorderby)) {
	$searchorderby = array(
		'ord',
		'street',
		'number'
	); // Default $searchorderby, used for MLS search results as default if not set. 
}

if(!isset($searchorderdirection)) {
	$searchorderdirection = array(
		'ASC',
		'ASC',
		'DESC'
	); // Default $searchorderdirection, used for MLS search results as default if not set. 
}

if(!isset($blanketfilter)) {
	$blanketfilter = array(
		'feature'=>1
	); // Building are shown by whether featured or not.
}

if(!isset($perpage) || $perpage=='' || $perpage=0) {
	$perpage = $defaultperpage;
}
/* DEFAULTS SET UP COMPLETE! */


$query = param_to_query($params); // filter which of the $params work as listing $query vars. 

$language_on = isset($_GET['language']) || isset($_SESSION['language']);

if($params['pageid']!='') {
	// custom page ID is set, go with that.
    if($language_on) {
        $thispage = new bilang_page;
        $thispage->initialize_cust($params['pageid']);
    } else {
        $thispage = new page;
        $thispage->initialize($params['pageid']);
    }
	$pagetitle = $thispage->title.($params['page']!='' ? ' (Page '.$params['page'].')' : '');
	$metatitle = ($thispage->metatitle ? $thispage->metatitle : $thispage->title).($params['page']!='' ? ' ('.$params['page'].')' : '').' - '.$settings['title'];
	$content = $thispage->content;
	$metadescription = ($thispage->description!='' ? $thispage->description : $metatitle.' - '.$settings['tagline']);
	$ogtags['url'] = $thispage->pageurl;
	if(DEBUG===true) {
		echo 'going off page id.<br />';
	}
} else if(is_array($query)) {
	// MLS search query has been passed, so auto-generate based on generate_search_desc() function. 
	list($metatitle, $metadescription) = generate_search_desc($query);
	$pagetitle = $metatitle; // generate_search_desc() puts page # at the end anyway. 
	$metatitle = $metatitle.' - '.$settings['title'];
	$content = $metadescription;

    if($language_on) {
        $thispage = new bilang_page;
        $thispage->initialize_cust($defaultpageid); // MLS search, but set up the $thispage var so we can use it for whatever purposes (top image etc.) even though its content is overridden by the generate_search_desc() function.
    } else {
        $thispage = new page;
        $thispage->initialize($defaultpageid); // MLS search, but set up the $thispage var so we can use it for whatever purposes (top image etc.) even though its content is overridden by the generate_search_desc() function.
    }
	$ogtags['url'] = curpageurl();
	
	if(DEBUG===true) {
		echo 'going off auto generated stuff from search<br />';
	}
} else {
	// default to top listing page
    if($language_on) {
        $thispage = new bilang_page;
        $thispage->initialize_cust($defaultpageid);
    } else {
        $thispage = new page;
        $thispage->initialize($defaultpageid);
    }
	$pagetitle = $thispage->title.($params['page']!='' ? ' (Page '.$params['page'].')' : '');
	$metatitle = ($thispage->metatitle ? $thispage->metatitle : $thispage->title).($params['page']!='' ? ' ('.$params['page'].')' : '').' - '.$settings['title'];
	$metadescription = ($thispage->description!='' ? $thispage->description : $metatitle.' - '.$settings['tagline']);
	$ogtags['url'] = $thispage->pageurl;
	$content = $thispage->content;
	if(DEBUG===true) {
		echo 'going off default';
	}
}

// now that we have page title/content etc. set, let's get to the listing query and other specifics. 


if(!is_array($query)) {
	// $query is blank, so fall back to default, featured listings of all sold statuses.
	$query = $defaultquery;
	$perpage = $defaultperpage;
	$order_by = $defaultorderby;
	$order_direction = $defaultorderdirection;
} else {// queries given, so process otherwise. 
	
	// if city is not set, force to whatever $searchfilter limits to. Useful for most realtors who want van/westvan/northvan but not pitt meadows, surrey etc. 
	if(!array_key_exists('city', $query) && array_key_exists('city', $searchfilter)) {
		$query['city'] = $searchfilter['city'];
	}
	
// if area is not set, force to whatever $searchfilter limits to. Useful for niche websites for pemberton heights etc. 
	if(!array_key_exists('area', $query) && array_key_exists('area', $searchfilter)) {
		$query['area'] = $searchfilter['area'];
	}
	
	// if type is not set, force to whatever $searchfilter limits to. Useful for Lots/condos only websites etc. 
	if(!array_key_exists('type', $query) && array_key_exists('type', $searchfilter)) {
		$query['type'] = $searchfilter['type'];
	}
	
	// if source is set specifically (most likely =1.. because this part only handles mls searches
	if(!array_key_exists('source', $query) && array_key_exists('source', $searchfilter)) {
		$query['source'] = $searchfilter['source'];
	}
	
	if(!array_key_exists('sold',$params) && !array_key_exists('mylisting',$params) && !array_key_exists('ownlisting',$params)) {
		$query['sold']=0;
	}
		
	if($params['order_by']!='') {
		$order_by = $params['order_by'];
	} else {
		$order_by = $searchorderby;
	}
	
	if($params['order_direction']!='') {
		$order_direction = $params['order_direction'];
	} else {
		$order_direction = $searchorderdirection;
	}
}

$query = array_merge($query, $blanketfilter); // put teh final blanket filter that should go on ALL websites.. mainly publish=1

if(DEBUG===true) {
	echo $order_by.' ,'.$order_direction;
	echo '<br />';
	echo $perpage.' per page.<br />';
	print_r($query);
}

?>