<?php
set_include_path(dirname(__FILE__) . "/" . PATH_SEPARATOR . get_include_path());
require_once 'config.inc'; // contains $mysql_host, user etc. etc.

// Finally killing this in 2023, if any site crashes becauase of this they nee dto email us and upgrade.
//if($settings['legacy_mysql']==1) {
//	$db = mysql_connect($mysql_host, $mysql_user, $mysql_pass);
//	mysql_select_db($mysql_table);
//}

/*
 * 2024-01 upgerades to start utilizing RDS on AWS!
 * */
$mysql_host_rds = 'brixwork-m-2023.ctltldql7oq9.us-west-2.rds.amazonaws.com:3306';
// TODO: once all are migrated, simply set to override $mysqli_host with with $mysql_host_rds UNLESS $mysqli_host is not "localhost" for another DB instance.

if($mysql_host!=$mysql_host_rds) {

	mysqli_report(MYSQLI_REPORT_STRICT);

	try {
		$mysqli_rds = new mysqli($mysql_host_rds, $mysql_user, $mysql_pass, $mysql_table);
		// If connection is successful, assign $mysqli_rds to $mysqli
		$mysqli_rds->set_charset("utf8");
		$mysqli = $mysqli_rds;
	} catch (mysqli_sql_exception $e) {
		// Catch errors related to the RDS connection
		if(strpos($e->getMessage(), 'Access denied')!==false || strpos($e->getMessage(), 'Connection refused')!==false) {
			// Access denied will show IF the RDS dose not have the username/db combo,
			// Connection refused is most likely if port 3306 is NOT open on the WHM Firewall rules, or the EC2 to RDS security group config is not set up yet to allow connection .
			$mysqli = new mysqli($mysql_host, $mysql_user, $mysql_pass, $mysql_table);
			if ($mysqli->connect_errno) {
				echo "Check the database settings! (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
				die("Localhost DB connection failed.");
			}
		} else {
			echo "Unknown MySQL Error: ".$e->getMessage();
			die("");
		}
	}
}

mysqli_report(MYSQLI_REPORT_OFF);
//unset($mysql_user, $mysql_pass);
// off strict mode, just basic security.
$mysqli->query("SET SESSION sql_mode = 'NO_ENGINE_SUBSTITUTION,NO_AUTO_CREATE_USER';");
// $mysqli->query("SET SESSION sql_mode = 'STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION';")

// memcache modules
if (extension_loaded('memcache')) {
	$memcache = new Memcache();
	$memcache->addServer('localhost', 11211);
} else if (extension_loaded('memcached')) {
	$memcache = new Memcached();
	$memcache->addServer('localhost', 11211);
} else {
	$memcache = false;
}
/*
 * Notes on compression of memcache
 * The compression threshold etc. cannot be set at PHP script level
 * It has to be in the .ini settings.
 * We haven't changed from default yet as of 2024-05-01
 * https://stackoverflow.com/questions/12953538/php-memcached-client-compression-not-working-while-setting-the-data
 * */

function get_memcache($params, $data=false) {
	global $memcache;
	global $settings;
	// Merging of all memcache function allows use to have ONE function that generates the key for different data types and listings (MLS or OWN).
	// if $data is false (or, not fed) - DEFAULT - it means fetch, and return fail if we don't have it stored.
	// if $data is string or array, it means set it (enter it into the cache).
	// if $data=='delete', then we delete the memcache (no longer needs separate delete_memcache function.

	$type = trim((isset($params['type']) ? $params['type'] : false)); // if type is false, simply return false and reject atttempt.
	$objectid = (isset($params['objectid']) ? intval($params['objectid']) : false); // this can be blank, in case of page cache calls.

	// more detailed parameters for listing calls - source=0 and source=1 listings have different key structures to avoid duplicate MLS #s causing issues.
	$listingsource = (isset($params['listingsource']) ? intval($params['listingsource']) : false);
	$mlsnum = trim((isset($params['mlsnum']) ? $params['mlsnum'] : (isset($params['mls']) ? $params['mls'] : false)));

	// $query and $order/by params for get_properties, get_buildings query results.
	$query = (isset($params['query']) ? $params['query'] : false);

	if($memcache!==false) {

		if($query!==false) {
			ksort($query);
		}

		switch($type) {
			case "page":
			case "pages":
				$key = parse_url($settings['sitepath'], PHP_URL_HOST); // Cannot use get_host() since functions.php calls it later.
				$key.='-'.BRIX_PAGES_CACHE;
				$cache_expiry = 0; // unlimited.
			// entire page cache stored. No need for $objectid.
				break;
			case "pagephotos":
			case "page_photos":
				if($objectid!==false) {
					$key = parse_url($settings['sitepath'], PHP_URL_HOST);
					$key.='-page_photos-';
					$key.=$objectid;
					$cache_expiry = 0; // unlimited.
				} else {
					echo 'Error: pagephotos memcache needs $data nor $objectid set!<br />'.PHP_EOL;
					$return = false;
				}
				break;
			case "listing":
			case "home":
				if($listingsource===BRIX_LISTING_MLS && $mlsnum!==false) {
					/*
					 * source=1 (MLS Reciprocity) listing. USe MLS # with rets_import_url as base to prevent duplicate MLS #s.
					 * Note that constant BRIX_LISTING_MLS is 1. This is simply more verbose. ==1 would work just the same.. never changes.
					 * and BRIX_LISTING_OWN == 0, naturally.
					 * */

					$key = parse_url($settings['mls_import_url'], PHP_URL_HOST); // get just vancouver.brixwork.com or whatever to use same cache for same MLS feed.
					$key.='-mls-'; // to make it easier to read on debug.
					$key.=$mlsnum; // always use dashes for IDs.
					$cache_expiry = 3600 * 30; // 30 days for now.
					// $cache_expiry = 120; // 2 mins only during test cause i can't wait a month - works well!
					if(DEBUG==true) {
						echo "MLS Listing memcache key: " . $key . " (exp in ".$cache_expiry." seconds)<br />" . PHP_EOL;
					}
				} else if($listingsource===BRIX_LISTING_OWN && $objectid!=false) {
					// source=0 (OWN) listing.
					$key = parse_url($settings['sitepath'], PHP_URL_HOST);
					$key.='-home-'; // to make it easier to read on debug..
					$key.=$objectid; // always use dashes for IDs.
					$cache_expiry = 0; // unlimited.
					if(DEBUG==true) {
						echo "OWN Listing memcache key: " . $key . " (exp in ".$cache_expiry." seconds)<br />" . PHP_EOL;
					}
				} else {
					echo 'Error: When creaeting memcache for a listing, we need at least $mlsnum or $objectid set, with $listingsource defined!<br />'.PHP_EOL;
					print_r($params);
				}
			break;
			case "homephotos":
			case "home_photos":
				if($objectid!==false) {
					// This only runs for source=0 listings with rows in `photos` table.
					// MLS (source=1) listings call the JSON file remotely that feeds URLs of photos on Cloudfront.
					// The JSON URL is cached in the listing memcache.
					$key = parse_url($settings['sitepath'], PHP_URL_HOST);
					$key.='-home_photos-';
					$key.=$objectid;
					$cache_expiry = 0; // unlimited.
				} else {
					echo 'Error: listingphoto memcache needs $data and $objectid set!<br />'.PHP_EOL;
					$return = false;
				}
			break;
			case "agent":
				$key = parse_url($settings['sitepath'], PHP_URL_HOST);
				$key.='-agent-'; // to make it easier to read on debug..
				$key.=$objectid; // always use dashes for IDs.
				$cache_expiry = 0; // unlimited.
			break;
			case "agentphotos":
			case "agent_photos":
				if($objectid!==false) {
					// This only runs for source=0 listings with rows in `photos` table.
					// MLS (source=1) listings call the JSON file remotely that feeds URLs of photos on Cloudfront.
					// The JSON URL is cached in the listing memcache.
					$key = parse_url($settings['sitepath'], PHP_URL_HOST);
					$key.='-agent_photos-';
					$key.=$objectid;
					$cache_expiry = 0; // unlimited.
				} else {
					echo 'Error: agentphoto memcache needs $data and $objectid set!<br />'.PHP_EOL;
					$return = false;
				}
				break;
			case "building":
				// single building object!
				$key = parse_url($settings['sitepath'], PHP_URL_HOST);
				$key.='-building-'; // to make it easier to read on debug.
				$key.=$objectid; // always use dashes for IDs.
				$cache_expiry = 0; // unlimited.
				break;
			case "buildings":
				/* Muliple builings from get_buildings() result, EXCEPT subbuildings.
				This array covers many parameters such as
				feature
				status
				city
				subarea
				Also caches subbuildings, etc.
				*/
				$key = parse_url($settings['sitepath'], PHP_URL_HOST);
				$key.='-bldg-'; // to make it easier to read on debug. And keep shorter, as this gets $query vars added.
				$qcount = 0;
				foreach($query as $q=>$v) {
					if($qcount>0) {
						$key.=';';
					}
					$key.=$q.':'.$v;
					$qcount++;
				}
				$cache_expiry = 3600; // These are dynamic queries, so just expire them every hr.
				break;
			case "buildingphotos":
			case "building_photos":
				if($objectid!==false) {
					// This only runs for source=0 listings with rows in `photos` table.
					// MLS (source=1) listings call the JSON file remotely that feeds URLs of photos on Cloudfront.
					// The JSON URL is cached in the listing memcache.
					$key = parse_url($settings['sitepath'], PHP_URL_HOST);
					$key.='-building_photos-';
					$key.=$objectid;
					$cache_expiry = 0; // unlimited. These are only changed in the /admin, so we just manually expire.
				} else {
					echo 'Error: buildingphoto memcache needs $data and $objectid set!<br />'.PHP_EOL;
					$return = false;
				}
				break;
			default:
				if(DEBUG==true) {
					echo "Error: Memcache needs the type key set in params var.<br />".PHP_EOL;
				}
				$key = false;
		}
			/*
			 * We mpw jave a $key for the memcache object type and object ID (if applicable)
			 * $data is what determines whether we fetch ,set, or purge.
			 * */
		if(is_string($key) && strlen($key)>5) {
			if($data===false) {
				$return = $memcache->get($key);
				if(DEBUG==true) {
					echo "Attempt to get memcache key: ".$key.", retrieved ".(is_array($return)  ? count($return)." ROW array" : ($return===false ? 'FALSE' : 'EMPTY'))."<br />.".PHP_EOL;
				}
				// return the memcache data.
			} else if($data=='delete') {
				$return = $memcache->delete($key);
				if(DEBUG==true) {
					echo "Delete memcache key: ".$key.", result was ".($return===true ? 'success' : 'fail')."<br />.".PHP_EOL;
				}
				// return the success or fail of delete.
			} else if(isset($data)) {
				// apparently, setting same key again creates duplicate results, rather than replace...
				// SEe argyleblanket's comment on https://www.php.net/manual/en/memcache.set.php#84032
				$memcachestore = $memcache->replace($key, $data);
				if($memcachestore===false) {
					$memcachestore = $memcache->set($key, $data, $cache_expiry);
				}
				if($memcachestore) {
					$return = $key;
					// return the $key that was used to store it. NO point in feeding $data back, nor the success or failure.
				} else {
					// failed to store, hmmm. Don't even debug it, echo the error.
					echo "Failed to store memcache at key ".$key.", result var dump:<br />".PHP_EOL;
					var_dump($memcachestore);
					$return = false;
				}
			}
		} else {
			$return = false;
		}
	} else {
		// no memcache eanbled, just return false no matter what so the fallback to SQL triggers in whatever function is calling it.
		$return = false;
	}
	return $return;
}
