<?
/*

Listing search form for Bootstrap websites. 
Optimized for wider view. 
has some .JS and other inclues in there. 
*/

// Let's set the variables accordingly to what's set in the Search section on the backend.
// If any of the fields is empty, then just set a fallback.


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price);
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}


$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);
	
if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square);
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}


if((is_array($settings['brixwork_search_type'])) && (count($settings['brixwork_search_type']) > 0)) {
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	$searchtype = $dwelling_type;
}
?>
<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
<script type="text/javascript" src="<?=brixwork_core_url('js/bootstrap3-typeahead.min.js')?>"></script>
<script type="text/javascript" src="<?=brixwork_core_url('js/jquery.touuchpunch.js')?>"></script>

<link href="<?= brixwork_core_url('css/listing_search_mainst.css') ?>" rel="stylesheet" />
<script type="text/javascript" src="<?= brixwork_core_url('js/listing_search_mainst.js') ?>"></script>

<script type="text/javascript">
<?
if(isset($params['area'])) {
	// var set!
	echo 'window.params_areas = []; // declare array for subareas chosen
	';
	if(is_array($params['area'])) {
		// multiple subareas in array format.
		foreach($params['area'] as $keycount=> $subarea) {
			echo 'window.params_areas['.$keycount.'] = "'.$subarea.'";
			';
		}
	} else {
		// single subarea.
		echo 'window.params_areas[0] = "'.$params['area'].'";
		';
	}
}
?>


$(document).ready(function(){
	<?
	if($settings['listing_search_skip_to_listings']==1 && ($params===false || !isset($params['pageid']))) {
		?>
		$('html, body').delay(1000).animate({scrollTop: $("#listings_wrapper").offset().top-100}, 2000);
		<?
	}
	?>
	
	
});
</script>

<style type="text/css">
	.slider_wrap .ui-slider .ui-slider-handle {
		width:19px;
		height:19px;
		top:-8px;
		border:none;
		margin-left:-8px;
		z-index:9;
	}
	
	.slider_display_value_container {
		text-align: center;
		
		-webkit-transition: all 0.5s;
		-moz-transition: all 0.5s; 
		transition: all 0.5s;
	}
	
	.slider_display_value_container p.slider_display_value {
		margin-left:auto;
		margin-right:auto;
		text-align: center;
		display:inline-block;
		width:auto;
		-webkit-transition: all 0.5s;
		-moz-transition: all 0.5s; 
		transition: all 0.5s;
		margin-bottom:20px;
	}
	
	#listing_search_form .slider_wrap {
		margin-bottom:40px;
	}
</style>


	<form id="listing_search_form" method="post" enctype="multipart/form-data">
		
		<input type="hidden" name="listing_search_min_sqft" id="listing_search_min_sqft" <?=($params['min_sqft']!='' ? ' value="'.$params['min_sqft'].'"' : '')?> autocomplete="off" />
		<input type="hidden" name="listing_search_max_sqft" id="listing_search_max_sqft" <?=($params['max_sqft']!='' ? ' value="'.$params['max_sqft'].'"' : '')?> autocomplete="off" />
		<input type="hidden" name="listing_search_min_price" id="listing_search_min_price" <?=($params['min_price']!='' ? ' value="'.$params['min_price'].'"' : 'value=""')?> autocomplete="off" />
		<input type="hidden" name="listing_search_max_price" id="listing_search_max_price" <?=($params['max_price']!='' ? ' value="'.$params['max_price'].'"' : 'value=""')?> autocomplete="off" />
					
		<input type="hidden" id="search_min_price" value="<?=$price_param['min']?>" autocomplete="off" />
		<input type="hidden" id="search_max_price" value="<?=$price_param['max']?>" autocomplete="off" />
		<input type="hidden" id="search_price_increments" value="<?=$price_param['increment']?>" autocomplete="off" />
			
		<input type="hidden" id="default_min_price" value="<?=($params['min_price']!='' ? $params['min_price'] : $price_param['min'])?>" autocomplete="off" />
		<input type="hidden" id="default_max_price" value="<?=($params['max_price']!='' ? $params['max_price'] : $price_param['max'])?>" autocomplete="off" />
		
		<div class="col-md-8 col-sm-12">
		<div class="brixwork_mainst_slider_wrap">	
				<div class="brixwork_mainst_search_slider_min" id="brixwork_mainst_price_min_display">&nbsp;</div>
				<div class="brixwork_mainst_search_slider_max" id="brixwork_mainst_price_max_display">&nbsp;</div>
				<div class="brixwork_mainst_slider formcolor" id="brixwork_mainst_price_slider"></div>
				
			</div>
		</div>
		
		<input type="hidden" id="search_min_sqft" value="<?=$sqft_param['min']?>" autocomplete="off" />
		<input type="hidden" id="search_max_sqft" value="<?=$sqft_param['max']?>" autocomplete="off" />
		<input type="hidden" id="search_sqft_increments" value="<?=$sqft_param['increment']?>" autocomplete="off" />
		
		<input type="hidden" id="default_min_sqft" value="<?=($params['min_sqft']!='' ? $params['min_sqft'] : $sqft_param['min'])?>" autocomplete="off" />
		<input type="hidden" id="default_max_sqft" value="<?=($params['max_sqft']!='' ? $params['max_sqft'] : $sqft_param['max'])?>" autocomplete="off" />
		
		<div class="col-md-4 col-sm-12">
			<div class="brixwork_mainst_slider_wrap">	
				<div class="brixwork_mainst_search_slider_min" id="brixwork_mainst_sqft_min_display">&nbsp;</div>
				<div class="brixwork_mainst_search_slider_max" id="brixwork_mainst_sqft_max_display">&nbsp;</div>
				<div class="brixwork_mainst_slider formcolor" id="brixwork_mainst_sqft_slider"></div>
				
			</div>
		</div>
				
		<div class="clearfix"></div>
		
		<div class="col-xs-12">
			<div class="brixwork_mainst_city_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<path d="M4.647,7.657v0.02C4.641,7.785,4.638,7.897,4.638,8.012c0,2.265,1.432,3.885,2.951,5.602
							c0.509,0.577,1.039,1.172,1.527,1.812c1.643,2.137,2.513,5.461,2.885,7.259c0.375-1.798,1.247-5.122,2.888-7.259
							c0.49-0.639,1.016-1.235,1.526-1.812c1.519-1.717,2.95-3.337,2.95-5.602c0-0.113-0.002-0.225-0.009-0.335V7.653
							c-0.183-3.938-3.413-7.097-7.36-7.193C8.058,0.556,4.83,3.717,4.647,7.657 M12.229,24h-0.456c-0.007-0.055-0.806-5.404-3.022-8.292
							c-0.481-0.627-1.005-1.219-1.508-1.789c-1.576-1.783-3.068-3.469-3.068-5.907c0-0.092,0.002-0.179,0.006-0.268L4.168,7.728
							l0.019-0.09C4.378,3.454,7.805,0.101,11.996,0c4.201,0.101,7.628,3.454,7.819,7.639l0.019,0.09l-0.013,0.017
							c0.004,0.09,0.006,0.179,0.006,0.268c0,2.44-1.49,4.124-3.065,5.907c-0.506,0.57-1.029,1.162-1.509,1.789
							C13.034,18.598,12.237,23.947,12.229,24"/>
						<path d="M14.304,7.705c0,1.271-1.031,2.301-2.302,2.301c-1.271,0-2.303-1.03-2.303-2.301
							c0-1.271,1.031-2.302,2.303-2.302C13.273,5.403,14.304,6.434,14.304,7.705"/>
					</g>
				</svg>

				<select name="listing_search_city" id="brixwork_mainst_listing_search_city" class="brixwork_mainst_city_select" data-placeholder="Choose a City" autocomplete="off">
				<option value="" selected="selected">Choose A City</option>
				<?
				$city_query['publish'] = 1;

				$activecities = get_areas($city_query);

				foreach($activecities as $cityid) {
					$city = new area;
					$city->initialize($cityid);
					if($city->publish==1) {
                        $selectedtext = '';

                        if(is_string($city->name) && is_string($params['city'])) {
                            if (strtolower($city->name) == strtolower($params['city'])) {
                                $selectedtext = ' selected="selected"';
                            }
						}
						echo '<option rel="' . $city->id . '" value="' . $city->name . '" ' . $selectedtext . '>' . $city->name . '</option>';
					}
				}
				?>
				</select>
			</div>
			<div class="brixwork_mainst_area_container">
				<select name="listing_search_subarea[]" id="brixwork_mainst_listing_search_area" class="brixwork_mainst_area_select" multiple data-placeholder="Choose City First" autocomplete="off">
					<option value="" selected="selected">Choose Subareas</option>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_street_search_container">
				<input type="text" name="listing_search_street" id="brixwork_mainst_street_search" class="typeahead" data-provide="typeahead" autocomplete="nope" />
				<input type="hidden" name="listing_search_street_dir" value="" />
				<input type="hidden" name="listing_search_street_name" value="" />
				<input type="hidden" name="listing_search_street_type" value="" />
				<input type="hidden" name="listing_search_street_suffix" value="" />
			</div>
		</div>
		<div class="clearfix"></div>
		
		<div class="col-xs-12">
			<div class="brixwork_mainst_criterion brixwork_mainst_type_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<g>
						<path d="M9.942,17.651h4.119c0.137,0,0.25-0.111,0.25-0.252V14c0-0.137-0.114-0.249-0.25-0.249H9.942
							c-0.139,0-0.25,0.112-0.25,0.249v3.399C9.691,17.54,9.803,17.651,9.942,17.651z M10.19,14.253h3.617v2.898H10.19V14.253z"/>
						<path d="M21.824,10.251l-9.497-8.129c-0.188-0.162-0.465-0.162-0.654,0l-9.499,8.129
							c-0.158,0.138-0.216,0.36-0.143,0.554c0.072,0.2,0.26,0.329,0.47,0.329h2.861v9.637c0,0.275,0.225,0.5,0.501,0.5h12.274
							c0.275,0,0.502-0.225,0.502-0.5v-9.637h2.857c0.211,0,0.398-0.129,0.471-0.329C22.042,10.611,21.984,10.389,21.824,10.251z
							 M17.634,20.266H6.365v-9.132h11.269V20.266z M18.137,10.131H5.864H3.859L12,3.164l8.138,6.968H18.137z"/>
						</g>
						<g>
						<path d="M9.942,17.651h4.119c0.137,0,0.25-0.111,0.25-0.252V14c0-0.137-0.114-0.249-0.25-0.249H9.942
							c-0.139,0-0.25,0.112-0.25,0.249v3.399C9.691,17.54,9.803,17.651,9.942,17.651z M10.19,14.253h3.617v2.898H10.19V14.253z"/>
						<path d="M21.824,10.251l-9.497-8.129c-0.188-0.162-0.465-0.162-0.654,0l-9.499,8.129
							c-0.158,0.138-0.216,0.36-0.143,0.554c0.072,0.2,0.26,0.329,0.47,0.329h2.861v9.637c0,0.275,0.225,0.5,0.501,0.5h12.274
							c0.275,0,0.502-0.225,0.502-0.5v-9.637h2.857c0.211,0,0.398-0.129,0.471-0.329C22.042,10.611,21.984,10.389,21.824,10.251z
							 M17.634,20.266H6.365v-9.132h11.269V20.266z M18.137,10.131H5.864H3.859L12,3.164l8.138,6.968H18.137z"/>
						</g>
					</g>
				</svg>
				<select name="listing_search_type" id="brixwork_mainst_search_type" data-placeholder="Property Type">
					<option value="">Any Type</option>
					<?php
					$count = 0;		
					$typeid = get_property_type_id($params['type']);
					
					// first get ID of the house type currently selected
					foreach ($searchtype as $id => $title) {
						if($typeid==$id) {
							$selectedtext = ' selected="selected"';
						} else {
							$selectedtext = '';
						}
						?>
						<option rel="<? echo $id; ?>"<? echo $selectedtext; ?> value="<? echo $settings['type'][$id]; ?>" ><? echo $title; ?></option>
					<?php
						$count++;
					} ?>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_bed_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<g>
							<path d="M22.001,14.163c0-1.113-0.905-2.018-2.018-2.018H4.02c-1.112,0-2.018,0.905-2.018,2.018l0.001,3.861
							h19.999L22.001,14.163z M3.053,16.968l-0.004-2.805c0-0.536,0.436-0.971,0.971-0.971h15.963c0.536,0,0.972,0.436,0.972,0.971
							l0,2.805H3.053z"/>
							<rect x="3.078" y="19.063" width="2.181" height="1.046"/>
							<rect x="18.747" y="19.063" width="2.181" height="1.046"/>
						</g>
						<g>
							<path d="M4.18,11.248V8.082c0-0.866,0.705-1.57,1.57-1.57h12.505c0.866,0,1.57,0.704,1.57,1.57v3.167h0.065
							c0.344,0,0.673,0.061,0.981,0.168V8.082c0-1.442-1.173-2.616-2.616-2.616H5.75c-1.443,0-2.616,1.174-2.616,2.616v3.334
							c0.307-0.106,0.636-0.167,0.98-0.167H4.18z"/>
							<path d="M6.789,9.15c0-0.203,0.171-0.374,0.374-0.374h2.725c0.203,0,0.374,0.171,0.374,0.374v2.098h1.046V9.15
							c0-0.783-0.637-1.42-1.42-1.42H7.163c-0.783,0-1.42,0.638-1.42,1.42v2.098h1.046V9.15z"/>
							<path d="M13.744,9.15c0-0.203,0.171-0.374,0.374-0.374h2.724c0.203,0,0.374,0.171,0.374,0.374v2.098h1.046V9.15
							c0-0.783-0.637-1.42-1.42-1.42h-2.724c-0.783,0-1.42,0.638-1.42,1.42v2.098h1.046V9.15z"/>
						</g>
					</g>
				</svg>
				<select id="brixwork_mainst_search_bedrooms" name="listing_search_bedrooms" autocomplete="off">
					<option value="">All Beds</option>
					<?
					// important to note that 
					if($settings['brixwork_search_min_bedrooms']!='' && $settings['brixwork_search_max_bedrooms']!='') {
						$min_bedrooms = $settings['brixwork_search_min_bedrooms'];
						$max_bedrooms = $settings['brixwork_search_max_bedrooms'];
					} else {
						$min_bedrooms = 0;
						$max_bedrooms = 5;
					}
					$bed_count = $min_bedrooms; // start from minimum... not always 0. 
					while($bed_count<=$max_bedrooms) {
						
						if($bed_count <= 3) {
							echo '<option value="'.$bed_count.'" '.(($params['bedroom']*1==$bed_count && isset($params['bedroom'])) ? 'selected="selected"': '').'>'.($bed_count==0 ? 'Studio' : $bed_count.' Bedroom'.($bed_count>1 ? 's':'')).'</option>';
						}
						
						// min bedrooms.. so instead of 3, it shows 3+ as option as well!
						if($bed_count >= 3) {
							echo '<option value="'.$bed_count.'" rel="min" '.(($params['min_bedroom']*1==$bed_count && isset($params['min_bedroom'])) ? 'selected="selected"': '').'>'.$bed_count.'+ Bedrooms</option>';
						}
						
						$bed_count++;
					}
					?>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_bath_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<path d="M18.025,12.471H4.556c-0.306,0-0.554,0.248-0.554,0.554c0,0.305,0.248,0.553,0.554,0.553h13.469
							c0.306,0,0.554-0.248,0.554-0.553C18.579,12.719,18.331,12.471,18.025,12.471z"/>
						<path d="M19.449,2.276h-6.432c-1.277,0-2.316,1.039-2.316,2.316v1.473c-3.418,0.224-6.109,2.373-6.109,4.985
							c0,0.306,0.248,0.554,0.554,0.554h12.289c0.306,0,0.554-0.248,0.554-0.554c0-2.631-2.729-4.789-6.181-4.988v-1.47
							c0-0.667,0.542-1.208,1.208-1.208h6.432c0.306,0,0.554-0.248,0.554-0.554C20.002,2.524,19.754,2.276,19.449,2.276z M16.826,10.498
							H5.755c0.387-1.89,2.722-3.347,5.535-3.347C14.104,7.15,16.439,8.607,16.826,10.498z"/>
						<circle cx="7.045" cy="15.397" r="0.712"/>
						<circle cx="7.045" cy="17.587" r="0.712"/>
						<circle cx="7.045" cy="19.775" r="0.713"/>
						<circle cx="15.536" cy="15.397" r="0.712"/>
						<circle cx="15.536" cy="17.587" r="0.712"/>
						<circle cx="15.536" cy="19.775" r="0.713"/>
						<circle cx="12.706" cy="15.397" r="0.712"/>
						<circle cx="12.706" cy="17.587" r="0.712"/>
						<circle cx="12.706" cy="19.775" r="0.713"/>
						<circle cx="9.875" cy="15.397" r="0.712"/>
						<circle cx="9.875" cy="17.587" r="0.712"/>
						<circle cx="9.875" cy="19.775" r="0.713"/>
					</g>
				</svg>
				<select id="brixwork_mainst_search_min_bathrooms" name="listing_search_bathrooms" autocomplete="off">
					<option value="">All Baths</option>
					<?
					if($settings['brixwork_search_min_bathrooms']!='' && $settings['brixwork_search_max_bedrooms']!='') {
						$min_bathrooms = $settings['brixwork_search_min_bathrooms'];
						$max_bathrooms = $settings['brixwork_search_max_bathrooms'];
					} else {
						$min_bathrooms = 0;
						$max_bathrooms = 5;
					}
					$bath_count = $min_bathrooms;
					while($bath_count<=$max_bathrooms) {
						
						if($bath_count <= 3) {
							echo '<option value="'.$bath_count.'" '.(($params['bathroom']*1==$bath_count && isset($params['bathroom'])) ? 'selected="selected"': '').'>'.($bath_count==0 ? 'None' : $bath_count.' Bathroom'.($bath_count>1 ? 's':'')).'</option>';
						}
						
						// min bathrooms
						if($bath_count >= 3) {
							echo '<option value="'.$bath_count.'" rel="min" '.(($params['min_bathroom']*1==$bath_count && isset($params['min_bathroom'])) ? 'selected="selected"': '').'>'.$bath_count.'+ Bathrooms</option>';
						}
						
						$bath_count++;
					}
					?>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_features_container">
				<select id="brixwork_mainst_search_features" name="listing_search_features[]" multiple autocomplete="off" data-placeholder="Other Features">
					<option value="" selected="selected" class="select_disabled">No Features</option>
					<?
						/*
							waterfront
							skihill
							golfcourse
							marina
							gatedcomm
							retirementcomm
						*/
						foreach($settings['home_features'] as $featuredesc => $featurefield) {
                            if(is_array($params) && array_key_exists($featurefield, $params)===true) {
								$selectedtext = 'selected="selected"';
							} else {
								$selectedtext = '';
							}
							echo '<option value="'.$featurefield.'" '.$selectedtext.'>'.$featuredesc.'</option>';
						}
					?>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_checkbox brixwork_mainst_openhouse_container">
				<input type="checkbox" name="listing_search_openhouse" autocomplete="off" id="brixwork_mainst_search_openhouse" <?=($params['openhouse']==1 ? 'checked' : '')?> />
				<label for="brixwork_mainst_search_openhouse">&nbsp;Has Open House</label>
			</div>
		</div>
		
		<div class="clearfix"></div>
		
		<div class="col-xs-12">
			<div class="brixwork_mainst_criterion brixwork_mainst_orderby_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<g>
						<path d="M6.272,15.518h-2.3C3.434,15.518,3,15.954,3,16.491c0,0.535,0.434,0.967,0.972,0.967h2.3V15.518z"/>
						<path d="M20.021,15.518H8.318v1.94h11.703c0.541,0,0.979-0.432,0.979-0.967C21,15.954,20.562,15.518,20.021,15.518z
							"/>
					</g>
					<g>
						<path d="M6.272,11.33h-2.3C3.434,11.33,3,11.766,3,12.307c0,0.539,0.434,0.972,0.972,0.972h2.3V11.33z"/>
						<path d="M20.021,11.33H8.318v1.949h11.703c0.541,0,0.979-0.433,0.979-0.972C21,11.766,20.562,11.33,20.021,11.33z"
							/>
					</g>
					<g>
						<path d="M6.272,7.146h-2.3C3.434,7.146,3,7.581,3,8.12c0,0.542,0.434,0.973,0.972,0.973h2.3V7.146z"/>
						<path d="M20.021,7.146H8.318v1.947h11.703C20.562,9.093,21,8.661,21,8.12C21,7.581,20.562,7.146,20.021,7.146z"/>
					</g>
					
				</svg>
				<select name="listing_order_by" id="brixwork_mainst_listing_order_by" autocomplete="off">
					<option value="create_date"<? if($params['order_by']=='create_date' || !isset($params['order_by'])) { echo ' selected="selected"';}?>>Date Listed</option>
					<option value="price"<? if($params['order_by']=='price') { echo ' selected="selected"';}?>>Listed Price</option>
					<option value="sqft"<? if($params['order_by']=='sqft') { echo ' selected="selected"';}?>>Size of Home</option>
					<option value="bedroom"<? if($params['order_by']=='bedroom') { echo ' selected="selected"';}?>>Bedrooms</option>
					<option value="bathroom"<? if($params['order_by']=='bathroom') { echo ' selected="selected"';}?>>Bathrooms</option>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_orderdir_container">
				<svg x="0px" y="0px" width="24px" height="24px" viewBox="0 0 24 24" class="brixwork_mainst_select_icons">
					<path d="M22.3,11.498l-5.812-6.422c-0.119-0.134-0.293-0.21-0.474-0.21c-0.179,0-0.351,0.076-0.472,0.21l-4.77,5.269
	V5.91c0-0.352-0.285-0.638-0.639-0.638H5.812c-0.354,0-0.638,0.286-0.638,0.638v5.451H2.095c-0.253,0-0.481,0.151-0.585,0.381
	c-0.102,0.232-0.058,0.5,0.111,0.686l5.881,6.499c0.119,0.135,0.291,0.209,0.471,0.209s0.352-0.074,0.474-0.209l4.769-5.27v4.434
	c0,0.354,0.285,0.639,0.635,0.639h4.326c0.353,0,0.637-0.285,0.637-0.639v-5.451h3.08c0.005,0,0.01,0,0.013,0
	c0.353,0,0.638-0.288,0.638-0.638C22.544,11.795,22.446,11.613,22.3,11.498z M7.973,17.547L3.53,12.639h2.282
	c0.354,0,0.637-0.288,0.637-0.638V6.545h3.048V12c0,0.011,0.007,0.021,0.007,0.027c0.002,0.065,0.016,0.134,0.04,0.198
	c0.002,0.01,0.004,0.018,0.006,0.027c0.002,0.003,0.002,0.004,0.002,0.004c0.029,0.068,0.075,0.128,0.122,0.177
	c0.016,0.017,0.027,0.025,0.043,0.04c0.044,0.036,0.088,0.067,0.14,0.092c0.018,0.01,0.036,0.02,0.056,0.025
	c0.07,0.027,0.147,0.047,0.221,0.047h2.284L7.973,17.547z M18.177,11.361c-0.354,0-0.641,0.288-0.641,0.64v5.451h-3.045V12
	c0-0.011-0.006-0.02-0.009-0.029c-0.001-0.065-0.013-0.133-0.038-0.197c-0.002-0.006-0.002-0.017-0.007-0.028
	c-0.003-0.001-0.003-0.003-0.003-0.004c-0.029-0.067-0.07-0.125-0.12-0.179c-0.015-0.012-0.028-0.021-0.044-0.035
	c-0.041-0.037-0.087-0.067-0.137-0.094c-0.021-0.009-0.037-0.018-0.061-0.027c-0.069-0.026-0.143-0.046-0.223-0.046h-2.279
	l4.442-4.906l4.441,4.906H18.177z"/>
				</svg>
				<select name="listing_order_direction" id="brixwork_mainst_listing_order_direction" autocomplete="off" data-placeholder="Order Direction">
					<option value="DESC"> </option>
					<option value="ASC"<? if($params['order_direction']=='ASC') { echo ' selected="selected"';}?>> </option>
				</select>
			</div>
			<div class="brixwork_mainst_criterion brixwork_mainst_submit_container">
				<input type="button" id="listing_search_submit" value="SEARCH" class="btn-mst" />
			</div>
		</div>
		
		<?
		if ($params['keyword'] != '') { ?>
			<input type="hidden" name="keyword" value="<?=$params['keyword']?>" />
		<? } ?>
		
		<?
		if($params['bldg']=='') { // show the standard area/subarea based listing search ONLY if the bldg param is OFF. 
		?>
		
		<? } else { ?>
			<input type="hidden" name="listing_bldg" value="<? echo $params['bldg']; ?>" />
			<input type="hidden" name="listing_building" value="<? echo $params['building']; ?>" />
		<? } ?>



		<?
		if($params['bldg']=='') { // ordering not necessary for building based listings yet.  
		?>
	
		
			<div style="display: none;">
	
					
			</div>
		<?
		if($listing_custom_filename!='') {
			echo '<input type="hidden" value="'.$listing_custom_filename.'" name="listing_custom_filename" autocomplete="off" />';
		}
		?>

	<? } else { ?>
			<input type="hidden" name="listing_bldg" value="<? echo $params['bldg']; ?>" />
			<input type="hidden" name="listing_building" value="<? echo $params['building']; ?>" />
	<? } ?>
	

	</form>