<?php
/*
 *
 *
 * Legacy systems had a /includes/dropdown.inc. file that determined $square, $price etc. that ran the MLS search forms.
 * This file will attempt to use the min/max price settings under Settings / Search Settings.
 * And then fall back to some defaults.
 * */


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price); // in case it's declared at dropdown.inc, but not always.
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}

$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);

if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square); // in case it's declared at dropdown.inc, but not always.
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}



if(!is_array($dwelling_type)) {
	// not declaired in includes/dropdown.inc, often missing this file!

// override default types for each board, fallback is vancouver types
	if(strpos('edmonton', $settings['mls_import_url'])) {
		$dwelling_type = array(
			1 => 'House',
			2 => 'Condominium',
			3 => 'Townhouse',
			4 => 'Duplex',
			5 => 'Triplex',
			6 => 'Fourplex',
			7 => 'Cottage',
			8 => 'Manufactured Home',
			9 => 'Parking Stall',
			10 =>'Vacant Land'
		);
	} else if(strpos('kelowna', $settings['mls_import_url'])) {
		$dwelling_type = array(
			1 => 'House',
			2 => 'Condo',
			3 => 'Townhome',
			4 => 'Duplex',
			5 => 'Triplex',
			6 => 'Penthouse',
			7 => 'Land',
			10 => 'Property',
			11 => 'Loft',
			12 => 'Farm or Ranch',
			13 => 'Laneway House'
		);
	} else if(strpos('toronto', $settings['mls_import_url'])) {
		$dwelling_type = array(
			1 => 'Detached',
			2 => 'Townhouse',
			3 => 'Condo',
			4 => 'Semi-Detached',
			5 => 'Duplex',
			6 => 'Triplex',
			12 => 'Farm',
			17 => 'Land'
		);
	} else if (strpos('viva', $settings['mls_import_url'])) {
		$dwelling_type = array(
			1 => 'House',
			2 => 'Condo',
			3 => 'Townhome',
			4 => 'Duplex',
			5 => 'Triplex',
			10 => 'Land',
			11 => 'Recreational',
		);
	} else {
		// Vancouver default, but all older sties setup without MLS IDX will have same IDs.
		$dwelling_type = array(
			1 => 'House',
			2 => 'Condo',
			3 => 'Townhome',
			4 => 'Duplex',
			5 => 'Triplex',
			6 => 'Penthouse',
			7 => 'Land Only'
		);
	}
}


if((is_array($settings['brixwork_search_type'])) && (count($settings['brixwork_search_type']) > 0)) {
	unset($searchtype); // in case it's declared at dropdown.inc, but not always.
	$searchtype = array();
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	// to fall back to $dwelling_type as defined in dropdown.inc.
	$searchtype = $dwelling_type;
}


// final fallback to default vars we scrounged from dropdown.inc.
if(!is_array($price)) {
	// not declaired in includes/dropdown.inc, often missing this file!
	$price = array(1 => 0, 2 => 200000, 3 => 300000, 4 => 400000, 5 => 500000, 6 => 750000,
		7 => 1000000, 8 => 1250000, 9 => 1500000, 10 => 2000000, 11 => 3000000, 12 => 5000000);

}

if(!is_array($square)) {
	// not declaired in includes/dropdown.inc, often missing this file!
	$square = array(1 => 0, 2 => 500, 3 => 750, 4 => 1000, 5 => 1250,
		6 => 1500, 7 => 2000, 8 => 3000, 9 => 4000);
}

if(!is_array($bed)) {
	// not declaired in includes/dropdown.inc, often missing this file!
	// 0 bedroom means studio. and for some reason the guy who wrote it started at key 1,
	// I guess key 0 was meant to be blank?
	$bed = array(1 => 0, 2 => 1, 3 => 2, 4 => 3, 5 => 4, 6 => 5, 7 => 6);

}

if(!is_array($bath)) {
	// not declaired in includes/dropdown.inc, often missing this file!
	$bath = array(1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5);
}
