<?php
/* This include helps geneerate the home object, and subsequent items such as the meta tag contents etc. for the showlisting page. */

// get home object ready!

$memcache_params = array(
	'type'=>'home'
);

$request_uri = str_ireplace('//', '/', $_SERVER['REQUEST_URI']);
$request = explode('/',$request_uri);
$url_params = parse_pagevars('', $request_uri);
$mlsnum = false; // by default, false. OWN listings will use ID.
if($settings['mls_integrated']==1) {
	foreach ($url_params as $url_key => $url_val) {
		if($url_key=='mls') {
			$mlsnum = $url_val;
			break; // once MLS is found no need to keep going.
		}
	}
}

if($mlsnum===false) {
	// no MLS #, look for raw ID in a source==0 listing.
	$memcache_params['objectid']  = $homeid = $url_params['pageid']; // get home ID.. the first number.
	$memcache_params['listingsource']=0;
} else {
	// MLS # found, so feed different params to memcache as well as $home initialization.
	$memcache_params['mlsnum'] = $homeid['mls'] = $mlsnum;
	$memcache_params['listingsource']=1;

}
if(DEBUG==true) {
	echo "Memcache params for listing after determining ".($mlsnum===false ? 'ID: '.$homeid : 'MLS: '.$mlsnum)."<br />".PHP_EOL;
	var_dump($memcache_params);
}

// prime to enable debug mode. logged_in() does a MySQL query, so don't call it multiple times. Turn into accessible boolean.
if(logged_in()!==false) {
	$listing_preview = true;
} else {
	$listing_preview = false;
}

$data = get_memcache($memcache_params);
$home = new home;
if(is_array($data) && count($data)>10) {
	$homeresult = $home->initialize($homeid, $data);
	if(DEBUG==true) {
		echo "Home initialized from memcache data with ".count($data)." rows.<br />".PHP_EOL;
		echo "Memcache params: <br />".PHP_EOL;
		print_r($memcache_params);
		echo "Home Var Dump: <br />".PHP_EOL;
		var_dump($home);
	}
} else {
	if(DEBUG==true) {
		echo "Home initialized through MySQL manually, data var type was: ".gettype($data).".<br />".PHP_EOL;
		print_r($memcache_params);
	}
	$homeresult = $home->initialize($homeid);
	// if none of the forwaders triggered, go ahead and show the listing!
}

if($homeresult===false || ($listing_preview!==true && $home->publish==0)) {
	if(isset($home->city) && $settings['mls_integrated']==1 && $home->source==BRIX_LISTING_MLS) {
		/*
		 * If a recently disabled mls listing is flagged,
		 * */
		$params['city'] = $home->city;
		if($home->area!='' && $home->area!=false) {
			$params['area'] = $home->area;
		}

		$params['type'] = $home->type;
		$home_price_raw = remove_all_but_numbers($home->price);// get raw # first.
		$variance = 0.10; // +/- percentage.
		$params['min_price'] = $home_price_raw - ($home_price_raw*$variance); // +/- 5% variance.
		$params['max_price'] =  $home_price_raw + ($home_price_raw*$variance);

		$params['oldhome'] = $home->id;
		// log which listing was removed, so that next page can say "Sorry, 123 Main street was not foujnd" from the unpusblidshed row.

		$mls_search_url = get_listing_search_url($params);

		$targeturl = $mls_search_url['listingurl']; // include ID, so that the error message can show "The listing MLS # at whatever was deleted, but here's more"
		// echo $targeturl;
		header('Location: '.$targeturl, true, 301);
		exit;
	} else {
		if(DEBUG==true) {
			echo "Unable to load home for some reason, would have forwarded to NOTFOUND. Here's $home var:<br />";
			var_dump($home);
		} else {
			header('Location: '.$settings['sitepath'].'notfound');
		}
		exit;
	}

} else if($settings['mls_integrated']==BRIX_LISTING_OWN && $home->source==BRIX_LISTING_MLS) {
	/*

	site set to disable mls listings (probably a recent billing change?)
	so set this to disabled. But canmnot forward to any listing search result as there's no MLS
	Disabling to save money, so do not give the benefit of a graceful forward to a related listings search page.
	*/
	header('Location: '.$settings['sitepath']);
	exit;
}


$home->getphotos(); // Always initialize photo fetch on listing detail page. Only skip ohn gallery pages if $data==true is used to fetch.
$homedata = array(
	'id' => $home->id,
	'cityid' => $home->data['city'],
	'areaid' => $home->data['area'],
	'typeid' => $home->data['type'],
	'price' => $home->price,
	'bed' => $home->bedroom,
	'bath' => $home->bathroom,
	'sqft' => $home->sqft,
	'mls' => $home->mls,
	'fulladdress' => $home->fulladdress
);

if(is_object($visitor)) {
	$visitor->listing_action($homedata, 'view');
}


$body['id'] = $home->id;
$body['type'] = BRIX_PAGE_TYPE_LISTING_DETAILS;
$body['data']['type'] = BRIX_PAGE_TYPE_LISTING_DETAILS;
$body['data']['home_id'] = $home->id;

$body['data']['home_type'] = $home->type;
$body['data']['home_typeId'] = $home->data['type'];     // returns integer id

$body['data']['home_area'] = $home->area;
$body['data']['home_areaId'] = $home->data['area'];     // returns integer id

if($home->area_alt) {
    $body['data']['home_areaAlt'] = $home->area_alt;
    $body['data']['home_areaAltId'] = $home->data['area_alt'];
}

$body['data']['home_city'] = $home->city;
$body['data']['home_cityId'] = $home->data['city'];

$body['data']['home_price'] = $home->price;                             // $1,000,000 format
$body['data']['home_priceInt'] = remove_all_but_numbers($home->price);   // 1000000 format

$body['data']['home_forRent'] = $home->data['for_rent'];
$body['data']['home_sold'] = $home->sold;






// descriptions & title first...	
$metadescription = $home->metadescription;
$pagetitle = ($listing_preview===true && $home->publish==0 ? "DRAFT - " : '').$home->fulladdress.($home->mls!='' ? ' ('.$home->mls.')' : '');
$metatitle = ($listing_preview===true && $home->publish==0 ? "DRAFT - " : '').$home->metatitle;


// then move onto URL, photos etc. 
$img = $home->get_main_image_path();
if( // finds out if we should default to the LOGO file as the og:image for open graph tags... looks for all possible reasons.
	(
		!(
			strpos($img, $home->id) // Check if ID is included in the image path. If so, then it's a valid image... 
			||
			strpos($img, $home->data['masterid'])
		)
		&& 
		(	// and if mls_import_url is different from master, not blank, and that is not included in the image
			$settings['mls_import_url']!=''
			&&
			strpos($img, $settings['mls_import_url'])===false
		)
	) 
	|| strpos($img, 'noimage')===true
) { // if  above conditions are met, then it's not a valid home image. Probably referring to a noimage file. 
	$img = '';
	// home id is not part of url, that means the image does not exist so it defaulted. 
	
	// Using .jpg as the primary source for the logo, so we can have it sized 1200x630 as per Facebook recommendation and still having logo.png sized whatever size is needed for the website, with it's transparency.
	$logos = array(
		'logo.jpg', // Main st. / Yaletown templates
		'logo.png', // Main st. / Yaletown templates fallback
		'logo/header_logo.jpg', // White rock template
		'logo/header_logo.png', // White rock template fallback
		'logo/logo.jpg', // Gastown template
		'logo/logo.png' // Gastown template fallback
	); // list possible logo file locations
	foreach($logos as $logo_filename) {
		if(file_exists($_SERVER['DOCUMENT_ROOT'].($settings['use_template']==1 ? '/templates'.$settings['templatefolder'] : '').'/images/'.$logo_filename)) {
			$img = ($settings['use_template']==1 ? $settings['templatepath'] : $settings['sitepath']).'images/'.$logo_filename;
			break;
		}
	}
}

if($img!='') {
	$ogtags['img'] = $img; // put image in there! 
}

$ogtags['url'] = $home->get_property_link($settings['url_trail'],'showlisting/');


/* Lead email - send to agent if set? */
if($settings['email_listing_agents_only']!=0) {
	// override the TO emails to the listing agents.
	$email_to = array();
	if($home->agent_1 && $home->agent_1->email!='') {
		$email_to[] = $home->agent_1->email;
		$email_to_name[] = $home->agent_1->displayname;
	}
	if($home->agent_2 && $home->agent_2->email!='') {
		$email_to[] = $home->agent_2->email;
		$email_to_name[] = $home->agent_2->displayname;
	}
	if($home->agent_3 && $home->agent_3->email!='') {
		$email_to[] = $home->agent_3->email;
		$email_to_name[] = $home->agent_3->displayname;
	}

	if($settings['email_listing_agents_only']==2 && count($email_to)>0) {
		// add CC to contact email since the TO email is set.
		// only do this if contact email is set. Otherwise this will cause duplicte with the TO field,
		// since the TO field will have $settings['contactemail']
		$email_cc = array();
		$email_cc[] = $settings['contactemail']; // the regular lead emails will get cc'd while the agents are primary "to" addresses.
	}
}


if(DEBUG===true) {
	$debug_displays = array();
	$debug_displays['JSON url'] = $home->json_url;
	$debug_displays['Source'] = ($home->source==BRIX_LISTING_OWN ? 'OWN' : 'MLS').($home->mls!='' ? ' (MLS#: '.$home->mls.')' : '');
	$debug_displays['Dates'] = 'Created: '.$home->create_date.', Modified: '.$home->modify_date;
	$debug_displays['Timestamp'] = 'Raw Time: '.$home->timestamp.', Photo Timestamp: '.$home->photo_timestamp;
	$debug_displays['Photo Count'] = is_countable($home->photos) ? count($home->photos) : 0;
	$debug_displays['Master ID'] = ($home->masterid!='' && $home->masterid!=0 ? $home->masterid : 'No Master ID');
	$debug_displays['Unique ID'] = $home->id;
	$debug_displays['PHP File'] = $home->data['phpfile'];

	if($home->mainphoto) {
		foreach ($home->mainphoto as $mainphotokey => $mainphotourl) {
			$debug_displays['mainphoto_'.$mainphotokey] = $mainphotourl;
		}
	}

	if($home->photos) {
		$debug_displays['Gallery Photos'] = count($home->photos);
	} else {
		$debug_displays['Gallery Photos'] = 'No photos.';
	}

	foreach($debug_displays as $label => $value) {
		echo $label.': '.$value."<br />\r\n";
	}
}

?>