<?php
/*

Listing search form for 12 grid websites.
Modified from Fairview.
Optimized for wider view. 
has some .JS and other includes in there.
*/

// Let's set the variables accordingly to what's set in the Search section on the backend.
// If any of the fields is empty, then just set a fallback.


// Setting the variables
$price_param['min'] = ($settings['brixwork_search_min_price'] != '' ? $settings['brixwork_search_min_price'] : $fallback_price_min);
$price_param['max'] = ($settings['brixwork_search_max_price'] != '' ? $settings['brixwork_search_max_price'] : $fallback_price_max);
$price_param['increment'] = ($settings['brixwork_search_price_increments'] != '' ? $settings['brixwork_search_price_increments'] : $fallback_price_inc);

if (($settings['brixwork_search_min_price'] != '') && ($settings['brixwork_search_max_price'] != '') && ($settings['brixwork_search_price_increments'] != '')) {
	unset($price);
	$price = range($price_param['min'], $price_param['max'], $price_param['increment']);
	$price = array_combine(range(1, count($price)), array_values($price)); // forces the array to start at key=1 to keep back compatibility
}


$sqft_param['min'] = ($settings['brixwork_search_min_sqft'] != '' ? $settings['brixwork_search_min_sqft'] : $fallback_sqft_min);
$sqft_param['max'] = ($settings['brixwork_search_max_sqft'] != '' ? $settings['brixwork_search_max_sqft'] : $fallback_sqft_max);
$sqft_param['increment'] = ($settings['brixwork_search_sqft_increments'] != '' ? $settings['brixwork_search_sqft_increments'] : $fallback_sqft_inc);

if (($settings['brixwork_search_min_sqft'] != '') && ($settings['brixwork_search_max_sqft'] != '') && ($settings['brixwork_search_sqft_increments'] != '')) {
	unset($square);
	$square = range($sqft_param['min'], $sqft_param['max'], $sqft_param['increment']);
	$square = array_combine(range(1, count($square)), array_values($square)); // forces the array to start at key=1 to keep back compatibility
}


if(array_key_exists('brixwork_search_type', $settings) && is_array($settings['brixwork_search_type']) && (count($settings['brixwork_search_type']) > 0)) {
	$searchtype = array();
	foreach($settings['brixwork_search_type'] as $typeid) {
		$searchtype[$typeid] = $settings['type'][$typeid];
	}
} else {
	echo "SETTINGS ERROR - please select property types to be searchable under ADMIN =&rt; SETTINGS =&rt; SEARCH SETTINGS.<br />";
	die('Aborting load until the issue is resolved.');
}
?>

<link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons" />

<?php
// Disables cdn loading so we can test the forms. If true, then css and js need to be loaded locally
if ( !isset($yaletown2_include_path_css) || $yaletown2_include_path_css == '' ) {
	$yaletown2_include_path_css = "/css/yaletown2/";
}
if ( !isset($yaletown2_include_path_js) || $yaletown2_include_path_js == '' ) {
	$yaletown2_include_path_js = "/js/";
}
if (!$search_form_test) {
	// live site, so pull from cloudfront (demo.brixwork.com
	?>
    <link rel="stylesheet" href="<?= brixwork_core_url($yaletown2_include_path_css . 'listing_search_form_yaletown2.css') ?>" />
	<?php
	$scriptinclude_footer_default[] = brixwork_core_url($yaletown2_include_path_js . '/listing_search_form_yaletown2.js');
} else {
	// testing, load cSS from local, not cloudfront which is for distribution!
	// from yaletown2.brixwork.ca local for testing.


	?>

    <link rel="stylesheet" href="<?= brixwork_core_url($yaletown2_include_path_css . 'listing_search_form_yaletown2.css', '', $settings['sitepath']) ?>" />
	<?php
	$scriptinclude_footer_default[] = brixwork_core_url($yaletown2_include_path_js . '/listing_search_form_yaletown2.js', '', $settings['sitepath']);
}

$scriptinclude_footer_default[] = brixwork_core_url('js/jquery.touuchpunch.js');
$scriptinclude_footer_default[] = brixwork_core_url('js/bootstrap3-typeahead.min.js');

?>
<script type="text/javascript">
	<?php
	if(isset($params['area'])) {
		// var set!
		echo 'window.params_areas = []; // declare array for subareas chosen
		';
		if(is_array($params['area'])) {
			// multiple subareas in array format.
			foreach($params['area'] as $keycount=> $subarea) {
				echo 'window.params_areas['.$keycount.'] = "'.$subarea.'";
				';
			}
		} else {
			// single subarea.
			echo 'window.params_areas[0] = "'.$params['area'].'";
			';
		}
	}
	?>


    $(document).ready(function(){
        /*
				var script = document.createElement('script');
				script.src = "/js/listing_search_form_yaletown2.js";
				document.getElementsByTagName('head')[0].appendChild(script);
		*/


		<?php
		if(array_key_exists('listing_search_skip_to_listings', $settings) && $settings['listing_search_skip_to_listings']==1 && ($params===false || !isset($params['pageid']))) {
		?>
        $('html, body').delay(1000).animate({scrollTop: $("#listings_wrapper").offset().top-100}, 2000);
		<?php
		}
		?>
    });
</script>

<style>
  .slider_wrap .ui-slider .ui-slider-handle {
	width:19px;
	height:19px;
	top:-8px;
	border:none;
	margin-left:-8px;
	z-index:9;
  }

  .slider_display_value_container {
	text-align: center;

	-webkit-transition: all 0.5s;
	-moz-transition: all 0.5s;
	transition: all 0.5s;
  }

  .slider_display_value_container p.slider_display_value {
	margin-left:auto;
	margin-right:auto;
	text-align: center;
	display:inline-block;
	width:auto;
	-webkit-transition: all 0.5s;
	-moz-transition: all 0.5s;
	transition: all 0.5s;
	margin-bottom:20px;
  }

  #listing_search_form .slider_wrap {
	margin-bottom:40px;
  }
</style>


<form id="listing_search_form" class="row" method="post" enctype="multipart/form-data">
	<?php
	// process min sqft/max sqft as passed in the URL.
	$min_sqft = (is_array($params) && array_key_exists('min_sqft', $params) && $params['min_sqft']!='' ? $params['min_sqft'] : false);
	$max_sqft = (is_array($params) && array_key_exists('max_sqft', $params) && $params['max_sqft']!='' ? $params['max_sqft'] : false);
	$min_price = (is_array($params) && array_key_exists('min_price', $params) && $params['min_price']!='' ? $params['min_price'] : false);
	$max_price = (is_array($params) && array_key_exists('max_price', $params) && $params['max_price']!='' ? $params['max_price'] : false);
	?>
    <input type="hidden" name="listing_search_min_sqft" id="listing_search_min_sqft" <?=($min_sqft ? ' value="'.$min_sqft.'"' : '')?> autocomplete="off" />
    <input type="hidden" name="listing_search_max_sqft" id="listing_search_max_sqft" <?=($max_sqft ? ' value="'.$max_sqft.'"' : '')?> autocomplete="off" />
    <input type="hidden" name="listing_search_min_price" id="listing_search_min_price" <?=($min_price ? ' value="'.$min_price.'"' : 'value=""')?> autocomplete="off" />
    <input type="hidden" name="listing_search_max_price" id="listing_search_max_price" <?=($max_price ? ' value="'.$max_price.'"' : 'value=""')?> autocomplete="off" />

    <input type="hidden" id="search_min_price" value="<?=$price_param['min']?>" autocomplete="off" />
    <input type="hidden" id="search_max_price" value="<?=$price_param['max']?>" autocomplete="off" />
    <input type="hidden" id="search_price_increments" value="<?=$price_param['increment']?>" autocomplete="off" />

    <input type="hidden" id="default_min_price" value="<?=(isset($params['min_price']) && $params['min_price']!='' ? $params['min_price'] : $price_param['min'])?>" autocomplete="off" />
    <input type="hidden" id="default_max_price" value="<?=(isset($params['max_price']) && $params['max_price']!='' ? $params['max_price'] : $price_param['max'])?>" autocomplete="off" />

    <div class="col-md-8 col-sm-12">
        <div class="brixwork_yaletown2_slider_wrap">
            <div class="brixwork_yaletown2_search_slider_min" id="brixwork_yaletown2_price_min_display">&nbsp;</div>
            <div class="brixwork_yaletown2_search_slider_max" id="brixwork_yaletown2_price_max_display">&nbsp;</div>
            <div class="brixwork_yaletown2_slider formcolor" id="brixwork_yaletown2_price_slider"></div>
        </div>
    </div>

    <input type="hidden" id="search_min_sqft" value="<?=$sqft_param['min']?>" autocomplete="off" />
    <input type="hidden" id="search_max_sqft" value="<?=$sqft_param['max']?>" autocomplete="off" />
    <input type="hidden" id="search_sqft_increments" value="<?=$sqft_param['increment']?>" autocomplete="off" />

    <input type="hidden" id="default_min_sqft" value="<?=(isset($params['min_sqft']) && $params['min_sqft']!='' ? $params['min_sqft'] : $sqft_param['min'])?>" autocomplete="off" />
    <input type="hidden" id="default_max_sqft" value="<?=(isset($params['max_sqft']) && $params['max_sqft']!='' ? $params['max_sqft'] : $sqft_param['max'])?>" autocomplete="off" />

    <div class="col-md-4 col-sm-12">
        <div class="brixwork_yaletown2_slider_wrap">
            <div class="brixwork_yaletown2_search_slider_min" id="brixwork_yaletown2_sqft_min_display">&nbsp;</div>
            <div class="brixwork_yaletown2_search_slider_max" id="brixwork_yaletown2_sqft_max_display">&nbsp;</div>
            <div class="brixwork_yaletown2_slider formcolor" id="brixwork_yaletown2_sqft_slider"></div>

        </div>
    </div>

    <div class="col-xs-12">
        <div class="brixwork_yaletown2_city_container">
            <select name="listing_search_city" id="brixwork_yaletown2_listing_search_city" class="brixwork_yaletown2_city_select" data-placeholder="Choose a City" autocomplete="off">
                <option value="" selected="selected">Choose A City</option>
				<?php
				$city_query['publish'] = 1;
				$cities = get_areas($city_query);
				foreach($cities as $cityid) {
					$city = new area;
					$city->initialize($cityid);
					if(isset($params['city']) && strtolower($params['city'])==strtolower($city->name)) {
						$selectedtext = ' selected="selected"';
					} else {
						$selectedtext = '';
					}
					echo '<option rel="'.$city->id.'" value="'.$city->name.'" '.$selectedtext.'>'.$city->name.'</option>';
				}
				?>
            </select>
        </div>
        <div class="brixwork_yaletown2_area_container">
            <select name="listing_search_subarea[]" id="brixwork_yaletown2_listing_search_area" class="brixwork_yaletown2_area_select" multiple data-placeholder="Choose City First" autocomplete="off">
                <option value="" selected="selected">Choose Subareas</option>
            </select>
        </div>
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_street_search_container">
            <input type="text" name="listing_search_street" id="brixwork_yaletown2_street_search" class="typeahead" data-provide="typeahead" autocomplete="off" />
            <input type="hidden" name="listing_search_street_dir" value="<?=isset($params['street_dir']) && $params['street_dir']!='' ? $params['street_dir'] : ''?>" />
            <input type="hidden" name="listing_search_street_name" value="<?=isset($params['street_name']) && $params['street_name']!='' ? $params['street_name'] : ''?>" />
            <input type="hidden" name="listing_search_street_type" value="<?=isset($params['street_type']) && $params['street_type']!='' ? $params['street_type'] : ''?>" />
            <input type="hidden" name="listing_search_street_suffix" value="<?=isset($params['street_suffix']) && $params['street_suffix']!='' ? $params['street_suffix'] : ''?>" />
        </div>
    </div>

    <div class="col-xs-12">
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_type_container">
            <select name="listing_search_type" id="brixwork_yaletown2_search_type" data-placeholder="Property Type">
                <option value="">Any Type</option>
				<?php
				$count = 0;
				if(isset($params['type']) && $params['type']!='') {
					$typeid = get_property_type_id($params['type']);
				} else {
					$typeid = false;
				}

				// first get ID of the house type currently selected
				foreach ($searchtype as $id => $title) {
					if($typeid==$id) {
						$selectedtext = ' selected="selected"';
					} else {
						$selectedtext = '';
					}
					?>
                    <option rel="<?=$id?>"<?=$selectedtext;?> value="<?=$settings['type'][$id]?>" ><?=$title;?></option>
					<?php
					$count++;
				} ?>
            </select>
        </div>
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_bed_container">
            <select id="brixwork_yaletown2_search_bedrooms" name="listing_search_bedrooms" autocomplete="off">
                <option value="">All Beds</option>
				<?php
				if(array_key_exists('brixwork_search_min_bedrooms', $settings) && $settings['brixwork_search_min_bedrooms']!='' ) {
					$min_bedrooms = $settings['brixwork_search_min_bedrooms'];

				} else {
					$min_bedrooms = 0;
				}

				if(array_key_exists('brixwork_search_max_bedrooms', $settings) && $settings['brixwork_search_max_bedrooms']!='') {
					$max_bedrooms = $settings['brixwork_search_max_bedrooms'];
				} else {
					$max_bedrooms = 5;
				}
				$bed_count = $min_bedrooms; // start from minimum... not always 0.
				while($bed_count<=$max_bedrooms) {

					if($bed_count <= 3) {
						echo '<option value="'.$bed_count.'" '.(isset($params['bedroom']) && $params['bedroom']*1==$bed_count ? 'selected="selected"': '').'>'.($bed_count==0 ? 'Studio' : $bed_count.' Bedroom'.($bed_count>1 ? 's':'')).'</option>';
					}

					// min bedrooms
					if($bed_count >= 3) {
						echo '<option value="'.$bed_count.'" rel="min" '.(isset($params['min_bedroom']) && $params['min_bedroom']*1==$bed_count ? 'selected="selected"': '').'>'.$bed_count.'+ Bedrooms</option>';
					}

					$bed_count++;
				}
				?>
            </select>
        </div>
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_bath_container">
            <select id="brixwork_yaletown2_search_min_bathrooms" name="listing_search_bathrooms" autocomplete="off">
                <option value="">All Baths</option>
				<?php
				if(array_key_exists('brixwork_search_min_bathrooms', $settings) && $settings['brixwork_search_min_bathrooms']!='') {
					$min_bathrooms = $settings['brixwork_search_min_bathrooms'];
				} else {
					$min_bathrooms = 0;
				}
				if(array_key_exists('brixwork_search_max_bathrooms', $settings) && $settings['brixwork_search_max_bathrooms']!='') {
					$max_bathrooms = $settings['brixwork_search_max_bathrooms'];
				} else {
					$max_bathrooms = 5;
				}

				$bath_count = $min_bathrooms;
				while($bath_count<=$max_bathrooms) {
					if($bath_count <= 3) {
						echo '<option value="'.$bath_count.'" '.(isset($params['bathroom']) && $params['bathroom']*1==$bath_count  ? 'selected="selected"': '').'>'.($bath_count==0 ? 'None' : $bath_count.' Bathroom'.($bath_count>1 ? 's':'')).'</option>';
					}

					// min bathrooms
					if($bath_count >= 3) {
						echo '<option value="'.$bath_count.'" rel="min" '.(isset($params['min_bathroom']) && $params['min_bathroom']*1==$bath_count ? 'selected="selected"': '').'>'.$bath_count.'+ Bathrooms</option>';
					}

					$bath_count++;
				}
				?>
            </select>
        </div>
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_features_container">
            <select id="brixwork_yaletown2_search_features" name="listing_search_features[]" multiple autocomplete="off" data-placeholder="Other Features">
                <option value="" selected="selected" class="select_disabled">No Features</option>
				<?php
				/*
					waterfront
					skihill
					golfcourse
					marina
					gatedcomm
					retirementcomm
				*/
				foreach($settings['home_features'] as $featuredesc => $featurefield) {
					if(is_array($params) && array_key_exists($featurefield, $params)===true) {
						$selectedtext = 'selected="selected"';
					} else {
						$selectedtext = '';
					}
					echo '<option value="'.$featurefield.'" '.$selectedtext.'>'.$featuredesc.'</option>';
				}
				?>
            </select>
        </div>
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_checkbox brixwork_yaletown2_openhouse_container">
            <input type="checkbox" name="listing_search_openhouse" autocomplete="off" id="brixwork_yaletown2_search_openhouse" <?=(isset($params['openhouse']) && $params['openhouse']==1 ? 'checked' : '')?> />
            <label for="brixwork_yaletown2_search_openhouse">&nbsp;Has Open House</label>
        </div>

		<?php
		if (isset($params['keyword']) && $params['keyword'] != '') {
			?>
            <input type="hidden" name="keyword" value="<?= htmlentities($params['keyword'], ENT_QUOTES) ?>" />
			<?php
		}
		if (isset($listing_custom_filename) && $listing_custom_filename != '') {
			?>
            <input type="hidden" value="<?= htmlentities($listing_custom_filename, ENT_QUOTES) ?>" name="listing_custom_filename" autocomplete="off" />
			<?php
		}
		?>
    </div>



    <div class="col-xs-12">
		<?php
		// show the standard area/subarea based listing search ONLY if the bldg param is OFF.
		if (isset($params['bldg']) || isset($params['building'])) {
			?>
            <input type="hidden" name="listing_bldg" value="<?=(array_key_exists('bldg', $params) ? htmlentities($params['bldg'], ENT_QUOTES) : '')?>" />
            <input type="hidden" name="listing_building" value="<?= (array_key_exists('building', $params) ? htmlentities($params['building'], ENT_QUOTES) : '')  ?>" />
			<?php
		} else {
			?>
            <div class="brixwork_yaletown2_criterion brixwork_yaletown2_orderby_container">
                <select name="listing_order_by" id="brixwork_yaletown2_listing_order_by" autocomplete="off">
                    <option value="create_date"<?=((isset($params['order_by']) && $params['order_by']=='create_date') || !isset($params['order_by']) ? ' selected="selected"': '')?>>Date Listed</option>
                    <option value="price"<?=(isset($params['order_by']) && $params['order_by']=='price' ? ' selected="selected"' : '')?>>Listed Price</option>
                    <option value="sqft"<?=(isset($params['order_by']) && $params['order_by']=='sqft'? ' selected="selected"': '')?>>Size of Home</option>
                    <option value="bedroom"<?=(isset($params['order_by']) && $params['order_by']=='bedroom' ? ' selected="selected"' : '')?>>Bedrooms</option>
                    <option value="bathroom"<?=(isset($params['order_by']) && $params['order_by']=='bathroom' ? ' selected="selected"' : '')?>>Bathrooms</option>
                </select>
            </div>
            <div class="brixwork_yaletown2_criterion brixwork_yaletown2_orderdir_container">
                <select name="listing_order_direction" id="brixwork_yaletown2_listing_order_direction" autocomplete="off" data-placeholder="Order Direction">
                    <option value="DESC"> </option>
                    <option value="ASC"<?=(isset($params['order_direction']) && $params['order_direction']=='ASC' ? ' selected="selected"' : '')?>> </option>
                </select>
            </div>
			<?php
		} // end of block that hides the order by if building ID is set in params.
		?>
        <div class="brixwork_yaletown2_criterion brixwork_yaletown2_submit_container">
            <input type="button" id="listing_search_submit" value="Refine Search" class="btn-yt2" />
        </div>
    </div>
</form>
