<?php
//require_once 'start.php';
set_time_limit(0); // no limit

// for upgrade we need more RAM, and show all errors for easy troubleshooting.
ini_set('display_errors', 1);
ini_set('memory_limit','512M');
error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING);

ob_start();
/*
 * 2022-12-29 Testing line replacement to handle the PHP7 to 8 upgrades on template files that cannot easily be upgraded.
 * */

/*
Let's create an array of files & possible folders under which to look for (sometimes may have to search by depth)
And each one  can have a sub array of lines to be replaced with - That way we can keep tab of files & lines firmly, and verbosely.
*/

$files_with_faulty_lines = array(); // declare empty array.

/*

DISABLING ONES THAT ALREADY RAN - 2023-07-10

$files_with_faulty_lines[] = array(
	'depth' => 2, // /templates/main/
	'filename' => 'functions.php',
	'lines' => array(
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$bbs = \'<div class="bbs_wrapper">\' . implode($info_array, \' <span class="dot">•</span> \') . \'</div>\';'
			),
			'replace' => '$bbs = \'<div class="bbs_wrapper">\' . implode(\' <span class="dot">•</span> \', $info_array ) . \'</div>\';'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$bbs = \'<div class="bbs_wrapper">\' . implode($info_array, \' <span class="dot">|</span> \') . \'</div>\';'
			),
			'replace' => '$bbs = \'<div class="bbs_wrapper">\' . implode(\' <span class="dot">|</span> \', $info_array ) . \'</div>\';'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if(count($bbs_array) > 3) {'
			),
			'replace' => 'if(is_countable($bbs_array) && count($bbs_array) > 3) {'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$bbs = \'\';'
			),
			'replace' => '$bbs = array();'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if(count($bbs_array > 3)) {'
			),
			'replace' => 'if(is_countable($bbs_array) && count($bbs_array) > 3) {'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'function listings_swipe_gallery(home $h, $main_img_num = 0, $plink = \'\', $noimage, $class = \'\', $num_carousel_photos = 3) {'
			),
			'replace' => 'function listings_swipe_gallery(home $h, $main_img_num = 0, $plink = \'\', $noimage=\'\', $class = \'\', $num_carousel_photos = 3) {'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'function build_three_col_object( $agent_image_number = 1, $col_page, $col_agent ) {'
			),
			'replace' => 'function build_three_col_object( $agent_image_number = 1, $col_page = false, $col_agent = false ) {'
		)
	)
);



$files_with_faulty_lines[] = array(
	'depth' => 2,
	'filename' => 'header_html.php',
	'lines' => array(
		array(
			'catch' => array(
				'preg' => false,
				'line' => '\'header_search_icon\' 	 => get_svg(file_get_contents(\'images/icons/header_search_icon.svg\', true)),'
			),
			'replace' => '\'header_search_icon\' 	 => get_svg(file_get_contents($settings[\'includepath\'].\'images/icons/header_search_icon.svg\', true)),'
		),

		array(
			'catch' => array(
				'preg' => false,
				'line' => '\'header_search_icon\' 	 => get_svg(file_get_contents(\'images/icons/header_menu_icon.svg\', true)),'
			),
			'replace' => '\'header_search_icon\' 	 => get_svg(file_get_contents($settings[\'includepath\'].\'images/icons/header_menu_icon.svg\', true)),'
		),

		array(
			'catch' => array(
				'preg' => false,
				'line' => '\'header_search_icon\' 	 => get_svg(file_get_contents(\'images/icons/header_menu_close_icon.svg\', true)),'
			),
			'replace' => '\'header_search_icon\' 	 => get_svg(file_get_contents($settings[\'includepath\'].\'images/icons/header_menu_close_icon.svg\', true)),'
		),

		array(
			'catch' => array(
				'preg' => false,
				'line' => '\'header_search_icon\' 	 => get_svg(file_get_contents(\'images/icons/header_menu_call_icon.svg\', true)),'
			),
			'replace' => '\'header_search_icon\' 	 => get_svg(file_get_contents($settings[\'includepath\'].\'images/icons/header_menu_call_icon.svg\', true)),'
		),

		array(
			'catch' => array(
				'preg' => false,
				'line' => '\'header_search_icon\' 	 => get_svg(file_get_contents(\'images/icons/header_menu_email_icon.svg\', true)),'
			),
			'replace' => '\'header_search_icon\' 	 => get_svg(file_get_contents($settings[\'includepath\'].\'images/icons/header_menu_email_icon.svg\', true)),'
		),
	)
);




$files_with_faulty_lines[] = array(
	'depth' => 2,
	'filename' => 'index.php',
	'lines' => array(
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$slides=\'\';'
			),
			'replace' => '$slides=array();'
		),

	)
);

*/


$files_with_faulty_lines[] = array(
	//'depth' => 2,
	'folder' => 'templates/main/',
	// 'filename' => 'links.php', // soe are named links.php, others resources.php... might as well not specify.
	'lines' => array(
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if (count($resources)>0 && $resources) {'
			),
			'replace' => 'if(is_countable($resources) && count($resources)>0) {'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if(count($resources)>0 && $resources) {'
			),
			'replace' => 'if(is_countable($resources) && count($resources)>0) {'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => '<?if ($thispage->content != \'\') {?>'
			),
			'replace' => '<?php if ($thispage->content != \'\') {?>'
		),

		array(
			'catch' => array(
				'preg' => false,
				'line' => '<?}?>'
			),
			'replace' => '<?php } ?>'
		),
	)
);



$files_with_faulty_lines[] = array(
	'depth' => 1,
	'filename' => 'wp-config.php',
	'lines' => array(
		array(
			'catch' => array(
				'preg' => true,
				'pattern_match' => '/\bdefine\s*\(\s*["\']?DB_HOST["\']?\s*,\s*["\']?localhost["\']?\s*\)/',
				'pattern_replace' => '/localhost/' // define ONLY the block to replace.
			),
			'replace' => "brixwork-m-2023.ctltldql7oq9.us-west-2.rds.amazonaws.com:3306"
		),
	)
);


$files_with_faulty_lines[] = array(
	'depth' => 1,
	'filename' => '.user.ini',
	'lines' => array(
		array(
			'catch' => array(
				'preg' => true,
				'pattern_match' => '^auto_prepend_file.*\/home\/[a-z0-9_-]+\/public_html.*wordfence-waf',
				'pattern_replace' => '\/home\/' // define ONLY the block to replace.
			),
			'replace' => "/home3/"
		),
	)
);


$files_with_faulty_lines[] = array(
	'folder' => 'templates/main/',
	// 'filename' => 'listings.php',
	// this can be in sold-lisings.php, properties.php etc.
	'lines' => array(
		array(
			'catch' => array(
				'preg' => true, // when it's regular expression, we often need different patterns for detectin (preg_match) vs replacing (preg_replace)
				'pattern_match' => '/(\$sold,)(\s*\$query,\s*\$order_by,\s*\$order_direction)/', // detects this after spaces & tabs are replaced.
				'pattern_replace' => '/\$sold/' // define ONLY the block to replace.
			),
			'replace' => "''"
		),
	)
);


/*
 * DISABLING ONES THAT ALREADY RAN - 2023-07-10
$files_with_faulty_lines[] = array(
	'depth' => 2,
	'filename' => 'showlisting.php',
	'lines' => array(
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if (count($listings_ids) > 0) {'
			),
			'replace' => 'if ($listings_ids && count($listings_ids) > 0) {'
		),
	)
);
*/

/* /templates/main/includes/header_html.php issues to write out:

'header_search_icon' 	 => get_svg(file_get_contents('images/icons/header_search_icon.svg', true)),
	'header_menu_icon' 		 => get_svg(file_get_contents('images/icons/header_menu_icon.svg', true)),
	'header_menu_close_icon' => get_svg(file_get_contents('images/icons/header_menu_close_icon.svg', true)),
	'header_menu_call_icon'	 => get_svg(file_get_contents('images/icons/header_menu_call_icon.svg', true)),
	'header_menu_email_icon' => get_svg(file_get_contents('images/icons/header_menu_email_icon.svg', true)),


All these need $settings['includepath']. before!
*/

/*

$files_with_faulty_lines[] = array(
	'folder' => 'templates/main/',
	// 'filename' => 'listings.php',
	// this can be in sold-lisings.php, properties.php etc.
	'lines' => array(
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$is_sold = (isset($query[\'sold\']) and !(($query[\'sold\'] === 0) or in_array(0, $query[\'sold\'])));'
			),
			'replace' => '$is_sold = (isset($query[\'sold\']) and !(($query[\'sold\'] === 0) or (is_array($query[\'sold\']) && in_array(0, $query[\'sold\']))));'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$scriptinclude_footer = \'index.js\';'
			),
			'replace' => '$scriptinclude_footer = array(); $scriptinclude_footer[] = \'index.js\';'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if ( count($resources) > 0 && $resources ) { ?>'
			),
			'replace' => 'if (is_countable($resources) && count($resources) > 0) { ?>'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => 'if ( count($listing_agents) > 1 ) {'
			),
			'replace' => 'if ( is_countable($listing_agents) && count($listing_agents) > 1 ) {'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$static_map_url .= ($lat != \'\' ? \'&center="\'.$lat.\',\'.$long.\'"\' : \'\');'
			),
			'replace' => '$static_map_url .= ($lat != \'\' ? \'&center=\'.$lat.\',\'.$long.\'\' : \'\');'
		),
		array(
			'catch' => array(
				'preg' => false,
				'line' => '$agent_name = implode($listing_agents["first_names"], \', \');'
			),
			'replace' => '$agent_name = implode(\', \', $listing_agents["first_names"]);'
		),
		array(
			'catch' => array(
				'preg' => true, // when it's regular expression, we often need different patterns for detectin (preg_match) vs replacing (preg_replace)
				'pattern_match' => '/^<\?$/', // detects this after spaces & tabs are replaced.
				'pattern_replace' => '/<\?/' // to replace, we need to ignore spaces etc. so cannot start/end wwidth.
			),
			'replace' => '<?php  '
		),
	)
);

 */


/*
 * DISABLING ONES THAT ALREADY RAN - 2023-07-10

$files_with_faulty_lines[] = array(
'depth' => 4, // blog/wp-content/themes/_____/*.php
'filename' => 'functions.php',
'lines' => array(
	array( // we never use this widget anyways
		'catch' => array(
			'preg' => false,
			'line' => 'register_widget( \'Twenty_Eleven_Ephemera_Widget\' );'
		),
		'replace' => '//register_widget( \'Twenty_Eleven_Ephemera_Widget\' );'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(THREE_ACROSS, true);'
		),
		'replace' => 'define(\'THREE_ACROSS\', true);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(THREE_ACROSS, false);'
		),
		'replace' => 'define(\'THREE_ACROSS\', false);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(THREE_ACROSS, $_GET[\'across\'] == 3);'
		),
		'replace' => 'define(\'THREE_ACROSS\', $_GET[\'across\'] == 3);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => '$categories_list = get_the_category_list(__((!THREE_ACCROSS ? \', \' : \' \'), \'twentyeleven\'));'
		),
		'replace' => '$categories_list = get_the_category_list(\' \');'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(ARTICLE_COL_GALLERY, $article_column_size_gallery);'
		),
		'replace' => 'define(\'ARTICLE_COL_GALLERY\', $article_column_size_gallery);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(ARTICLE_COL_CARD, $article_column_size_card);'
		),
		'replace' => 'define(\'ARTICLE_COL_CARD\', $article_column_size_card);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(SIDEBAR_COL, $sidebar_column_size);'
		),
		'replace' => 'define(\'SIDEBAR_COL\', $sidebar_column_size);'
	)
)
);




$files_with_faulty_lines[] = array(
'depth' => 4, // blog/wp-content/themes/_____/*.php
'filename' => 'content.php',
'lines' => array(

	array(
		'catch' => array(
			'preg' => false,
			'line' => '$categories_list = get_the_category_list(__((!THREE_ACCROSS ? \', \' : \' \'), \'twentyeleven\'));'
		),
		'replace' => '$categories_list = get_the_category_list(\' \');'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => '$categories_list = get_the_category_list(__((!THREE_ACCROSS ? \', \' : \' \'), \'twentyeleven\'));'
		),
		'replace' => '$categories_list = get_the_category_list(\' \');'
	),
)
);


$files_with_faulty_lines[] = array(
'depth' => 4, // blog/wp-content/themes/_____/*.php
'filename' => 'content-single.php',
'lines' => array(

	array(
		'catch' => array(
			'preg' => false,
			'line' => "<? if(count(wp_get_related_posts()) != 0) { ?>"
		),
		'replace' => "<?php if(function_exists(\"wp_get_related_posts\") && count(wp_get_related_posts()) != 0) { ?>"
	),

	array(
		'catch' => array(
			'preg' => false,
			'line' => "if (has_post_video()) {"
		),
		'replace' => "if (function_exists('has_post_video') && has_post_video()) {"
	),
)
);


$files_with_faulty_lines[] = array(
'depth' => 4, // blog/wp-content/themes/_____/*.php
'filename' => 'header.php',
'lines' => array(

	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(ARTICLE_COL_GALLERY, $article_column_size_gallery);'
		),
		'replace' => 'define(\'ARTICLE_COL_GALLERY\', $article_column_size_gallery);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(ARTICLE_COL_CARD, $article_column_size_card);'
		),
		'replace' => 'define(\'ARTICLE_COL_CARD\', $article_column_size_card);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(SIDEBAR_COL, $sidebar_column_size);'
		),
		'replace' => 'define(\'SIDEBAR_COL\', $sidebar_column_size);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(THREE_ACROSS, true);'
		),
		'replace' => 'define("THREE_ACROSS", true);'
	),
	array(
		'catch' => array(
			'preg' => false,
			'line' => 'define(THREE_ACROSS, false);'
		),
		'replace' => 'define("THREE_ACROSS", false);'
	)
)
);
*/



/*
 * Needs either:
 * A. File location firmly (including exact folder)
 * B. Depth of folder from the web root.
 *
 * Definitely needs:
 * A. Filename to look for under specific folder, or depth
 *
 * Array of lines to chagne
 * - Array within an array.
 * To Match for either:
 * -- Strict line
 * -- Preg match,
 *
 * */

/**
 * @param $folder
 * @param $filepath
 * @param $replacetarget
 * @param $replacecontent
 * @return void
 */
function replace_file_lines($folder, $filepath, $linesets) {

	if(preg_match('/\/$/', $folder)===0) {
		// missing slash at the end.
		$folder = $folder.'/';
	}

	$filehandle = fopen($folder.$filepath, "r");
	// blank array of lines to catch, and back up the old lines just in case as a backup?
	$targetlines = array();
	$targetlines_backup = array();
	if ($filehandle) {
		$fileline = 0;
		$generate_new_file = false; // no backup file needs to be created unless we have at least one line to swap out.
		while (!feof($filehandle)) {
			$fileline++;
			$line = fgets($filehandle);

			// process the line read. Use $thisline to compare, but replace from $line to preserve leading tab/space indents..
			$compareline = trim(preg_replace('/\t+/', '', $line));
			//$compareline = str_ireplace(array('  ', '   '), array(' ',' '), $compareline); // double spaces to single space just incase.
			// clean up tabs, spaces around etc.

			$replace = false;
			foreach($linesets as $linekey=>$lineset) {
				if($lineset['catch']['preg']===true) {
					// run preg match.
					if(preg_match($lineset['catch']['pattern_match'], $compareline)===1) {
						$replace = true;
					}
				} else {
					if(stripos($compareline, trim($lineset['catch']['line']))!==false) {
						$replace = true;
						echo "LINE MATCH at ".$fileline."<br />".PHP_EOL;
					}
				}

				if($replace===true) {
					if($lineset['catch']['preg']===true) {
						$newline = preg_replace($lineset['catch']['pattern_replace'], $lineset['replace'], $line);
						// to preserve any tabs or indents, we keep original stuff.
						echo "Regex ".$lineset['catch']['pattern_match']."  swap to ".$lineset['replace']." line (#".$fileline.") with: ".htmlspecialchars($newline)."<br />".PHP_EOL;
					} else {
						$newline = str_ireplace(trim($lineset['catch']['line']), $lineset['replace'], $line);
						// to preserve any tabs or indents, we keep original stuff.
						echo "Replacing line with:<br />".$newline."<br />".PHP_EOL;
					}

					// If at least one line is swapped, create a new file to back up to just in case.
					if($generate_new_file==false) {
						// new file needs to be generated only ONCE, if we detect lines that need to be replaced.
						$newfile = $folder.$filepath.'.bu';
						echo "Creating new file at ".$newfile."<br />".PHP_EOL;
						copy ($folder.$filepath, $newfile); // copy over file as a backup.
						chmod ( $newfile , 0644);
						$generate_new_file = true;
					}
					break;
				}
			}

			if($replace===false) {
				// $newline was not made from a match.
				$newline = $line; // use as it was.
			}
			$targetlines[] = $newline;
		}
		fclose($filehandle);
		if($generate_new_file===true) {
			echo $newfile." backup created: ".file_exists($newfile)."<br />\n";
		} else {
//			echo "No changes in ".$filepath."<br />";
		}

		if($generate_new_file === true && file_exists($newfile)==true) {
			// for now disable the actual rewrite with the 1==2
			// only proceed if the new file was successfully written.

			if(count($targetlines)>10) {
				// write new file!
				echo "Writing fixed file at ".$folder.$filepath."<br />".PHP_EOL;
				$filehandle = fopen($folder.$filepath, 'w');
				foreach ($targetlines as $writelines) {
					// write out each line.
					fwrite($filehandle, $writelines);
				}
				fclose($filehandle);
				chmod ( $folder.$filepath , 0644);
			}
		}
	} else {
		// error opening the file.
		echo "Failed to open: ".$folder.$filepath."<br />";
	}
}



/*
 * Master function to loop through some folders.
 * But to save CPU, let's exclude admin, includes, js, css, images folders etc.
 * */


$exclude = array(
	'/.',
	'/..',
	'/admin/*', // everything under /admin/ as the stem, exclude.
	'/ajax/*',
	'/cron/*',
	'*/css/',
	'/images/*',
	'/includes/*',
	'*/wp-includes/*', // any path that has wp-includes in its folders, regardless of start or end, exclude.
	'*/wp-admin/*',
	'*/wp-plugins/*',
	'/js/*',
	'.bu', // all file extensions .bu is excluded.
	'.php.bu',
	'.backup',
	'/packages/*',
	'/packages_8/*',
	'/vendor_disable/*',
	'/vendor/*',
	'config.inc', // by filename, reglardless of what level.
	// 'wp-config.php',
	'.htaccess'
);

/**
 * This function, when used in a directory/folder loop such as RecursiveDirectoryIterator,
 * will decide which files/folders to process & scan for whatever purpose, or exclude if it meets the exclusion criteria.
 *
 * Note - this function will generally run on upgrade.php or other one-time usage scripts as we don't need to keep replacing lines on a file,
 * so it will generally be used as a stand-alone function, and not included in admin/functions.php or admin/admin_functions.php etc.
 * - Jeff Kee (2023-01-07)
 *
 * @param $fullpath
 * @param $exclude
 * @param $mindepth
 * @return bool
 */

function is_excluded($folder, $file, $exclude, $mindepth = 1) {
	// TRUE return means exclusion filter was matched, so do not process.
	// for file replacement scan to happen, we want it to return FALSE.
	$return = false;

	$folder = clean_folder_path($folder);

	$depth = get_folder_depth($folder);
	if($depth<$mindepth) {
		// echo "<br />Skipping ".$folder.'/'.$file." due to depth (".$depth.")<br />".PHP_EOL;
		return true;
		// depth not matched, don't even bother with other things.
	}

	if($file=='.' || $file == '..' || strpos($file, '.php')===false) {
		return true;
		// exclude the folder notations, or non-PHP files altogether.
	}

	// split filename suchas wp-config.php to
	// $filename = 'wp-config' (not used)
	// $extension = 'php';
	$pathinfo = pathinfo($file);
	$extension = $pathinfo['extension'];

	foreach($exclude as $excludepattern) {
		if(strpos($excludepattern, '/')!==false) {
			// folder exclusion.
			if(preg_match('/\*$/', $excludepattern)===1 && preg_match('/^\//', $excludepattern)===1) {
				// /includes/*  type of exclusions... exclude all items under a certain subfolder - most commmon type.
				if(strpos($folder, substr($excludepattern, 1, strlen($excludepattern)-3)) === 0) {
					// remove the /* from the end as well as the preceding / and compare the folder root, exclude all subitems.
					// Make sure we compare the STARTING WITH.
//					echo $folder.' is sub folder of '.$excludepattern."<br />".PHP_EOL;
					$return = true;
				}
			} else if(preg_match('/^\*/', $excludepattern)===1 && preg_match('/\/$/', $excludepattern)===1) {
				// */wp-includes/ type of exclusion, so exclude certain END folders regardless of how they begin, or depth.
				$folders = array_reverse(explode('/', $folder));
				$lastfolder = ($folders[0] != '' ? $folders[0] : $folders[1]); // maybe the folder had a / at the end, which means the last folder will return blank.
				$strposresult = strpos($lastfolder, substr($excludepattern, 2, strlen($excludepattern)-3));
//				echo "Comparing last folder: ".$lastfolder." (original: ".$folder."/".$file.") vs ".substr($excludepattern, 2, strlen($excludepattern)-3)."<br />".PHP_EOL;
				if($strposresult===0) { // compare without the preceding */ against last folder.
					// remove the * from the end and compare the folder root, exclude all subitems.
					//echo $lastfolder.' is the last folder, matches '.$excludepattern."<br />".PHP_EOL;
					$return = true;
				}
			} else if(preg_match('/^\*/', $excludepattern)===1 && preg_match('/\*$/', $excludepattern)===1) {
				// */wp-includes/* type.. exclude all under wp-includes, regardless of the step folder (if any of the folder paths match, basically)
				$folders = explode('/', $folder);
				list($head, $folder_to_exclude, $trail) = explode('/', $excludepattern); // turn */wp-includes/* to get wp-includes only.
				foreach($folders as $folderpath) {
					if($folderpath==$folder_to_exclude) {
						$return = true; // found a sub match.
//						echo $folderpath.' is part of the comp path '.$folder_to_exclude."<br />".PHP_EOL;
					}
				}
			} else {
				// exclude only this specific folder, but let the subfodlers be detected.
				if($excludepattern==$folder) {
					echo $folder.' exact match to '.$excludepattern."<br />".PHP_EOL;
					$return = true;
				}
			}
		} else if(strpos($excludepattern, '.')!==false) {
			// filetype detector.
			if(strpos($excludepattern, '.')===0) {
				// starts with ., so all files with extension matching at the end.
				if(substr($excludepattern, 1) == $extension) {
					// extension matches.
					echo substr($excludepattern, 1).' extension detected at '.$file."<br />".PHP_EOL;
					$return = true;
				}
			} else{
				// exact filename?
				if($excludepattern == $file) {
//					echo $excludepattern.' filename full match at '.$file."<br />".PHP_EOL;
					$return = true;
				}
			}
		} else {
			echo "Unknown exclusion pattern at ".$excludepattern."<br />";
		}
	}
	return $return;
}

function split_folder_file($fullpath) {
	// first split the full path to folder & filename for ease of processing.
	$pathinfo = pathinfo($fullpath);

	$folder = $pathinfo['dirname'];
	$file = $pathinfo['basename'];

	$result = array(
		$folder,
		$file
	);
	return $result;
}

function clean_folder_path($folder) {
	if(preg_match('/\/$/', $folder)===0) {
		// missing ending /
		$folder = $folder.'/';
	}

	if(preg_match('/^\./', $folder)===1) {
		$folder = substr($folder, 2); // remove preceding ./
	}

	return $folder;
}

function get_folder_depth($folder) {
	// make sure to remove the last one?
	if(preg_match('/\/$/', $folder)===1) {
		$folder = substr($folder, 0, strlen($folder)-1); // cut the last / out.
		// brixwork has a function for this, but this has to run standalone on upgrade.php so we write in all functions raw.
	}
	$depth = substr_count($folder, '/') + ($folder!='' ? 1 : 0); // if there's a folder path, even without trailing or starting / it's at least 1 folder.
	return $depth;
}


function file_needs_checking($folder, $filename, $files_to_check) {
	$match = false; // default to false match until a pattern is found.
	$folder = clean_folder_path($folder);
	$depth = get_folder_depth($folder);



	foreach($files_to_check as $file) {
		if(
			(
				(isset($file['depth']) && $depth==$file['depth'])
				||
				(isset($file['folder']) && strpos($folder, $file['folder'])!==false)
			)
			&&
			(!isset($file['filename']) || ($file['filename']==$filename && $filename!=''))
		) {
			if($match===false) {
				unset($match);
				$match = array();
			}
			foreach($file['lines'] as $line) {
				/*
				 * each LINE is a set of rules to find & replace:
				 *
				 * [0] => Array
                (
                    [catch] => Array
                        (
                            [preg] =>
                            [line] => define(ARTICLE_COL_GALLERY, $article_column_size_gallery);
                        )

                    [replace] => define('ARTICLE_COL_GALLERY', $article_column_size_gallery);
                )
				 *
				 * */
				$match[] = $line;
			}
		}
	}

	return $match;

}

$folder_root = '.';

$directory = new RecursiveDirectoryIterator($folder_root);
// would start at templates, or blog, but we don't know if they're all named "blog" for wordpress.
// need to loop through all subfolders but put a depth limiteer instead.

$iterator = new RecursiveIteratorIterator($directory);

$updated_files_count = 0; // count how many.

foreach ($iterator as $info) {
	$filepath = $info->getPathname();
	list($folder, $filename) = split_folder_file($filepath);
	// here, the $folder will contain the relative path such as "./" to open.
	$excluded = is_excluded($folder, $filename, $exclude, 1);

	if($excluded!==true) {
		$check = file_needs_checking($folder, $filename, $files_with_faulty_lines);
		if(strpos($folder, 'realty_blog')!==false) {
			//echo "Checking ".$folder."/".$filename.", need check: ".($check===false ? "FALSE" : count($check))."<br />".PHP_EOL;
		}
		if($check!==false) {
			echo "<br />Scan file for line replace on ".$filepath."<br />".PHP_EOL;

			echo "<br />".PHP_EOL;

			replace_file_lines($folder, $filename, $check);
		}
	} else {
		// echo "Excluding ".$filepath."<br />".PHP_EOL;
	}
}

?>