<?php
/*
Filename: classes.php

Method: INCLUDE
Output: INCLUDE

Description: Master class object file that holds all!

Author: Jeff Kee
*/

// the class home! The mothership.
class home {
	var $objecttype = false;

	var $data;

	var $id;
	var $publish;
	var $feature;

	var $modify_date;
	var $create_date;
	var $timestamp;
	var $phpfile;
	var $photo_timestamp;


	var $agent_1;
	var $agent_2;
	var $agent_3;
	var $sold;
	var $type;
	var $parcel_id; // comes from the `pid` column in the `homes` table. Changing the name to avoid confusion with $data['pid'] we use for PHoto ID on JOIN statement with `photos` table.
	var $zoning;
	var $address;
	var $building;
	var $price;
	var $prevprice;
	var $soldprice;



	var $area = '';
	var $city = '';

	var $areaid = false;
	var $cityid = false;
	var $area_altid = false;

	var $postal;
	var $areacity;
	var $fulladdress;
	var $heading;
	var $heading2;
	var $remarks;
	var $desc;
	var $desc2;
	var $keywords; // default set of keywords built up based on data, later to be mearged into $metakeywords
	var $metakeywords; // used for SEO
	var $metadescription; // used for SEO

	var $bedroom;
	var $den;
	var $flex;
	var $bathroom;
	var $maintenance;
	var $year;

	var $sqft;
	var $lot;
	var $lot_acres;//for future use
	var $lot_hectares;//for future use
	var $frontage;
	var $depth;

	var $land_title;

	// photos, attached media etc.
	var $mainphoto;
	var $pdf;
	var $photos;
	var $floorplan_exists;
	var $featuresheet_exists;
	var $pdf_labels;
	var $youtube;
	var $vimeo;
	var $videourl;
	var $videoembedurl;
	var $video_exists;
	var $gallery_exists;
	var $virtualtour;

	var $openhouse;

	// rental stuff add-on
	var $for_rent;
	var $rental_price_display;
	var $rental_price_day;
	var $rental_price_week;
	var $rental_price_month;
	var $rental_period;
	var $rental_min_term;
	var $rental_furnished;
	var $rental_pets;
	var $rental_smoking;
	var $rental_parking;
	var $rental_washerdryer;
	var $rental_dishwasher;
	var $rental_availability;

	var $features;
	var $featuresdisplay;

	//commercial stuff add on (JJ)
	var $comm_sub_type;

	var $comm_price_sqft_y;
	var $comm_price_addl_y;
	var $comm_rental_rate;

	var $comm_price;
	var	$price_sqf_m;
	var	$price_tot_y;
	var	$price_tot_m;
	var $price_per_sqf;	// $ / sqft !! for sale properties only. For lease, use $comm_price for $ per sqft per year total.

	var $comm_min_divisible;
	var $comm_availability;
	var $comm_use_type;
	var $comm_commission_split;
	var $comm_cap_rate;
	var $comm_occupancy;
	var $comm_tenancy;
	var $comm_tenant;
	var $comm_tenant_sqft;
	var $comm_tenant_lease_end;
	var $comm_financial_year;
	var $comm_financial_income;
	var $comm_financial_expenses;
	var $comm_parking_ratio;

	// vars that are added as part of the RETS upgrade
	var $source; // 0 is manually loaded, 1 means through MLS
	var $firm_1;
	var $firm_2;
	var $firm_1_id;
	var $firm_2_id;
	var $firm_phone_1;
	var $firm_phone_2;
	var $firm_fax_1;
	var $firm_fax_2;
	var $realtor_1;
	var $realtor_2;
	var $realtor_3;
	var $realtor_id_1;
	var $realtor_id_2;
	var $realtor_id_3;

	var $realtor_phone_1;
	var $realtor_phone_2;
	var $realtor_phone_3;


	//custom fields for custom home features
	var $custom_fields;

	// status fields to figure out photo fetch status etc.
	var $photos_fetched = false; // defaults to false.

	function initialize($id, $homearray = false) {
		global $mysql_time;
		global $settings;
		global $local;
		global $mysqli;
		global $today;

		$data = false;

		$skipphotos = false; // by default we do not skip photos.

		/*
		 * 2024 upgrade,
		 * $id can be an array with 'mls' or 'id' or 'masterid' etc. (flexible!) in it.
		 * This allows usage such as /showlisting/mls-R2874952/1234-street-name-area-city/ type of URLs.
		 * This helps with memcache primary since memcache retrievals are done by MLS number to avoid redundant cache.
		 * If $id is an integer, we assuem it's the PRIMARY ID (original method)
		 *
		 * */
		if($homearray===false || count($homearray)<10) {
			// default way of querying based on input of home ID.
			// OR, For memcache not set yet, we just get $homearray['id'] and nothing else.. a good result will have almost 200 array count. Min 10 is good.
			// the get_properties() function is designed to get enough information to show the list of listings (listing gallery) for display, so even though it may be tempting to replace the below query with another iteration of get_properties('', $query['id'],...);, DONT DO IT. - JEff 2017-09-20

			$memcache_params = array(
				'type'=>'home'
			);

			if(is_array($id)) {
				if(isset($id['mls']) && $id['mls']!='') {
					// very unlikelyl this will be used.. get_properties() gets memcache for all the MLS listings and feeds into $homearray.
					$home_where = "LOWER(h.mls)='".strtolower($mysqli->real_escape_string($id['mls']))."'";
					$memcache_params['mlsnum'] = trim($id['mls']);
					$memcache_params['listingsource']=BRIX_LISTING_MLS;
				} else if(isset($id['masterid']) && $id['masterid']!='') {
					$home_where = "h.masterid='".$mysqli->real_escape_string($id['masterid'])."'";
				} else if(isset($id['id']) && $id['id']!='') {
					// Highly unlikely this will be used.. get_properties() will figure it out.
					$home_where = "h.id='".$mysqli->real_escape_string($id['id'])."'";
					$memcache_params['objectid'] = trim($id['id']);
					$memcache_params['listingsource']=BRIX_LISTING_OWN;
				}
			} else {
				// in case $home->initialize(ID) is set without anything else.
				// fallback to $id - could be int or string format, doesn't matter.
				$home_where = "h.id='".$mysqli->real_escape_string($id)."'";
				$memcache_params['objectid'] = trim($id);
				$memcache_params['listingsource']=0;
			}

			$memcache_data = get_memcache($memcache_params);

			if(DEBUG==true) {
				echo "Data array count was ".(is_array($homearray) ? count($homearray) : "FALSE").", for home object retrieval:<br  />".PHP_EOL;
				if(is_array($memcache_data)) {
					echo "Got Memcache for home object (".count($memcache_data)." rows) using params:<br />".PHP_EOL;
					print_r($memcache_params);
				} else {
					echo "No memcache for this home object.<br />".PHP_EOL;
				}
				echo "SQL Query count so far: ".$GLOBALS[BRIX_PAGES_QUERY]."<br />".PHP_EOL;
			}

			if(is_array($memcache_data)) {
				$data = $memcache_data;
			} else {
				$sql = "SELECT 
       				h.*, 
       				h.pid as parcel_id, 
       				a.name as subarea_name, 
       				aa.name AS subarea_alt_name, 
       				a.id AS areaid, 
       				aa.id AS areaaltid, 
       				c.name as city_name, 
       				c.id AS cityid, 
       				p.id as pid, 
       				p.filename as filename, 
       				p.timestamp as photo_timestamp 
					FROM `homes` h 
					    LEFT OUTER JOIN `subareas` a ON h.area=a.id 
					    LEFT OUTER JOIN `subareas` aa ON h.area_alt=aa.id 
					    LEFT OUTER JOIN `areas` c ON h.city=c.id 
					    LEFT OUTER JOIN `photos` p on h.id=p.home 
			WHERE ".$home_where." GROUP BY h.id ";
				// had to manually add "parcel_id" from 'pid' column, as this stupid query takes photo ID as pid on JOIN.

				$result = $mysqli->query($sql);
				$GLOBALS[BRIX_PAGES_QUERY]++;
				if($result->num_rows>0) {
					$data = $result->fetch_assoc();
					$memcache_params = array(
						'type'=>'listing',
						'listingsource'=>$data['source']
					);

					// even if listing was initialized by PRIMARY ID, if its source=1 (MLS) listing we store as MLS type key in memcache.
					if($data['source']==1 && $data['mls']!='') {
						$memcache_params['mlsnum'] = $data['mls'];
						unset($memcache_params['objectid']);
					} else if($data['source']==0) {
						$memcache_params['objectid'] = $data['id'];
					}

					$listing_cache_key = get_memcache($memcache_params, $data);

					if(DEBUG===true) {
						echo "Save to Memcache from SQL with params: <br />".PHP_EOL;
						print_r($memcache_params);
						echo PHP_EOL."<br />New Key: ".$listing_cache_key."<br />".PHP_EOL;
					}
				} else {
					// Lilsting does not exist.
					// DO NOT expire memcache here however.
					// With no source column, we can't even determine the key to delete anyway.
					// publish=0, or non-existent listings should simply not show up under get_properties() results.
					$data = false;
				}

				if(DEBUG===true) {
					echo "Home SQL: {$sql}<br />\n";
					echo "Num Rows: {$result->num_rows}<br />\n";
				}
			}

		} else if(is_array($homearray)) {
			// retrieve from the $data array - the get_properties function already returned a lot of the fields to speed it up, this reduces query time for map searches.
			$data = $homearray;// feed $homearray into $data then start processing the data only, bypass the MySQL query.
			if(DEBUG==true) {
				echo "Memcache flag on home array: ".(isset($homearray['memcache']) && $homearray['memcache']===true ? "true" : "false")."<br />".PHP_EOL;
			}
		}

		if($data['source']==1) {
			$skipphotos = true;
			// In case it's a fast load on listing gallery page, skip photo load. Saves JSON calls.
		}

		if($data!==false) {
			$this->objecttype = 'home';
			foreach($data as $key=>$value) {
				$this->data[$key] = $value;
			}
			$this->id = $data['id'];
			$this->publish = $data['publish'];
			$this->source = $data['source'];

			$this->create_date = $data['create_date'];
			$this->modify_date = $data['modify_date'];

			$this->timestamp = $data['timestamp'];

			$this->mls = $data['mls'];
			$this->mls_photo = ($data['mls_photo']!='' ? $data['mls_photo'] : false);

			$this->lat = trim($data['lat']);
			$this->long = trim($data['long']);
			$this->land_title = trim($data['land_title']);
			$this->parcel_id = trim($data['parcel_id']);
			$this->zoning = trim($data['zoning']);
			// for OWN listings, photo_timestamp should come from the `photos` table, or not have one at all (no photos)
			// for MLS listings, default to
			$this->photo_timestamp = ($this->source==0 ? ($data['photo_timestamp']!='' && $data['photo_timestamp']>0  ?$data['photo_timestamp'] : 0) : ($data['mls_photo_timestamp']!='' && $data['mls_photo_timestamp']>0 ? $data['mls_photo_timestamp'] : ($this->mls_photo!='' ? strtotime($this->modify_date) : 0)));

			$this->feature = $data['feature'];
			$this->sold = $data['sold'];

			$this->keywords = 'real estate'; // start buildling the keywords fo rthis home.

			$this->price = preg_replace('/\.[0]*$/', '', $data['price']);

			$this->prevprice = isset($data['prevprice']) ? $data['prevprice'] : '';
			$this->soldprice = isset($data['soldprice']) ? $data['soldprice'] : '';

			$this->showaddress = isset($data['showaddress']) ? $data['showaddress'] : '';
			// should be boolean but because Jeff was an idiot in 2010 we have 0 or 1 as string spitting out. Use non-strict comparison (== or !=, never === or !==)
			$this->name = isset($data['name']) ? $data['name'] : '';
			$this->name2 = isset($data['name2']) ? $data['name2'] : '';

			$this->heading = isset($data['heading']) ? $data['heading'] : '';
			$this->heading2 = isset($data['heading2']) ? $data['heading2'] : '';

			$desc_options = array(
				'add_p'=> ($this->source==1 ? true : false),
				'prepend' => 'Listed by ',
				'append' => '.',
				'showagent'=>false,
				'agent_separator'=>false,
				'providedby_tag'=>'p',
				'providedby_classes'=>array('addendum')
			);

			if(strpos($settings['mls_import_url'],'edmonton.brixwork.com')!==false) {
				$desc_options['showagent'] = true;
				$desc_options['agent_separator'] = ' of ';
				$desc_options['prepend'] = 'Courtesy of ';
			}

			$this->providedby = $data['firm_1'].($data['firm_2']!='' && $data['firm_2']!=$data['firm_1'] ? '/'.$data['firm_2'] : '');

			// IF SHOW ADDRESS = TRUE, APPEND THE NICKNAME BEFORE THE DESCRIPTION, WRAPPED IN <h5>
//			if($this->showaddress==1) {
//				$multi_lang_name = $this->name2 ? ' ('.$this->name2.')' : '';
//				$custom_name_string = $settings['description2on']==1 ? $this->name.$multi_lang_name : $this->name;
//				$this->desc = '<h5 class="custom_nickname">'.$custom_name_string.'</h5>';
//			}
			$this->desc .= $this->generate_desc($data['description'], $desc_options); // this already figures out whether it's source 1 or not etc.

			if($this->source==1) {

				if($this->mls_photo!==false) {
					// also enter mls_photo as $photo array [0] for use:
					// refer to function get_object_photos for arrays needed.
					$mls_photo = array(
						'id'=>$this->id,
						's3' => 1,
						'filename'=>basename($this->mls_photo),
						'title'=>($this->showaddress== 1 ? $this->fulladdress : $this->mls),
						'filepath'=>$this->mls_photo,
						'originalfilepath'=>$this->mls_photo
					);
				}


			} else {
				// OWN listing source=0

				$this->mainphoto = delimited_options_to_array($data['mainphoto'], $settings['homes_mainphotofilename']);
				$this->pdf = delimited_options_to_array($data['pdf'], $settings['homes_pdffilename']);
				// these will activate the attachments that do exist into format of array
			}

			// internal agent pointers, where they refer to agent object WITHIN the site... separate from the MLS agent info.
			if($data['agent_1']!='' && $data['agent_1']!=0 && $settings['multiagents']==1) {
				$this->agent_1 = new agent;
				$this->agent_1->initialize(intval($data['agent_1']));
			} else {
				$this->agent_1 = false;
			}

			if($data['agent_2']!='' && $data['agent_2']!=0 && $settings['multiagents']==1) {
				$this->agent_2 = new agent;
				$this->agent_2->initialize(intval($data['agent_2']));
			} else {
				$this->agent_2 = false;
			}

			if($data['agent_3']!='' && $data['agent_3']!=0 && $settings['multiagents']==1) {
				$this->agent_3 = new agent;
				$this->agent_3->initialize(intval($data['agent_3']));
			} else {
				$this->agent_3 = false;
			}

			$this->listing_agents = '';

			// Check if any realtor data is set, otherwise fallback to agent data
			if ($data['realtor_1'] != '') {
				$this->listing_agents .= $data['realtor_1'];

				if ($data['realtor_2'] != '' && $data['realtor_2'] != $data['realtor_1']) {
					$this->listing_agents .= ' & ' . $data['realtor_2'];
				}

				if ($data['realtor_3'] != '' && $data['realtor_3'] != $data['realtor_1'] && $data['realtor_3'] != $data['realtor_2']) {
					$this->listing_agents .= ' & ' . $data['realtor_3'];
				}
			} else {
				// Fallback to agent data
				if ($this->agent_1) {
					$this->listing_agents .= $this->agent_1->fname .' '. $this->agent_1->lname;
					if ($this->agent_2) {
						$this->listing_agents .= ' & ' . $this->agent_2->fname .' '. $this->agent_2->lname;
					}
					if ($this->agent_3) {
						$this->listing_agents .= ' & ' . $this->agent_3->fname .' '. $this->agent_3->lname;
					}
				}
			}

			// firm / brokerage ID.

			$this->firm_1 = $data['firm_1'];
			$this->firm_2 = $data['firm_2'];
			$this->firm_3 = $data['firm_3'];
			$this->firm_1_id = $data['firm_1_id'];
			$this->firm_2_id = $data['firm_2_id'];
			$this->firm_3_id = $data['firm_3_id'];
			$this->firm_phone_1 = isset($data['firm_phone_1']) ? $data['firm_phone_1'] : '';
			$this->firm_phone_2 = isset($data['firm_phone_2']) ? $data['firm_phone_2'] : '';
			$this->firm_phone_3 = isset($data['firm_phone_3']) ? $data['firm_phone_3'] : '';
			$this->firm_fax_1 = isset($data['firm_fax_1']) ? $data['firm_fax_1'] : '';
			$this->firm_fax_2 = isset($data['firm_fax_2']) ? $data['firm_fax_2'] : '';
			$this->firm_fax_3 = isset($data['firm_fax_3']) ? $data['firm_fax_3'] : '';

			if(strtolower($this->firm_1)==strtolower($this->firm_2)) {
				// if firm 1 and 2 are equal, they are co-listed within one brokerage... no need to display twice.
				$this->firm_2 = '';
				$this->firm_phone_2 = '';
				$this->firm_fax_2 = '';
			}
			// get agent info, not to confuse with agent object reference for WITHIN site, such as VPG's site.
			$this->realtor_1 = isset($data['realtor_1']) ? $data['realtor_1'] : '';
			$this->realtor_2 = isset($data['realtor_2']) ? $data['realtor_2'] : '';
			$this->realtor_3 = isset($data['realtor_3']) ? $data['realtor_3'] : '';
			$this->realtor_id_1 = $data['realtor_id_1'] ?? '';
			$this->realtor_id_2 = $data['realtor_id_2'] ?? '';
			$this->realtor_id_3 = $data['realtor_id_3'] ?? '';
			$this->realtor_phone_1 = isset($data['realtor_phone_1']) ? $data['realtor_phone_1'] : '';
			$this->realtor_phone_2 = isset($data['realtor_phone_2']) ? $data['realtor_phone_2'] : '';
			$this->realtor_phone_3 = isset($data['realtor_phone_3']) ? $data['realtor_phone_3'] : '';

			$this->description = $this->desc;
			$this->description2 = (isset($data['description2']) && $data['description2']!='' ? $data['description2'] : false); // alternate description for chinese, or other languages.
			$this->description3 = (isset($data['description3']) && $data['description3']!='' ? $data['description3'] : false); // alternate description for chinese, or other languages.

			$this->type = $data['type'] < 50 ? $settings['type'][$data['type']] : $settings['type_commercial'][$data['type']];

			if($this->type=='') {
				$this->type = 'Listing'; // default is listing...
			}

			if($this->type!='') {
				$this->keywords.=', '.$this->type;
			}

			$this->remarks = $settings['remarks'][$data['remarks']];

			if($this->remarks=='' && $this->source==1) {
				// this listing is an MLS fed listing, with no remarks set.
				$createtimestamp = strtotime($this->create_date);
				$oneday = 3600 * 24;
				$twodays = $oneday * 2;
				$threedays = $oneday * 3;
				$oneweek = $oneday * 7;
				$this->agetimestamp = $local-$createtimestamp;
				if($this->agetimestamp>$oneweek) {
					// leave remarks blank for older than one week
				} else if($this->agetimestamp>$threedays && $this->agetimestamp<=$oneweek) {
					// less than week old, but more than 3 days old
					$this->remarks = "New Listing";
				} else if($this->agetimestamp>$oneday && $this->agetimestamp<=$threedays) {
					$this->remarks = "Just Listed";
				} else if($this->agetimestamp<=$oneday) {
					$this->remarks = "Listed Today";
				}
			}
			if($data['building']!='') {
				$this->bldg = new building;
				$this->bldg->initialize($data['building']);
				// see if the building has a main building!
				if($this->bldg->mainbuilding) {
					// this is a SUB building!
					$this->directbldg = $this->bldg; // set the building its attached to as directbldg just in case we need it later.
					$this->bldg = $this->bldg->mainbuilding; // set the master building as the bldg object here.
					$data['building_address'] = $this->directbldg->address; // the address of building still should remain with integrity to whatever townhome its part of.
				} else {
					$data['building_address'] = $this->bldg->address;
				}

				$this->building = $this->bldg->name;
				$this->buildingid = $this->bldg->id;
				$data['building_name'] = $this->building = $this->bldg->name;

				if(!$this->bldg->defaultname) {
					$this->keywords.=', '.$this->building;
				}
			} else {
				$this->building = false;
				$this->buildingid = false;
				$this->bldg = false;
			}

			$this->address = '';
			if($data['unit']!='') {
				$this->address .= $data['unit'].' - ';
				$this->unit = str_replace('#','',$data['unit']);
			}
			// process address strings
			$this->street_dir_position = ($data['street_dir_position']!=NULL ? $data['street_dir_position'] : $settings['street_dir_position_default']); // get street dir position, if this property has it set, go with it, if not default.

			$this->number = $data['number'];

			list($street_name, $street_type, $street_dir, $street_suffix) = separate_streetname($data['street']); // initial processing, see how much of the full street details are put in the name already, and blast it out.

			$this->street_name = $street_name; // extract just the name!
			// override dir/type etc. if they are explicitly set, even if street name infers it.
			$this->street_dir = ($data['street_dir']!='' ? ucwords(strtolower($data['street_dir'])) :  $street_dir);
			$this->street_type = ($data['street_type']!='' ? ucwords(strtolower($data['street_type'])) : $street_type);
			$this->street_suffix = ($data['street_suffix']!='' ? ucwords(strtolower($data['street_suffix'])) : $street_suffix);

			$numericending = '/ *[0-9]$/';
			$numericendingmatch = preg_match($numericending, $data['street']);

			if($numericendingmatch>0) {
				// street ends with a number.. just echo teh raw 'street' var.
				// most likely one of those Edmonton rural addresses like 53443 Range Road 222
				$this->street = $data['street'];
			} else {
				$this->street =
					($this->street_dir!='' && $this->street_dir_position==0 ? $this->street_dir.' ' : '').
					$this->street_name.
					($this->street_type!='' ? ' '.$this->street_type : '').
					($this->street_dir!='' && $this->street_dir_position==1 ? ' '.$this->street_dir : '').
					($this->street_suffix ? ' '.$this->street_suffix : '');
			}


			$this->address .= $this->number.' '.$this->street;

			// prep the alt subarea first, since we append the old school area AFTER.
			// i.e. Olympic Village (Mount Pleasant VE)
			if($data['subarea_alt_name']!='') {
				$this->area_alt = $data['subarea_alt_name'];
				$this->area_altid = $this->data['area_alt'] = $data['areaaltid'];
			} else {
				$this->area_alt = false;
				$this->area_altid = false;
			}

			if($data['subarea_name']!='') {
				$this->area = $data['subarea_name'];
				$this->areaid = $this->data['area'] = $data['areaid'];
				if($this->area_alt!==false && $this->area != $this->area_alt) {
					// make sure the area alt was not a duplicate!
					// sometimes polygons on already MLS designated areas can
					// TODO: assign both values, if they are not duplicates only. Something that should ultimately be looked in the retsimport.php?
					$this->area = $this->area_alt.' ('.$this->area.')';

				}
			} else if($this->area_alt!==false) {
				// no subarea name but only alt area name?
				$this->area = $this->area_alt;
			}

			if($data['city_name']!='') {
				$this->city = $data['city_name'];
				$this->cityid = $this->data['city'] = $data['cityid'];
			} else {
				$this->city = '';
				$this->cityid = false;
			}

			if($this->area!='') {
				$this->keywords.=', '.$this->area;
			}

			if($this->city!='') {
				$this->keywords.=', '.$this->city;
			}

			$this->areacity = ($this->area!='' && $this->area!=$this->city ? $this->area.', ' : '').$this->city;

			// PHP behavior for when hide address set to yes
			if($this->showaddress==0) {
				$multi_lang_title = $this->name2 ? ' ('.$this->name2.')' : '';
				$this->address = ($this->name || $this->name2) ? $settings['description2on']==1 ? $this->name.$multi_lang_title : $this->name : $this->address;
			}

			$this->fulladdress = $this->address.($this->areacity != '' ? ', '.$this->areacity : ''); // only add comma if areacity actually exists.

			$this->postal = isset($data['postal']) ? $data['postal'] : '';

			if(array_key_exists('dimension', $data) && $data['dimension']!='') {
				// $this->dimension = unserialize($data['dimension']);
				// this is a terrible way to do this.... unserializing user entered data can be dangerous.
				// separted by ; and :.
				$rooms = explode(';', $data['dimension']); // splits by ; - each one is "Roomname: 12 X 9"
				if(is_array($rooms) && count($rooms)>0) {
					$dimension = array(); // start blank array.
					foreach($rooms as $room) {
						if($room!='' && stripos($room, ':')!==false) {
							list($roomname, $roomsize) = explode(':', $room );
							if($roomname!='' && $roomsize!='') {
								$dimension[] = array(
									'name'=>$roomname,
									'size'=>$roomsize
								);
							}
						}


					}

					$this->dimension = $dimension;
				}

			} else {
				$this->dimension = false;
			}

			$this->bedroom = (isset($data['bedroom'])) ? $data['bedroom'] : '';
			$this->den = (isset($data['den']) && $data['den']!='' && $data['den']>0) ? $data['den'] : false;
			$this->flex = (isset($data['flex']) && $data['flex']!='' && $data['flex']>0) ? $data['flex'] : false;
			$this->bathroom = (isset($data['bathroom'])) ? $data['bathroom'] : '';
			$this->fullbath = (isset($data['fullbath'])) ? $data['fullbath'] : '';
			$this->halfbath = (isset($data['halfbath'])) ? $data['halfbath'] : '';

			// MLS data has truncated numbers, whereas self-loaded data will have full details.
			if($this->source==1) {
				$this->masterid = $data['masterid'];

				// watch out for cases where $data['sqft'] ONLY contains strings...
				$sqft_float = (isset($data['sqft']) ? remove_all_but_numbers($data['sqft']) : ''); // figure out if we even have a number.
				$sqft_up_float = (isset($data['sqftup']) ? remove_all_but_numbers($data['sqftup']) : '');
				$sqft_main_float = (isset($data['sqftmain']) ? remove_all_but_numbers($data['sqftmain']) : '');
				$sqft_down_float = (isset($data['sqftdown']) ? remove_all_but_numbers($data['sqftdown']) : '');

				$this->sqft		= (is_numeric($sqft_float) && $sqft_float > 0) ? number_format($sqft_float,0,'.',',').' sqft' : '';
				$this->sqftup	= (is_numeric($sqft_up_float) && $sqft_up_float > 0) ? number_format($sqft_up_float,0,'.',',').' sqft' : '';
				$this->sqftmain = (is_numeric($sqft_main_float) && $sqft_main_float > 0) ? number_format($sqft_main_float,0,'.',',').' sqft' : '';
				$this->sqftdown = (is_numeric($sqft_down_float) && $sqft_down_float > 0) ? number_format($sqft_down_float,0,'.',',').' sqft' : '';

				$lot_i = remove_all_but_numbers($data['lot']);
				if(array_key_exists('lot', $data) && $data['lot']!='' && $lot_i!=0) {
					$this->lot = number_format($lot_i,0,'.',',').' sqft';
				}

				$lot_acres_i = remove_all_but_numbers($data['lot_acres']);
				if(array_key_exists('lot_acres', $data) && $data['lot_acres']!='' && $lot_acres_i!=0) {
					//fed from MLS
					$this->lot_acres = number_format(remove_all_but_numbers($lot_acres_i),0,'.',',').' acres';
				} elseif (array_key_exists('lot', $data) && ($data['lot']!='' && $lot_i!=0) && $lot_i>43559) {
					//converted from sqft lot
					$acres = remove_all_but_numbers($data['lot'])/43560;
					$this->lot_acres = number_format($acres, 2, '.', ',').' acre'.($acres>1?'s':'');
				}

				if(array_key_exists('lot_hectares', $data) && $data['lot_hectares']!='' && $data['lot_hectares']*1!=0) {
					//fed from MLS
					$this->lot_hectares = number_format(remove_all_but_numbers($data['lot_hectares']),0,'.',',').' hectares';
				} elseif (array_key_exists('lot', $data) && ($data['lot']!='' && $data['lot']*1!=0) && remove_all_but_numbers($data['lot'])>107638) {
					//converted from sqft lot
					$hectares = remove_all_but_numbers($data['lot'])/107639;
					$this->lot_hectares = number_format($hectares, 2, '.', ',').' hectare'.($hectares>1?'s':'');
				}

				if(array_key_exists('depth', $data) && $data['depth']!='' && $data['depth']*1!=0) {
					$this->depth = number_format(remove_all_but_numbers($data['depth']),2,'.',',').' ft';
				}
				if(array_key_exists('frontage', $data) && $data['frontage']!='' && remove_all_but_numbers($data['frontage'])*1 != 0) {
					$this->frontage = number_format(remove_all_but_numbers($data['frontage']),2,'.',',').' ft';
				}

				if(array_key_exists('story', $data) && $data['story']!='') {
					$this->story = $data['story'].' storeys';
				}

				if(array_key_exists('year', $data) && $data['year']!='') {
					// only process if its NOT blank. If blank, and the intval() returns 0, we might mis-represent an unkonwn as as 0 years old (brand new)
					$rawyear = intval(remove_all_but_numbers($data['year']));
					if($rawyear<500) {
						// year is less than 500, so presumably this is "xx years old"
						$this->year = date($mysql_time['year'],strtotime(-$rawyear.' years'));
					} else if($rawyear>1500) {
						// year is over 1500.. built year.
						$this->year = $rawyear;
					}
				} else {
					$this->year = ''; // blank (unknown) is fine. no need rof ralse here.
				}

				if(array_key_exists('tax', $data) && $data['tax']!='') {
					if(!preg_match('/^\$/', $data['tax'])) {
						$this->tax = '$'.$data['tax'];
					} else {
						$this->tax = $data['tax'];
					}
				}
				if(array_key_exists('maintenance', $data) && $data['maintenance']!='') {
					$this->maintenance = '$'.number_format(remove_all_but_numbers($data['maintenance']),2,'.',',');
				}
			} else {
				// source=0 OWN lsiting with manually entered strings.
				$this->sqft = isset($data['sqft']) ? $data['sqft'] : '';
				$this->sqftup = isset($data['sqftup']) ? $data['sqftup'] : '';
				$this->sqftmain = isset($data['sqftmain']) ? $data['sqftmain'] : '';
				$this->sqftdown = isset($data['sqftdown']) ? $data['sqftdown'] : '';

				$this->year = isset($data['year']) ? $data['year'] : '';

				$this->lot = isset($data['lot']) ? $data['lot'] : '';
				$this->lot_acres = isset($data['lot_acres']) ? $data['lot_acres'] : '';
				$this->lot_hectares = isset($data['lot_hectares']) ? $data['lot_hectares'] : '';

				$this->depth = isset($data['depth']) ? $data['depth'] : '';
				$this->frontage = isset($data['frontage']) ? $data['frontage'] : '';
				$this->story = isset($data['story']) ? $data['story'] : '';

				$this->tax = isset($data['tax']) ? $data['tax'] : '';
				$this->maintenance = isset($data['maintenance']) ? $data['maintenance'] : '';

			}
			
			// other misc features!!
			$this->kitchen = isset($data['kitchen']) ? $data['kitchen'] : '';
			$this->fireplace = isset($data['fireplace']) ? $data['fireplace'] : '';
			$this->parking = isset($data['parking']) ? $data['parking'] : '';
			$this->storage = isset($data['storage']) ? $data['storage'] : '';
			$this->style = isset($data['style']) ? $data['style'] : '';
			$this->warranty = isset($data['warranty']) ? $data['warranty'] : '';
			$this->rearexposure = isset($data['rearexposure']) ? $data['rearexposure'] : '';
			$this->basement = isset($data['basement']) ? $data['basement'] : '';
			$this->suite = isset($data['suite']) ? $data['suite'] : '';
			$this->view = isset($data['view']) ? $data['view'] : '';
			$this->balcony = isset($data['balcony']) ? $data['balcony'] : '';
			$this->rental = isset($data['rental']) ? $data['rental'] : '';
			$this->construction = isset($data['construction']) ? $data['construction'] : '';
			$this->water_source = isset($data['water_source']) ? $data['water_source'] : '';
			$this->comm_available_sqft = isset($data['comm_available_sqft']) ? $data['comm_available_sqft'] : '';
			$this->uppersqft = isset($data['uppersqft']) ? $data['uppersqft'] : '';
			$this->mainsqft = isset($data['mainsqft']) ? $data['mainsqft'] : '';
			$this->lowersqft = isset($data['lowersqft']) ? $data['lowersqft'] : '';
			$this->fuel = isset($data['fuel']) ? $data['fuel'] : '';
			$this->heating = isset($data['heating']) ? $data['heating'] : '';




			// other data regarding media etc.
			$this->openhouse = isset($data['openhouse']) ? $data['openhouse'] : '';
			$this->videolink = isset($data['videolink']) ? $data['videolink'] : '';

			if(isset($data['virtualtour']) && $data['virtualtour']!='') {
				if (strpos(strtolower($data['virtualtour']), '<iframe') !== false || strpos(strtolower($data['virtualtour']), '<a') !== false) {
					// somebody put an iFrame tag set into virtual tour, so let's just retrieve raw URL only.
					if($doc = new DOMDocument()) {
						if($doc->loadHTML($data['virtualtour'])) {
							$href = $doc->getElementsByTagName('a');
							if ($href->length) {
								$this->virtualtour = get_secured_url($href->item(0)->getAttribute('href'));
							}
							$doc = null;
						} else {
							$this->virtualtour = '';
						}
					} else {
						$this->virtualtour = ''; // invalid iframe tag, return null.
					}
				} else {
					// just a URL it appears.
					$this->virtualtour = get_secured_url($data['virtualtour']);
				}
			} else {
				$this->virtualtour = ''; // blank, not false, for backwards compat since most of our front end will have if($home->virtualtour!='') as detection.
			}


			$this->youtube = (isset($data['youtube']) && $data['youtube']!='' ? get_secured_url($data['youtube']) : false);
			$this->vimeo = (isset($data['vimeo']) && $data['vimeo']!='' ? get_secured_url($data['vimeo']) : false);

			// process URL slug, the default one.
			if($this->showaddress== 0) {
				$this->slug_default = urlencode(
						url_format($this->data['name'] ?: 'address-upon-request')
					).'/';
			} else {
				$this->slug_default = urlencode(
						url_format($this->fulladdress)
					).'/';
			}


			if(array_key_exists('slug', $data) && $data['slug']!='') {
				// override with manually entered URL slug for SEO reasons.
				$this->slug = $this->data['slug'];
			} else {
				$this->slug = $this->slug_default; // set to default if no custom one set.
			}

			// process meta title
			$this->metatitle_default = $this->fulladdress.($this->mls!='' ? ' ('.$this->mls.')' : '');
			if(array_key_exists('metatitle', $data) && $data['metatitle']!='') {
				$this->metatitle = $data['metatitle'];
			} else {
				$this->metatitle = $this->metatitle_default;
			}

			// process meta description
			$this->metadescription_default = $this->type.' in '.$this->city.'. '.$this->fulladdress.($this->mls!='' ? ' (MLS #'.$this->mls.')' : '').'. '.($this->bedroom!='' ? $this->bedroom.' bed, ' : '').($this->bathroom!='' ? $this->bathroom.' bath, ' : '').($this->sqft!='' ? 'Size '.$this->sqft.', ' : '').$this->price.'.';

			if(array_key_exists('metadescription', $data) && $data['metadescription']!='') {
				$this->metadescription = $data['metadescription'];
			} else {
				$this->metadescription = $this->metadescription_default;
			}

			if(array_key_exists('features', $data) && $data['features']!='') {
				// process features
				$featuresarray = explode(',', $data['features']);
				$featurecount = 0;
				foreach($featuresarray as $count=>$featureid) {
					// If features was added at least once, the BRIX_HOMEFEATURES_CACHE has to be an array, so is_array() check is irrelevant.
					if(array_key_exists($featureid, $GLOBALS[BRIX_HOMEFEATURES_CACHE])){
						$this->features[] = $GLOBALS[BRIX_HOMEFEATURES_CACHE][$featureid];

						if($featurecount>0) {
							$this->featuresdisplay .= ', ';
						}
						$this->featuresdisplay .= $GLOBALS[BRIX_HOMEFEATURES_CACHE][$featureid];

						$featurecount++;
					}
				}
			} else {
				$this->features = false; // actual false.
				$this->featuresdisplay = ''; // blank string.
			}

			//setting all the rental variables to false by default, until $data['for_rent']=1 is confirmed.
			$this->for_rent = false;
			$this->rental_price_day = false;
			$this->rental_price_week = false;
			$this->rental_price_month = false;
			$this->rental_period = false;
			$this->rental_min_term = false;
			$this->rental_furnished = false;
			$this->rental_pets = false;
			$this->rental_smoking = false;
			$this->rental_parking = false;
			$this->rental_washerdryer = false;
			$this->rental_dishwasher = false;
			$this->rental_availability = false;

			//setting all the commercial variables to false by default as well, until $data['type']>=50 is confirmed.
			$this->parcel_id						= false;
			$this->comm_sub_type		   	= false;
			$this->comm_price			   	= false;
			$this->price_sqf_m			= false;
			$this->price_tot_y			= false;
			$this->price_tot_m			= false;
			$this->price_per_sqf		= false;//$ per sqft ONLY FOR SALE COMMERCIAL PROPERTIES (NOT LEASE)
			$this->comm_min_divisible	   	= false;
			$this->comm_availability	   	= false;
			$this->comm_use_type		   	= false;
			$this->comm_commission_split  	= false;
			$this->comm_cap_rate		   	= false;
			$this->comm_occupancy		   	= false;
			$this->comm_tenancy			   	= false;
			$this->comm_tenant			   	= false;
			$this->comm_tenant_sqft		   	= false;
			$this->comm_tenant_lease_end  	= false;
			$this->comm_financial_year	   	= false;
			$this->comm_financial_income  	= false;
			$this->comm_financial_expenses 	= false;
			$this->comm_rental_rate			= false;
			$this->comm_parking_ratio		= false;

			if($data['type']>=50) {
				if($data['for_rent']==1) {
					$this->for_rent = true;
					// set the base vars.
					$this->comm_price_sqft_y = isset($data['comm_price_sqft_y']) ? $data['comm_price_sqft_y'] : '';
					$this->comm_price_addl_y = isset($data['comm_price_addl_y']) ? $data['comm_price_addl_y'] : '';
					$this->comm_rental_rate = isset($data['comm_rental_rate']) ? $data['comm_rental_rate'] : '';

					if($this->comm_price_sqft_y!='') {
						// commercial for lease. Therefore just process the lease
						// base rent + additial rent = net $ per sqft/year. NOt yet multiplied by sqft.
						$this->comm_price = remove_all_but_numbers($this->comm_price_sqft_y ?: 0) + remove_all_but_numbers($this->comm_price_addl_y ?: 0); // multiplied by the sqft total  for whole year.
						// net $ per sqft for each month (divide by 12)
						$this->price_sqf_m = $this->comm_price/12; // divide to $ per sqft/mth

						// total rent for whole year - $ per sqft net multiplied by total sqft.
						$this->price_tot_y = $this->comm_price * remove_all_but_numbers($this->sqft ?: 0);

						$this->price_tot_m = $this->price_tot_y/ 12; // effective rent per month net with sqft taken into consideration.
						// $price_tot_m was used in previous sites, so keeping it for sake of backwards compat.
						if($this->comm_rental_rate=='') {
							// sies before 2021-12 will not have had the optoin to manually fill this out,
							// but we allow manual override.
							// If you want to display the dollar amount in a different format, you can either
							// remove_all_but_numbers($this->comm_rental_rate) or
							// remove_all_but_numbers($this->price_tot_m) or
							$this->comm_rental_rate = dollar_amount_display($this->price_tot_m);
						}
					} else {
						// rental rate not disclosed on MLS, so all false.
						// adjust dispaly to say "Inquire" or "Ask For Quote" etc. as you please.
						$this->comm_price = false;
						$this->price_tot_y = false;
						$this->price_sqf_m = false;
						$this->price_tot_m = false;
					}

				} else {
					// commercial for sale. Do not process the $ per sqft rental rates etc..
					// We're using default $home->price for this one just like resale price of residential listings.

					$temp_sqft = preg_replace("/[^0-9.]/", "", $this->sqft);

					if ($temp_sqft != '' && $temp_sqft != 0) {
						// purchase price per sqft is a big thing in commerical as well as residential.
						// should this be default for condos/townhomes as well on res?
						$price_i = remove_all_but_numbers($this->price);
						$sqft_i = remove_all_but_numbers($this->sqft);
						if (is_numeric($price_i) && is_numeric($sqft_i) && $sqft_i > 0) {
							$price_per_sqft_i = $price_i / $sqft_i;
							$this->price_per_sqft = dollar_amount_display($price_per_sqft_i);
						} else {
							// false cus we didn't do the math
							$this->price_per_sqft = false;
						}
					}
				}


				//property commercial regardless of leasing or selling status so we'll process are variables that are not the price
				$this->parcel_id				= isset($data['pid']) ? $data['pid'] : '';
				$this->comm_sub_type		   	= isset($data['comm_sub_type']) ? $data['comm_sub_type'] : '';
				$this->comm_min_divisible	   	= isset($data['comm_min_divisible']) ? $data['comm_min_divisible'] : '';
				$this->comm_availability	   	= (isset($data['comm_availability']) && $data['comm_availability']!='' && strpos($data['comm_availability'],'00-')===false ) ? date($mysql_time['day'], strtotime($data['comm_availability'])) : '';
				$this->comm_tenant_lease_end  	= (isset($data['comm_tenant_lease_end']) && $data['comm_tenant_lease_end']!='' && strpos($data['comm_tenant_lease_end'],'00-')===false ) ? date($mysql_time['day'], strtotime($data['comm_tenant_lease_end'])) : '';
				$this->comm_use_type		   	= isset($data['comm_use_type']) ? $data['comm_use_type'] : '';
				$this->comm_commission_split  	= isset($data['comm_commission_split']) ? $data['comm_commission_split'] : '';
				$this->comm_cap_rate		   	= (isset($data['comm_cap_rate']) && $data['comm_cap_rate']!='' && (is_numeric(remove_all_but_numbers($data['comm_cap_rate'])) && remove_all_but_numbers($data['comm_cap_rate'])>0)) ? $data['comm_cap_rate'] : '';
				$this->comm_occupancy		   	= isset($data['comm_occupancy']) ? $data['comm_occupancy'] : '';
				$this->comm_tenancy			   	= isset($data['comm_tenancy']) ? $data['comm_tenancy'] : '';
				$this->comm_tenant			   	= isset($data['comm_tenant']) ? $data['comm_tenant'] : '';
				$this->comm_tenant_sqft		   	= isset($data['comm_tenant_sqft']) ? $data['comm_tenant_sqft'] : '';
				$this->comm_financial_year	   	= (isset($data['comm_financial_year']) && $data['comm_financial_year']!='' && $data['comm_financial_year']!=0 && strpos($data['comm_financial_year'], '0000')===false) ? $data['comm_financial_year'] : '';
				$this->comm_financial_income  	= isset($data['comm_financial_income']) ? $data['comm_financial_income'] : '';
				$this->comm_financial_expenses 	= isset($data['comm_financial_expenses']) ? $data['comm_financial_expenses'] : '';
				$this->comm_parking_ratio	 	= isset($data['comm_parking_ratio']) ? $data['comm_parking_ratio'] : '';


			} else {
				if($data['for_rent']==1) {
					// residential for rent
					$this->for_rent = true;

					$this->rental_price_day = array_key_exists('rental_price_day', $data) ? $data['rental_price_day'] : '';
					$this->rental_price_week = array_key_exists('rental_price_week', $data) ? $data['rental_price_week'] : '';
					$this->rental_price_month = array_key_exists('rental_price_month', $data) ? $data['rental_price_month'] : '';

					$this->rental_price_display = get_rental_price($this->rental_price_day,'/day',$this->rental_price_week,'/wk',$this->rental_price_month,'/mth');

					$this->price = $this->rental_price_display;

					$this->rental_min_term = isset($data['rental_min_term']) ? $data['rental_min_term'] : '';
					$this->rental_furnished = isset($data['rental_furnished']) ? ($data['rental_furnished'] == 1 ? 'Furnished' : 'Unfurnished') : '';
					$this->rental_pets = isset($data['rental_pets']) ? ($data['rental_pets'] == 1 ? 'Pets Allowed' : 'No Pets') : '';
					$this->rental_smoking = isset($data['rental_smoking']) ? ($data['rental_smoking'] == 1 ? 'Smoking OK' : 'No Smoking') : '';
					$this->rental_parking = isset($data['rental_parking']) ? ($data['rental_parking'] == 0 ? 'No Parking Included' : $data['rental_parking'].' Parking Spots') : '';
					$this->rental_washerdryer = isset($data['rental_washerdryer']) ? ($data['rental_washerdryer'] == 0 ? 'No Laundry' : ($data['rental_washerdryer'] == 1 ? 'Shared Laundry' : 'In-Suite Laundry')) : '';
					$this->rental_dishwasher = isset($data['rental_dishwasher']) ? ($data['rental_dishwasher'] == 0 ? 'No Dishwasher' : 'Dishwasher') : '';
					$this->rental_availability = isset($data['rental_availability']) ? $data['rental_availability'] : '';


				} else {
					//residential for sale, so all the above values stay false. YeeeeaaaaaaAAAH
				}
			}

			$this->floorplan_exists = $this->floorplan_exists();
			$this->featuresheet_exists = $this->featuresheet_exists();

			$pdf_labels_unserialized = false; // default false.
			if($data['pdf_labels']!='') {
				$pdf_labels_unserialized = unserialize($data['pdf_labels']);
			}
			if($pdf_labels_unserialized!==false) {
				foreach ($pdf_labels_unserialized as $key => $pdf_label) {
					// Use $key when assigning value so that the key->value pair stays the same as database.
					// if pdf label is empty, fall back to $settings default label - if $settings not set, make a quick fallback here
					if($pdf_label=='') {
						$this->pdf_labels[$key] = ((isset($settings['homes_pdfname'][$key]) && $settings['homes_pdfname'][$key]) != '' ? $settings['homes_pdfname'][$key] : 'PDF '. ($key + 1));
					} else {
						$this->pdf_labels[$key] = $pdf_label;
					}
				}
			} else {
				// if all labels are empty, use site $settings default
				$this->pdf_labels = $settings['homes_pdfname'];
			}

			$this->video_exists = $this->video_exists();
			$this->get_video();

			$this->get_custom_fields();
			if($skipphotos!==true){
				// when loaded by data, we only need photo #1, not fully gallery. WE can always initialize within properties page.
				$this->getphotos();
			}
			return $this->id;
		} else {
			return false;
		}
	}

	function get_property_link($trail='',$base='showlisting/') {
		global $settings;

		// showlistings can be replace dwith $settings['listing_detail_url_base'] when calling for URL.
		// because we want to leave this flexible for the front end UI in case we need to show listings in a different (alternate) format etc.,
		// we won't build the fallback to the $settings sitewide modificaiton here just yet .
// 		if($trail=='' && $settings['url_trail']!='') {
//			$trail = $settings['url_trail'];
//		}
		// we don't use the $trail thing anymore because it's stupid?

		if($this->source==1) {
			$url_param = 'mls-'.$this->mls;
		} else {
			$url_param = $this->id;
		}
		return $settings['sitepath'].$base.$url_param.'/'.$this->slug;
	}

	function getphotos($photos=false, $force = false) {
		global $settings;
		global $mysqli;

		if($this->photos_fetched!=true || $force==true) {
			// photos already fetched, and force re-do is not set to true.
			// should we use this for buildings/pages etc.?
			unset($this->photos);
			$this->photos_fetched = true; // set this to true so it doesn't run again on this instance - waste of a query!
			if($this->source==1) {

				$this->json_url = ($settings['mls_import_url_cloudfront'] !='' ? $settings['mls_import_url_cloudfront'] : $settings['master_url']).'admin/api/cache/'.$this->masterid.'.txt?timestamp='.$this->data['mls_photo_timestamp'];
				// echo "PHoto fetch JSON URL: ".$this->json_url."<br />".PHP_EOL;
				$json_raw = curl_get_file_contents($this->json_url, 'GET', '', 1000);
				$json = json_decode($json_raw, TRUE); // we got it, so decode it.
				$this->json = $json;

				if(DEBUG===true) {
					echo "Remote fetch photo JSON: ".$this->json_url."<br />".PHP_EOL;
					echo "Photo count: ".count($json)."<br />".PHP_EOL;
				}

				if(is_array($json) && isset( $json['code']) && $json['code']==1) {
					$this->gallery_exists = 1;
					$this->photos = $json['photos'];
					$return = true;
					$runlocal = 0;
					/*
					 * 2018-04-17 Timthumb is being deprecated out of our websites. It's archaic and slow.
					 * Only time timthumb runs is if $settings['timthumb']==1 only.
					 * Otherwise we skip it.
					 * */
					if($settings['timthumb']==1) {
						foreach ($this->photos as $pkey => $photoarray) {
							$this->photos[$pkey]['thumbnailpath'] = $settings['sitepath'] . 'timthumb.php?src=' . $photoarray['filepath'] . '&w=' . $settings['thumbnailwidth'] . '&h=' . $settings['thumbnailheight'] . '&zc=1';
							$this->photos[$pkey]['mobilepath'] = $settings['sitepath'] . 'timthumb.php?src=' . $photoarray['filepath'] . '&w=' . $settings['mobilewidth'] . '&zc=1';
						}
					}
				} else {
					$this->gallery_exists = 0;
					$this->photos = false;
					$return = false;
					$runlocal = 1;
				}
			} else {
				$runlocal = 1;
			}

			if($runlocal == 1) {
				// run the query internally though `photos` table.
				if($photos == false) {
					// photo array not fed manually so let's do full fetch.
					$this->photos = get_object_photos('homes', $this->id);
				}


				if(is_array($this->photos) && count($this->photos)>0) {
					$this->gallery_exists = 1;
					$return = true;
				} else {
					$this->gallery_exists = 0;
					$this->photos = false;
					$return = false;
				}
			}
		} else {
			// return previously returned photos field - if there's no gallery, this still returns FALSE as per above lines. If not, will return true.
			$return = $this->photos;
		}
		return $return;
	}

	function get_main_image($width='', $height='', $noimage = 'noimage.png', $cssclass='', $quality = 75) {
		// soon to be deprecated perhaps in favour of get_main_image_path? Or use in conjunction?
		global $settings;
		return $this->get_main_images(0, $width, $height, $noimage, $cssclass, $quality);
	}

	function get_main_images($num = 0, $width='', $height='', $noimage = 'noimage.png', $cssclass='', $quality = 75, $fallback=0) {
		// applies only to source=0 listings that may contain more than 1 MAIN IMAGE files. $num var is use dto find the array key.
		global $settings;
		if($width=='') {
			$width = $settings['homes_mainphotowidth'][$num];
		}
		if($height=='') {
			$height = $settings['homes_mainphotoheight'][$num];
		}

		$width = remove_all_but_numbers($width)*1;

		$classhtml = '';
		if($cssclass) {
			if(is_array($cssclass)!=1) {
				$classhtml = $cssclass; // singular class
			} else {
				// multiple classes passed by array, list them all with spaces.
				foreach($cssclass as $classcount => $css) {
					if($classcount>0) {
						$classhtml.=' ';
					}
					$classhtml.=$css;
				}
			}
		}
		// to get path, use get_main_images_path
		$fileurl = $this->get_main_images_path($num, $noimage, $fallback);
		$timthumbimageurl = str_ireplace('?', '%3F', $fileurl);

		if(
			(strpos($fileurl,'noimage') !== false && strpos($fileurl,$settings['homes_mainphotofilename'][$num]) !== false)
			|| $width>=960
			|| ($this->source==1 && $settings['timthumb']==0)
		) {
			// if its noimage, or a specifically set mainimage, no need to do timthumb - already pressed.
			// Or, if its above 960 pixels, really no point in using timthumb - just use raw JPG.
			// Or, if it is an MLS picture.. just feed the regular web version, as long as timthumb is opted OUT?
			$imgtag = '<img src="'.$fileurl.'" alt="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" title="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').' by '.$settings['title'].'" class="'.$classhtml.'" />';
		} else {
			// still use timthumb to fit the grid, and compress from the unnecessariliy larger photos.
			$imgtag = '<img src="/timthumb.php?src='.$timthumbimageurl.'&w='.$width.'&h='.$height.'&q='.$quality.'" alt="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" title="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" class="'.$classhtml.'" />';
		}

		return $imgtag;
	}

	function get_main_image_path($noimage='noimage.png', $fallback = true) {
		// soon to refer to the master function get_main_images_path() below.
		global $settings;
		return $this->get_main_images_path(0, $noimage, $fallback);
	}

	function get_main_images_path($num = 0, $noimage = 'noimage.png', $fallback = 0) {
		global $settings;

		if($this->source==1 && $this->masterid) {
			// MLS Listing, not local source=0 listing.
			// get it straight from the MLS source rather than local.
			if($fallback!==false) {
				// don't fall back to the same photo sequence, go back to whatever was given.
				if($fallback!==true && is_numeric($fallback)) {
					// if $fallback is not false, but a number, the fallback shoudl be the same sequence in photo gallery, following $num.
					// Otherwise, if it's a number, go for what $fallback says.
					// if gallery image, or lead image on top is supposed to explicity set for the 2nd main photo ($num==1), or degrade to be the first photo in gallery ($num==0)
					// then $fallback might have to be 0 even if $num was 1.
					$num = $fallback * 1;
				}
			}

			if($this->data['mls_photo']!='' && $num==0) {
				$return = $this->data['mls_photo']; // use the cached main MLS photo field here. Easiest!
			} else if(is_array($this->photos) && count($this->photos)>1 && $num>0 && $this->photos[$num]['filepath']!='') {
				// try to fall back to photo $num or $fallback as per MLS feed.
				if($fallback!==true && is_numeric($fallback)) {
					if(array_key_exists($fallback, $this->photos)) {
						$num = $fallback;
					} else {
						$num = count($this->photos)-1;
					}
				}
				$return = $this->photos[$num]['filepath'];
			} else {
				if(substr( $noimage, 0, 4 ) == "http" || substr( $noimage, 0, 9 ) == "holder.js") {
					$return = $noimage;
				} else {
					if($noimage=='') {
						// if accidentally passing blank, set to nomiage.jpg.
						$noimage = 'noimage.jpg';
					}
					$return = ($settings['use_template']==1 ? $settings['templatepath'] : $settings['sitepath']).'images/'.$noimage;
				}
			}
		} else {
			// own lisitng so get what the user uploaded.. if possible.
			$return = get_main_images_path('homes', $this, $num, $noimage, $fallback);
		}
		return $return;
	}

	/**
	 * Generates the listing source disclaimers such as "Courtesy of John Doe of Remax" or "Listed by Sotheby's Itnl' Realty" for source=1 listings
	 * @example $desc_options['add_p'] = ($home->source==0 ? false : true); // add <p> and </p> only for source=1 listings.
	 * @example $desc_options['display_by'] = ($home->source==0 ? false : true); // show "Listed by" type of disclaimer only for source=1 listings.
	 * @example $options['prepend'] = 'Courtesy of '; // Deafult is "Listed by "
	 * @example $options['append'] = ($home->mls!='' ? ' ('.$home->mls.')' : ''); // if you need to add MLS # in brackets
	 * @example $options['showagent'] = true; // default is false!
	 * @example $options['agent_separator'] = ' of '; // this is default, can skip.
	 * @example $options['tag'] = 'span'; // default is p, but use <span> instead in this case.
	 * @example $options['classes'] = array('disclaimer centered'); // two classes. Defaults to 'addendum' only.
	 * @example
	 * @example echo $thishome->generate_desc($home->data['description'], $desc_options);
	 * @example
	 *
	 * @param string $desc_text The actual desc text, normally $home->data['description'].
	 * @param array $options Some are for the description itself, others are passed ONTO the $home->generate_providedby_display() function.
	 * @param string $options['add_p'] Determines whether the $desc_text string should be wrapped in <p> tags - useful for MLS (source=1) listings
	 * @param string $options['display_by'] Determines whether the $desc_text string should be wrapped in <p> tags - useful for MLS (source=1) listing
	 * @param string $options['prepend'] string to come BEFORE the provided_by string, such as "Listed by " (default)
	 * @param string $options['append'] string to come AFTER the provided_by string, often "." (default)
	 * @param bool $options['showagent'] True to show the name of agent on TOP of the brokerage. False to skip.
	 * @param string $options['agent_separator'] String to separate name from brokerage, such as ' of '. Not relevant if $options['showagent'] is false.
	 * @param mixed $options['tag'] Tag to wrap the provided_by portion. Defaults to p.
	 * @param array $options['classes'] = CSS classes to give to the tag. If $options['tag'] is false, this is irrelevant.
	 *
	 * @return Home Description, then appended by the "Listed by " setnence.
	 */
	function generate_desc($desc_text, $options) {


		// process $options into variables for variable usage.
		$options_add_p = (isset($options['add_p']) ? $options['add_p'] : true);
		$options_display_by = (isset($options['display_by']) ? $options['display_by'] : true);

		// these below vars are not used in this function itself, but rather fed to $this->generate_provided_display() instead.
		// have them default if unset.
		$options['prepend'] = (isset($options['prepend']) ? $options['prepend'] : 'Listing provided by ');
		$options['append'] = (isset($options['append']) ? $options['append'] : '.');
		$options['showagent'] = (isset($options['showagent']) ? $options['showagent'] : false);
		$options['agent_separator'] = (isset($options['agent_separator']) ? $options['agent_separator'] : '');
		$options['tag'] = (isset($options['providedby_tag']) ? $options['providedby_tag'] : 'p');
		$options['classes'] = (isset($options['providedby_classes']) ? $options['providedby_classes'] : array('addendum'));

		$return = ($options_add_p==true ? '<p>' : '').nl2br($desc_text).($options_add_p==true ? '</p>' : '');

		if($this->source==1) {
			if($options_display_by==true) {

				$this->providedby_display = $this->generate_providedby_display($options);
			} else {
				$this->providedby_display= '';
			}

			$return.=$this->providedby_display;
		}

		return $return;
	}

	/**
	 * Generates the listing source disclaimers such as "Courtesy of John Doe of Remax" or "Listed by Sotheby's Itnl' Realty" for source=1 listings
	 * @param mixed $options['tag'] Tag to wrap the provided_by portion. Defaults to p.
	 * @param array $options['classes'] = CSS classes to give to the tag. If $options['tag'] is false, this is irrelevant
	 * @param string $options['prepend'] string to come BEFORE the provided_by string, such as "Listed by " (default)
	 * @param string $options['append'] string to come AFTER the provided_by string, often "." (default)
	 * @param bool $options['showagent'] True to show the name of agent on TOP of the brokerage. False to skip.
	 * @param string $options['agent_separator'] String to separate name from brokerage, such as ' of '. Not relevant if $options['showagent'] is false.
	 *
	 * @return string Default will look like "Listed by [brokerage]" since agent name defaults to false.
	 */
	function generate_providedby_display($options) {
		$tag = (isset($options['tag']) ? $options['tag'] : 'p');
		$classes = (isset($options['classes']) ? $options['classes'] : array('addendum'));

		$prepend = (isset($options['prepend']) ? $options['prepend'] : 'Listing provided by ');
		$append = (isset($options['append']) ? $options['append'] : '.');
		$showagent = (isset($options['showagent']) ? $options['showagent'] : false);
		$agent_separator = (isset($options['agent_separator']) ? $options['agent_separator'] : false);


		$class_value = '';
		if(is_array($classes) && count($classes)>0) {
			foreach($classes as $class) {
				$class_value.=' '.$class;
			}
		}

		$return = ($tag!=false && $tag!='' ? '<'.$tag.' class="'.$class_value.'">' : '').$prepend.($showagent==true ? $this->listing_agents.$agent_separator : ' ').$this->providedby.$append.($tag!=false && $tag!='' ? '</'.$tag.'>' : '');
		return $return;
	}

	function floorplan_exists() {
		global $settings;
		if(
			is_array($this->pdf) &&
			(
				array_key_exists(1, $this->pdf)
				|| array_key_exists(2, $this->pdf)
				|| array_key_exists(3, $this->pdf)
			)
		) {
			return true;
		} else {
			return false;
		}
	}

	function featuresheet_exists() {
		global $settings;
		if(is_array($this->pdf) && array_key_exists(0, $this->pdf)) {
			return true;
		} else {
			return false;
		}
	}

	function pdf_file_link($num=0, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('homes', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}

	function video_exists() {
		// obsolete function now, refers simply to get_video for true/false return.
		return $this->get_video();
	}

	function get_video($autoplay = false) {
		global $settings;

		if($this->youtube!='') {
			$this->videourl = "https://www.youtube.com/v/".$this->youtube."?rel=0&hl=en&fs=1&autoplay=".($autoplay ? '1' : '0');
			$this->videoembedurl = "//www.youtube.com/embed/".$this->youtube."?rel=0&enablejsapi=1&fs=1&autoplay=".($autoplay ? '1' : '0');
			$return = true;

		} else if($this->vimeo!='') {
			$this->videourl = 'https://vimeo.com/'.$this->vimeo;
			$this->videoembedurl = "//player.vimeo.com/video/".$this->vimeo."?title=0&amp;byline=0&amp;portrait=0"; // from vimeo, hides all other junk. rest of page has title all over it anyway.
			$return = true;

		} else if($this->data['videolink']!=''){
			$this->videourl = $this->data['videolink'];
			$return = true;
			// RARELY used..
			// the follow blocks are checks implemented by Taran to set videoembed url if vimeo/youtube in virtual tour
			// don't want to override a video set by user so check to see if youtube/vimeo blank first
		} else if ( $this->youtube == '' && getyoutubeid($this->data['virtualtour']) ) {

			$this->youtube = getyoutubeid($this->data['virtualtour']);
			$this->videourl = "https://www.youtube.com/v/".$this->youtube."?rel=0&hl=en&fs=1&autoplay=".($autoplay ? '1' : '0');
			$this->videoembedurl = "//www.youtube.com/embed/".$this->youtube."?rel=0&fs=1&enablejsapi=1&autoplay=".($autoplay ? '1' : '0');
			$return = true;

		} else if ( $this->vimeo == '' && getvimeoid($this->data['virtualtour']) ) {

			$this->vimeo = getvimeoid($this->data['virtualtour']);
			$this->videourl = 'https://vimeo.com/'.$this->vimeo;
			$this->videoembedurl = "//player.vimeo.com/video/".$this->vimeo."?title=0&amp;byline=0&amp;portrait=0";
			$return = true;
		} else if($this->data['virtualtour']!='') {
			// virtual tour is filled, but not blank, and youtube/vimeo all failed.
			// Virtual tour was also not a youtube/vimeo URL either.
			$this->videourl = $this->virtualtour;
		} else {
			$this->videourl = false;
			$this->videoembedurl = false;
			$return = false;
		}
		return $return;
	}

	/**
	 * Old $home->bedroom_display() function on home object
	 * Old $home->bedroom_display() function on home object
	 * to be replaced by new $home->bed_den_display()
	 * @deprecated
	 */
	function bedroom_display($label="Bedroom", $plural=true) {

		if(preg_match("/[a-z]/i", $this->bedroom)==0) {
			// only run this if "bed" or whatever is not already part of the database entry
			$bedroom_i = remove_all_but_numbers($this->bedroom); // create integer.
			$return = $bedroom_i.' '.$label.($plural==true && $bedroom_i!=1 ? 's' : '');
		} else {
			$return = $this->bedroom; // return as-is.
		}

		// den or flex?
		if($this->den!='') {
			$return = $this->bedroom.'+'.($this->den==1 ? 'Den' : $this->den.' Dens');
		}

		if($this->flex!='') {
			$return = $this->bedroom.'+'.($this->flex==1 ? 'Flex' : $this->flex.' Flexes');
		}

		return $return;
	}

	function bed_den_display($params = array()) {

		$label = ((isset($params['label']) && $params['label']!='') ? $params['label'] : "Bed");
		$plural = ((isset($params['plural']) && ($params['plural']==true || $params['plural']==1)) ? true : false);
		$separator = ((isset($params['separator']) && $params['separator']!='') ? $params['separator'] : "+");
		$den_label = ((isset($params['den_label']) && $params['den_label']!='') ? $params['den_label'] : "Den");
		$flex_label = ((isset($params['flex_label']) && $params['flex_label']!='') ? $params['flex_label'] : "Flex");
		// To replace bedroom_display as the more flexible function.
		if(preg_match("/[a-z]/i", $this->data['bedroom'])==0 && preg_match("/[0-9]/", $this->data['bedroom'])) {
			// only run this if "bed" or whatever is not already part of the database entry and is just a raw number.
			$bedroom_i = trim($this->data['bedroom'])*1; // create integer.
			$return = $this->bedroom.($label!='' ? ' '.$label : '').($plural==true && $bedroom_i!=1 ? 's' : '');
		} else {
			$return = $this->bedroom; // return as-is, realtor entered 1 Bedroom or 2 Bedroom etc. If its blank its blank.
		}

		// den or flex to add?
		if($this->den!=false) {
			$den_i = remove_all_but_numbers(trim($this->data['den']))*1; // create integer.
			$return = $this->bedroom.$separator.$den_i.($den_label!='' ? ' '.$den_label : '');
		}

		if($this->flex!=false) {
			$flex_i =remove_all_but_numbers(trim($this->data['flex']))*1;  // create integer.
			$return = $this->bedroom.$separator.$flex_i.($flex_label!='' ? ' '.$flex_label: '');
		}

		return $return;
	}


	function bathroom_display($label="Bathroom", $plural=true) {

		if(preg_match("/[a-z]/i", $this->bathroom)==0) {
			// only run this if "bath", "bth" or whatever is not already part of the database entry
			$bathroom_i = remove_all_but_numbers($this->bathroom); // create integer.
			$return = $bathroom_i.' '.$label.($plural==true && $bathroom_i!=1 ? 's' : '');
		} else {
			$return = $this->bathroom; // return as-is.
		}
		return $return;
	}

	function convert_ownlisting() {
		global $settings;
		global $mysqli;
		global $year;
		global $handle; // log file handle?

		$original_modify_date = $this->data['modify_date']; // preserve the original modify date to put back when the listing is good.
		$sql = "UPDATE `homes` SET `source`=0, `publish`=1, `modify_date`='2000-01-01 00:00:01' WHERE `id`='".$this->id."'";
		$execute = $mysqli->query($sql);
		if($mysqli->affected_rows==1) {
			// found listing locally.
			$code = 1;
			$homeid = $this->id; // set homeid as $this->id for easy use.
			// now we process the YEAR to convert properly - MLS provides the # of years old, whereas our system requires the year built.
			if($this->data['year']!='' && $this->data['year']<500) {
				// only if the old stuff is age based rather than absolute year.
				$updatehome['year'] = $year - $this->data['year'];
			}
			$updatehome['description'] = '<p>'.nl2br($this->data['description']).'</p>';

			$originalvars['sqft'] = $this->data['sqft'];

			if($originalvars['sqft']!='' && $originalvars['sqft']>0) {
				$updatehome['sqft'] = number_format(remove_all_but_numbers($originalvars['sqft']),0,'.',',').' sqft';
			} else {
				$updatehome['sqft'] = '';
			}

			if($this->data['sqftup']!='') {
				$updatehome['sqftup'] = number_format(remove_all_but_numbers($this->data['sqftup']),0,'.',',').' sqft';
			}
			if($this->data['sqftmain']!='') {
				$updatehome['sqftmain'] = number_format(remove_all_but_numbers($this->data['sqftmain']),0,'.',',').' sqft';
			}
			if($this->data['sqftdown']!='') {
				$updatehome['sqftdown'] = number_format(remove_all_but_numbers($this->data['sqftdown']),0,'.',',').' sqft';
			}

			if(get_host($this->data['virtualtour']) == get_host($settings['sitepath'])) {
				// if Virtual Tour URL on MLS is set to a page within this website, empty it.
				// Otherwise, the iframe on showlisting will show itself again.
				// OR if virtual is either youtube or vimeo, use that instead and blank the virtualtour so that it wont repeat itself.
				$updatehome['virtualtour'] = '';
			}

			if(getvimeoid($this->data['virtualtour'])!==false) {
				$updatehome['vimeo'] = getvimeoid($this->data['virtualtour']);
				$updatehome['virtualtour'] = '';
			} else if(getyoutubeid($this->data['virtualtour'])!==false) {
				$updatehome['youtube'] = getvimeoid($this->data['virtualtour']);
				$updatehome['virtualtour'] = '';
			}

			$originalvars['frontage'] = $this->data['frontage'];
			$originalvars['lot'] = $this->data['lot'];
			$originalvars['depth'] = $this->data['depth'];
			$originalvars['tax'] = $this->data['tax'];
			$originalvars['maintenance'] = $this->data['maintenance'];

			if ($originalvars['frontage']!='') {
				// if just a number, process it and add the ft unit
				// if string, a unit is already part of the value, so just use it.
				if (is_numeric($originalvars['frontage'])) {
					$updatehome['frontage'] = number_format($originalvars['frontage'],2,'.',',').' ft';
				} else {
					$updatehome['frontage'] = $originalvars['frontage'];
				}
			} else {
				$updatehome['frontage'] = '';
			}
			if ($originalvars['lot']!='') {
				// if just a number, process it and add the sqft unit
				// if string, a unit is already part of the value, so just use it.
				if (is_numeric($originalvars['lot'])) {
					$updatehome['lot'] = number_format($originalvars['lot'],0,'.',',').' sqft';
				} else {
					$updatehome['lot'] = $originalvars['lot'];
				}
			} else {
				$updatehome['lot'] = '';
			}
			if ($originalvars['depth']!='') {
				// if just a number, process it and add the sqft unit
				// if string, a unit is already part of the value, so just use it.
				if (is_numeric($originalvars['depth'])) {
					$updatehome['depth'] = number_format($originalvars['depth'],2,'.',',').' ft';
				} else {
					$updatehome['depth'] = $originalvars['depth'];
				}
			} else {
				$updatehome['depth'] = '';
			}
			if($originalvars['tax']!='' && $originalvars['tax']>0) {
				$updatehome['tax'] = dollar_amount_display(remove_all_but_numbers($originalvars['tax']));
			} else {
				$updatehome['tax'] = '';
			}
			if($originalvars['maintenance']!='' && $originalvars['maintenance']>0) {
				$updatehome['maintenance'] = dollar_amount_display($originalvars['maintenance']);
			} else {
				$updatehome['maintenance'] = '';
			}
			$updatehome['mls_photo'] = ''; // this is now moot - since it becomes own listing, this should fall to gallery #1 or main.jpg.
			$updatehome['feature'] = 1; // chances are new listings are to be featured.. might as well!
			$updatehome['publish'] = 1; // if it's freshly disabled from MLS.. change back to publish 1

			// update order of whole table to push things back to put this on top.
			$ordersql = "UPDATE `homes` SET `ord`=`ord`+1 WHERE `source`=0 OR `feature`=1";
			$mysqli->query($ordersql);
			$updatehome['ord'] = 0; // put this to top.
			$photosmoved = 0;
			form_to_table('homes',$updatehome,$homeid); // overwrite new values!

			// Process Photos
			$this->getphotos();

			if($this->gallery_exists==true) {
				foreach($this->photos as $photocount => $photo) {
					// $photo['filepath'] containts FULL url, either a brixwork subdomain or S3 URL after upgrade.
					log_error("Attempting copy of {$photo['filename']} for {$homeid} towards S3 \n");
					$photoresult = attach_gallery_image('homes', $homeid, $photo['filename'], $photo['filepath']);
					//log_error('Upload attempt resulted in copy of '.count($photoresult['photoupload'])." Assets.\n");
					if($photoresult['mysql_insert']['success'] == false || !is_array($photoresult['photoupload'])) {
						// error! log it.
						log_error("Failed to copy file {$filepath} for {$homeid} towards S3.\n");
					} else {
						$photossql = "UPDATE `photos` SET `url`='', `s3`='1' WHERE `id`='".$photoresult['mysql_insert']['message']."'";
						$mysqli->query($photossql);
						$photosmoved++;
					}
				}
			} else {
				log_error($homeid." Photo Gallery disabled. \n");
			}

			$rowid = $homeid; // pass home ID.

			if($this->photos===false || $photosmoved>0) {
				// either no photos yet, or all photos moved!
				$sql = "UPDATE `homes` SET `modify_date`='".$original_modify_date."' WHERE `id`='".$this->id."'";
				$mysqli->query($sql);
				// once it's OWN listing, must run off local (even if the URL was imported)
				log_error("Migrated total of ".($this->photos ? $photosmoved."/".count($this->photos) : "0")." photos.\n");
				$message = 'MLS #'.$this->mls.' successfully converted to OWN listing.';
			} else {
				// TODO: even if photos fail, should we just keep it as source=0 and redirect to photo gallery page?
				$localcount = 0;
				$s3count = 0; // count # removed.
				$sqlcount = 0;
				$this->source = 0; // set source to 0 so that getphotos() will fetch from local if needed while verifying.
				$this->getphotos(); // get photos again from current local table.

				foreach($this->photos as $pcount=>$photo) {
					$removeresult = remove_gallery_photos($photo, 'homes');
					// echo "Local: ".$removeresult[0].", S3: ".$removeresult[1].", MySQL: ".$removeresult[2]."<br />\r\n";
					$localcount = $localcount+$removeresult[0];
					$s3count = $s3count+$removeresult[1];
					$sqlcount = $sqlcount+$removeresult[2];
					log_error("Removing file {$photo['filepath']}. Removed ".$removeresult[1]." from S3.\n");
				}
				$sql = "UPDATE `homes` SET `source`='1', `modify_date`='".$original_modify_date."' WHERE `id`='".$this->id."'";
				$mysqli->query($sql);
				$this->source=1;
				$message = 'MLS #'.$this->mls.' migration failed. reverting back.';
				log_error("Removed ".$s3count.". photos, and reverting back to source=1.\n");
			}
		} else {
			$code = 0;
			$rowid = false;
			$message = 'MLS #'.$this->mls.' cannot be converted to your OWN listing. Please check if this was converted already.';
			log_error('MLS #'.$this->mls.' cannot be converted to OWN listing.');
		}
		return array($code, $rowid, $message);
	}


	// CUSTOM FIELDS FUNCTIONS -- COPY TO OTHER OBJECTS AS WELL
	function get_custom_fields($name='') {
		global $mysqli;
		if($name!='') {
			// $name var given, look for array. If it's blank, it's blank... big diff from being unavailable.
			if(is_array($this->custom_fields) && array_key_exists($name, $this->custom_fields)) {
				$returnvar = $this->custom_fields[$name];
			} else {
				// if key does not exist, return false boolean
				$returnvar = false;
			}
		} else {
			// no name field given, get all fields and initialize
			$this->custom_fields = array();
			// get custom fields
			$sql = 'SELECT `id`, `name`, `desc`, `value` FROM `custom_fields` WHERE `home`="'.$this->id.'" ORDER BY `ord` ASC, `id` ASC';
			$returnvar = array();
			$result = $mysqli->query($sql);
			if($result->num_rows > 0) {
				// found rows, get results in array!
				while($array = $result->fetch_assoc()) {
					if(unserialize($array['value'])) {
						// it's an array so unserialize.
						$returnvar[$array['name']]['value'] = unserialize($array['value']);
					} else {
						// it's not an array, so string.
						$returnvar[$array['name']]['value'] = $array['value'];
					}
					$returnvar[$array['name']]['homeid'] = $this->id; // in case we need to refer to home ID but honestly quite redundant as this is PART of an home object already...
					$returnvar[$array['name']]['desc'] = $array['desc']; // description of what the field does etc.
					$returnvar[$array['name']]['id'] = $array['id']; // ID of the row in the `custom_fields` table in case we need reference.
					$returnvar[$array['name']]['ord'] = $array['ord']; // order of the custom feat.
				}

			} else {
				$returnvar = false; // not a single row of custom fields for this page
			}
			$this->custom_fields = $returnvar;
		}
		return $returnvar;
	}

	function update_custom_field($id, $value, $desc='', $ord='') {
		global $mysqli;
		if($id!='') {
			$updatesql = "UPDATE `custom_fields` SET 
			   `value`='".cleanupforentry($value)."', 
			   `desc`='".cleanupforentry($desc)."' 
				".(isset($ord) ? ", `ord`='".remove_all_but_numbers($ord)."'" : "")."
				WHERE `id`='".$id."' and `home`='".$this->id."' ";
			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function add_custom_field($name, $value, $desc='', $ord=0) {
		global $mysqli;
		if($name!='') {
			// name can never be blank. however the value can be  a blank value if its meant to be!
			$insertarray['name']	= $name;
			$insertarray['value']	= $value;
			$insertarray['desc']	= $desc;
			$insertarray['home']	= $this->id;
			$insertarray['ord']		= remove_all_but_numbers($ord);
			return form_to_table('custom_fields', $insertarray);
		} else {
			return false;
		}
	}

	function drop_custom_field($params) {
		// allow deletoin by unique ID, or  by name.
		global $mysqli;
		$id = (isset($params['id']) ? $params['id'] : false);
		$name = (isset($params['name']) ? $params['name'] : false);

		if($id === false && $name!==false) {
			// get ID by field name.
			$custom_field = $this->get_custom_fields($name);
			if ($custom_field) {
				$id = $custom_field['id'];
			} else {
				$id = false;
			}
		}
		if($id) {
			$deletesql = "DELETE FROM `custom_fields` WHERE `home` = ".$this->id." AND `id`=".$id ;
			if($mysqli->query($deletesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function drop_custom_fields() {
		global $mysqli;
		if($this->id!='') {
			$updatesql = "DELETE FROM `custom_fields` WHERE `home` = ".$this->id;
			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
}


class building {
	var $id;
	var $objecttype = false;
	var $name;
	var $mainid = false;
	var $subids = false;
	var $mainbuilding = false;
	var $feature;
	var $publish;
	var $status; // displayable status such as "VIP Presale"
	var $statusid; // raw ID for status such as 0, 1, 2..
	var $land_title;
	var $defaultname; // flag to detect whether the building name given is a default (address) or a given name (proper)
	var $builder;

	var $agent_1;
	var $agent_2;
	var $agent_3;

	var $heading = false;
	var $desc;
	var $excerpt;
	var $youtube;
	var $vimeo;
	var $virtualtour;

	var $photos;

	var $content;
	var $numlistings = 0;
	var $numactivelistings = 0;
	var $numsoldlistings = 0;

	var $website;
	var $email;
	var $listings;
	var $number;
	var $street;
	var $address;
	var $lat;
	var $long;

	var $area;
	var $area_alt;
	var $city;
	var $areacity;

	var $areaid = false;
	var $cityid = false;
	var $area_altid = false;

	var $rental;
	var $short_term_rental;
	var $pets;
	var $air_conditioning;
	var $ev_charging;
	var $storeys;
	var $construction;
	var $suites;
	var $year;
	var $strataid;
	var $min_beds;
	var $max_beds;
	var $min_baths;
	var $max_baths;
	var $min_price;
	var $max_price;
	var $features; // array of all features in plan text...  array('pool','BBQ','Sauna');
	var $featuresdisplay; // string display of features... pool, BBQ, sauna
	var $fulladdress;

	var $showroom_address;
	var $showroom_area;
	var $showroom_city;
	var $showroom_street_dir_position;
	var $pdf_labels;

    var $custom_fields;
	var $keywords;

    function initialize($id, $buildingarray = false) {
		global $settings;
		global $mysqli;

		$data = false;
		$pdata = false; // default these to FALSE to start.
		if(!isset($id) || $id=='' || $id===false || !is_numeric($id)) {
			if(isset($buildingarray['id'])) {
				$id = $buildingarray['id'];
			}
		}
		if($buildingarray===false) {

			$memcache_params = array(
				'type'=>'building',
				'objectid'=>intval($id)
			);

			$memcache_data = get_memcache($memcache_params);

			if(is_array($memcache_data)) {
				$data = $memcache_data;
				$data['memcache'] = true;
				if(DEBUG==true) {
					echo "Building data from memcache: ".count($data)." columns retrieved.<br />".PHP_EOL;
				}
			} else {
				$sql = "SELECT b.*, a.name as subarea_name, aa.name AS subarea_alt_name, c.name as city_name, showroom_a.name as showroom_subarea_name, showroom_c.name as showroom_city_name FROM `buildings` b 
LEFT OUTER JOIN `subareas` a ON b.area=a.id 
LEFT OUTER JOIN `subareas` aa ON b.area_alt=aa.id 
LEFT OUTER JOIN `areas` c ON b.city=c.id  
LEFT OUTER JOIN `subareas` showroom_a ON b.showroom_area=showroom_a.id 
LEFT OUTER JOIN `areas` showroom_c ON b.showroom_city=showroom_c.id 
WHERE b.id='".$id."'";

				$result = $mysqli->query($sql);
				$GLOBALS[BRIX_PAGES_QUERY]++;
				if($result->num_rows>0) {
					$data = $result->fetch_assoc();
					$building_cache_key = get_memcache($memcache_params, $data);
					if(DEBUG===true) {
						echo "SQL Query: ".$sql."<br />".PHP_EOL;
						echo "Attempt memcache storage with params: <br />".PHP_EOL;
						print_r($memcache_params);
						echo PHP_EOL."<br />New Key: ".$building_cache_key."<br />".PHP_EOL;
					}
				} else {
					$data = false;
				}
			}
		} else if(is_array($buildingarray)) {
			// retrieve from the $data array - the get_properties function already returned a lot of the fields to speed it up, this reduces query time for map searches.
			$data = $buildingarray;// feed $homearray into $data then start processing the data only, bypass the MySQL query.
			if($data['filename']!='' && $data['pid']!='') {
				$pdata = array('pid'=>$data['pid'], 'filename'=>$data['filename'],'timestamp'=> $data['timestamp']);
			}
			if(DEBUG==true) {
				echo "Memcache flag on building array: ".(isset($buildingarray['memcache']) && $buildingarray['memcache']===true ? "true" : "false")."<br />".PHP_EOL;
			}
		}

		if($data!==false) {
			$this->objecttype = 'building';
			foreach($data as $key=>$value) {
				$this->data[$key] = $value;
			}

			$this->id = $data['id'];

			$this->mainphoto = delimited_options_to_array($data['mainphoto'], $settings['buildings_mainphotofilename']);
			$this->pdf = delimited_options_to_array($data['pdf'], $settings['buildings_pdffilename']);


			// start with random string dummy patterns to avoid false positive.
			$street_type_suffix_pattern = "/fjldkhsagfelahfijlsd/";
			$street_suffix_pattern = "/fjldkhsagfelahfijlsd/";
			$street_type_pattern = "/fjldkhsagfelahfijlsd/";

			// building/development address
			$this->address = '';
			// process address strings
			$this->street_dir_position = ($data['street_dir_position']!='' ? $data['street_dir_position'] : $settings['street_dir_position_default']); // get street dir position, if this property has it set, go with it, if not default.

			$this->number = $data['number'];

			list($street_name, $street_type, $street_dir, $street_suffix) = separate_streetname($data['street']); // initial processing, see how much of the full street details are put in the name already, and blast it out.

			$this->street_name = $street_name; // extract just the name!
			// override dir/type etc. if they are explicitly set, even if street name infers it.
			$this->street_dir = ($data['street_dir']!='' ? ucwords(strtolower($data['street_dir'])) :  $street_dir);
			$this->street_type = ($data['street_type']!='' ? ucwords(strtolower($data['street_type'])) : $street_type);
			$this->street_suffix = ($data['street_suffix']!='' ? ucwords(strtolower($data['street_suffix'])) : $street_suffix);

			if($this->street_type!='') {
				$street_type_pattern = "/".$this->street_type."$/i";
				if($this->street_suffix!='') {
					$street_type_suffix_pattern = "/".$this->street_type." ".$this->street_suffix."$/i";
				}
			}

			if($this->street_suffix) {
				$street_suffix_pattern = "/".$this->street_suffix."$/i";
			}


			$this->street =
				($this->street_dir!='' && $this->street_dir_position==0 ? $this->street_dir.' ' : '').
				$this->street_name.
				($this->street_type!='' ? ' '.$this->street_type : '').
				($this->street_dir!='' && $this->street_dir_position==1 ? ' '.$this->street_dir : '').
				($this->street_suffix ? ' '.$this->street_suffix : '');

			$this->address .= $this->number.' '.$this->street;


			/*

						echo 'Type Suffix match: '.$street_type_suffix_pattern.':'.preg_match($street_type_suffix_pattern, $this->street_name).'<br />';
						echo 'Type Only match: '.$street_type_pattern.':'.preg_match($street_type_pattern, $this->street_name).'<br />';
			*/

			$this->lat = ($data['lat']!=0 && $data['lat']!='' ? $data['lat'] : '');
			$this->long = ($data['long']!=0 && $data['long']!='' ? $data['long'] : '');

			$this->mainid = ($data['mainid']>0 ? $data['mainid'] : false); // see if mainbuilding field is set.

			if($this->mainid && $this->mainid!=$this->id) {
				// mainid is SET, yet the mainbuilding and this ID do not match. This is a SUB building!
				$this->mainbuilding = new building;
				$this->mainbuilding->initialize($this->mainid); // load the main building that this is attached to.
			} else {
				$this->mainbuilding = false;
			}


            $this->virtualtour = get_secured_url($data['virtualtour']);
            if (strpos(strtolower($data['virtualtour']), '<iframe') !== false || strpos(strtolower($data['virtualtour']), '<a') !== false) {
                $doc = new DOMDocument();
                $doc->loadHTML($this->virtualtour);
                $href = $doc->getElementsByTagName('a');
                if ($href->length) {
                    $this->virtualtour = get_secured_url($href->item(0)->getAttribute('href'));
                }
                $doc = null;
            }


			if($this->mainbuilding) {
				// this building is attached to another MAIN building.
				// This is a SUB building because mainbuilding is TRUE.
				$this->feature = $this->mainbuilding->feature;
				$this->publish = $this->mainbuilding->publish;
				$this->desc = $this->description = $this->mainbuilding->desc;
				$this->desc2 = $this->description2 = $this->mainbuilding->desc2;
				$this->heading = $this->mainbuilding->heading;
				$this->heading2 = $this->mainbuilding->heading2;
				$this->excerpt = $this->mainbuilding->excerpt;
				$this->excerpt2 = $this->mainbuilding->excerpt2;
				$this->builder = $this->mainbuilding->builder;
				$this->status = $settings['building_status_display'][$this->mainbuilding->data['status']];
				$this->statusid = $this->mainbuilding->data['status']; // raw ID is still useful.
				$this->land_title = $this->mainbuilding->land_title;

				$this->data['agent_1'] = $this->mainbuilding->data['agent_1'];
				$this->data['agent_2'] = $this->mainbuilding->data['agent_2'];
				$this->data['agent_3'] = $this->mainbuilding->data['agent_3'];


				$this->website = $this->mainbuilding->website;
				$this->email = $this->mainbuilding->email;
				$this->youtube = $this->mainbuilding->youtube;
				$this->vimeo = $this->mainbuilding->vimeo;
				$this->virtualtour = $this->mainbuilding->virtualtour;

				$this->remarks = $this->mainbuilding->remarks;
				$this->remarks2 = $this->mainbuilding->remarks2;

				$this->rental = ($this->mainbuilding->data['rental']==1 ? true : ($this->data['rental']===NULL ? '' : false));
				$this->short_term_rental = ($this->mainbuilding->data['short_term_rental']==1 ? true : ($this->data['short_term_rental']===NULL ? '' : false));
				$this->pets = ($this->mainbuilding->data['pets']==1 ? true : ($this->data['pets']===NULL ? '' : false));
				$this->air_conditioning = ($this->mainbuilding->data['air_conditioning']==1 ? true : ($this->data['air_conditioning']===NULL ? '' : false));
				$this->ev_charging = ($this->mainbuilding->data['ev_charging']==1 ? true : ($this->data['ev_charging']===NULL ? '' : false));

				$this->storeys = $this->mainbuilding->storeys;
				$this->suites = $this->mainbuilding->suites;
				$this->construction = $this->mainbuilding->construction;
				$this->year = $this->mainbuilding->year;
				$this->strataid = $this->mainbuilding->strataid;

				$this->min_beds = $this->mainbuilding->data['min_beds'];
				$this->max_beds = $this->mainbuilding->data['max_beds'];

				$this->min_baths = $this->mainbuilding->data['min_baths'];
				$this->max_baths = $this->mainbuilding->data['max_baths'];

				// get unit types available.
				if(strlen($this->mainbuilding->data['unittypes'])>2) {
					// unit types is set!
					$unittypes_array = explode('|', $this->mainbuilding->data['unittypes']);
					foreach($unittypes_array as $unittype_id) {
						if($unittype_id!='') {
							$this->unittypes[$unittype_id] = $settings['type'][$unittype_id];
						}
					}
				} else {
					$this->unittypes = false;
				}

				// start assembling building area/city and address.
				// sub buildings CAN technically be in a different area so use its own data.
				if($data['subarea_alt_name']!='') {
					$this->area_alt = $data['subarea_alt_name'];
				} else {
					$this->area_alt = false;
				}

				if($data['subarea_name']!='') {
					$this->area = $data['subarea_name'];
					$this->areaid = $data['area'];
					if($this->area_alt!==false) {
						$this->area = $this->area_alt.' ('.$this->area.')';
					}
				}

				if($data['city_name']!='') {
					$this->cityid = $data['city'];
					$this->city = $data['city_name'];
				}

				$this->areacity = ($this->area!='' && $this->area!=$this->city ? $this->area.', ' : '').$this->city;

				if($this->area!='') {
					$this->keywords.=', '.$this->area;
				}
				if($this->city!='') {
					$this->keywords.=', '.$this->city;
				}

				$this->fulladdress = $this->address.', '.$this->areacity;

				$this->lat = ($this->data['lat']!=0 ? $this->data['lat'] : $this->mainbuilding->data['lat']);
				$this->long = ($this->data['long']!=0 ? $this->data['long'] : $this->mainbuilding->data['long']);

				// showroom address assembly begins.
				$this->showroom_address = $this->mainbuilding->showroom_address;
				// process address strings
				$this->showroom_street_dir_position = $this->mainbuilding->showroom_street_dir_position; // get street dir position, if this property has it set, go with it, if not default.

				$this->showroom_number = $this->mainbuilding->showroom_number;

				$this->showroom_street_name = $this->mainbuilding->showroom_street_name; // extract just the name!
				// override dir/type etc. if they are explicitly set, even if street name infers it.
				$this->showroom_street_dir = $this->mainbuilding->showroom_street_dir;
				$this->showroom_street_type = $this->mainbuilding->showroom_street_type;
				$this->showroom_street_suffix = $this->mainbuilding->showroom_street_suffix;

				$this->showroom_street =$this->mainbuilding->showroom_street;

				$this->showroom_lat = $this->mainbuilding->showroom_lat;
				$this->showroom_long = $this->mainbuilding->showroom_long;

				$this->showroom_hours = $this->mainbuilding->showroom_hours;

				if($this->mainbuilding->data['name']=='') {
					// if name is blank, the address should default.
					$this->name = $this->address.', '.$this->city;
					$this->defaultname = true;
				} else {
					$this->name = $this->mainbuilding->data['name'];
					$this->defaultname = false;
				}

				// process meta title
				$this->metatitle_default = $this->name.(!$this->defaultname ? ' ('.$this->fulladdress.')' : '').' Listings For Sale - '.$settings['title'];
				if($this->mainbuilding->data['metatitle']!='') {
					$this->metatitle = $this->mainbuilding->data['metatitle'];
				} else {
					$this->metatitle = $this->metatitle_default;
				}

				// process meta description
				$this->metadescription_default = 'Browse all listings for sale in '.$this->name.(!$this->defaultname ? ' ('.$this->fulladdress.')' : '').'. Currently featuring '.(is_countable($this->listings) ? count($this->listings) : '0').' at '.$this->address.', brought to you by '.$settings['title'];
				if($this->mainbuilding->data['metadescription']!='') {
					$this->metadescription = $this->mainbuilding->data['metadescription'];
				} else {
					$this->metadescription = $this->metadescription_default; // set to default if no custom one set.
				}

				// process URL slug
				$this->slug_default = (!$this->defaultname ? url_format($this->name) :
						url_format($this->mainbuilding->number)
						."+"
						.url_format($this->mainbuilding->street)
					)
					.'-'.url_format($this->city);

				if($this->mainbuilding->data['slug']!='') {
					$this->slug = $this->mainbuilding->data['slug'];
				} else {
					$this->slug = $this->slug_default; // set to default if no custom one set.
				}

				if($this->mainbuilding->features!==false) {
					// process features
					$this->features = $this->mainbuilding->features;
					$this->featuresdisplay = $this->mainbuilding->featuresdisplay;
				}
			} else {
				// its own building, itself.. no doctoring of data needed from the mainb!
				$this->feature = $this->data['feature'];
				$this->publish = $this->data['publish'];
				$this->desc = $this->description = $this->data['description'];
				$this->desc2 = $this->description2 = $this->data['description2'];
				$this->heading = $this->data['heading'];
				$this->heading2 = $this->data['heading2'];
				$this->excerpt = $this->data['excerpt'];
				$this->excerpt2 = $this->data['excerpt2'];
				$this->builder = $this->data['builder'];
				$this->status = $settings['building_status_display'][$this->data['status']];
				$this->statusid = $this->data['status'];
				$this->land_title = $settings['building_land_title_display'][$this->data['land_title']]; // 0 = unspecified (false), 1 = freehold, 2 = leasehold
				$this->remarks = $this->data['remarks'];
				$this->remarks2 = $this->data['remarks2'];

				$this->website = $this->data['website'];
				$this->email = $this->data['email'];
				$this->youtube = $this->data['youtube'];
				$this->vimeo = $this->data['vimeo'];

				$this->virtualtour = $this->data['virtualtour'];

				$this->rental = ($this->data['rental']==1 ? true : ($this->data['rental']===NULL ? '' : false));
				$this->short_term_rental = ($this->data['short_term_rental']==1 ? true : ($this->data['short_term_rental']===NULL ? '' : false));
				$this->pets = ($this->data['pets']==1 ? true : ($this->data['pets']===NULL ? '' : false));
				$this->air_conditioning = ($this->data['air_conditioning']==1 ? true : ($this->data['air_conditioning']===NULL ? '' : false));
				$this->ev_charging = ($this->data['ev_charging']==1 ? true : ($this->data['ev_charging']===NULL ? '' : false));

				$this->storeys = $this->data['storeys'];
				$this->suites = $this->data['suites'];
				$this->construction = $this->data['construction'];
				$this->year = ($this->data['year']>0 ? $this->data['year'] : '');
				$this->strataid = $this->data['strataid'];

				$this->min_beds = ($this->data['min_beds'] === NULL ? false : $this->data['min_beds']);
				$this->max_beds = ($this->data['max_beds'] === NULL ? false : $this->data['max_beds']);

				$this->min_baths = ($this->data['min_baths'] === NULL ? false : $this->data['min_baths']);
				$this->max_baths = ($this->data['max_baths'] === NULL ? false : $this->data['max_baths']);

				$this->min_price = ($this->data['min_price'] === NULL ? false : $this->data['min_price']);
				$this->max_price = ($this->data['max_price'] === NULL ? false : $this->data['max_price']);

				// get unit types available.
				$this->unittypes = delimited_options_to_array($this->data['unittypes'], $settings['type']);

				if($data['subarea_alt_name']!='') {
					$this->area_alt = $data['subarea_alt_name'];
					$this->area_altid = $data['area_alt'];
				} else {
					$this->area_alt = false;
				}

				if($data['subarea_name']!='') {
					$this->area = $data['subarea_name'];
					$this->areaid = $data['area'];
					if($this->area_alt!==false) {
						$this->area = $this->area_alt.' ('.$this->area.')';
					}
				}

				if($data['city_name']!='') {
					$this->city = $data['city_name'];
					$this->cityid = $data['city'];
				}

				if($this->area!='') {
					$this->keywords.=', '.$this->area;
				}
				if($this->city!='') {
					$this->keywords.=', '.$this->city;
				}

				$this->areacity = ($this->area!='' && $this->area!=$this->city ? $this->area.', ' : '').$this->city;

				$this->fulladdress = $this->address.', '.$this->areacity;

				$this->showroom_number = $data['showroom_number'];

				list($showroom_street_name, $showroom_street_type, $showroom_street_dir, $showroom_street_suffix) = separate_streetname($data['showroom_street']); // initial processing, see how much of the full street details are put in the name already, and blast it out.

				$this->showroom_street_name = $showroom_street_name; // extract just the name!
				// override dir/type etc. if they are explicitly set, even if street name infers it.
				$this->showroom_street_dir = ($data['showroom_street_dir']!='' ? ucwords(strtolower($data['showroom_street_dir'])) :  $showroom_street_dir);
				$this->showroom_street_type = ($data['showroom_street_type']!='' ? ucwords(strtolower($data['showroom_street_type'])) : $showroom_street_type);
				$this->showroom_street_suffix = ($data['showroom_street_suffix']!='' ? ucwords(strtolower($data['showroom_street_suffix'])) : $showroom_street_suffix);


				$this->showroom_street =
					($this->showroom_street_dir!='' && $this->showroom_street_dir_position==0 ? $this->showroom_street_dir.' ' : '').
					$this->showroom_street_name.
					($this->showroom_street_type!='' ? ' '.$this->showroom_street_type : '').
					($this->showroom_street_dir!='' && $this->showroom_street_dir_position==1 ? ' '.$this->showroom_street_dir : '').
					($this->showroom_street_suffix ? ' '.$this->showroom_street_suffix : '');

				$this->showroom_address .= $this->showroom_number.' '.$this->showroom_street;

				// showroom address
				if($data['showroom_subarea_name']!='') {
					$this->showroom_area = $data['showroom_subarea_name'];
				}

				if($data['showroom_city_name']!='') {
					$this->showroom_city = $data['showroom_city_name'];
				}

				$this->showroom_areacity = ($this->showroom_area!='' && $this->showroom_area!=$this->showroom_city ? $this->showroom_area.', ' : '').$this->showroom_city;
				$this->showroom_fulladdress = $this->showroom_address.', '.$this->showroom_areacity;

				$this->showroom_lat = ($data['showroom_lat']!=0 && $data['showroom_lat']!='' ? $data['showroom_lat'] : '');
				$this->showroom_long = ($data['showroom_long']!=0 && $data['showroom_long']!='' ? $data['showroom_long'] : '');

				$this->showroom_hours = ($data['showroom_hours']!='' ? nl2br($data['showroom_hours']) : '');

				if($this->data['name']=='') {
					// if name is blank, the address should default.
					$this->name = $this->address.', '.$this->city;
					$this->defaultname = true;
					$this->hasname = false;
				} else {
					$this->name = $this->data['name'];
					$this->defaultname = false;
				}

				// process meta title
				$this->metatitle_default = $this->name.(!$this->defaultname ? ' ('.$this->fulladdress.')' : '').' Listings For Sale - '.$settings['title'];
				if($this->data['metatitle']!='') {
					$this->metatitle = $this->data['metatitle'];
				} else {
					$this->metatitle = $this->metatitle_default;
				}

				// process meta description
				$this->metadescription_default = 'Browse all listings for sale in '.$this->name.(!$this->defaultname ? ' ('.$this->fulladdress.')' : '').'. '.(is_array($this->listings) ? 'Currently featuring  '.count($this->listings).' at ' : 'Learn more about ').$this->address.', brought to you by '.$settings['title'];
				if($this->data['metadescription']!='') {
					$this->metadescription = $this->data['metadescription'];
				} else {
					$this->metadescription = $this->metadescription_default;
				}

				// process URL slug
				$this->slug_default = (!$this->defaultname ? preg_replace("/[^a-z0-9-]+/i", "+", $this->name) :
						preg_replace("/[^a-z0-9-]+/i", "+", $this->number)
						."+"
						.preg_replace("/[^a-z0-9-]+/i", "+", $this->street)
					)
					.($this->city ? '-'.preg_replace("/[^a-z0-9-]+/i", "+", $this->city) : '');

				if($this->data['slug']!='') {
					$this->slug = $this->data['slug'];
				} else {
					$this->slug = $this->slug_default; // set to default if no custom one set.
				}

//
//				if($this->data['features']!='') {
//					// process features
//					$this->features = array();
//					$featuresarray = explode(',', $data['features']);
//					foreach($featuresarray as $count=>$featureid) {
//						$this->features[] = $GLOBALS[BRIX_BUILDINGFEATURES_CACHE][$featureid];
//						if($count>0) {
//							$this->featuresdisplay .= ', '.$GLOBALS[BRIX_BUILDINGFEATURES_CACHE][$featureid];
//						} else {
//							$this->featuresdisplay = $GLOBALS[BRIX_BUILDINGFEATURES_CACHE][$featureid];
//						}
//					}
//				} else {
//					$this->features = false; // actual false.
//					$this->featuresdisplay = ''; // blank string.
//				}

				if($this->data['features']!='') {
					// process features
					$featuresarray = explode(',', $data['features']);
					$featurecount = 0;
					foreach($featuresarray as $count=>$featureid) {
						// if any feature was added, BRIX_BUILDINGFEATURES_CACHE has to be an array. No is_array() check needed.
						if(array_key_exists($featureid, $GLOBALS[BRIX_BUILDINGFEATURES_CACHE])){
							$this->features[] = $GLOBALS[BRIX_BUILDINGFEATURES_CACHE][$featureid];

							if($featurecount>0) {
								$this->featuresdisplay .= ', ';
							}
							$this->featuresdisplay .= $GLOBALS[BRIX_BUILDINGFEATURES_CACHE][$featureid];

							$featurecount++;
						}
					}
				} else {
					$this->features = false; // actual false.
					$this->featuresdisplay = ''; // blank string.
				}

			}

			if(!is_url($this->website) && $this->website!='') {
				$this->website = '//'.$this->website;
				// means somebody entered www. without the http:// so we append with //, agnostic to http or https
			}

			// initialize agents.
			if($this->data['agent_1']!='' && $this->data['agent_1']!=0 && $settings['multiagents']==1) {
				$this->agent_1 = new agent;
				$this->agent_1->initialize($this->data['agent_1']);
			} else {
				$this->agent_1 = false;
			}

			if($this->data['agent_2']!='' && $this->data['agent_2']!=0 && $settings['multiagents']==1) {
				$this->agent_2 = new agent;
				$this->agent_2->initialize($this->data['agent_2']);
			} else {
				$this->agent_2 = false;
			}

			if($this->data['agent_3']!='' && $this->data['agent_3']!=0 && $settings['multiagents']==1) {
				$this->agent_3 = new agent;
				$this->agent_3->initialize($this->data['agent_3']);
			} else {
				$this->agent_3 = false;
			}

			$this->youtube = $data['youtube'];
			$this->vimeo = $data['vimeo'];
			$this->video_exists = $this->video_exists();

			$pdf_labels_unserialized = false; // default false.
			if($data['pdf_labels']!='') {
				$pdf_labels_unserialized = unserialize($data['pdf_labels']);
			}
			if($pdf_labels_unserialized!==false) {
				foreach ($pdf_labels_unserialized as $key => $pdf_label) {
					// Use $key when assigning value so that the key->value pair stays the same as database.
					// if pdf label is empty, fall back to $settings default label - if $settings not set, make a quick fallback here
					if($pdf_label=='') {
						$this->pdf_labels[$key] = ((isset($settings['buildings_pdfname'][$key]) && $settings['buildings_pdfname'][$key]) != '' ? $settings['buildings_pdfname'][$key] : 'PDF '. ($key + 1));
					} else {
						$this->pdf_labels[$key] = $pdf_label;
					}
				}
			} else {
				// if all labels are empty, use site $settings default
				$this->pdf_labels = $settings['buildings_pdfname'];
			}

			$this->get_custom_fields();
			$this->getphotos($pdata);
			$this->get_video();
			$this->load_subbuildings();

			return $this->id;

		} else {
			return false;
		}
	}

	function get_listings($query='', $order_by = array('sold', 'create_date'), $order_dir = array('ASC', 'DESC'), $perpage = 100, $page = 1 ) {
		global $mysqli;
		global $memcache;
		global $settings;

		$basequery['publish'] = 1;
		$basequery['sold'] = array(0, 1, 2); // can be overridden by $query var since it merges in later.
		$basequery['bldg'] = $this->id;

		if($this->subids) {
			// gotta get all sub-buildings to get # of listings here!
			$thisbid = array($this->id); // turn into array, to merge later.

			$basequery['bldg'] = array(); // empty array to start,
			$basequery['bldg'] = array_merge($thisbid, $this->subids);

		};
		if(is_array($query)) {
			$query = array_merge($basequery, $query);
		} else {
			$query = $basequery;
		}

		$listings = get_properties('', $query, $order_by, $order_dir, $perpage, $page, false, true); // retrieve all listings and full data.
		$this->numlistings = ($listings!==false ? count($listings) : 0);
		if($this->numlistings>0) {
			$this->pricelow = 0;
			$this->pricehigh = 0;
			$this->sqftlow = 0;
			$this->sqfthigh = 0;
			$this->numactivelistings = 0;
			$this->numsoldlistings = 0;

			$this->listings_data = ''; // full data for faster retrieval - can use $home->initialize($ldata['id'], $ldata);
			$this->listings = array(); // raw IDs of listings, just to pull them out - but each $home->initialize($listings[]) will be a query.
			foreach($listings as $ldata) {
				$l = new home;
				$l->initialize($ldata['id'], $ldata);
				$vars = get_object_vars($l);
				$this->listings_data[$ldata['id']] = $vars;
				$this->listings[] = ($memcache===false || $ldata['source']==BRIX_LISTING_OWN ? $ldata['id'] : array('source'=>$ldata['source'], 'mls'=>$ldata['mls']));
				if($ldata['sold']==0) {
					// everything that happens here is for active listings only, to see num active listings as well as calculate price range & sqft etc.
					$rawprice = remove_all_but_numbers($ldata['price']);
					$rawsqft = remove_all_but_numbers($ldata['sqft']);

					if($rawprice<$this->pricelow || $this->pricelow==0) {
						$this->pricelow = $rawprice; // set lower price range.
					}

					if($rawprice>$this->pricehigh || $this->pricehigh==0) {
						$this->pricehigh = $rawprice; // set lower price range.
					}

					if($rawsqft<$this->sqftlow || $this->sqftlow==0) {
						$this->sqftlow = $rawsqft; // set lower price range.
					}

					if($rawsqft>$this->sqfthigh || $this->sqfthigh==0) {
						$this->sqfthigh = $rawsqft; // set lower price range.
					}
					$this->numactivelistings++;
				}
			}
			$this->numsoldlistings = ($this->numlistings*1) - ($this->numactivelistings*1);
		}
		return $listings;
	}

	function getphotos($photos=false) {
		global $settings;
		global $mysqli;
		unset($this->photos);
		if($photos === false) {
			$this->photos = get_object_photos('buildings', $this->id);
		}

		if (is_array($this->photos) && count($this->photos)>0) {
			$this->gallery_exists = 1;
			$return = true;
		} else {
			$this->gallery_exists = 0;
			$this->photos = false;
			$return = false;
		}
		return $return;
	}

	function get_main_image($width='', $height='', $noimage = 'noimage.png', $cssclass = '') {
		// soon to be deprecated perhaps in favour of get_main_image_path? Or use in conjunction?
		global $settings;

		return $this->get_main_images(0, $width, $height, $noimage, $cssclass, 90);
	}


	function get_main_images($num = 0, $width='', $height='', $noimage = 'noimage.png', $cssclass='', $quality = 75, $fallback = 0) {
		// applies only to source=0 listings that may contain more than 1 MAIN IMAGE files. $num var is use dto find the array key.
		global $settings;
		if($width=='') {
			$width = $settings['buildings_mainphotowidth'][$num];
		}
		if($height=='') {
			$height = $settings['buildings_mainphotowidth'][$num];
		}

		$classhtml = '';
		if($cssclass) {
			if(is_array($cssclass)!=1) {
				$classhtml = $cssclass; // singular class
			} else {
				// multiple classes passed by array, list them all with spaces.
				foreach($cssclass as $classcount => $css) {
					if($classcount>0) {
						$classhtml.=' ';
					}
					$classhtml.=$css;
				}
			}
		}
		// to get path, use get_main_images_path
		$fileurl = $this->get_main_images_path($num, $noimage, $fallback);
		if(strpos($fileurl, '?mod=')) {
			$timthumbimageurl = str_ireplace('?', '%3F', $fileurl);
			// $timthumbimageurl = substr($fileurl, 0, strpos($fileurl, '?mod='));
		} else {
			$timthumbimageurl = $fileurl;
		}

		$imgtag = '<img src="/timthumb.php?src='.$timthumbimageurl.'&w='.$width.'&h='.$height.'&q='.$quality.'" alt="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" title="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" class="'.$classhtml.'" />';
		// by default, we timthumb the image to the size.

		if ((strpos($fileurl,'noimage') !== false || strpos($fileurl,'http') !== false) || strpos($fileurl, $settings['buildings_mainphotofilename'][$num])!==false || strpos($fileurl, 'amazonaws.com')) {
			$imgtag = '<img src="'.$fileurl.'" alt="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" title="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" class="'.$classhtml.'" />'; // just a noiomage file, or a specific main.jpg image or from S3, so use as-is.
		} else if(file_exists(($settings['fileroot']!='' ? $settings['fileroot'] : $_SERVER['DOCUMENT_ROOT']).'/'.$settings['rootpath'].'buildings/'.$this->id.'/'.$settings['buildings_mainphotofilename'][$num])) {
			// fall back to local file, let's compare size and see if we can skip timthumb.
			list($sourcewidth, $sourceheight, $sourcetype, $sourceattr) = getimagesize(($settings['fileroot']!='' ? $settings['fileroot'] : $_SERVER['DOCUMENT_ROOT']).'/'.$settings['rootpath'].'buildings/'.$this->id.'/'.$settings['buildings_mainphotofilename'][$num]);
			if($sourcewidth<=$width && $sourceheight<=$height) {
				// no need for timthumb since the source image is already smaller than or equal to display request size.
				$imgtag = '<img src="'.($settings['homespath']!='' ? $settings['homespath'] : $settings['sitepath']).'buildings/'.$this->id.'/'.$settings['buildings_mainphotofilename'][$num].'" alt="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" title="'.$this->fulladdress.' '.($num > 0 ? $num+1 : '').'" class="'.$classhtml.'" />';
			}
		}

		return $imgtag;
	}

	function get_main_image_path($noimage='noimage.png') {
		// soon to refer to the master function get_main_images_path() below.
		global $settings;
		return $this->get_main_images_path(0, $noimage);
	}

	function get_main_images_path($num = 0, $noimage='noimage.png', $fallback = true) {
		global $settings;
		return get_main_images_path('buildings', $this, $num, $noimage, $fallback);
	}

	function pdf_file_link($num, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('buildings', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}



	function video_exists() {
		// obsolete function now, refers simply to get_video for true/false return.
		return $this->get_video();
	}



    function get_video($autoplay = false) {
        global $settings;

        if($this->youtube!='') {
            $this->videourl = "https://www.youtube.com/v/".$this->youtube."?rel=0&hl=en&fs=1&autoplay=".($autoplay ? '1' : '0');
            $this->videoembedurl = "//www.youtube.com/embed/".$this->youtube."?rel=0&fs=1&enablejsapi=1&autoplay=".($autoplay ? '1' : '0');
            $return = true;

        } else if($this->vimeo!='') {
            $this->videourl = 'https://vimeo.com/'.$this->vimeo;
            $this->videoembedurl = "//player.vimeo.com/video/".$this->vimeo."?title=0&amp;byline=0&amp;portrait=0"; // from vimeo, hides all other junk. rest of page has title all over it anyway.
            $return = true;

        } else if ( $this->youtube == '' && getyoutubeid($this->data['virtualtour']) ) {

            $this->youtube = getyoutubeid($this->data['virtualtour']);
            $this->videourl = "https://www.youtube.com/v/".$this->youtube."?rel=0&hl=en&fs=1&autoplay=".($autoplay ? '1' : '0');
            $this->videoembedurl = "//www.youtube.com/embed/".$this->youtube."?rel=0&fs=1&enablejsapi=1&autoplay=".($autoplay ? '1' : '0');
            $return = true;

        } else if ( $this->vimeo == '' && getvimeoid($this->data['virtualtour']) ) {

            $this->vimeo = getvimeoid($this->data['virtualtour']);
            $this->videourl = 'https://vimeo.com/'.$this->vimeo;
            $this->videoembedurl = "//player.vimeo.com/video/".$this->vimeo."?title=0&amp;byline=0&amp;portrait=0";
            $return = true;
        }
        // end of taran's block

        else {
            $this->videourl = false;
			$this->videoembedurl = false;
            $return = false;
        }

        if ($return == false ) {
            if ( strpos(strtolower($this->data['virtualtour']), '<iframe') !== false || strpos(strtolower($this->data['virtualtour']), '<a') !== false) {
                $doc = new DOMDocument();
                $doc->loadHTML($this->data['virtualtour']);
                $ifra = $doc->getElementsByTagName('iframe');
                if ($ifra->length) {
                    $this->videoembedurl = get_secured_url($ifra->item(0)->getAttribute('src'));
                    $return = true;
                }
                $doc = null;
            }
        }

        return $return;
    }




	function get_building_link($trail='',$base='listings/') {
		global $settings;
		if($trail=='' && $settings['url_trail']!='') {
			$trail = $settings['url_trail'];
		}
		return $settings['sitepath'].$base.'bldg-'.$this->id.'/'.$this->slug;
	}

	function load_subbuildings($data = false) {
		// load the buildings that belong to this master building.
		global $settings;
		global $mysqli;
		if($this->mainid && $this->id==$this->mainid) {
			// this is the MASTER building. Retrieve subids.
			$query['mainid'] = $this->id;
			/*
			 * To be able to have agile memcache of building/listing results,
			 * we will start building cache to be within get_buildings() instead of at this function layer
			 * While this is tempting to make it easier, that's will create too many redundant spots to cache at.
			 * */

			$buildings = get_buildings($query, array('street', 'number'), array('asc', 'asc'), 1000, 1, false, $data);
			if(is_array($buildings) && $buildings!=false && count($buildings)>0) {
				$this->subids = array(); // reset array.
				$this->subbuildings = array(); // reset array.
				if($data==true) {
					foreach($buildings as $bkey => $barray) {
						$this->subids[] = $bkey; // fetch just the IDs for regular iterations (old school)
						$this->subbuildings[$bkey] = $barray; // full array for better data fetch!
					}
					$return = $this->subbuildings; // also return the full data if $data==true
				} else {
					foreach($buildings as $bid) {
						$this->subids[] = $bid;
					}
					$this->subbuildings = false; // no full data of subbuildings, so leave this false to avoid any confusion.
					$return = $this->subids;
				}

			}	else {
				// no sub buildings found.
				if($this->data['mainid']!=0) {
					$mysqli->query("UPDATE `buildings` SET `mainid`=0 WHERE `id`='".$this->id."'");
				}
				$this->subids = false;
				$this->mainid = false;
				$return = false;
			}
		} else {
			$this->subids = false;
			$return = false;
		}
		return $return;
	}


	function make_primary_building($targetbuildingid='') {
		// if this building also is attached to another building, then the attached building will be it.
		global $mysqli;
		global $settings;
		if($targetbuildingid=='' && $this->mainid!=$this->id && is_object($this->mainbuilding)) {
			// target building ID not set... this means just go through other sub-buildings, and set this as primary
			// useful for when multiple buildings are there with the WRONG one set to primary.
			$subbuildings = $this->mainbuilding->load_subbuildings(); // get the parent building's sub-buildings.. AKA sibling buildings to this!


			$sqlfilter = "WHERE id='".$this->mainbuilding->id."' "; // WHERE filter for the current main building ABOVE this building, soon to be demoted to a child building.
			if($subbuildings) {
				// more sibling buildings?
				foreach($subbuildings as $subid) {
					// then aggregate its sub-buildings.
					if($subid!='') {
						// make sure its not blank, or this building itself (soon to be main building)
						$sqlfilter .= "OR `id`='".$subid."' ";
					}
				}
			}
			$switchsql = "UPDATE `buildings` SET `mainid` = '".$this->id."', `feature`=0 ".$sqlfilter;
			//echo $switchsql."\r\n";
			// sub-buildings, except this one (soon to be the new head bulding) should be set to mainid => this building, and feature=0 so it doesn't show on list (only one head building tha tis "FEATURED" may show here.
			if($mysqli->query($switchsql)) {
				// to demote all other buildings was successful, let's PROMOTE this one.
				// A building's own `mainid` equalling its own `id` is an indication that it is a primary building.
				// buildings_mod.php also has a <input name="mainid"> that changes to its own ID when attaching buildings.
				$featuresql = "UPDATE `buildings` SET `feature`=1, `mainid`=".$this->id." WHERE `id`='".$this->id."'";
				//echo $featuresql."\r\n";
				if($mysqli->query($featuresql)) {
					$result = true;
				} else {
					$result = false;
				}
			} else {
				$result = false;
			}
		} else {
			// target building is set... $targetbuildingid becomes a sub-building of $this.
			// first check if this IS the primary building or not.
			$mainbuildingid = $this->id;
			if($this->mainid!=$this->id) {
				// this is the main building, or is not even a parent building yet.
				$mainbsql = "UPDATE `buildings` SET `mainid` = '".$this->id."', `feature`=1 WHERE `id`='".$this->id."';"; // set its own ID as mainid to show that is primary building.
				$mysqli->query($mainbsql);
			}

			// initialize the target building to become a child building to $this
			$targetbuilding = new building;
			$targetbuilding->initialize($targetbuildingid);
			if(is_object($targetbuilding)) {
				$sqlfilter = " WHERE `id`='".$targetbuilding->id."'";// set target buildling to chnage mainid=$this->id as well as feature=0 so it becomes a child.

				if($targetbuilding->mainid!=$targetbuilding->id && $targetbuilding->mainbuilding) {
					// This has another main building, so find all of ITS sub buildings.
					$subbuildings = $targetbuilding->mainbuilding->load_subbuildings(); // load up all other sub-buildings.
					$subbuildings[] = $targetbuilding->mainbuilding->id; // include the topbuilding itself!
				} else if($targetbuilding->mainid==$targetbuilding->id) {// this is the previous mainbuilding, so all of its sub-buildings need to follow this guy!
					$subbuildings = $targetbuilding->load_subbuildings(); // load up all other sub-buildings.
				}

				foreach($subbuildings as $subid) {
					$sqlfilter .= "OR `id`='".$subid."' ";
				}
				$mainbsql = "UPDATE `buildings` SET `mainid`='".$mainbuildingid."', `feature`=0 ".$sqlfilter; // finally attach the target building to this BUILDING!

				if($mysqli->query($mainbsql)) {
					$result = true;
				} else {
					$result = false;
				}
			} else {
				$result = false;
			}
		}

		if($this->data['name']=='') {
			// doesn't have a name! pull the name from anotehr building that was part of this before.
			// just an afterthought, not critical to completion of the function!
			$namesql = "SELECT `name` FROM `buildings` WHERE `mainid`='".$this->id."' AND `name`!=''";
			$nameresult = $mysqli->query($namesql);
			if($nameresult->num_rows>0) {
				$namearray = $nameresult->fetch_assoc();
				$nameupdatesql = "UPDATE `buildings` SET `name`='".$namearray['name']."' WHERE `id`='".$this->id."'";
				$mysqli->query($nameupdatesql);
			}
		}
		return $result;
	}

	function detach_building() {
		global $mysqli;
		global $settings;
		// make this building independent from it's parent buliding.
		$updatesql = "UPDATE `buildings` SET `mainid`=0, `feature`=1 WHERE `id`='".$this->id."'";
		// first check if this even has main building.
		if($this->mainbuilding) {
			// 1 load up the mainbuilding for processing.
			// 2 load up the # of sub buildings the main building has.
			$subbuildings = $this->mainbuilding->load_subbuildings();
			// 3 if the main building only has one subbuilding (meaning this one!) then the "mainid" on the main building has to be set to 0 as well!
			if(is_array($subbuildings) && count($subbuildings)==1) {
				// only one subbuidling, this was the ONLY child. So the maser building mainid shoud be 0, feature to 1.
				$updatesql.=" OR `id`='".$this->mainbuilding->id."'";
			}
			//echo $updatesql."\r\n";
			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return $mysqli->error;
			}
			// run the query that sets the mainid = 0 on this building, or perhaps the one above it!
		} else {
			return false;
		}
	}

	function get_duplicate_buildings() {
		global $mysqli;
		global $settings;
		$memcache = false; // this is always going to be a back-edn quuery to get the latest fresh stuff.
		// get city & streetname.
		$dupid = false; // by default this is FALSE.
		$cityid = $this->data['city']; // 9 for Van West etc. depending on each system.
		$streetdir = $this->data['street_dir']; // West, E or North etc.
		$streetnum = $this->data['number']; // 499 etc.
		list($streetname, $streettype) = separate_streetname($this->data['street']); // broughton, street separated as array.
		// often realtors confuse ave str etc., just let it slide... they can select.
		// $streettype = ($this->data['street_type']!='' ? $this->data['street_type'] : $streettype);

		$dupsql = "SELECT `id`, `number`, `street_dir`, `street`, `street_type`, `name`  FROM `buildings` WHERE `number`='".$streetnum."' AND 
			(LOWER(`street`) LIKE '".$streetname."%' OR 
			LOWER(`street`) LIKE 'n ".$streetname."%' OR 
			LOWER(`street`) LIKE 's ".$streetname."%' OR 
			LOWER(`street`) LIKE 'e ".$streetname."%' OR 
			LOWER(`street`) LIKE 'w ".$streetname."%' OR 
			LOWER(`street`) LIKE 'north ".$streetname."%' OR 
			LOWER(`street`) LIKE 'south ".$streetname."%' OR 
			LOWER(`street`) LIKE 'east ".$streetname."%' OR 
			LOWER(`street`) LIKE 'west ".$streetname."%' OR 
			LOWER(`street`) LIKE 'n.".$streetname."%' OR 
			LOWER(`street`) LIKE 's.".$streetname."%' OR 
			LOWER(`street`) LIKE 'e.".$streetname."%' OR 
			LOWER(`street`) LIKE 'w.".$streetname."%' OR 
			LOWER(`street`) LIKE 'n. ".$streetname."%' OR 
			LOWER(`street`) LIKE 's. ".$streetname."%' OR 
			LOWER(`street`) LIKE 'e. ".$streetname."%' OR 
			LOWER(`street`) LIKE 'w. ".$streetname."%' OR 
			LOWER(`street`) LIKE 'nw ".$streetname."%' OR 
			LOWER(`street`) LIKE 'ne ".$streetname."%' OR 
			LOWER(`street`) LIKE 'sw ".$streetname."%' OR 
			LOWER(`street`) LIKE 'se ".$streetname."%' OR 
			LOWER(`street`) LIKE ' ".$streetname."%' 
			)
			AND `city`='".$cityid."'";
		$dupresult = $mysqli->query($dupsql);
		if($dupresult->num_rows>1) { // we'll always have ONE result, as the buildilng itself willbe picked up by this query... we are only concerned if theres more than one.
			$dupid = array();
			while($dupbuilding = $dupresult->fetch_assoc()) {
				// we have a street name, address & city match
				// let's make sure this filter doesn' tpick up pacific street and pacific blvd as identicals.
				list($dupstreetname, $dupstreettype) = separate_streetname($dupbuilding['street']);
				// $dupstreettype = ($dupbuilding['street_type']!='' ? $dupbuilding['street_type'] : $dupstreettype);
//				 echo 'comparing '.$dupstreettype.' against '.$streettype.'<br />';
				if($dupbuilding['id']==$this->id) {
					// the building itself, so should be part of the array for prcoessing/merging later..
					$dupid[] = $dupbuilding['id'];
				} else if($streettype==$dupstreettype) {// identical street types.. no brainer!
					$dupid[] = $dupbuilding['id'];
				} else if(
					($streettype=='' && $dupstreettype!='') // one of the street names is EMPTY
					||
					($streettype!='' && $dupstreettype=='')// one of the street names is EMPTY
					||
					(
						($streettype!='' || $dupstreettype!='') // both are filled, but same street type such as AVE vs AV, or STREEET vs STR
						&&
						find_streettype($streettype)==find_streettype($dupstreettype)
					)
				) {
					// streettype on ths building is blank and the other one is not (i.e. Beach => Beach Ave, for example)
					// OR streettype is NOT blank on this building, and the comparable is also not blank, and mismatch, so it's not
					$dupstreetdir = $dupbuilding['street_dir'];
					// echo compare_street_dir($streetdir, $dupstreetdir).' is result for "'.$streetdir.'" vs "'.$dupstreetdir.'"<br />';
					if(
						($streetdir=='' && $dupbuilding['street_dir']=='') // both blank...
						||
						(compare_street_dir($streetdir, $dupstreetdir)===true && ($streetdir!='' || $dupstreetdir!='')) // street direction matches, and at least one street name entered.
						||
						( // or at least one of them does NOT have street direction provided.
							($streetdir=='' && $dupstreetdir!='')
							||
							($streetdir!='' && $dupstreetdir=='')
						)
					) {
						// compare directions now., or if both directions are blank.
						$dupid[] = $dupbuilding['id'];
					}
				}
			}
		}

		if(is_countable($duplid) && count($dupid)==1) {
			// means no good result, return false.
			$dupid = false;
		}
		return $dupid;
	}


	function merge_duplicate_buildings($dupids) {
		global $mysqli;
		global $settings;
		global $handle;
		// merge the arrays found in the $dupids into $this building.
		// first load the $dupids
		foreach($dupids as $dupid) {
			$dupbuilding = new building;
			$dupbuilding->initialize($dupid);

			$bdata[$dupid]['number'] = $dupbuilding->data['number']; // 499 etc.
			list($bdata[$dupid]['street_name'], $bdata[$dupid]['street_type'], $bdata[$dupid]['street_dir']) = separate_streetname($dupbuilding->data['street']); // broughton, street separated as array.
			if($bdata[$dupid]['street_type']=='' && $dupbuilding->data['street_type']!='') {
				$bdata[$dupid]['street_type'] = $dupbuilding->data['street_type']!='';
			}
			if($bdata[$dupid]['street_dir']=='' && $dupbuilding->data['street_dir']!='') {
				$bdata[$dupid]['street_dir'] = $dupbuilding->data['street_dir']; // West, E or North etc.
			}
			// gather SEO fields now.
			$bdata[$dupid]['metatitle'] = $dupbuilding->data['metatitle'];
			$bdata[$dupid]['slug'] = $dupbuilding->data['slug'];
			$bdata[$dupid]['metadescription'] = $dupbuilding->data['metadescription'];

			$photocount = 0;
			while($photocount<$settings['buildings_mainphotonum']) {
				// load up main photo paths to merge if we need to later.
				$photopath = $dupbuilding->get_main_images_path($photocount, 'nobuildingimage.jpg');
				if(!strpos($photopath, 'nobuildingimage.jpg')) {
					$bphoto[$dupid][$photocount] = $photopath;
				} else {
					$bphoto[$dupid][$photocount] = '';
				}
				$photocount++;
			}
		}

		// now add new set for currently selected home ID
		$bdata[$this->id]['number'] = $this->data['number']; // 499 etc.
		list($bdata[$this->id]['street_name'], $bdata[$this->id]['street_type'], $bdata[$this->id]['street_dir']) = separate_streetname($this->data['street']); // broughton, street separated as array.
		if($bdata[$this->id]['street_type']=='' && $this->data['street_type']!='') {
			$bdata[$this->id]['street_type'] = $this->data['street_type']!='';
		}
		if($bdata[$this->id]['street_dir']=='' && $this->data['street_dir']!='') {
			$bdata[$this->id]['street_dir'] = $this->data['street_dir']; // West, E or North etc.
		}

		$bdata[$this->id]['metatitle'] = $this->data['metatitle'];
		$bdata[$this->id]['slug'] = $this->data['slug'];
		$bdata[$this->id]['metadescription'] = $this->data['metadescription'];

		$inputdata['name'] = $this->data['name'];
		$inputdata['description'] = $this->data['description'];
		$inputdata['features'] = $this->data['features'];
		$inputdata['builder'] = $this->data['builder'];

		$inputdata['feature'] = 1;
		$inputdata['modify_date'] = $now;
		// use the name & description & features of the building that we selected!

		$compared_fields = array(
			'number',
			'street_name',
			'street_type',
			'street_dir',
			'metatitle',
			'slug',
			'metadescription'
		);
		// print_r($bdata);

		foreach($compared_fields as $field) {
			$fieldcount = 0;
			foreach($bdata as $bid=>$data) {
				if($fieldcount>0) {
					$inputdata[$field] = find_longer_value($data[$field], $prevdata[$field]); // compare current row to previous row to determine better value to keep.
				}
				$prevdata = $data; // load up the current set to the $prevdata array to compare on next loop.
				$fieldcount++;
			}
		}

		// clean up the $inputdata fields to match the columns in MySQL and also uppercase first letter!
		$inputdata['street'] = ucwords($inputdata['street_name']).($inputdata['street_type']!='' ? ' '.ucwords($inputdata['street_type']) : '');

		$updateid = form_to_table('buildings',$inputdata, $this->id); // update the fields accordingly.
		// figure out photos to avoid overlaps.

		// loop through other buildings to figiure out photo.
		foreach($bphoto as $bid => $photo) {
			// loop to each building ID
			foreach($photo as $pid => $filepath) {
				// loop through each photo array
				if(!strpos($this->get_main_images_path($pid, 'nobuildingimage.jpg'), 'nobuildingimage.jpg')) {
					// no action required, keep the photo, this building has the main photo number $pid.
				} else if($filepath!='') {
					// another building has the file while this building doesn't have it! Copy it over before we destroy it.
					copy ($filepath, $_SERVER['DOCUMENT_ROOT'].'/buildings/'.$this->id.'/'.$settings['buildings_mainphotofilename'][$pid]);
				}
			}
		}

		foreach($dupids as $dupid) {

			// merge homes attached to buildings we are zapping!
			log_error("Merging all homes attached to building ".$dupid." (".$bdata[$dupid]['street_name']." ".$bdata[$dupid]['street_type'].", DIR ".$bdata[$dupid]['street_dir'].")\n");

			$updatesql = "UPDATE `homes` SET `building`='".$this->id."' WHERE `building`='".$mysqli->real_escape_string($dupid)."'";
			$mysqli->query($updatesql);
			log_error("Deleting building ".$dupid." after ".$mysqli->affected_rows." homes were detached from it and re-attached to ".$this->id." (".$this->address.", ID ".$this->id.")\n");

			$deletesql = "DELETE FROM `buildings` WHERE id='".$dupid."'";
			$mysqli->query($deletesql);

			rmdir_files($_SERVER['DOCUMENT_ROOT'].'/buildings/'.$dupid);

		}
		return $this->id;
	}

	// CUSTOM FIELDS FUNCTIONS -- COPY TO OTHER OBJECTS AS WELL
	function get_custom_fields($name='') {
		global $mysqli;
		if($name!='') {
			// $name var given, look for array. If it's blank, it's blank... big diff from being unavailable.
			if(is_array($this->custom_fields) && array_key_exists($name, $this->custom_fields)) {
				$returnvar = $this->custom_fields[$name];
			} else {
				// if key does not exist, return false boolean
				$returnvar = false;
			}
		} else {
			// no name field given, get all fields and initialize
			$this->custom_fields = array();
			// get custom fields
			$sql = 'SELECT `id`, `name`, `desc`, `value` FROM `custom_fields` WHERE `building`="'.$this->id.'" ORDER BY `ord` ASC, `id` ASC';
			$returnvar = array();
			$result = $mysqli->query($sql);
			if($result->num_rows > 0) {
				// found rows, get results in array!
				while($array = $result->fetch_assoc()) {
					if(unserialize($array['value'])) {
						// it's an array so unserialize.
						$returnvar[$array['name']]['value'] = unserialize($array['value']);
					} else {
						// it's not an array, so string.
						$returnvar[$array['name']]['value'] = $array['value'];
					}
					$returnvar[$array['name']]['desc'] = $array['desc']; // description of what the field does etc.
					$returnvar[$array['name']]['id'] = $array['id']; // ID of the row in the `custom_fields` table in case we need reference.
					$returnvar[$array['name']]['ord'] = $array['ord']; // order of the custom feat.
				}

			} else {
				$returnvar = false; // not a single row of custom fields for this page
			}
			$this->custom_fields = $returnvar;
		}
		return $returnvar;
	}

	function update_custom_field($id, $value, $desc='', $ord='') {
		global $mysqli;
		if($id!='') {
			$updatesql = "UPDATE `custom_fields` SET 
			   `value`='".cleanupforentry($value)."', 
			   `desc`='".cleanupforentry($desc)."' 
				".(isset($ord) ? ", `ord`='".remove_all_but_numbers($ord)."'" : "")."
				WHERE `id`='".$id."' and `building`='".$this->id."' ";
			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function add_custom_field($name, $value, $desc='', $ord=0) {
		global $mysqli;
		if($name!='') {
			// name can never be blank. however the value can be  a blank value if its meant to be!
			$insertarray['name']	= $name;
			$insertarray['value']	= $value;
			$insertarray['desc']	= $desc;
			$insertarray['building']= $this->id;
			$insertarray['ord'] = remove_all_but_numbers($ord);
			return form_to_table('custom_fields', $insertarray);
		} else {
			return false;
		}
	}

	function drop_custom_field($params) {
		// allow deletoin by unique ID, or  by name.
		global $mysqli;
		$id = (isset($params['id']) ? $params['id'] : false);
		$name = (isset($params['name']) ? $params['name'] : false);

		if($id === false && $name!==false) {
			// get ID by field name.
			$custom_field = $this->get_custom_fields($name);
			if ($custom_field) {
				$id = $custom_field['id'];
			} else {
				$id = false;
			}
		}
		if($id) {
			$deletesql = "DELETE FROM `custom_fields` WHERE `building` = ".$this->id." AND `id`=".$id ;
			if($mysqli->query($deletesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}


	function bed_min_max($prefix='From ', $label='Bedroom', $plural=true, $separator='to ') {

		if($this->min_beds && $this->max_beds && ($this->min_beds === $this->max_beds)){
			//if min_beds and max_beds are equal and set, then just show, X bedrooms...
			$return = $this->min_beds.($label!='' ? ' '.$label : '');
		}else if($this->min_beds && $this->max_beds){
			//both min and max are set, show by default, From X to X Bedrooms
			$return = $prefix.$this->min_beds.($separator!='' ? ' '.$separator : '').$this->max_beds.($label!='' ? ' '.$label : '').($plural==true && $this->max_beds > 1 ? 's' : '');
		}else if ($this->min_beds){
			//if only min_beds is set then show, From X Bedrooms
			$return = $prefix.$this->min_beds.($label!='' ? ' '.$label : '').($plural==true && $this->min_beds > 1 ? 's' : '');
		}else if($this->max_beds){
			//if only max beds is set then show, Max X Bedrooms
			$prefix = ((isset($params['prefix']) && $params['prefix'] != '' ? $params['prefix'].' ' : 'Max '));
			$return = $prefix.$this->max_beds.($label!='' ? ' '.$label : '').($plural==true && $this->max_beds > 1 ? 's' : '');
		}
		return $return;
	}
	function bath_min_max($prefix='From ', $label='Bathroom', $plural=true, $separator='to ') {

		if($this->min_baths && $this->max_baths && ($this->min_baths === $this->max_baths)){
			//if min_beds and max_beds are equal and set, then just show, X bedrooms...
			$return = $this->min_baths.($label!='' ? ' '.$label : '');
		}else if($this->min_baths && $this->max_baths || ($this->min_baths == '0' && $this->max_baths)){
			//both min and max are set, show by default, From X to X Bedrooms
			$return = $prefix.$this->min_baths.($separator!='' ? ' '.$separator : '').$this->max_baths.($label!='' ? ' '.$label : '').($plural==true && $this->max_baths > 1 ? 's' : '');
		}else if ($this->min_baths || $this->min_baths == '0'){
			//if only min_beds is set then show, From X Bedrooms
			$return = $prefix.$this->min_baths.($label!='' ? ' '.$label : '').($plural==true && $this->min_baths > 1 ? 's' : '');
		}else if($this->max_baths){
			//if only max beds is set then show, Max X Bedrooms
			$prefix = ((isset($params['prefix']) && $params['prefix'] != '' ? $params['prefix'].' ' : 'Max '));
			$return = $prefix.$this->max_baths.($label!='' ? ' '.$label : '').($plural==true && $this->max_baths > 1 ? 's' : '');
		}
		return $return;
	}

	function price_min_max($shorten=false, $prefix='From ', $separator=' to ') {

		if($this->min_price && $this->max_price){
			if($shorten){

				$min_price = dollar_amount_display($this->min_price, true);
				$max_price = dollar_amount_display($this->max_price, true);
			}else{
				$min_price = dollar_amount_display($this->min_price);
				$max_price = dollar_amount_display($this->max_price);
			}
			$return = $prefix.$min_price.$separator.$max_price;
		}else if ($this->min_price){
			if($shorten){
				$min_price = dollar_amount_display($this->min_price, true);
			}else{
				$min_price = dollar_amount_display($this->min_price);

			}
			$return = $prefix.$min_price;
		}
		//todo, if only min price is entered then output, Starting from XXXX



		return $return;
	}


	/**
	 * Get Sum PRICE of ACTIVE listings in the building
	 * @param $additional_query array	more query if coder wants more specific data
	 * @return int|float				returns the calculated value.
	 */
	function listing_price_sum(array $additional_query = array()) {
		$data_array = $this->listing_data_sum(0, $additional_query);
		return $data_array[0];
	}
	/**
	 * Get Average PRICE of ACTIVE listings in the building
	 * @param $additional_query array	more query if coder wants more specific data
	 * @return int|float				returns the calculated value.
	 */
	function listing_price_average(array $additional_query = array()) {
		$data_array = $this->listing_data_sum(0, $additional_query);
		return $data_array[1];
	}

	/**
	 * Get Sum SQFT of ACTIVE listings in the building
	 * @param $additional_query array	more query if coder wants more specific data
	 * @return int|float				returns the calculated value.
	 */
	function listing_sqft_sum(array $additional_query = array()) {
		$data_array = $this->listing_data_sum(1, $additional_query);
		return $data_array[0];
	}
	/**
	 * Get Average SQFT of ACTIVE listings in the building
	 * @param $additional_query array	more query if coder wants more specific data
	 * @return int|float				returns the calculated value.
	 */
	function listing_sqft_average(array $additional_query = array()) {
		$data_array = $this->listing_data_sum(1, $additional_query);
		return $data_array[1];
	}

	/**
	 * Get Sum PRICE Per SQFT of ACTIVE listings in the building
	 * @param $additional_query array	more query if coder wants more specific data
	 * @return int|float				returns the calculated value.
	 */
	function listing_pps_sum(array $additional_query = array()) {
		$data_array = $this->listing_data_sum(2, $additional_query);
		return $data_array[0];
	}
	/**
	 * Get Average PRICE Per SQFT of ACTIVE listings in the building
	 * @param $additional_query array	more query if coder wants more specific data
	 * @return int|float				returns the calculated value.
	 */
	function listing_pps_average(array $additional_query = array()) {
		$data_array = $this->listing_data_sum(2, $additional_query);
		return $data_array[1];
	}

	/**
	 * Helper function for above price_sum() and sqft_sum() functions.
	 * Mainly to avoid querying the database multiple times & easier maintenance.
	 * listing_pps_sum = sum of Price/SQFT of listings.
	 * @param $additional_query array	Additional Query if coder wants more specific data.
	 * @param $action_type int			0 = price, 1 = sqft, 2 = price per sqft
	 * @return array|bool               return depends on action type defined.
	 */
	function listing_data_sum(int $action_type, array $additional_query = array()): array|bool
	{
		$listing_price_sum = $listing_sqft_sum = $listing_pps_sum = $listing_pps_average = $listing_price_average = $listing_sqft_average = 0;

		$base_query = array(
			'sold' => 0,
			'publish' => 1
		);
		$merge_query = !empty($additional_query) ? array_merge($base_query, $additional_query) : $base_query;
		$bldg_listings = $this->get_listings($merge_query);

		// only loop through if listings exist.
		if (is_array($bldg_listings)) {
			foreach ($bldg_listings as $listing_data) {
				$each_listing_price = remove_all_but_numbers($listing_data['price']) ?: 0;
				$each_listing_sqft	= remove_all_but_numbers($listing_data['sqft']) ?: 0;

				$listing_price_sum	+= $each_listing_price;
				$listing_sqft_sum	+= $each_listing_sqft;

				if ($each_listing_sqft > 0) {
					$listing_pps_sum += $each_listing_price / $each_listing_sqft;
				}
			}
		} else {
			return false; // insufficient data - just escape!
		}

		// benefit of calculating average here is that the count($bldg_listings) is using the same query - guaranteed accuracy when doing the math.
		if (count($bldg_listings) > 0) {
			$listing_price_average	= $listing_price_sum / count($bldg_listings);
			$listing_sqft_average	= $listing_sqft_sum / count($bldg_listings);
			$listing_pps_average	= $listing_pps_sum / count($bldg_listings);
		}

		// return different result depending on action type defined ... These are meant to be processed again by the function that calls this helper function.
		return match ($action_type) {
			0 => array($listing_price_sum, $listing_price_average),
			1 => array($listing_sqft_sum, $listing_sqft_average),
			2 => array($listing_pps_sum, $listing_pps_average),
			default => false, // only when a coder put unexpected parameter by mistake
		};
	}


	/**
	 * Get price sum of listings with the SAME area as the building
	 * @param string $type
	 * @param array $additional_query
	 * @return mixed
	 */
	function area_price_sum(string $type, array $additional_query = array()) {
		return $this->area_data_sum($type, 0, $additional_query);
	}

	/**
	 * Get SQFT sum of the listings with the SAME area as the building.
	 * @param string $type
	 * @param array $additional_query
	 * @return mixed
	 */
	function area_sqft_sum(string $type, array $additional_query = array()) {
		return $this->area_data_sum($type, 1, $additional_query);
	}

	function area_pps_average(string $type, array $additional_query = array()) {
		return $this->area_data_sum($type, 3, $additional_query);
	}

	/**
	 * Helper function for listings within the same area as this building.
	 * @param $type string				'Condo', 'Townhomes', etc. This could be in the $additional_query but just make it more explicit cus this data is important.
	 * @param $action_type int			0 => price, 1 => sqft, 2 => price/sqft?
	 * @param $additional_query array	array of optional queries in case coder wants more specific data.
	 * @return mixed
	 */
	function area_data_sum(string $type, int $action_type, array $additional_query = array()): mixed {
		$listing_price_sum = $listing_sqft_sum = $listing_pps_sum = $listing_pps_average = 0;

		$base_query['publish'] = 1;
		$base_query['sold'] = $additional_query['sold'] ?: array(0); // array_merge() overwrites the data in the first array with the second array, but do this just in case.
		$base_query['area'] = $this->area;
		$base_query['type'] = $type;

		// Merge additional query if any & query the listing
		$area_query = array_merge($base_query, $additional_query);
		$area_listings = get_properties('', $area_query);

		// Only process data if $area_listings and $bldg->area exists ... listings data without area is useless in this function's context.
		if (is_array($area_listings) && $this->area) {
			foreach ($area_listings as $listing_id) {
				$each_listing = new home;
				$each_listing->initialize($listing_id);

				$each_listing_price = remove_all_but_numbers($each_listing->price) ?: 0;
				$each_listing_sqft	= remove_all_but_numbers($each_listing->sqft) ?: 0;

				$listing_price_sum	+= $each_listing_price;
				$listing_sqft_sum	+= $each_listing_sqft;

				if ($each_listing_sqft > 0) {
					$listing_pps_sum += $each_listing_price / $each_listing_sqft;
				}
			}
		} else {
			return false; // insufficient data - just escape!
		}

		if (count($area_listings) > 0) {
			$listing_pps_average = $listing_pps_sum / count($area_listings);
		}

		// return different result depending on action type defined.
		return match ($action_type) {
			0 => $listing_price_sum,
			1 => $listing_sqft_sum,
			2 => $listing_pps_sum,
			3 => $listing_pps_average,
			default => false, // only when a coder put unexpected parameter by mistake
		};
	}
}

class page {
	var $objecttype = false;
	var $id;
	var $title;
	var $menu_title;
	var $metatitle;
	var $custom_pageurl;
	var $slug;
	var $content;
	var $embedded = false;
	var $excerpt;
	var $publish;
	var $description;
	var $keywords;

	var $city = false; // holds city object.
	var $area = false;
	// holds single area object - first of the key.
	// better to use $areas instead, and use $areas[1] for single.
	var $areas = false; // holds the Object, not IDs.
	var $cityid = false; // defaults ot ffalse.
	var $areaid = false; // turns into array of area IDs, even singular.
	/** @var @deprecated <br/>
	 * Use ->get_main_images() for the whole img tag already set OR <br/>
	 * ->get_main_images_path() for the image url.
	 */
	var $topimage;
	var $enable_photo_gallery;
	var $youtube;
	var $vimeo;
	var $videourl;
	var $videoembedurl;
	var $data; // data array is raw data output from the pages table in mysql
	var $children; // contains array of children pages
	var $publishedchildren; // contains array of PUBLISHED children pages
	var $childrencount; // number of children
	var $publishedchildrencount; // number of published children
	var $parents; // contains array of parent pages, starting from top level
	var $directparent; // the parent right above
	var $topparent; // top ancestor
	var $pageurl;
	var $breed; // whether new pages can be added under this or not
	var $deepbreed; // whether this allows multi-level children under it
	var $photos;
	var $pdf_labels; //labels for pdf attachments. Class method for retrieval still to implement
	var $alt_tags;

	var $main_img_titles;
	var $mainwidth;
	var $mainheight;

	function initialize($id) {
		global $settings;
		global $mysqli;

		if(is_array($GLOBALS[BRIX_PAGES_CACHE]) && array_key_exists($id, $GLOBALS[BRIX_PAGES_CACHE])) {
			$data = $GLOBALS[BRIX_PAGES_CACHE][$id];
		} else if($id!='') {
			$sql = "SELECT * FROM pages WHERE id='".$id."'";
			$result = $mysqli->query($sql);

			$GLOBALS[BRIX_PAGES_QUERY]++;

			if($result->num_rows>0) {
				$data = $result->fetch_assoc();
			} else {
				$data = false;
			}
		} else {
			$data = false;
		}

		if($data!==false) {
			$this->objecttype = 'page';
			$this->id = $data['id'];

			$this->enable_photo_gallery = ($data['enable_photo_gallery']=='1' ? true : false);

			$this->mainphoto = delimited_options_to_array($data['mainphoto'], $settings['pages_mainphotofilename']);
			$this->pdf = delimited_options_to_array($data['pdf'], $settings['pages_pdffilename']);

			$this->title = $data['title'];
			$this->title2 = ($data['title2']!='' ? $data['title2'] : false); // alternate content for chinese, or other languages.
			$this->title3 = (array_key_exists('title3', $data) && $data['title3']!='' ? $data['title3'] : false); // alternate content for chinese, or other languages.

			$this->menu_title = ($data['menu_title']!='' ? $data['menu_title'] :  $this->title);
			$this->menu_title2 = ($data['menu_title2']!='' ? $data['menu_title2'] :  false);
			$this->menu_title3 = (array_key_exists('menu_title3', $data) && $data['menu_title3']!='' ? $data['menu_title3'] :  false);

			$data['metadescription'] = $data['description'];

			$this->metatitle_default = $this->title.' - '.$settings['title'];
			$this->metatitle = ($data['metatitle']!='' ? $data['metatitle'] :  $this->metatitle_default); // this has to return false by default, so that the pages_prep.php can put the pagetitle + sitetitle together. Otherwise, use as-is.
			$this->metadescription_default = $this->title.', provided to you by '.$settings['title'];
			$this->metadescription = ($data['description']!='' ? $data['description'] :  $this->metadescription_default); // if blank, google will sort it out on its own.
			$this->description = $this->metadescription; // used to be $description so just pass $metadescription thorugh to this for legacy sites.
			// process URL slug
			$this->slug_default = strtolower(str_replace('--','-',str_replace(array('-','&',' ','_',',','/','\'', '"'),'-',$this->title)));
			if($data['slug']!='') {
				$this->slug = $data['slug'];
			} else {
				$this->slug = $this->slug_default; // set to default if no custom one set.
			}

			$this->embedded = ($data['embedded']==1 ? true : false);

			$this->create_date = $data['create_date'];
			$this->modify_date = $data['modify_date'];

			$this->content = $data['content'];
			$this->content2 = ($data['content2']!='' ? $data['content2'] : false); // alternate content for chinese, or other languages.
			$this->content3 = (array_key_exists('content3', $data) && $data['content3']!='' ? $data['content3'] : false); // alternate content for chinese, or other languages.

			$this->excerpt = $data['excerpt'];
			$this->excerpt2 = ($data['excerpt2']!='' ? $data['excerpt2'] : false); // alternate content for chinese, or other languages.
			$this->excerpt3 = (array_key_exists('excerpt3', $data) &&  $data['excerpt3']!='' ? $data['excerpt3'] : false); // alternate content for chinese, or other languages.

			$this->publish = $data['publish'];
			$this->keywords = $data['keywords'];
			$this->breed = $data['breed'];
			$this->deepbreed = $data['deepbreed'];
			$this->custom_pageurl = trim($data['custom_pageurl']);

			if (unserialize($data['main_img_titles'])) {
				$this->main_img_titles = unserialize($data['main_img_titles']);
			} else {
				$this->main_img_titles = $data['main_img_titles'];
			}

			if(unserialize($data['mainwidth'])) {
				$this->mainwidth = unserialize($data['mainwidth']);
			} else {
				$this->mainwidth = $data['mainwidth'];
			}

			if(unserialize($data['mainheight'])) {
				$this->mainheight = unserialize($data['mainheight']);
			} else {
				$this->mainheight = $data['mainheight'];
			}

			if(is_array($this->mainwidth)) {
				foreach($this->mainwidth as $wkey=>$wval) {
					// clean out all blank/empty values so the mainimage count is accurate on attachments.
					if($wval=='' || $wval==0 || !is_numeric($wval)) {
						// if one of w or height is blank, we cannot use it. Unset.
						unset($this->mainwidth[$wkey]);
						if(isset($this->mainheight[$wkey])) {
							unset($this->mainheight[$wkey]);
						}
					}
				}
			}

			if(is_array($this->mainheight)) {
				foreach($this->mainheight as $hkey=>$hval) {
					// $hval = $hval*1;
					// clean out all blank/empty values so the mainimage count is accurate on attachments.
					if($hval=='' || $hval==0 || !is_numeric($hval)) {
						// if one of w or height is blank, we cannot use it. Unset.
						unset($this->mainheight[$hkey]);
						if(isset($this->mainwidth[$hkey])) {
							unset($this->mainwidth[$hkey]);
						}
					}
				}
			}

			if($data['youtube']!='') {
				$this->youtube = $data['youtube'];
			} else {
				$this->youtube = false;
			}

			if($data['vimeo']!='') {
				$this->vimeo = $data['vimeo'];
			} else {
				$this->vimeo = false;
			}

			$this->get_video();

			if(strpos($data['area'], ';')!==false) {
				// multiple areas hooked to this.
				$this->areas = array();
				$this->areaid = array();
				$areasarray  = explode(';', $data['area']);
				foreach($areasarray as $areaid) {
					$this->areas[] = gettablefield('subareas','name',$areaid);
					$this->areaid[] = $areaid;
				}
				$this->area = $this->areas[0]; // first one goes into the singular ->area for backwards compat.
				// force the FIRST of the array as the singular $this->area for backwards compatibility.
			} else if($data['area']!='' && $data['area']!='0') {
				$this->area = gettablefield('subareas','name',$data['area']);
				$this->areas = array();
				$this->areas[] = $this->area;
				$this->areaid = array();
				$this->areaid[] = $data['area']; // singular but still array.
			} else {
				$this->area = false; // nothing!
				$this->areaid = false; // nothing!
			}

			$this->areaids = $this->areaid; // same same. But in case somebody uses plural.

			if($data['city']!='') {
				$this->city = gettablefield('areas','name',$data['city']);
				$this->cityid = $data['city'];
			} else {
				$this->city = false;
				$this->cityid = false;
			}

			// raw data vars.
			foreach($data as $key=>$value) {
				$this->data[$key] = $value;
			}

			if(is_array($this->mainwidth)) {
				// it's an array, therefore return multiple arrays!
				$topimagecount = 0;
				$this->topimage = array();
				foreach($this->mainwidth as $key => $w) {
					$this->topimage[$key] = $this->get_main_images_path($key, false, false);
				}
				$topimagecount = (is_countable($this->topimage) ? count($this->topimage) : 0);
				if($topimagecount==1) {
					// on odler sites, topimage is single string var, not array, so keep it this way.
					$this->topimage = $this->topimage[0]; // only 1, so just push the 1st one as main string, no array needed.
				} else if($topimagecount==0) {
					$this->topimage = false; // despite size array, no actual images all false, so just return singular false.
				}
			} else {
				// single width, so single variable only.
				$this->topimage = $this->get_main_images_path(0, false, false);

			}
			$this->find_parents();

			$this->children = find_children($this->id);
			if($this->children) {
				// returns false if no children, so no need to check for is_countable etc. below.
				$this->publishedchildren = array();
				$this->childrencount = count($this->children);
				foreach($this->children as $childid => $var) {
					$publishvar = gettablefield('pages','publish',$childid);
					if($publishvar==1) {
						$this->publishedchildren[$childid] = $var;
					}
				}
				$this->publishedchildrencount = count($this->publishedchildren);

			} else {
				$this->childrencount = 0;
				$this->publishedchildren = false;
			}
			// get page URL
			$this->pageurl = get_page_url($this->id, $this->custom_pageurl, $this->slug, $this->embedded, $this->parents);

			$pdf_labels_unserialized = false; // default false.
			if($data['pdf_labels']!='') {
				$pdf_labels_unserialized = unserialize($data['pdf_labels']);
			}
			if($pdf_labels_unserialized!==false) {
				foreach ($pdf_labels_unserialized as $key => $pdf_label) {
					// Use $key when assigning value so that the key->value pair stays the same as database.
					// if pdf label is empty, fall back to $settings default label - if $settings not set, make a quick fallback here
					if($pdf_label=='') {
						$this->pdf_labels[$key] = ((isset($settings['pages_pdfname'][$key]) && $settings['pages_pdfname'][$key]) != '' ? $settings['pages_pdfname'][$key] : 'PDF '. ($key + 1));
					} else {
						$this->pdf_labels[$key] = $pdf_label;
					}
				}
			} else {
				// if all labels are empty, use site $settings default
				$this->pdf_labels = $settings['pages_pdfname'];
			}

			$this->alt_tags = unserialize($data['alt_tags'] ?: '');
			$this->get_custom_fields();
			if($this->enable_photo_gallery===true) {
				$this->getphotos(false);
			}

			return $this->id;
		} else {
			return false;
		}
	}

	function find_parents() {
		global $mysqli;

		// see parent/child hierarchy
		if(is_array($GLOBALS[BRIX_PAGES_CACHE])) {
			// has at least one parent, let's see if it has more?
			$this->parents = find_parents($this->id);
			if($this->parents!==false) {
				$this->directparent = $this->parents[count($this->parents)-1];
				$this->topparent = $this->parents[0];
			}
		} else {
			// MySQL fallback
			$parentsql = "SELECT `parent` FROM `hierarchy` WHERE `page`='".$this->id."'";
			$parentresult = $mysqli->query($parentsql);

			$GLOBALS[BRIX_PAGES_QUERY]++;
			if($parentresult->num_rows>0) {
				$parent = $parentresult->fetch_assoc();
			} else {
				$parent = false;
			}

			// keep looping upwards!
			if($parent!==false) {
				while($end!=1) {
					$this->parents[] = $parent['parent'];
					$lastparent = $parent['parent'];
					//echo $lastparent.' retrieved after query:'.$parentsql.'<br />';
					$parentsql = "SELECT `parent` FROM `hierarchy` WHERE `page`='".$lastparent."'";
					$parentresult = $mysqli->query($parentsql);

					if($parentresult->num_rows==0) {
						$end = 1;
					}
				}
				$this->parents = array_reverse($this->parents);
				$this->directparent = $this->parents[count($this->parents)-1];
				$this->topparent = $this->parents[0];
			} else {
				$this->parents = false;
			}
		}
	}

	function register_parent($parentid) {
		global $mysqli;
		if($parentid!=''){
			// check for valid parent
			$searchsql = "SELECT * FROM `pages` WHERE id='".$parentid."'";
			$searchresult = $mysqli->query($searchsql);
			if($searchresult->num_rows>0) {
				// target parent is valid
				if(is_array($this->parents) && count($this->parents)>0) {
					// this page already has a parent - remove it first.
					// in fact remove all hierarchy rows that attach this page, as there's only one permissible parent per page!
					$removesql = "DELETE FROM `hierarchy` WHERE page='".$this->id."'";
					$mysqli->query($removesql);
				}
				// now we insert a new row
				$insertsql = "INSERT INTO `hierarchy` (page,parent) VALUES ('".$this->id."','".$parentid."')";
				$mysqli->query($insertsql);
			}else{
				return false;
			}
		}
	}

	// CUSTOM FIELDS FUNCTIONS -- COPY TO OTHER OBJECTS AS WELL
	function get_custom_fields($name='') {
		global $mysqli;
		if($name!='') {
			// $name var given, look for array. If it's blank, it's blank... big diff from being unavailable.
			if(is_array($this->custom_fields) && array_key_exists($name, $this->custom_fields)) {
				$returnvar = $this->custom_fields[$name];
			} else {
				// if key does not exist, return false boolean
				$returnvar = false;
			}
		} else {
			// no name field given, get all fields and initialize
			$this->custom_fields = array();
			// get custom fields
			$sql = 'SELECT `id`, `name`, `desc`, `value` FROM `custom_fields` WHERE `page`="'.$this->id.'" ORDER BY `ord` ASC, `id` ASC';
			$returnvar = array();
			$result = $mysqli->query($sql);
			if($result->num_rows > 0) {
				// found rows, get results in array!
				while($array = $result->fetch_assoc()) {
					if(unserialize($array['value'])) {
						// it's an array so unserialize.
						$returnvar[$array['name']]['value'] = unserialize($array['value']);
					} else {
						// it's not an array, so string.
						$returnvar[$array['name']]['value'] = $array['value'];
					}
					$returnvar[$array['name']]['desc'] = $array['desc']; // description of what the field does etc.
					$returnvar[$array['name']]['id'] = $array['id']; // ID of the row in the `custom_fields` table in case we need reference.
					$returnvar[$array['name']]['ord'] = $array['ord']; // order of the custom feat.
				}

			} else {
				$returnvar = false; // not a single row of custom fields for this page
			}
			$this->custom_fields = $returnvar;
		}
		return $returnvar;
	}

	function update_custom_field($id, $value, $desc='', $ord='') {
		global $mysqli;
		if($id!='') {
			$updatesql = "UPDATE `custom_fields` SET 
			   `value`='".cleanupforentry($value)."', 
			   `desc`='".cleanupforentry($desc)."' 
				".(isset($ord) ? ", `ord`='".remove_all_but_numbers($ord)."'" : "")."
				WHERE `id`='".$id."' and `page`='".$this->id."' ";
			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function add_custom_field($name, $value, $desc='', $ord=0) {
		global $mysqli;
		if($name!='') {
			// name can never be blank. however the value can be  a blank value if its meant to be!
			$insertarray['name']	= $name;
			$insertarray['value']	= $value;
			$insertarray['desc']	= $desc;
			$insertarray['page']	= $this->id;
			$insertarray['ord']		= remove_all_but_numbers($ord);
			return form_to_table('custom_fields', $insertarray);
		} else {
			return false;
		}
	}

	function drop_custom_field($params) {
		// allow deletoin by unique ID, or  by name.
		global $mysqli;
		$id = (isset($params['id']) ? $params['id'] : false);
		$name = (isset($params['name']) ? $params['name'] : false);

		if($id === false && $name!==false) {
			// get ID by field name.
			$custom_field = $this->get_custom_fields($name);
			if ($custom_field) {
				$id = $custom_field['id'];
			} else {
				$id = false;
			}
		}
		if($id) {
			$deletesql = "DELETE FROM `custom_fields` WHERE `page` = ".$this->id." AND `id`=".$id ;
			if($mysqli->query($deletesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}



	function get_main_images($num = 0, $width='', $height='', $noimage = 'noimage.png', $cssclass='', $quality = 75, $fallback=true) {
		// Page main images are now fetched through the same tag function as the homes or buildings - 2017-08-08 Jeff K
		global $settings;
		if($width=='') {
			$width = $this->mainwidth[$num];
		}
		if($height=='') {
			$height = $this->mainheight[$num];
		}

		$classhtml = '';
		if($cssclass) {
			if(is_array($cssclass)!=1) {
				$classhtml = $cssclass; // singular class
			} else {
				// multiple classes passed by array, list them all with spaces.
				foreach($cssclass as $classcount => $css) {
					if($classcount>0) {
						$classhtml.=' ';
					}
					$classhtml.=$css;
				}
			}
		}
		if($this->alt_tags[$num] != ''){
			$alt_tags = $this->alt_tags[$num];
		}else if($this->title != ''){
			$alt_tags = $this->title;
		}
		// to get path, use get_main_images_path
		$fileurl = $this->get_main_images_path($num, $noimage, $fallback); // get the S3 bucket path.

		if(($fileurl==false || $fileurl=='') && $fallback==false ) {
			// no fallback, and no image loaded, so return false, not a blank IMG tag.
			$imgtag = false;
		} else {
			// either return the image, or no image, in full <img /> tag!
			$imgtag = '<img src="'.$fileurl.'" alt="'.$alt_tags.''.($num > 0 ? $num+1 : '').'" title="'.$this->title.' '.($num > 0 ? $num+1 : '').'" class="'.$classhtml.'" />';
			// by default, we timthumb the image to the size.

			if ((strpos($fileurl,'noimage') !== false && strpos($fileurl,'http') !== false) || strpos($fileurl, $settings['pages_mainphotofilename'][$num])!==false) {
				$imgtag = '<img src="'.$fileurl.'" alt="'.$alt_tags.' '.($num > 0 ? $num+1 : '').'" title="'.$this->title.' '.($num > 0 ? $num+1 : '').'" class="'.$classhtml.'" />'; // just a noiomage file, skip timbthumbs.. Or its designated main image, or source=0 listing with S3 attachment.. either way use it as-is.
			}
		}

		return $imgtag;
	}

	function get_main_images_path($num = 0, $noimage='noimage.png', $fallback = true) {
		global $settings;
		return get_main_images_path('pages', $this, $num, $noimage, $fallback);
	}

	// attachment functions, with S3 capacity, added 2016-12.
	function pdf_file_link($num=0, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('pages', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}

	function get_video($autoplay = false) {
		global $settings;
		if($this->youtube!='') {
			$this->videourl = "https://www.youtube.com/v/".$this->youtube."?rel=0&hl=en&fs=1&autoplay=".($autoplay ? '1' : '0');
			$this->videoembedurl = "//www.youtube.com/embed/".$this->youtube."?rel=0&fs=1&enablejsapi=1&autoplay=".($autoplay ? '1' : '0');
			$return = true;
		} else if($this->vimeo!='') {
			$this->videourl = 'https://vimeo.com/'.$this->vimeo;
			$this->videoembedurl = "//player.vimeo.com/video/".$this->vimeo."?title=0&amp;byline=0&amp;portrait=0"; // from vimeo, hides all other junk. rest of page has title all over it anyway.
			$return = true;
		} else {
			$this->videourl = false;
			$return = false;
		}
		return $return;
	}

	function getphotos($photos=false) {
		global $settings;
		global $mysqli;
		unset($this->photos);
		if($photos === false) {
			$this->photos = get_object_photos('pages', $this->id);
		}

		if (is_array($this->photos) && count($this->photos)>0) {
			$this->gallery_exists = 1;
			$return = true;
		} else {
			$this->gallery_exists = 0;
			$this->photos = false;
			$return = false;
		}
		return $return;
	}
}


class resource {
	var $objecttype = false;
	var $id;
	var $title;
	var $displaytitle;
	var $url;
	var $email;
	var $phone;
	var $category; // name of category
	var $categoryid; // ID var of the category
	var $address1;
	var $address2;
	var $postal;
	var $city;
	var $area;
	var $areacity;
	var $addressdisplay;
	var $contact;
	var $company;
	var $targeturl; // target URL, if the $url is populated, that's it. If not, reverts to $email, if not, blank.
	var $desc; // description
	var $content;
	var $gallery_exists;
	var $topimage;
	var $photos = false; // does not have photos...
	var $pdf_labels; //to set custom pdf labels. Method for pdf retrieval still to implement
	var $publish;

	function initialize($id, $data = false) {
		global $settings;
		global $mysqli;

		if(!is_array($data)) {
			$sql = "SELECT * FROM `resources` WHERE `id`='".$id."'";
			$result = $mysqli->query($sql);
			if($result->num_rows>0) {
				$data = $result->fetch_assoc();
			}
		}

		$this->objecttype = 'resource';
		$this->id = $data['id'];

		$this->mainphoto = delimited_options_to_array($data['mainphoto'], $settings['resources_mainphotofilename']);
		$this->pdf = delimited_options_to_array($data['pdf'], $settings['resources_pdffilename']);

		$this->url = $data['url'];
		$this->email = $data['email'];
		$this->phone = $data['phone'];
		$this->category = gettablefield('resourcecategories','title',$data['category']);
		$this->categoryid = $data['category'];
		$this->title = $data['title'];
		$this->contact = $data['contact'];
		$this->company = $data['company'];

		$this->address1 = $data['address1'];
		$this->address2 = $data['address2'];
		$this->postal = $data['postal'];

		$this->publish = $data['publish'];

		if($data['area']!='') {
			$this->area = gettablefield('subareas','name',$data['area']);
		}
		if($data['city']!='') {
			$this->city = gettablefield('areas','name',$data['city']);
		}

		if($this->area!='' && $this->area!=$this->city) {
			$this->areacity = $this->area.', '.$this->city;
		} else if($this->city!='') {
			$this->areacity = $this->city;
		} else {
			$this->areacity = '';
		}

		if($this->areacity!='') {
			// city is populated, this resource entry is post 2014-06 when we upgraded the resource class to take city/area variables linked to the tables.
			$this->address = $this->address1.($this->address2!='' ? ' '.$this->address2 : '');
		} else {
			// city is not populated, so use the old display.
			$this->address = $this->address1.($this->address2!='' ? '<br />'.$this->address2 : ''); // address2 contains area/city/prov so display as such.
		}

		$this->addressdisplay = $this->address.($this->areacity!='' ? '<br />'.$this->areacity.($this->postal!='' ? ' '.$this->postal : '') : '');

		$this->desc = $data['desc'];
		$this->content = $this->desc; // same stuff..

		// now process the image
		if($settings['resources_mainphotonum'] > 1) {
			// it's an array, therefore return multiple arrays!
			foreach($settings['agents_mainphotofilename'] as $key=>$filename) {
				$this->topimage[$key] = $this->get_main_images_path($key, false, false);
			}

		} else {
			// single width, so single variable only.
			$this->topimage = $this->get_main_images_path(0, false, false);
		}

		$this->display_title = $this->get_title();

		if($this->url!='') {
			$this->targeturl = $this->url; // website URL is set!
		} else if($this->email!='') {
			$this->targeturl = $this->email; // website is blank but email is set, so set email as target URL.
		} else {
			$this->targeturl=false;
		}

		foreach($data as $key=>$value) {
			$this->data[$key] = $value;
		}

		$this->getphotos(false);

		$pdf_labels_unserialized = false; // default false.
		if($data['pdf_labels']!='') {
			$pdf_labels_unserialized = unserialize($data['pdf_labels']);
		}
		if($pdf_labels_unserialized!==false) {
			foreach ($pdf_labels_unserialized as $key => $pdf_label) {
				// Use $key when assigning value so that the key->value pair stays the same as database.
				// if pdf label is empty, fall back to $settings default label - if $settings not set, make a quick fallback here
				if($pdf_label=='') {
					$this->pdf_labels[$key] = ((isset($settings['resources_pdfname'][$key]) && $settings['resources_pdfname'][$key]) != '' ? $settings['resources_pdfname'][$key] : 'PDF '. ($key + 1));
				} else {
					$this->pdf_labels[$key] = $pdf_label;
				}
			}
		} else {
			// if all labels are empty, use site $settings default
			$this->pdf_labels = $settings['resources_pdfname'];
		}


		return $this->id;

	}

	function get_title($openbracket='(',$closebracket=')') {
		if($this->title!='') {
			// no change necesssary - do nothing.
			$display_title = $this->title;
		} else {
			if($this->contact!='' && $this->company!='') {
				$display_title = $this->contact.' '.$openbracket.$this->company.$closebracket;
			} else if($this->contact!='') {
				$display_title  = $this->contact;
			} else if($this->company!='') {
				$display_title = $this->company;
			} else if($this->url!='') {
				$display_title = $this->url;
			} else if($this->email!='') {
				$display_title = $this->email;
			} else {
				$display_title =  "Resource ".$this->id;
			}
		}
		return $display_title;
	}

	function get_link_tag($anchortext = 'Visit Website', $target='_blank', $prepend='', $append='', $nofollow = false) {
		if($this->targeturl) {
			if($this->url=='') {
				// then it means it's an email. URL is blank, but targeturl is positive.
				$href = 'mailto:'.$this->targeturl;
			} else {
				if(strpos($this->targeturl, 'http')!=0 && strpos($this->targeturl, '//')!=0) {
					// URL does not begin with http or //, so prepend it.
					$href = '//'.$this->targeturl;
				} else {
					$href = $this->targeturl;
				}
			}
			$return =  $prepend.'<a href="'.$href.'" target="'.$target.'" title="'.$this->get_title().' '.$this->addressdisplay.'" '.($nofollow ? 'rel="nofollow"' : '').'>'.$anchortext.'</a>'.$append;
		} else {
			$return = false;
		}
		return $return;
	}

	function get_main_images_path($num = 0, $noimage='noimage.png', $fallback = true) {
		global $settings;
		return get_main_images_path('resources', $this, $num, $noimage, $fallback);
	}


	// attachment functions, with S3 capacity, added 2016-12.
	function pdf_file_link($num=0, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('resources', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}

	function getphotos($photos=false) {
		global $settings;
		global $mysqli;
		unset($this->photos);
		if($photos === false) {
			$this->photos = get_object_photos('pages', $this->id);
		}

		if (is_array($this->photos) && count($this->photos)>0) {
			$this->gallery_exists = 1;
			$return = true;
		} else {
			$this->gallery_exists = 0;
			$this->photos = false;
			$return = false;
		}
		return $return;
	}

}




class area {
	var $objecttype = false;
	var $id;
	var $name;
	var $content;
	var $excerpt;
	var $lat = false;
	var $long = false;
	var $subareascount;
	var $feature;
	var $polygon = false; // default false, unless filled in.
	var $numlistings;

	function initialize($id) {
		global $settings;
		global $mysqli;

		if(is_array($GLOBALS[BRIX_AREAS_CACHE]) && array_key_exists($id, $GLOBALS[BRIX_AREAS_CACHE])) {
			$data = $GLOBALS[BRIX_AREAS_CACHE][$id];
		} else if($id!='') {
			$sql = "SELECT * FROM `areas` WHERE `id`='".$id."'";
			$result = $mysqli->query($sql);
			$GLOBALS[BRIX_PAGES_QUERY]++;
			if($result->num_rows>0) {
				$data = $result->fetch_assoc();
			} else {
				$data = false;
			}
		} else {
			$data = false;
		}


		if($data) {
			$this->objecttype = 'area';
			$this->id = $data['id'];
			$this->name = $data['name'];
			$this->feature = $data['feature'];

			$this->lat = $data['lat'];
			$this->long = $data['long'];
			$this->zoomlevel = $data['zoomlevel'];

			$this->content = $data['content'];
			$this->excerpt = $data['excerpt'];

			if($data['polygon']!='') {
				$polygonarray = explode("\n", $data['polygon']); // pass array of polygon arrays.

				// remove any empty rows or 0 rows!
				$newpolygonarray = array();
				foreach($polygonarray as $pkey=>$coordinate) {
					if($coordinate!='') {$newpolygonarray[$pkey] = $coordinate;}
				}
				$this->polygon = $newpolygonarray;
				if($this->polygon[0]!=$this->polygon[count($this->polygon)-1]) {
					// the first and last array needs to match on a polygon, because that's the way to close the polygon.
					// other wise all shapes may end up falling OUT of the polygon in the point check algorithm, returning false for all!
					$this->polygon[count($this->polygon)] = $this->polygon[0];
				}

				$this->pointLocation = new pointLocation();
			}

			// This really should have been a boolean since 2009 but we have too many that probably check for if($area->publish == 1) .. so we have to let it be.
			if(array_key_exists('publish',$data)) {
				$this->publish = $data['publish']; // publish field is set, so follow the field content.
			} else {
				$this->publish = 1; // publish field not set on this db yet, default to publish for now
			}

			$this->subareas = array();
			$this->subareascount = 0;
			if(is_array($GLOBALS[BRIX_SUBAREAS_CACHE]) && count($GLOBALS[BRIX_SUBAREAS_CACHE])>0) {
				foreach($GLOBALS[BRIX_SUBAREAS_CACHE] as $subarea) {
					if($subarea['area']==$this->id) {
						$this->subareas[$subarea['id']] = $subarea['name'];
					}
				}
				$this->subareascount = count($this->subareas);
			} else {
				$subareassql = "SELECT id, name FROM `subareas` WHERE `area`='" . $this->id . "' ORDER BY `name`";
				$subareasresult = $mysqli->query($subareassql);
				$GLOBALS[BRIX_PAGES_QUERY]++;
				if($subareasresult->num_rows>0) {
					while($subarea = $subareasresult->fetch_assoc()) {
						$this->subareas[$subarea['id']] = $subarea['name'];
					}

					$this->subareascount = count($this->subareas);
				}
			}

			if (count($this->subareas) === 0){
				$this->subareas = false;
			}

			foreach($data as $key=>$value) {
				$this->data[$key] = $value;
			}
			return $this->id;
		}
	}

	function get_num_listings($type = false) {
		global $mysqli;
		// cache these evetually? TODO:
		$query = array('cityid'=>$this->id, 'publish'=>1); // since it's listings for the city, this much is basic.
		if($type!==false) {
			if(is_numeric($type)) {
				$query['typeid'] = $type;
			} else if(is_string($type)) {
				$query['type'] = $mysqli->real_escape_string($type);
			}
		}
		$homescount = get_properties('',$query, '', '', 100000, '', true, false);
		if($type==false) {
			$this->numlistings = $homescount;
		}
		return $homescount;
	}

	function listing_in_polygon($input) {
		if(is_object($home)) {
			$latlong = $input->data['lat'].','.$input->data['long'];
		} else {
			$latlong = $input;
		}
		if($this->polygon) {
			return $this->pointLocation->pointInPolygon($latlong, $this->polygon);
		} else {
			return false;
		}
	}

	function get_main_images_path($num = 0, $noimage='noimage.png', $fallback = true) {
		global $settings;
		return get_main_images_path('areas', $this, $num, $noimage, $fallback);
	}

	function pdf_file_link($num, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('areas', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}

	/** ADDED BY 2022-10 BRIAN
	 * process $query into the get_properties(), to get the total number of listings in most cases.
	 * @param $query array	Array of queries
	 * @param $counter	boolean	If true, get count only. If False, get data only
	 * @return array|false|float|int	Returns counter of $sum = true, else returns array of listing data
	 */
	function get_properties($query, $counter = true) {
		// default queries that are pretty important
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
		}
		$query['cityid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		return get_properties('', $query, '', '', 100000, '', $counter, !$counter);
	}

	/** ADDED BY 2022-10 BRIAN
	 * Sum of prices of queries listings
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param $query array	Array of query types.
	 * @return int			returns the sum of all listings price
	 */
	function get_price_sum(array $query = array()) {
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['cityid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		$listings = $this->get_properties($query, false); // get available listings.

		// then loop through all prices, turn them into RAW numbers without $, add them up.
		$price_sum = 0;
		foreach ($listings as $each_listing) {
			$price_sum += remove_all_but_numbers($each_listing['price']);
		}
		return $price_sum;
	}

	/** ADDED BY 2022-10 BRIAN
	 * Sum of SQFT of queries listings
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param $query array	Array of query types.
	 * @return int			returns the sum of all listings SQFT
	 */
	function get_sqft_sum(array $query = array()) {
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['cityid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		$listings = $this->get_properties($query, false); // get available listings.

		// then loop through all SQFT, turn them into RAW numbers without $, add them up.
		$sqft_sum = 0;
		foreach ($listings as $each_listing) {
			$sqft_sum += remove_all_but_numbers($each_listing['sqft']);
		}
		return $sqft_sum;
	}

	/** ADDED BY 2022-10 BRIAN
	 * Get Average price of type in the area.
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param array $query	Important query needed is the "type"
	 * @return float		Avery price of type in the area
	 */
	function get_price_average(array $query = array()) {
		// Default query that's pretty important
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['cityid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		// get average by getting SUM / COUNTER
		$type_count = $this->get_properties($query, true);
		$type_price_sum = $this->get_price_sum($query);

		return ($type_price_sum / $type_count);
	}

	/** ADDED BY 2022-10 BRIAN
	 * Get Average SQFT of type in the area.
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param array $query	Important query needed is the "type"
	 * @return float		Avery price of type in the area
	 */
	function get_sqft_average(array $query = array()) {
		// Default query that's pretty important
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['cityid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		// get average by getting SUM / COUNTER
		$type_count = $this->get_properties($query, true);
		$type_sqft_sum = $this->get_sqft_sum($query);

		return ($type_sqft_sum / $type_count);
	}

	/** ADDED BY 2022-10 BRIAN
	 * Uses previous functions to calculate AVERAGE PRICE PER SQ. FT. of TYPE ( Condo or House, possibly just all types combined )
	 * @param array $query	Important query needed is "type"
	 * @return float|int
	 */
	function get_price_per_sqft(array $query = array()) {
		$avg_price = $this->get_price_average($query);
		$avg_sqft = $this->get_sqft_average($query);

		return ($avg_price / $avg_sqft);
	}
}



class subarea {
	var $objecttype = false;
	var $id;
	var $name;
	var $area; // id of city
	var $city; // actual name of the city above it.
	var $content;
	var $excerpt;
	var $lat;
	var $long;
	var $feature;
	var $polygon = false; // default false, unless filled in.
	var $numlistings;

	function initialize($id) {
		global $settings;
		global $mysqli;


		if(is_array($GLOBALS[BRIX_SUBAREAS_CACHE]) && array_key_exists($id, $GLOBALS[BRIX_SUBAREAS_CACHE])) {
			$data = $GLOBALS[BRIX_SUBAREAS_CACHE][$id];

		} else if($id!='') {
			$sql = "SELECT s.*, a.name AS `city` FROM `subareas` s LEFT JOIN `areas` a ON s.area = a.id WHERE s.id='".$id."'";
			$result = $mysqli->query($sql);
			$GLOBALS[BRIX_PAGES_QUERY]++;
			if($result->num_rows>0) {
				$data = $result->fetch_assoc();
			} else {
				$data = false;
			}
		} else {
			$data = false;
		}


		if($data) {
			$this->objecttype = 'subarea';
			$this->id = $data['id'];
			$this->name = $data['name'];

			$this->lat = $data['lat'];
			$this->long = $data['long'];
			$this->zoomlevel = $data['zoomlevel'];

			$this->feature = $data['feature'];
			$this->area = $data['area'];
			$this->city = ($data['city']!='' ? $data['city'] : gettablefield('areas','name',$this->area));
			$this->content = $data['content'];
			$this->excerpt = $data['excerpt'];

			if($data['polygon']!='') {
				$polygonarray = explode("\n", $data['polygon']); // pass array of polygon arrays.

				// remove any empty rows or 0 rows!
				$newpolygonarray = array();
				foreach($polygonarray as $pkey=>$coordinate) {
					if($coordinate!='') {$newpolygonarray[$pkey] = $coordinate;}
				}
				$this->polygon = $newpolygonarray;

				if($this->polygon[0]!=$this->polygon[count($this->polygon)-1]) {
					// the first and last array needs to match on a polygon, because that's the way to close the polygon.
					// other wise all shapes may end up falling OUT of the polygon in the point check algorithm, returning false for all!
					$this->polygon[count($this->polygon)] = $this->polygon[0];
				}

				$this->pointLocation = new pointLocation();
			}

			foreach($data as $key=>$value) {
				$this->data[$key] = $value;
			}
			return $this->id;
		}
	}

	function get_num_listings($type = false) {
		global $mysqli;
		// cache these evetually? TODO:
		$query = array('areaid'=>$this->id, 'publish'=>1); // since it's listings for the city, this much is basic.
		if($type!==false) {
			if(is_numeric($type)) {
				$query['typeid'] = $type;
			} else if(is_string($type)) {
				$query['type'] = $mysqli->real_escape_string($type);
			}
		}
		$homescount = get_properties('',$query, '', '', 100000, '', true, false);
		if($type==false) {
			$this->numlistings = $homescount;
		}
		return $homescount;
	}

	function listing_in_polygon($input) {
		if(is_object($input)) {
			$input_lat = $input->data['lat'] ?? false;
			$input_long = $input->data['long'] ?? false;
			if ($input_lat && $input_long) {
				$latlong = $input_lat.','.$input_long;
			} else {
				return false;
			}
		} else {
			$latlong = $input;
		}
		if($this->polygon) {
			return $this->pointLocation->pointInPolygon($latlong, $this->polygon);
		} else {
			return false;
		}
	}


	function get_main_images_path($num = 0, $noimage='noimage.png', $fallback = true) {
		global $settings;
		return get_main_images_path('subareas', $this, $num, $noimage, $fallback);
	}

	function pdf_file_link($num, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('subareas', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}


	/** ADDED BY 2022-10 BRIAN
	 * process $query into the get_properties(), to get the total number of listings in most cases.
	 * @param $query array	Array of queries
	 * @param $counter	boolean	If true, get count only. If False, get data only
	 * @return array|false|float|int	Returns counter of $sum = true, else returns array of listing data
	 */
	function get_properties($query, $counter = true) {
		// default queries that are pretty important
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}

		$query['areaid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		return get_properties('', $query, '', '', 100000, '', $counter, !$counter);
	}

	/** ADDED BY 2022-10 BRIAN
	 * Sum of prices of queries listings
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param $query array	Array of query types.
	 * @return int			returns the sum of all listings price
	 */
	function get_price_sum(array $query = array()) {
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['areaid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		$listings = $this->get_properties($query, false); // get available listings.

		// then loop through all prices, turn them into RAW numbers without $, add them up.
		$price_sum = 0;
		foreach ($listings as $each_listing) {
			$price_sum += remove_all_but_numbers($each_listing['price']);
		}
		return $price_sum;
	}

	/** ADDED BY 2022-10 BRIAN
	 * Sum of SQFT of queries listings
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param $query array	Array of query types.
	 * @return int			returns the sum of all listings SQFT
	 */
	function get_sqft_sum(array $query = array()) {
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['areaid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		$listings = $this->get_properties($query, false); // get available listings.

		// then loop through all SQFT, turn them into RAW numbers without $, add them up.
		$sqft_sum = 0;
		foreach ($listings as $each_listing) {
			$sqft_sum += remove_all_but_numbers($each_listing['sqft']);
		}
		return $sqft_sum;
	}

	/** ADDED BY 2022-10 BRIAN
	 * Get Average price of type in the area.
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param array $query	Important query needed is the "type"
	 * @return float		Avery price of type in the area
	 */
	function get_price_average(array $query = array()) {
		// Default query that's pretty important
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['areaid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		// get average by getting SUM / COUNTER
		$type_count = $this->get_properties($query, true);
		if($type_count>0) {
			$type_price_sum = $this->get_price_sum($query);
			$return = ($type_price_sum / $type_count);
		} else {
			$return = false;
		}
		return $return;
	}

	/** ADDED BY 2022-10 BRIAN
	 * Get Average SQFT of type in the area.
	 * Leave the result as raw number for coder to manipulate for their purpose
	 * @param array $query	Important query needed is the "type"
	 * @return float		Avery price of type in the area
	 */
	function get_sqft_average(array $query = array()) {
		// Default query that's pretty important
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['areaid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;

		// get average by getting SUM / COUNTER
		$type_count = $this->get_properties($query, true);
		if($type_count>0) {
			$type_sqft_sum = $this->get_sqft_sum($query);
			$return = ($type_sqft_sum / $type_count);
		} else {
			$return = false;
		}
		return $return;
	}

	/** ADDED BY 2022-10 BRIAN
	 * Uses previous functions to calculate AVERAGE PRICE PER SQ. FT. of TYPE ( Condo or House, possibly just all types combined )
	 * @param array $query	Important query needed is "type"
	 * @return float|int
	 */
	function get_price_per_sqft(array $query = array()) {
		if(!array_key_exists('forsale', $query)) {
			// unless specified, alwayas limit to for sale listings.
			$query['forsale']=1;
			$query['sold']=0;
		}
		$query['areaid'] = $this->id; // pass its own city ID obbvioiusly.
		$query['publish'] = 1;
		$avg_price = $this->get_price_average($query);
		$avg_sqft = $this->get_sqft_average($query);

		return ($avg_price / $avg_sqft);
	}
}




/* Polygon shape functions to detect existence on maps without relying on Google */
/*
Description: The point-in-polygon algorithm allows you to check if a point is
inside a polygon or outside of it.
Author: Michaël Niessen (2009)
Website: http://AssemblySys.com

If you find this script useful, you can show your
appreciation by getting Michaël a cup of coffee ;)
PayPal: michael.niessen@assemblysys.com

As long as this notice (including author name and details) is included and
UNALTERED, this code is licensed under the GNU General Public License version 3:
http://www.gnu.org/licenses/gpl.html
*/

class pointLocation {
	var $pointOnVertex = true; // Check if the point sits exactly on one of the vertices?

	function pointInPolygon($point, $polygon, $pointOnVertex = true) {
		$this->pointOnVertex = $pointOnVertex;

		// Transform string coordinates into arrays with x and y values
		$point = $this->pointStringToCoordinates($point);
		$vertices = array();
		foreach ($polygon as $vertex) {
			$vertices[] = $this->pointStringToCoordinates($vertex);
		}

		// Check if the point sits exactly on a vertex
		if ($this->pointOnVertex == true and $this->pointOnVertex($point, $vertices) == true) {
			return true;
		}

		// Check if the point is inside the polygon or on the boundary
		$intersections = 0;
		$vertices_count = count($vertices);

		for ($i=1; $i < $vertices_count; $i++) {
			$vertex1 = $vertices[$i-1];
			$vertex2 = $vertices[$i];
			if ($vertex1['y'] == $vertex2['y'] and $vertex1['y'] == $point['y'] and $point['x'] > min($vertex1['x'], $vertex2['x']) and $point['x'] < max($vertex1['x'], $vertex2['x'])) { // Check if point is on an horizontal polygon boundary
				return true;
			}
			if ($point['y'] > min($vertex1['y'], $vertex2['y']) and $point['y'] <= max($vertex1['y'], $vertex2['y']) and $point['x'] <= max($vertex1['x'], $vertex2['x']) and $vertex1['y'] != $vertex2['y']) {
				$xinters = ($point['y'] - $vertex1['y']) * ($vertex2['x'] - $vertex1['x']) / ($vertex2['y'] - $vertex1['y']) + $vertex1['x'];
				if ($xinters == $point['x']) { // Check if point is on the polygon boundary (other than horizontal)
					return true;
				}
				if ($vertex1['x'] == $vertex2['x'] || $point['x'] <= $xinters) {
					$intersections++;
				}
			}
		}
		// If the number of edges we passed through is odd, then it's in the polygon.
		if ($intersections % 2 != 0) {
			return true;
		} else {
			return false;
		}
	}

	function pointOnVertex($point, $vertices) {
		foreach($vertices as $vertex) {
			if ($point == $vertex) {
				return true;
			}
		}

	}

	function pointStringToCoordinates($pointString) {
		$coordinates = explode(",", $pointString);
		return array("x" => trim($coordinates[0]), "y" => trim($coordinates[1]));
	}

}

/* END OF POLYGON SHAPES */


class agent {
	var $objecttype = false;
	var $id;
	var $fname;
	var $mname;
	var $lname;
	var $fname2;
	var $mname2;
	var $lname2;
	var $billable;
	var $email;
	var $emaildisplay;
	var $website;
	var $displayname;
	var $displayname2;
	var $lnamefirst;
	var $position;
	var $agentid;
	var $heading;
	var $content;
	var $excerpt;
	var $facebook;
	var $linkedin;
	var $twitter;
	var $googleplus;
	var $instagram;
	var $tiktok;
	var $pinterest;
	var $youtubechannel;
	var $hometown;
	var $langauges;
	var $youtube;
	var $publish;
	var $photos;
	var $pdf_labels;

    var $custom_fields;

	function initialize($id, $agentarray=false) {
		global $settings;
		global $mysqli;

		$data = false;

		if($agentarray===false) {
			// default way of querying based on input of home ID.
			// the get_properties() function is designed to get enough information to show the list of listings (listing gallery) for display, so even though it may be tempting to replace the below query with another iteration of get_properties('', $query['id'],...);, DONT DO IT. - JEff 2017-09-20
			$memcache_params = array(
				'type'=>'agent',
				'objectid'=>$id
			);

			$memcache_data = get_memcache($memcache_params);
			if(is_array($memcache_data)) {
				$data = $memcache_data;
				$data['memcache'] = true;
				if(DEBUG==true) {
					echo "Agent data from memcache: ".count($data)." columns retrieved.<br />".PHP_EOL;
				}
			} else if($memcache_data==='') {
				$data = false; // feed false, so the object returns false.
			} else {
				$sql = "SELECT a.*, c.name AS `classname`, c.name2 AS `classname2`, c.billable AS `billable`  FROM agents a LEFT JOIN `agent_classes` c ON a.class = c.id WHERE a.id='".$id."'";
				$result = $mysqli->query($sql);
				$GLOBALS[BRIX_PAGES_QUERY]++;
				if($result->num_rows>0) {
					$data = $result->fetch_assoc();
					$agent_cache_key = get_memcache($memcache_params, $data);
				} else {
					// Agent does not exist.. yet. So just save the blank cache.
					$data = false;
					$agent_cache_key = get_memcache($memcache_params, '');
					if(DEBUG==true) {
						echo "Set blank agent memcache for " . $agent_cache_key . "<br />" . PHP_EOL;
					}
				}
				// even store false data.
				// There were cases where deleted agents kept getting queried, returning false.
				// No cache means repeated SQL calls.

				if(DEBUG===true) {
					echo "SQL Query: ".$sql."<br />".PHP_EOL;
					echo "Store to Memcache with params: <br />".PHP_EOL;
					print_r($memcache_params);
					echo PHP_EOL."<br />New Key: ".$agent_cache_key."<br />".PHP_EOL;
				}

			}
		} else if(is_array($agentarray)) {
			// retrieve from the $data array - the get_properties function already returned a lot of the fields to speed it up, this reduces query time for map searches.
			$data = $agentarray;// feed $agentarray into $data then start processing the data only, bypass the MySQL query.
			if(DEBUG==true) {
				echo "Memcache flag on agent array: ".(isset($agentarray['memcache']) && $agentarray['memcache']===true ? "true" : "false")."<br />".PHP_EOL;
			}
		}

		if($data!==false) {
			$this->objecttype = 'agent';
			$this->id = $data['id'];

			$this->mainphoto = delimited_options_to_array($data['mainphoto'], $settings['agents_mainphotofilename']);
			$this->pdf = delimited_options_to_array($data['pdf'], $settings['agents_pdffilename']);

			$this->fname = trim($data['fname']);
			$this->lname = trim($data['lname']);
			$this->mname = trim($data['mname']);

			$this->fname2 = trim($data['fname2']);
			$this->lname2 = trim($data['lname2']);
			$this->mname2 = trim($data['mname2']);

			$this->position = trim($data['position']);
			if($data['class']>0) {
				$this->class = $data['classname'];
				$this->class2 = $data['classname2'];
				$this->billable = ($data['billable']=='1' ? true : false);
			} else {
				$this->class = false;
				$this->class2 = false;
				if($settings['agent_classes']) {
					$this->billable = false;
				} else {
					$this->billable = true;
				}
				 // always billable when there's no agent classes.
			}

			$this->cell = $data['cell'];
			$this->email = $data['email'];
			$this->emaildisplay = mungemail($this->email, $this->email);
			$this->publish = $data['publish'];

			$this->displayname = ($this->fname!='' ? $this->fname.' ' : '').($this->mname!='' ? $this->mname.' ' : '').($this->lname!='' ? $this->lname : '');
			$this->lnamefirst = $this->lname.($this->fname!='' ? ', '.$this->fname.($this->mname!='' ? ' '.$this->mname : '') : '');

			$this->displayname2 = ($this->fname2!='' ? $this->fname2.' ' : '').($this->mname2!='' ? $this->mname2.' ' : '').($this->lname2!='' ? $this->lname2 : '');
			$this->lnamefirst2 = $this->lname2.($this->fname2!='' ? ', '.$this->fname2.($this->mname2!='' ? ' '.$this->mname2 : '') : '');

			$this->agentid = $data['agentid'];


			$this->slug_default = url_format($this->displayname);
			$this->slug = ($data['slug']!='' ? $data['slug'] : $this->slug_default);

			$this->pageurl = $settings['sitepath'].($settings['agents_url'] ? $settings['agents_url'].'/' : 'agent/').$this->id.'/'.$this->slug;

			$this->listingsurl = $settings['sitepath'].($settings['agent_listings_url'] ? $settings['agent_listings_url'].'/' : 'listings/').'agent-'.$this->id.'/'.$this->slug;

			$this->website = ($data['website']!='' && !is_url($data['website']) ? 'http://'.$data['website'] : $data['website']);

			$this->facebook = $data['facebook'];
			$this->linkedin = $data['linkedin'];
			$this->twitter = $data['twitter'];
			$this->googleplus = $data['googleplus'];
			$this->instagram = $data['instagram'];
			$this->tiktok = $data['tiktok'];
			$this->pinterest = $data['pinterest'];
			$this->youtubechannel = $data['youtubechannel'];

			$this->heading = $data['heading'];

			$this->content = $data['content'];
			$this->content2 = $data['content2'];
			$this->excerpt = $data['excerpt'];

			// description & content are same.
			$this->description = $this->content;
			$this->description2 = $this->content2;

			// prcoess basic meta stuff
			// process meta title
			$this->metatitle_default = $this->displayname.', '.$settings['company'];
			if($data['metatitle']!='') {
				$this->metatitle = $data['metatitle'];
			} else {
				$this->metatitle = $this->metatitle_default;
			}

			// process meta description
			$this->metadescription_default = $this->displayname.' '.($this->position!='' ? '('.$this->position.')' : '').'is a proud team member of '.$settings['company'].'. ';

			if($data['description']!='') {
				$this->metadescription = $data['description'];
			} else {
				$this->metadescription = $this->metadescription_default;
			}

			$this->hometown = $data['hometown'];
			$this->languages = $data['languages'];

			if($data['youtube']!='') {
				$this->youtube = $data['youtube'];
			} else {
				$this->youtube = false;
			}

			if($data['vimeo']!='') {
				$this->vimeo = $data['vimeo'];
			} else {
				$this->vimeo = false;
			}

			/*
			if($data['area']!='') {
				$this->area = gettablefield('subareas','name',$data['area']);
			}
			*/

			if($data['city']!='') {
				$this->city = gettablefield('areas','name',$data['city']);
			}

			foreach($data as $key=>$value) {
				$this->data[$key] = $value;
			}

			$this->data['metadescription'] = $this->data['description'];

			// now process the image
			if($settings['agents_mainphotonum'] > 1) {
				// it's an array, therefore return multiple arrays!
				foreach($settings['agents_mainphotofilename'] as $key=>$filename) {
					$this->topimage[$key] = $this->get_main_images_path($key, false, false);
				}

			} else {
				// single width, so single variable only.
				$this->topimage = $this->get_main_images_path(0, false, false);
			}

            $this->get_custom_fields();
            $this->getphotos(false);

			$pdf_labels_unserialized = false; // default false.
			if($data['pdf_labels']!='') {
				$pdf_labels_unserialized = unserialize($data['pdf_labels']);
			}
			if($pdf_labels_unserialized!==false) {
				foreach ($pdf_labels_unserialized as $key => $pdf_label) {
					// Use $key when assigning value so that the key->value pair stays the same as database.
					// if pdf label is empty, fall back to $settings default label - if $settings not set, make a quick fallback here
					if($pdf_label=='') {
						$this->pdf_labels[$key] = ((isset($settings['agents_pdfname'][$key]) && $settings['agents_pdfname'][$key]) != '' ? $settings['agents_pdfname'][$key] : 'PDF '. ($key + 1));
					} else {
						$this->pdf_labels[$key] = $pdf_label;
					}
				}
			} else {
				// if all labels are empty, use site $settings default
				$this->pdf_labels = $settings['agents_pdfname'];
			}

			return $this->id;
		} else {
			return false;
		}
	}

	function get_video() {
		global $settings;

		if($this->youtube!='') {
			$this->videourl = "https://www.youtube.com/v/".$this->youtube."?rel=0&hl=en&fs=1&autoplay=1";
			$return = true;

		} else if($this->vimeo!='') {
			$this->videourl = "https://player.vimeo.com/video/".$this->vimeo;
			$return = true;

		} else if(file_exists(($settings['fileroot']!='' ? $settings['fileroot'] : $_SERVER['DOCUMENT_ROOT']).'/agents/'.$this->id.'/video.flv')) {
			$this->videourl = $settings['sitepath']."/agent/".$this->id."/video.flv";
			$return = true;

		} else if($this->data['videolink']!=''){
			$this->videourl = $this->data['videolink'];
			$return = true;

		} else {
			$this->videourl = false;
			$return = false;
		}

		return $return;
	}

	function get_agent_link($basefile = 'agents') {
		global $settings;
		return $settings['sitepath'].$basefile.'/'.$this->id.'/'.$this->slug;
	}

	function get_agent_listings_link($basefile = 'listings') {
		global $settings;
		return $settings['sitepath'].$basefile.'/agent-'.$this->id.'/'.$this->slug;
	}

	function get_main_images($num = 0, $width='', $height='', $noimage = 'noimage.png', $cssclass='', $quality = 75, $fallback = true) {
		// applies only to source=0 listings that may contain more than 1 MAIN IMAGE files. $num var is use dto find the array key.
		global $settings;
		if($width=='') {
			$width = $settings['agents_mainphotowidth'][$num];
		}
		if($height=='') {
			$height = $settings['agents_mainphotowidth'][$num];
		}

		$classhtml = '';
		if($cssclass) {
			if(is_array($cssclass)!=1) {
				$classhtml = $cssclass; // singular class
			} else {
				// multiple classes passed by array, list them all with spaces.
				foreach($cssclass as $classcount => $css) {
					if($classcount>0) {
						$classhtml.=' ';
					}
					$classhtml.=$css;
				}
			}
		}
		// to get path, use get_main_images_path
		$fileurl = $this->get_main_images_path($num, $noimage, $fallback);
		if(strpos($fileurl, '?mod=')) {
			$timthumbimageurl = str_ireplace('?', '%3F', $fileurl);
			// $timthumbimageurl = substr($fileurl, 0, strpos($fileurl, '?mod='));
		} else {
			$timthumbimageurl = $fileurl;
		}

		$imgtag = '<img src="/timthumb.php?src='.$timthumbimageurl.'&w='.$width.'&h='.$height.'&q='.$quality.'" alt="'.$this->displayname.($num > 0 ? ' '.$num+1 : '').'" title="'.$this->displayname.($num > 0 ? ' '.$num+1 : '').'" class="'.$classhtml.'" />';
		// by default, we timthumb the image to the size.

		if ((strpos($fileurl,'noimage') !== false || strpos($fileurl,'http') !== false) || strpos($fileurl, $settings['buildings_mainphotofilename'][$num])!==false || strpos($fileurl, 'amazonaws.com')) {
			$imgtag = '<img src="'.$fileurl.'" alt="'.$this->displayname.($num > 0 ? ' '.$num+1 : '').'" title="'.$this->displayname.($num > 0 ? ' '.$num+1 : '').'" class="'.$classhtml.'" />'; // just a noiomage file, or a specific main.jpg image or from S3, so use as-is.
		}

		return $imgtag;
	}

	function get_main_images_path($num = 0, $noimage='noimage.png', $fallback = true) {
		global $settings;
		return get_main_images_path('agents', $this, $num, $noimage, $fallback);
	}

	// attachment functions, with S3 capacity, added 2016-12.
	function pdf_file_link($num=0, $anchor='', $prefix='', $suffix='', $cssclass = '') {
		// universal PDF link displayer that can be used on both floorplans & feature sheet PDFs
		global $settings;
		return get_pdf_file_link('agents', $this, $num, $anchor, $prefix, $suffix, $cssclass);
	}


	function getphotos($photos=false) {
		/*
		 * Ultimately calls independent function get_object_photos() that works on homes, agents, buildings - all  objects.
		 * */
		global $settings;
		global $mysqli;
		unset($this->photos);
		if($photos === false) {
			$this->photos = get_object_photos('agents', $this->id);
		}

		if (is_array($this->photos) && count($this->photos)>0) {
			$this->gallery_exists = 1;
			$return = true;
		} else {
			$this->gallery_exists = 0;
			$this->photos = false;
			$return = false;
		}
		return $return;
	}

	/**
	 *  New Custom Field functions copied from Home class
	 */
	function get_custom_fields($name='') {
		global $mysqli;
		if($name!='') {
			// $name var given, look for array. If it's blank, it's blank... big diff from being unavailable.
			if(is_array($this->custom_fields) && array_key_exists($name, $this->custom_fields)) {
				$returnvar = $this->custom_fields[$name];
			} else {
				// if key does not exist, return false boolean
				$returnvar = false;
			}
		} else {
			// no name field given, get all fields and initialize
			$this->custom_fields = array();
			// get custom fields
			$sql = 'SELECT `id`, `name`, `desc`, `value` FROM `custom_fields` WHERE `agent`="'.$this->id.'" ORDER BY `ord` ASC, `id` ASC';
			$returnvar = array();
			$result = $mysqli->query($sql);
			if($result->num_rows > 0) {
				// found rows, get results in array!
				while($array = $result->fetch_assoc()) {
					if(unserialize($array['value'])) {
						// it's an array so unserialize.
						$returnvar[$array['name']]['value'] = unserialize($array['value']);
					} else {
						// it's not an array, so string.
						$returnvar[$array['name']]['value'] = $array['value'];
					}
					$returnvar[$array['name']]['agentid'] = $this->id; // in case we need to refer to home ID but honestly quite redundant as this is PART of an home object already...
					$returnvar[$array['name']]['desc'] = $array['desc']; // description of what the field does etc.
					$returnvar[$array['name']]['id'] = $array['id']; // ID of the row in the `custom_fields` table in case we need reference.
					$returnvar[$array['name']]['ord'] = $array['ord']; // order of the custom feat.
				}

			} else {
				$returnvar = false; // not a single row of custom fields for this page
			}
			$this->custom_fields = $returnvar;
		}
		return $returnvar;
	}

	function update_custom_field($id, $value, $desc='', $ord='') {
		global $mysqli;
		if($id!='') {
			$updatesql = "UPDATE `custom_fields` SET 
				   `value`='".cleanupforentry($value)."', 
				   `desc`='".cleanupforentry($desc)."' 
				    ".(isset($ord) ? ", `ord`='".remove_all_but_numbers($ord)."'" : "")."
				    WHERE `id`='".$id."' and `agent`='".$this->id."' ";

			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function add_custom_field($name, $value, $desc='', $ord=0) {
		global $mysqli;
		if($name!='') {
			// name can never be blank. however the value can be  a blank value if its meant to be!
			$insertarray['name']	= $name;
			$insertarray['value']	= $value;
			$insertarray['desc']	= $desc;
			$insertarray['agent']	= $this->id;
			$insertarray['ord']		= remove_all_but_numbers($ord);
			return form_to_table('custom_fields', $insertarray);
		} else {
			return false;
		}
	}

	function drop_custom_field($params) {
		// allow deletoin by unique ID, or  by name.
		global $mysqli;
		$id = (isset($params['id']) ? $params['id'] : false);
		$name = (isset($params['name']) ? $params['name'] : false);

		if($id === false && $name!==false) {
			// get ID by field name.
			$custom_field = $this->get_custom_field($name);
			if($custom_field) {
				$id = $custom_field['id'];
			} else {
				$id = false;
			}

		}
		if($id) {
			$deletesql = "DELETE FROM `custom_fields` WHERE `agent` = ".$this->id." AND `id`=".$id ;
			if($mysqli->query($deletesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	function drop_custom_fields() {
		global $mysqli;
		if($this->id!='') {
			$updatesql = "DELETE FROM `custom_fields` WHERE `agent` = ".$this->id;
			if($mysqli->query($updatesql)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
}

class user {
	/*
	 * Each user entity who has access to the back-end of the website.
	 * Ensure we distinguish from agents - not the same.
	 * Some users may be granted access to modify listings of ceratin agents too.
	 *
	 * */

	private $email;
	private $id;
	private $hash;
	private $password;
	private $level;
	private $agents;

	public $fname;
	public $lname;
	public $username;

	private $mailchimp_id;
	private $mailchimp_status; // 0, 1 etc. - related to $settings['mailchimp_subscriber_status']
	public $mailchimp_status_display; // actually shows "subscxribed" etc.

	public function __construct($config, $mysqli, $settings) {
		$this->mysqli = $mysqli;
		$this->settings = $settings;
		if (isset($config['id'])) {
			$this->initialize($config['id']);
		}
	}

	public function initialize($idr='') {
		if($idr!='') {
			$sql = "SELECT `id`, `username`, `fname`, `lname`, `email`, `hash`, `level`, `mailchimp_id`, `mailchimp_status`, `agents`, `password` FROM `users` WHERE `id` = ?";
			$stmt = $this->mysqli->prepare($sql);
			$stmt->bind_param('i', $idr);
			$stmt->execute();
			$userresult = $stmt->get_result();
			if($userresult->num_rows>0) {
				$data = $userresult->fetch_assoc();
				$this->id = $data['id']; // default the ID first.
				$this->username = $data['username']; // default the ID first.
				$this->fname = $data['fname'];
				$this->lname = $data['lname'];
				$this->email = $data['email'];
				$this->hash = $data['hash'];
				$this->level = $data['level'];
				$this->mailchimp_id = $data['mailchimp_id'];
				$this->mailchimp_status = $data['mailchimp_status'];
				$this->mailchimp_status_display = $this->settings['mailchimp_subscriber_status'][$this->mailchimp_status];// turn the 0, 1 etc. to a "subscribed" etc. type of string, or FALSE if not.
				$this->agents = $data['agents'];
				$this->password = $data['password'];
				return $this->getID();
			} else if($userresult->num_rows===0 || $userresult === false) {
				return false;
			}
		} else if($this->id!=false) {
			return $this->getID();
		} else {
			return false;
		}
	}

	public function getID() {
		return $this->id;
	}

	public function getFullName() {
		return trim($this->fname.' '.$this->lname);
	}

	public function getMailchimpId() {
		return $this->mailchimp_id;
	}

	public function getEmail() {
		return $this->email;
	}

	public function getLevel() {
		return $this->level;
	}


	public function getFName() {
		return $this->fname;
	}
	public function getLName() {
		return $this->lname;
	}
	public function getUsername() {
		return $this->username;
	}
	/**
	 * @return array    Returns array of agent ids attached to this user.
	 */
	public function getAgents(): array {
		return (!empty($this->agents)) ? explode(",", $this->agents) : array();
	}

	/**
	 * Using the array of agent IDs, initialize and return array of Realtor IDs (e.g. V12345)
	 * @return array
	 */
	public function getRealtorIDs(): array {
		$user_associated_agents = $this->getAgents();
		$realtor_id = array();

		// only run if user has agents associated.
		if (!empty($user_associated_agents)) {
			foreach ($user_associated_agents as $internal_id) {
				$each_agents = new agent;
				$each_agents->initialize($internal_id);
				$realtor_id[] = $each_agents->agentid;
			}
		}
		return $realtor_id;
	}
	/**
	 * Compare this user to login user and return true or false.
	 * Maybe we can come up with fancier mechanism for this, but for now this will suffice.
	 * @return boolean		true means user = login user ... this user object is the one that's logged in.
	 */
	public function isUserAuthenticated(): bool {
		global $login_user;

		return $this->getID() == $login_user->getID();
	}
	/**
	 * MATCH USER INPUT AND USER CLASS PASSWORD AND RETURN TRUE FALSE.
	 * @param $input_password    string hashed password
	 * @return bool
	 */
	public function matchPassword(string $input_password): bool {
		return (strcmp($this->password, $input_password) === 0);
	}


	public function addToBrixworkMailchimp($mcobject) {
		// make sure to pass $mcobject as the Brixwork API object.
		// This is our Active Clients list on Mailchimkp since 2011. Never changes.
		$activelistid = $this->settings['mailchimp_brixwork_active_clients_list'];

		if($this->getEmail()!='') {
			$subscriber_data['email_address'] = $this->getEmail();
			$subscriber_data['status'] = 'subscribed'; // or we hope. Mailchimp will reject this status if the user already unsubscribed.

			// start buliding the 'merge_fields' subarray using first/last name pairs.
			$response = $mcobject->lists->setListMember($activelistid, md5(strtolower($subscriber_data['email_address'])),$subscriber_data);
			/*
 * $response looksl ike:
[id] => 38c68ac055fbf5c89c34993b71e14fe2
[email_address] => jeff@jeffkee.com
[unique_email_id] => 73bf637c98
[contact_id] => 01d2ad53e5538d71567664f53ad544fa
[full_name] => Jeff Kee
[web_id] => 35879341
[email_type] => html
[status] => subscribed
[consents_to_one_to_one_messaging] => 1
[merge_fields] => stdClass Object
	(
		[FNAME] => Jeff
		[LNAME] => Kee
		[ACTVDATE] => 2011-01-01
		[URL] => https://www.silvervalleyhomes.com/
	)
 *
 * */

			if(isset($response->contact_id) && $response->contact_id!='') {
				$id = $this->mailchimp_id = $response->contact_id;
				$status = $this->mailchimp_status_display = $response->status;
				$mailchimp_status_id = $this->mailchimp_status = array_search($status, $this->settings['mailchimp_subscriber_status'], true);

				$updatesql = "UPDATE `users` SET `mailchimp_id`='".$id."', `mailchimp_status`='".$mailchimp_status_id."' WHERE `id`=".$this->getID();
				$result = $this->mysqli->query($updatesql);

				$message = "Successfully added ".$subscriber_data['email_address']." to Mailchimp list ".$activelistid." with status ID ".$this->mailchimp_status.", updated .";
			} else {
				$id = false;
				$result = false;
				$status = 0;
				$message = "Failed at adding ".$subscriber_data['email_address']." to Mailchimp list ".$activelistid.".";
			}

		} else {
			$id = false;
			$result = false;
			$status = '';
			$message = "Email is not set for user id  ".$this->getID().". Cannot add to Mailchimp without email.";
		}
		// Now move onto spitting out result

		$return = array(
			'id' => $id,
			'result' => $result,
			'status' => $status,
			'message' => $message
		);

		return $return;
	}

	public function updateBrixworkMailchimp($mcobject) {
		global $now;
		if($this->mailchimp_id!='') {
			$activelistid = $this->settings['mailchimp_brixwork_active_clients_list'];

			/*
			 * Mailchimp wants nthe following fromat.. even if we don' thave email addresses etc. since we're updating.
			 * $subscriber_data = array(
			 * 		'key/email/etc' => $email,
			 * 		'merge_fields' => array(
			 * 			'FNAME' => $first_name,
			 * 		)
			 * )
			 * */
			$subscriber_data['merge_fields'] = array(); // blank array by default.

			$firstname = trim($this->fname);
			$lastname = trim($this->lname);

			if($firstname!='') {
				// build the 'merge_fields' array key.
				// This is for the Brixwork active list, so we know the field names exactly.

				if(isset($firstname) ) {
					$subscriber_data['merge_fields']['FNAME'] = $firstname;
				}
				if(isset($lastname) ) {
					$subscriber_data['merge_fields']['LNAME'] = $lastname;
				}
			}

			// interest GROUP ID is 74ca86066e
			if($this->settings['mls_integrated']==1) {
				$subscriber_data['interests']['8851279c49'] = true;
				$subscriber_data['interests']['0c31df0188'] = false;

				// interest GROUP ID is 76f8bf1273 for the Location (MLS Region etc.)
				$mls_import_map = mailchimp_get_groups_list($mcobject, '76f8bf1273');
				foreach($mls_import_map as $mls_key=>$mls_val) {
					if(get_host($mls_key)!=='') {
						// if $mls_key from Mailchimp is non-MLS zone like "San Francisco, CA" then ignore from the comparison.
						if(strpos(get_host($this->settings['mls_import_url']), strtolower($mls_key))!==false) {
							$subscriber_data['interests'][$mls_val] = true;
						} else {
							$subscriber_data['interests'][$mls_val] = false;
						}
					}
				}
			} else {
				$subscriber_data['interests']['8851279c49'] = false; // MLS integrated YES is false,
				$subscriber_data['interests']['0c31df0188'] = true; // MLS integrated NO is true.
			}

			// interest GROUP IS is edf9c339d0 Rental yes/no.
			if($this->settings['rental_enabled']==1) {
				$subscriber_data['interests']['c462399e11'] = false;
				$subscriber_data['interests']['159e9e962c'] = true;
			} else {
				$subscriber_data['interests']['c462399e11'] = true;
				$subscriber_data['interests']['159e9e962c'] = false;
			}

			// interest GROUP IS ded0766c8f for Wordpress.
			// TODO: We need a better wordpress detector that checks folders, wp-config.php file, and then checks `pages` table where custom_url matches the folder.
			if(file_exists('blog/wp-config.php')) {
				$subscriber_data['interests']['492c46bf41'] = false;
				$subscriber_data['interests']['a08f4a7c13'] = true;
			} else {
				$subscriber_data['interests']['492c46bf41'] = true;
				$subscriber_data['interests']['a08f4a7c13'] = false;
			}

			// other merge data that may come in handy.
			$subscriber_data['merge_fields']['URL'] = $this->settings['sitepath']; // toss in current site URL as the main site.
			$subscriber_data['merge_fields']['LASTLOGIN'] = date('m/d/Y', time());// toss in current site URL as the main site.

			$response = $mcobject->lists->updateListMember($activelistid, $this->mailchimp_id, $subscriber_data);

			/*
			 * $response returns:
			 *  object(stdClass)#1503 (27) {
  ["id"]=>
  string(32) "38c68ac055fbf5c89c34993b71e14fe2"
  ["email_address"]=>
  string(16) "jeff@jeffkee.com"
  ["unique_email_id"]=>
  string(10) "73bf637c98"
  ["contact_id"]=>
  string(32) "01d2ad53e5538d71567664f53ad544fa"
  ["full_name"]=>
  string(8) "Jeff Kee"
  ["web_id"]=>
  int(35879341)
  ["email_type"]=>
  string(4) "html"
  ["status"]=>
  string(10) "subscribed"
  ["consents_to_one_to_one_messaging"]=>
  bool(true)
  ["merge_fields"]=>
  object(stdClass)#1497 (5) {
    ["FNAME"]=>
    string(4) "Jeff"
    ["LNAME"]=>
    string(3) "Kee"
    ["ACTVDATE"]=>
    string(10) "2011-01-01"
    ["URL"]=>
    string(25) "https://dev.brixwork.com/"
    ["LASTLOGIN"]=>
    string(10) "2023-05-11"
  }
			 *
			 * */
			if(isset($response->contact_id) && $response->contact_id==$this->mailchimp_id) {
				$updatecolumns = array();

				if($this->fname != $response->merge_fields->FNAME) {
					// If the name is blank on the `users` database, but Mailchimp has a FNAME for this user, update.
					$this->fname = $this->mysqli->real_escape_string($response->merge_fields->FNAME);
					$updatecolumns[] = "`fname` = '".$this->fname."'";
				}

				if($this->lname != $response->merge_fields->LNAME) {
					$this->lname = $this->mysqli->real_escape_string($response->merge_fields->LNAME);
					$updatecolumns[] = "`lname` = '".$this->lname."'";
				}

				$id = $this->mailchimp_id =  $response->contact_id;
				$statuslabel = $this->mailchimp_status_display = $response->status;
				$mailchimp_status_id = array_search($statuslabel, $this->settings['mailchimp_subscriber_status'], true);

				$status = $mailchimp_status_id;

				if($this->mailchimp_status != $mailchimp_status_id) {

					$this->mailchimp_status = $mailchimp_status_id;
					$updatecolumns[] = "`mailchimp_status` = '".$this->mailchimp_status."'";
				}

				if(count($updatecolumns)>0) {
					$updatesql = "UPDATE `users` SET `modify_date` = '".$now."'";

					foreach($updatecolumns as $updatecolumn) {
						$updatesql .= ", ".$updatecolumn;
					}
                   	$updatesql .= " WHERE `id`=".$this->getID();
					$result = $this->mysqli->query($updatesql);
					if($result) {
						$message = "Updated user with ".count($updatecolumns)." columns updated in MySQL users table (".$updatesql.").";
					} else {
						$message = "Mailchimp response was ".$response->status.", but MySQL update failed with error: ".$this->mysqli->error." for ".$response->contact_id.".";
					}
				} else {
					$id = $response->contact_id;
					$result = true;
					$status = $mailchimp_status_id;
					$message = "No changes were needed for subscriber with all merge fields matching already.";
				}


			} else {
				// Mailchimp response was error!
				$id = false;
				$result = false;
				$status = $response->status;
				$message = "Mailchimp API Error (".$response->title.") with contact ID ".$this->mailchimp_id." - ".$response->detail.".";
			}

		} else {
			// Needs to be added first. No Mailchimp ID means not registered yet?
			$id = false;
			$result = false;
			$status = 'Not On Mailchimp';
			$message = "User's mailchimp_id is blank. Must be added to the list first for the update to run.";
		}

		$return = array(
			'id' => $id,
			'result' => $result,
			'status' => $status,
			'message' => $message
		);
		return $return;
	}
}


class visitor {// new object that tracks visitor
	// runs partially on cookies, partially on new table called visitors


	var $sessionid; // derived from $_SESSION['id'] for initial setting. unique identifier.
	var $id; // if there is  DB row attached to visitor, this can be false.
	var $fname; // useful after the contact form trigger is done (ajax_sendemail.php can set this)
	var $lname;
	var $email;

	function initialize($sessionid) {
		global $mysqli;
		global $settings;

		// generally you'd pass $_COOKIE['sessionid'] so it links to an older one if exists.
		// if not, it will create new one from $_SESSION['id'] automatically.
		// important to udnerstand that initialize, for visitors, often does NOT link to a database table. before a user submits data,
		// this visitor is anonymous, and the object only consists of users's cookies only, nothing local yet.

		// but first check if user is logged in
//		if(logged_in()!==false && $_COOKIE['username'] != 'brixwork') {
//		if(logged_in()!==false || logged_in(1)) {
//			$this->id = false;
//			$this->sessionid = false; // logged in user to /admin so must be site owner or brixwork staff. ignore altogether!
//		} else {
			// valid visitor, let's initialize it.
			if(array_key_exists('visitorid', $_COOKIE) && $_COOKIE['visitorid']!='') {
				// linked to item in visitor table. get all the info!
				if($_COOKIE['email']=='') {
					$this->get_visitor_info($_COOKIE['visitorid']);
				}
			} else if($sessionid=='' || $sessionid==false) {
				// fresh new cookie, let's set up the user based on session ID which will be unique
				$sessionid = session_id();
			}
			$this->sessionid = $sessionid;

			set_visitor_cookie($sessionid);
			// essentially either sets or extends the cookie on each page load

//		}
		return $this->sessionid;
		// retrieve existing rows and merge with cookies?
		// perhaps using timestamp as an identifying ID would help

	}

	/**
	 * @param $data can contain array for 'fname', 'lname', 'email', 'phone'
	 * @return true on successful generation of visitor row or update of info. False on fail, or if not enough data.
	 */
	function register_visitor($data) {
		// only happens when a visitor actually sends an email. Tie them into our system.
		// it also updates existing visitors.
		global $mysqli;
		global $settings;
		global $now;
		global $local;

		// never run it without an email, pointless.
		if(is_array($data)) {
			$fname = cleanupforentry($data['fname']);
			$lname = cleanupforentry($data['lname']);
			$email = cleanupforentry($data['email']);
			$phone = cleanupforentry($data['phone']);
		}
		if($email!='') {
			$visitorsql = "SELECT `id`, `sessionid`, `fname`, `lname`, `email`, `phone` FROM `visitors` WHERE ";
			// first try to find existing ones and tie this user cookie to existing one?
			if ($email != '') {

				$visitorsql .= "`email`='" . $email . "'";

			} else if ($phone != '') {
				$phone = cleanupforentry(remove_all_but_numbers($phone));
				$visitorsql .= "`phone`='" . $phone . "'";
			}

			$visitorresult = $mysqli->query($visitorsql);

			if ($visitorresult->num_rows>0) {
				// existing row based on email or phone match!
				$visitorarray = $visitorresult->fetch_assoc();
				$this->id = $visitorarray['id'];
				set_visitor_cookie($visitorarray['sessionid']); // update the destination cookie to match the current visitor row.
				$this->sessionid = $visitorarray['sessionid'];
				// visitor exits. Update if any fields missing.
				$this->get_visitor_info($this->id);

				// lets seek to update?
				if ($this->fname != $fname || $this->lname != $lname || $this->email != $email || $this->phone != $phone) {
					$newvar['fname'] = find_longer_value($this->fname, $fname);
					$newvar['lname'] = find_longer_value($this->lname, $lname);
					$newvar['email'] = find_longer_value($this->email, $email);
					$newvar['phone'] = find_longer_value($this->phone, $phone);

					$updatesql = "UPDATE `visitors` SET
					`fname`='" . $newvar['fname'] . "', 
					`lname`='" . $newvar['lname'] . "',
					`email`='" . $newvar['email'] . "',
					`phone`='" . $newvar['phone'] . "',
					`modify_date`='" . $now . "'
					 WHERE `id`='" . $this->id . "'";
					$mysqli->query($updatesql);
				}
			} else {
				// brand new visitor! Set it up!
				$insertsql = "INSERT INTO `visitors`
				(`fname`, `lname`, `email`, `phone`, `sessionid`, `create_date`, `modify_date`, `phpfile`)
				VALUES ('".$fname."','".$lname."','".$email."', '".$phone."', '".$this->sessionid."', '".$now."', '".$now."', '".$_SERVER["SCRIPT_FILENAME"]."')";
				$mysqli->query($insertsql);
				$this->id = $mysqli->insert_id;
				$return = $this->id;
			}
		} else {
			$return = false;
		}
	}

	function get_visitor_info($visitorid='', $data = false) {
		// see if visitor has a row inside or not from front-end view.
		// from the back-end, this would be a more useful view.. and visitor ID would be mandatory.
		global $local;
		global $settings;
		global $mysqli;

		if($visitorid!='') {
			// run off the visitor table right away!
			$visitorid = cleanupforentry($visitorid); // clean it up duh.
			$visitorwhere = " WHERE `id`='".$visitorid."'";
		} else {
			// visitor id may not be set? in this case link up with the session ID within?
			$visitorwhere = " WHERE `sessionid`='".$this->sessionid."'";
		}

		if($data!==false) {
			// preset data from a massive query - probably from back-end list of visitors.
			$visitorarray = $data;
		} else {
			// individual queries.
			$visitorsql = "SELECT `id`, `sessionid`, `fname`, `lname`, `email`, `phone` FROM `visitors` ".$visitorwhere;
			$visitorresult = $mysqli->query($visitorsql);

			if($visitorresult->num_rows>0) {
				$visitorarray = $visitorresult->fetch_assoc();
			} else {
				$visitorarray = false;
			}
		}

		// visitor exists! all good! get data this way!
		if($visitorarray!==false) {
			$this->id = $visitorarray['fname'];
			if ($visitorarray['sessionid'] != $this->sessionid) {
				set_visitor_cookie($visitorarray['sessionid']);
				$this->sessionid = $visitorarray['sessionid'];
			}
			// effectively set $this->sessionid to match, sync up the data for better performance.

			$this->fname = $visitorarray['fname'];
			$this->lname = $visitorarray['lname'];
			$this->email = $visitorarray['email'];
			$this->phone = $visitorarray['phone'];

			$expiry = $local + (3600 * 24 * 30);

			setcookie('email', $this->email, $expiry, '/');
			setcookie('fname', $this->fname, $expiry, '/');
			setcookie('lname', $this->lname, $expiry, '/');
			setcookie('phone', $this->phone, $expiry, '/');
		}
		return $visitorarray;
	}

	/**
	 * @param $data
	 * @param $action
	 * @return bool
	 */
	function listing_action($data, $action) {
		global $local;
		global $settings;
		// saves a view of a proeprty into cookies.
		// must get listing history first to create new JSON
		if ($this->sessionid !== false) {
			$home = array(
				'pid' => $data['id'],
				'action' => $action, // was it a view? share? contact on? or remove from favorite
				'mls' => $data['mls'],
				'fulladdress' => $data['fulladdress'],
				'cityid' => $data['cityid'],
				'areaid' => $data['areaid'],
				'typeid' => $data['typeid'],
				'price' => $data['price'],
				'bed' => $data['bed'],
				'bath' => $data['bath'],
				'sqft' => $data['sqft'],
				'timestamp' => $local,
				'count' => 1
			);

			$history = $this->get_listing_history();

			// If property was already viewed, add to count++ and update latest timestamp.
			if(is_countable($history) && is_array($history)) {
				foreach($history as $pkey=>$property) {
					if($home['action']=='unfavorite' && $property['action']=='favorite' && $property['pid']==$home['pid'] ) {
						unset($history[$pkey]); // simply the row that is the favorited row. Leeave the 'view' actions as it is.
					}	else if($property['pid']==$home['pid'] && $property['action']==$home['action']) {
						$home['count'] = $history[$pkey]['count']+1;
						unset($history[$pkey]); // still unset it, so that the new row with count++ goes in.
					}
				}
			}

			if($home['action']=='unfavorite') {
				unset($home);
			}

			if(is_array($history) && count($history)>$settings['cookie_listing_history_max']) {
				// keep it at max. REmove the first few rows.
				$deduct = count($history) - $settings['cookie_search_history_max'];
				$history = array_splice ( $history , $deduct);
			}

			// whether it's antoher view, or new view, or adding to favorite, do the following to add back to array.
			modify_json_cookie($this->sessionid, 'listing_history', $home, $history);
		} else {
			return false;
		}
	}

	function get_listing_history($action = '', $starttime='', $endtime='') {
		/*
		return array of favorites, viewed, and contacted upon.
		*/
		$history = get_json_cookie_row($this->sessionid, 'listing_history');

		// if action type (view, favorite etc.) is set, then filter out to just those - kill all otehr arrays from

		if($action!='' && is_array($history)) {
			foreach($history as $pkey=>$property) {
				if($property['action']!=$action) {
					unset($history[$pkey]);
				}
			}
		}

		return $history;
	}

	/**
	 * @param $url Log everything after the domain, such as listings/city-WEst+vancouver/min_bedroom-3/page-2/
	 * @param $params To this we can send in all the $param vars from URL to emulate exactly what search happened.
	 * @return bool
	 */
	function search_action($url, $params) {
		global $local;
		global $settings;
		// saves a view of a proeprty into cookies.
		// must get listing history first to create new JSON
		if ($this->sessionid !== false) {

			$pageload = array(
				'action' => 'search', // default is search!
				'url'=>$url,
				'count' => 1
			);

			if(is_array($params) && count($params)>0) {
				foreach ($params as $paramname => $paramval) {
					$pageload[$paramname] = cleanupforentry($paramval);
				}
			}

			$history = $this->get_search_history();

			// If property was already viewed, add to count++ and update latest timestamp.
			if(is_array($history)) {
				foreach($history as $pkey=>$search) {
					if($search['url']==$pageload['url']) {
						$pageload['count'] = $history[$pkey]['count']+1;
						unset($history[$pkey]); // unset, then add to recent through $pageload.
					}
				}
			}

			// whether it's antoher view, or new view, or adding to favorite, do the following to add back to array.
			modify_json_cookie('search_history', $pageload, $history);

		} else {
			return false;
		}
	}

	function get_search_history($action = 'search', $starttime='', $endtime='') {
		/*
		return array of favorites, viewed, and contacted upon.
		*/

		$history = get_json_cookie_row($this->sessionid, 'search_history');

		// if action type (view, favorite etc.) is set, then filter out to just those - kill all otehr arrays from

		if($action!='' && is_array($history)) {
			foreach($history as $pkey=>$search) {
				if($search['action']!=$action) {
					unset($history[$pkey]);
				}
			}
		}

		return $history;
	}

	function killcookies() {
		// rarely used other than fo troubleshooting!
		set_visitor_cookie($_COOKIE['sessionid'], 0);
	}

	function enter_lead_email($email_data) {
	    global $mysqli;
	    $email_data['visitor'] = $this->id;

	    $table_exists = $mysqli->query("SHOW TABLES LIKE 'leads'");

	    if($table_exists->num_rows == 1) {
            if ($email_data->id != '') {
                $return = form_to_table('leads', $email_data, $email_data->id);
            } else {
                $return = form_to_table('leads', $email_data);
            }
        }
    }

	function debug() {

		echo '<strong>Session ID</strong>: '.$this->sessionid."<br />\r\n";
		echo '<strong>ID</strong>: '.$this->id."<br />\r\n";
		echo '<strong>Fname</strong>: '.$this->fname."<br />\r\n";
		echo '<strong>Lname</strong>: '.$this->lname."<br />\r\n";
		echo '<strong>Email</strong>: '.$this->email."<br />\r\n";

		$listing_history = $this->get_listing_history();
		print_r($listing_history);

		$search_history = $this->get_search_history();
		print_r($search_history);
	}
}
?>
